/***************************************************************************
 *   Copyright (C) 2007 by Harry Serenis                                   *
 *   chserenis@ee.auth.gr                                                  *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include <string>
#include "config.h"
#include <hKernel.h>

int main(int argc,char **argv)
{

#ifdef UNIX
	char buffer[1024];
	std::string binary;
	FILE *f=popen("englab-paths --bindir","r");
	if(f==NULL){
		cout<<"Cannot run `englab-paths' was englab installed properly?\n";
		return 1;
	}
	fgets(&buffer[0],1024,f);
	binary=string(buffer);
	binary+="/englab-conf";
	system(binary.c_str());
	hKernel t;
#endif
#ifdef WINDOWS
	int i;
	unsigned int size;
	std::string pathName(argv[0]);
	size=pathName.size();
	for(i=size-1;i>=0;i--){
		if(pathName[i]=='\\')
			break;
	}
	pathName=pathName.substr(0,i);
	hKernel t(pathName);
#endif
	unsigned char ch;
	long brackets=0;
	unsigned long i;
	using namespace std;
	string input;
	do{
		for(i=0;i<brackets;i++)
			cout<<'\t';
		ch=cin.get();
		while(ch!='\n'){
			if(ch=='{'){
				brackets++;
			}else if(ch=='}'){
				brackets--;
			}
			input+=ch;
			ch=cin.get();
		}
		if(input.size()){
	                t.parse(input,false,false);
		}
		else cout<<">> ";
                input.clear();
	}while(1);
	return 1;
}

