#include <iostream>
#include <fstream>
#include <vector>
#include <string>
#include <list>

#include "config.h"

#ifdef WINDOWS
	#define SLASH "\\"
#else
	#define SLASH "/"
#endif


void removeSpaces(std::string & str)
{
	if (!str.empty())
	{
		if (str[str.length()-1]==' ')
			str.erase(str.find_last_not_of(" ")+1);
		if (str[0]==' ')
			str.erase(0,str.find_first_not_of(" "));
	}
	unsigned long s=str.length()-2;
	for(unsigned long i=0;i<s;)
	{
		i=str.find("  ",i);
		if(i!=std::string::npos){
			str.erase(i+1,str.find_first_not_of(' ',i+2)-i-1);
		}
	}
}

std::vector<std::string> parseSpace(std::string arg){
	using namespace std;
	removeSpaces(arg);
	vector<string> ret;
	unsigned int i,j;
	i=j=0;
	i=arg.find(' ',j);
	while(i!=string::npos){
		ret.push_back(arg.substr(j,i-j));
		j=i+1;
		i=arg.find(' ',j);
	}
	ret.push_back(arg.substr(j,i-j));
	return ret;
	
}

int main(int argc,char **argv){
	using namespace std;	
	char buffer[1024];
	ifstream system,in;
	ofstream out;
	list<string> newTools;
	list<string>::iterator it;
	string etc,optionDir,user,temp,input1,input2,lineTemp;
#ifdef WINDOWS
	if(argc!=2){
		cout<<"You must specify the option directory\n";
		return 1
	}
	optionDir=string(argv[1]);
#else
	if(argc==2)
		optionDir=string(argv[1])+SLASH+"."PACKAGE;
	else
		optionDir=string(getenv("HOME"))+SLASH+"."PACKAGE;
	FILE *f=popen("englab-paths --confdir","r");
	if(f==NULL){
		cout<<"Cannot run `englab-paths' was englab installed properly?\n";
		return 1;
	}
	fgets(&buffer[0],1024,f);
	etc=string(buffer);
	etc=etc+SLASH+"libs.conf";
#endif
	user=optionDir+SLASH+"libs.conf";
	temp=optionDir+SLASH+"temp";

	system.open(etc.c_str());
	while(system.good()){
		system.getline(&buffer[0],1023);
		newTools.push_back(buffer);
	}
	system.close();
	in.open(user.c_str());
	out.open(temp.c_str());
	unsigned long line,lastLine=0;
	while(in.good()){
		in.getline(&buffer[0],1023);
		lineTemp=string(buffer);
		input1=parseSpace(lineTemp)[0];
		bool found=false;
		line=0;
		it=newTools.begin();
		while(!found && it!=newTools.end() && input1.size()){
			input2=parseSpace(*it)[0];
			if(!input1.compare(input2)){
				found=true;
				newTools.erase(it);
			}
			++it;
		}
		if(found){
//			lineTemp+='\n';
			out.write(lineTemp.c_str(),lineTemp.size());
			out.write("\n",1);
		}
	}
	in.close();
	out.close();
	out.open(temp.c_str(),ios_base::app);
	for(it=newTools.begin();it!=newTools.end();++it){
		out.write(it->c_str(),it->size());
		out.write("\n",1);
	}
	out.close();
	in.open(temp.c_str());
	out.open(user.c_str());
	while(in.good() && out.good()){
		in.getline(&buffer[0],1023);
		input1=string(buffer);
		if(input1.size()){
			out.write(input1.c_str(),input1.size());
			out.write("\n",1);
		}
	}		
	in.close();
	out.close();
	return 0;
}
