#include "hCommandParser.h"

//bad shit!!!!!
const string hCommandParser::registered_words[reg_words_count] = { "long double complex ","unsigned short int ","unsigned long int ","signed short int ","signed long int ",
	"float complex ","double complex ","long int ","short int ","unsigned int ","signed int ","unsigned long ","unsigned short ","signed short " ,"unsigned char ","signed char ","char const ","int const ","float const ","double const ","complex const ",
	"int ", "float ", "long double ","double ", "char ","const ","short ","long ","complex " };


const string hCommandParser::invalid_chars("?[]()./,';{}!@#$%^&*-=+`~><:|\\\" ");
const string hCommandParser::className = "hCommandParser";

hVariable hCommandParser::parseCommand(string cmd,hVariableTree *mem,hFunction *fun)
{
	display=false;
	memory = mem;
	functiontree=fun;
	cmd=hGlobals::trim(cmd);

	// search for any registered word int the command
	int i;
	bool exists=false;
	STRING_INDEX word_idx,regwpos;
	std::string regw;
	for ( i=0; i<reg_words_count; ++i )
	{
		word_idx = cmd.find(registered_words[i]);
		if ( word_idx != std::string::npos )
		{
			regw=registered_words[i];
			regwpos=word_idx;
			exists = true;
			break;
		}
	}


	if (exists)	// a registered word exists in the command
	{
		// it is assumed that no chars should exist before a registered word
		if (word_idx!=0)
		{
			throw hException("hCommandParser","Invalid command!",hInvalidCommand);
		}

		std::vector< std::string > args;
		checkForInvalidSpaces(cmd.substr(regw.size()));
		args=multipleArgs(cmd,regw);
		if(args.size()==0)
			return processRegWord(cmd,i,functiontree);
		else
		{
			for(int r=0;r<args.size();r++)
				processRegWord(args[r],i,functiontree);
			lastName="";
			return hVariable();
		}
	}
	else	// there is no registered word
	{
		return processNoRegWord(cmd,functiontree);
	}

}

std::vector< std::string >  hCommandParser::multipleArgs(std::string cmd,std::string regWord)
{
	std::vector< std::string > args;
	std::vector<unsigned int> commas;
	unsigned int spaces=0,firstSpace,agyl=0;
	std::string temp;
	firstSpace=regWord.size();
	temp=cmd.substr(firstSpace);
	for(int i=0;i<temp.size();i++)
	{
		if(temp[i]=='[')
		{
			agyl++;
			continue;
		}
		else if(temp[i]==']')
		{
			agyl--;
			continue;
		}
		else if(temp[i]==',' && agyl==0)
			commas.push_back(i);
	}
	unsigned int runn=0;
	for(int i=0;i<commas.size();i++)
	{
		args.push_back(regWord);
		args[i]+=temp.substr(runn,commas[i]-runn);
		runn=commas[i]+1;
	}
	if(commas.size()!=0)
	{
		args.push_back(regWord);
		args[args.size()-1]+=temp.substr(commas[commas.size()-1]+1);
	}
	return args;

}


hVariable hCommandParser::processRegWord(const string & cmd,unsigned int type_idx,hFunction *functions)
{
	string type = registered_words[type_idx];
	type.erase(type.length()-1);	// remove the last space char ' '
	STRING_INDEX name_start, name_end;
	string name;


	// make an initial parse of the variable's name
	name_start = cmd.find_first_not_of(" ",type.length()+1);
	name_end = cmd.find_first_of(" =",name_start) - 1 ;

	if (name_end+1==std::string::npos)
		name_end = cmd.length()-1;
	name = cmd.substr(name_start,name_end-name_start+1);

	STRING_INDEX parenthesis_idx=name.find("(");
	STRING_INDEX braket_idx=name.find("[");

	// check for the different types of declaration
	if ( parenthesis_idx < braket_idx )
	{
		// declare function
		//std::cout << "functions not implemented yet!"<<std::endl;
		throw hException("1:hCommandParser::processRegWord","Invalid variable name.",hError);
	}
	else if ( parenthesis_idx > braket_idx )
	{
		// there is an array on the left side
		hVariable r;
		// find the actual name and the argument list
		STRING_INDEX arg_start = name.find("[") + name_start;	// argument starting idx on the cmd
		STRING_INDEX arg_end = cmd.find("]",arg_start);	// argument ending idx on the cmd
		if( arg_end == std::string::npos )
		{
			throw hException("2:hCommandParser::processRegWord","No closing brackets!",hInvalidBracket);
		}

		string argmnt = cmd.substr(arg_start,arg_end-arg_start+1);
		name = name.substr(0,name.find("["));
		if(!isNameValid(name))
		{
			throw hException("3:hCommandParser::processRegWord","Variable name '"+name+"' is invalid!",
																hInvalidVariableName);
		}

		// declare array
		if ( memory->returnNode(name) == NULL || memory->returnNode(name)->getConstant())
		{
			// find the dimensions of the array
			m_dim=0;
			STRING_INDEX j=0;

			// first just count the dimension...
			while ( j<argmnt.length()  )
			{
				j = argmnt.find(",",j+1);
				++m_dim;
			}

			// ...then extract the size of each dimension
			if (m_dim>1)
			{
				hVariable tempVar;
				m_size = new unsigned long[m_dim];
				j=0;
				unsigned int size_idx = 0;
				while ( j<argmnt.length()-1  )
				{
					STRING_INDEX prev_j = j+1 ;
					j = argmnt.find(",",prev_j);
					if ( j == std::string::npos )
						j=argmnt.length()-1;	// reached the end of the argument list

					string temp = argmnt.substr(prev_j,j-prev_j);
					removeSpaces(temp);
					if(!temp.compare(""))
						throw hException("hCommandParser::processRegWord","Error: Null argument!",hInvalidVariableName);
					try
					{
						
						exprParser.setExpression(temp);
						tempVar = exprParser.calculate(memory,*functions);
					}
					catch (hException &e)
					{
						delete[] m_size;
						hException *e_new = new hException("4:hCommandParser::processRegWord","Cannot calculate the array index",hError);
						e.setException(e_new);
						throw(e);
					}
					if(tempVar.getType()<huChar || tempVar.getType()<hsInt){
						delete[] m_size;
						throw hException("5:hCommandParser::processRegWord","Invalid array index type in declaration",hInvalidIndex);
					}
					if( !isArgValid(tempVar) || tempVar.getValue(m_size[size_idx++])==0 )
					{
						delete[] m_size;
						throw hException("6:hCommandParser::processRegWord","Invalid array index in declaration",hInvalidIndex);
					}

				}
			}
			else	// just 1 dimension -> need to set to 1xsize
			{
				m_dim=1;
				hVariable tempVar;
				m_size = new unsigned long[1];
//				m_size[0]=1;
				string temp = argmnt.substr(1,argmnt.length()-2);
				removeSpaces(temp);
				
				try
				{
					exprParser.setExpression(temp);
					tempVar = exprParser.calculate(memory,*functions);
				}
				catch (hException &e)
				{
					delete[] m_size;
//					tempVar.erase();
					hException *e_new = new hException("7:hCommandParser::processRegWord",
						"Cannot calculate the array index",hError);
					e.setException(e_new);
					throw(e);
				}

				if( !isArgValid(tempVar) )
				{
					delete[] m_size;
//					tempVar.erase();
					throw hException("8:hCommandParser::processRegWord",
							"Invalid array index in declaration",hInvalidIndex);
				}
				else if( tempVar.getValue(m_size[0])==0 )
				{
					delete[] m_size;
//					tempVar.erase();
					throw hException("9:hCommandParser::processRegWord",
							"Zero array index in declaration",hInvalidIndex);
				}
				if(tempVar.getType()<huChar || tempVar.getType()<hsInt){
						delete[] m_size;
						throw hException("10:hCommandParser::processRegWord","Invalid array index type in declaration",hInvalidIndex);
				}
				//delete[] s_new;				
			}

			STRING_INDEX ass_idx = findAssignment(cmd);
			if ( ass_idx == std::string::npos )
			{
				r=createDefaultVariable(type,name,m_dim,m_size);
			}
			else
			{
				string right = cmd.substr(ass_idx+1);
				removeSpaces(right);
				if(right[right.size()-1]==';')
					right=right.substr(0,right.size()-1);
				try
				{
					exprParser.setExpression(right);
					r = exprParser.calculate(memory,*functions);
				}
				catch (hException &e)
				{
					hException *e_new = new hException("11:hCommandParser::processRegWord",
						"Cannot calculate right part",hError);
					e.setException(e_new);
					throw(e);
				}
				

				if( !checkSize(m_dim,r.getDim(),m_size,r.getSize()) )
				{
					throw hException("12:hCommandParser::processRegWord",
						"Initialization dimensions are different from declaration",
						hMismatchedDimension);
				}
				r=createVariableFromValues(type,name,r);

			}
			string tt=cmd;
			removeSpaces(tt);
			if(tt[tt.size()-1]!=';')
				display=true;
			lastName=name;
			delete[] m_size;


		}
		else
		{
			throw hException("13:hCommandParser::processRegWord",
				"Variable '"+name+"' already exists!",hVariableExists);
		}
		return r;
	}
	else
	{
		hVariable r;
		// declare variable
		if ( memory->returnNode(name) == NULL || memory->returnNode(name)->getConstant())
		{
			if(name[name.size()-1]==';')
				name=name.substr(0,name.size()-1);
			if(!isNameValid(name))
			{
				throw hException("14:hCommandParser::processRegWord",
						"Variable name '"+name+"' is invalid!",hInvalidVariableName);
			}

			STRING_INDEX ass_idx = findAssignment(cmd);
			if ( ass_idx == std::string::npos )
			{
				unsigned long m_size[1] = {1};
				r=createDefaultVariable(type,name,1,m_size);
				lastName=name;
			}
			else
			{
				string right = cmd.substr(ass_idx+1);
				removeSpaces(right);
				if(right[right.size()-1]==';')
					right=right.substr(0,right.size()-1);
				try
				{
					exprParser.setExpression(right);
					r = exprParser.calculate(memory,*functions);
				}
				catch (hException &e)
				{
					hException *e_new = new hException("15:hCommandParser::processRegWord",
						"Cannot calculate right part",hError);
					e.setException(e_new);
					throw(e);
				}

				if( r.getDim()!=1 )
				{
					throw hException("16:hCommandParser",
						"Initialization dimensions are different from declaration",
						hMismatchedDimension);
				}

				r=createVariableFromValues(type,name,r);
				lastName=name;
				//r = *createVariableFromValues(type,name,r);
			}
			
			string tt=cmd;
			removeSpaces(tt);
			if(tt[tt.size()-1]!=';')
				display=true;
		}
		else
		{
			throw hException("17:hCommandParser","Variable '"+name+"' already exists!",
				hVariableExists);
		}
		return r;
	}
	

}


hVariable hCommandParser::processNoRegWord(string & cmd,hFunction *functions)
{
	display=false;
	//removeSpaces(cmd);

	STRING_INDEX mid = findAssignment(cmd);

	if ( mid == std::string::npos )
	{
		hVariable r;
		// no assignment, calculate expression
		
		// I have commented this. Previously, if there was a symbol in the end, i threw an exception.
		// However, this cannot be right, since the expression can be 1+2*3++
		
		//if (isValidExpression(cmd))
		//{
			removeSpaces(cmd);
			if (cmd[cmd.length()-1]!=';'){
				display=true;
			}
			else 
			{	display=false;
				cmd=cmd.substr(0,cmd.length()-1);
			}

				try
				{
					if(cmd != ""){
						exprParser.setExpression(cmd);
						r = exprParser.calculate(memory,*functions);
					}
				}
				catch (hException &e)
				{
					hException *e_new = new hException("1:hCommandParser::processNoRegWord",
						"Cannot calculate expression",hError);
					e.setException(e_new);
					throw(e);
				}

				setCmdAnswer(r);
				lastName="ans";
				return r;
		//}
		//else
		//{
		//	throw hException("2:hCommandParser::processNoRegWord","Expression '"+cmd+"' is invalid!",
		//								hInvalidExpression);
		//}
	}
	else
	{
		if(!cmd.substr(mid).compare("=")) throw hException("3:hCommandParser::processNoRegWord","Invalid equation.",hError);;
		string left = cmd.substr(0,mid);
		string right = cmd.substr(mid+1);
		//string name = left.substr(0,left.find_first_of(" "));
		string name = left;
		removeEdgeSpaces(name);

		STRING_INDEX parenthesis_idx=name.find("(");
		STRING_INDEX array_symbol=name.find("[");

		if ( parenthesis_idx < array_symbol )
		{
			throw hException("4:hCommandParser::processNoRegWord","No functions yet...",hError);
		}

		// should I sent now the right side to ExpressionParser???
		char preoperant=0;
		if(name[name.size()-1]=='+')
		{
			preoperant='+';
			name=name.substr(0,name.size()-1);
		}
		else if(name[name.size()-1]=='-')
		{
			preoperant='-';
			name=name.substr(0,name.size()-1);
		}
		else if(name[name.size()-1]=='*')
		{
			preoperant='*';
			name=name.substr(0,name.size()-1);
		}
		else if(name[name.size()-1]=='/')
		{
			preoperant='/';
			name=name.substr(0,name.size()-1);
		}
		else if(name[name.size()-1]=='^')
		{
			preoperant='^';
			name=name.substr(0,name.size()-1);
		}
		else if(name[name.size()-1]=='&')
		{
			preoperant='&';
			name=name.substr(0,name.size()-1);
		}
		else if(name[name.size()-1]=='|')
		{
			preoperant='|';
			name=name.substr(0,name.size()-1);
		}
		else if(name[name.size()-1]=='<')
		{
			preoperant='<';
			name=name.substr(0,name.size()-1);
		}
		else if(name[name.size()-1]=='>')
		{
			preoperant='>';
			name=name.substr(0,name.size()-1);
		}

		if (!isValidExpression(right))
		{
			throw hException("5:hCommandParser::processNoRegWord","Expression '"+right+"' is invalid!",
																	hInvalidExpression);
		}

		removeSpaces(right);
		
		hVariable temp;
		try
		{
			if(right[right.size()-1]==';')
				exprParser.setExpression(right.substr(0,right.size()-1));
			else exprParser.setExpression(right);
			temp = exprParser.calculate(memory,*functions);
		}
		catch (hException &e)
		{
			hException *e_new = new hException("6:hCommandParser::processNoRegWord",
				"Cannot calculate right part",hError);
			e.setException(e_new);
			throw(e);
		}

		//STRING_INDEX array_symbol = name.find("[");
		if ( array_symbol != std::string::npos )
		{
			// deal with array
			string argmnt = name.substr(array_symbol);
			name = name.substr(0,array_symbol);

			hNodeTreeVariable *var = memory->returnNode(name);

			// deal with the argument first
			STRING_INDEX idx=0;
			STRING_INDEX prev_idx=0;

			// first find the dimensions...
			//unsigned int dim=0;
			m_dim=0;
			while (idx<argmnt.length())
			{
				//prev_idx = idx+1;
				idx = argmnt.find(",",idx+1);
				++m_dim;
			}
			
			// ...and then calculate the size of each dimension
			short unsigned int mamal;
			if (m_dim>1)
			{
				hVariable tempVar;
				m_size = new unsigned long[m_dim];
				unsigned short int k=0;
				prev_idx = 1;
				idx = argmnt.find(",",prev_idx);
				while (idx<argmnt.length())
				{
					try
					{
						exprParser.setExpression(argmnt.substr(prev_idx,idx-prev_idx));
						tempVar = exprParser.calculate(memory,*functions);
					}
					catch (hException &e)
					{
						delete[] m_size;
						hException *e_new = new hException("7:hCommandParser::processNoRegWord",
							"Cannot calculate array index",hError);
						e.setException(e_new);
						throw(e);
					}

					if( !isArgValid(tempVar) )
					{
						delete[] m_size;
						throw hException("8:hCommandParser::processNoRegWord","Invalid array index",hInvalidIndex);
					}
					if(tempVar.getType()<huChar || tempVar.getType()<hsInt)
						throw hException("9:hCommandParser::processNoRegWord",
							"Invalid array index type in declaration",hInvalidIndex);
					tempVar.getValue(m_size[k]);
					++k;

					prev_idx = idx+1;
					idx = argmnt.find(",",prev_idx);
				}

				// remove the ']' in the end
				argmnt.erase(argmnt.length()-1,1);

				try
				{
					exprParser.setExpression(argmnt.substr(prev_idx));
					tempVar = exprParser.calculate(memory,*functions);
				}
				catch (hException &e)
				{
					delete[] m_size;
					hException *e_new = new hException("10:hCommandParser::processNoRegWord",
						"Cannot calculate array index",hError);
					e.setException(e_new);
					throw(e);
				}
					if(tempVar.getType()<huChar || tempVar.getType()<hsInt)
						throw hException("11:hCommandParser::processNoRegWord",
							"Invalid array index type in declaration",hInvalidIndex);
				tempVar.getValue(m_size[k]);
			}
			else
			{
				// only 1 dim is known
				// check if is 1xN or Nx1
				/*if( var!=NULL )
				{
					std::vector<unsigned int> var_size = var->returnVar().getSize();
					if( var_size[0]!=1 )//&& var_size[1]!=1 )
					{
						throw hException("hCommandParser::processNoRegWord",
								"Invalid array index, array should have 1xN dimensions",hInvalidIndex);
					}
				}*/
				std::vector<unsigned int> var_size = var->returnVar().getSize();
				m_dim=1;
				hVariable tempVar;
				m_size = new unsigned long[1];
				short unsigned int shit[1]={0};
				m_size[0]=var_size[0];
				// remove the ']' in the end
				argmnt.erase(argmnt.length()-1,1);
				//string temp = argmnt.substr(1,argmnt.length()-2);
				//removeSpaces(temp);

				try
				{
					exprParser.setExpression(argmnt.substr(1));
					tempVar = exprParser.calculate(memory,*functions);
				}
				catch (hException &e)
				{
					delete[] m_size;
					hException *e_new = new hException("12:hCommandParser::processNoRegWord",
						"Cannot calculate array index",hError);
					e.setException(e_new);
					throw(e);
				}

				if( !isArgValid(tempVar) )
				{
					delete[] m_size;
					throw hException("13:hCommandParser::processNoRegWord","Invalid array index",hInvalidIndex);
				}
					if(tempVar.getType()<huChar || tempVar.getType()<hsInt)
						throw hException("14:hCommandParser::processNoRegWord",
							"Invalid array index type in declaration",hInvalidIndex);
				tempVar.getValue(m_size[0]);
			}

			//hNodeTreeVariable *var = memory->returnNode(name);
			if ( var==NULL )
			{
				// must create the variable
				if ( !checkSize(temp.getDim(),m_dim,temp.getSize(),m_size) )
				{
					throw hException("15:hCommandParser::processNoRegWord",
						"Initialization dimensions are different from declaration",
						hMismatchedDimension);
				}
				if(preoperant!=0){
					throw hException("16:hCommandParser::processNoRegWord","Variable '"+name+"' does not exist!",
					hInvalidExpression);
				}
				else{
					memory->insertNode(name,temp,false);
				}
			}
			else
			{
				// assign value
				hVariable k,m,f;
				k=var->returnVar();
				std::vector<unsigned int> m_sv;
				for(int i=0;i<m_dim;i++)
					m_sv.push_back(m_size[i]);	
				if(preoperant=='+'){
					m=k+temp;
					f=m.cast(k.getType());
					k.setValue(m_sv,f);
				}
				else if(preoperant=='-'){
					m=k-temp;
					f=m.cast(k.getType());
					k.setValue(m_sv,f);
				}
				else if(preoperant=='*'){
					m=k*temp;
					f=m.cast(k.getType());
					k.setValue(m_sv,f);
				}
				else if(preoperant=='/'){
					m=k/temp;
					f=m.cast(k.getType());
					k.setValue(m_sv,f);
				}
				else if(preoperant=='^'){
					m=k^temp;
					f=m.cast(k.getType());
					k.setValue(m_sv,f);
				}
				else if(preoperant=='|'){
					m=k|temp;
					f=m.cast(k.getType());
					k.setValue(m_sv,f);
				}
				else if(preoperant=='<'){
					m=k<temp;
					f=m.cast(k.getType());
					k.setValue(m_sv,f);
				}
				else if(preoperant=='>'){
					m=k>temp;
					f=m.cast(k.getType());
					k.setValue(m_sv,f);
				}
				else{
					//m=temp.cast(k.getType());
					k.setValue(m_sv,temp);
				}
				var->setVariable(k);
			}

			delete[] m_size;

		}
		else
		{
			// deal with variable
			if(!isNameValid(name))
			{
				throw hException("hCommandParser::processNoRegWord","Expression '"+name+"' is invalid!",
					hInvalidExpression);
			}

			hNodeTreeVariable *var = memory->returnNode(name);
			if( var==NULL )
			{
				// must create the variable
				if(preoperant!=0){
					throw hException("hCommandParser::processNoRegWord","Variable '"+name+"' does not exist!",
					hInvalidExpression);
				}
				else
					memory->insertNode(name,temp,false);
			}
			else
			{
				// assign the left part to the existing variable
				//////////////////////////////////////////////////////////////////////////
				// for now only this assignment is possible
				//unsigned int data_idx[2] = {0,0};
				//memory->returnNode(name)->returnVar()->setValue(data_idx,r);
				if(var->getConstant())
				{
					if(preoperant!=0){
						throw hException("hCommandParser::processNoRegWord","Cannot change constant's '"+name+"' value!",
						hInvalidExpression);
					}
					else
						memory->insertNode(name,temp,false);
				}
				else
				{
					hVariable left_var = var->returnVar();
					if ( !checkSize(temp.getDim(),(unsigned long)(left_var.getDim()),temp.getSize(),left_var.getSize()) )
					{
						if(preoperant==0)
						throw hException("hCommandParser::processNoRegWord",
								 "left part dimensions differ from right",hMismatchedDimension);
					}
					//hVariable m;
					unsigned char c=left_var.getType();
					hVariable f;
					if(preoperant=='+'){
						f=left_var+temp;
						var->deleteVar();
						var->setVariable(f.cast(c));
					}
					else if(preoperant=='-'){
						f=left_var-temp;
						var->deleteVar();
						var->setVariable(f.cast(c));
					}
					else if(preoperant=='*'){
						f=left_var*temp;
						var->deleteVar();
						var->setVariable(f.cast(c));
					}
					else if(preoperant=='/'){
						f=left_var/temp;
						var->deleteVar();
						var->setVariable(f.cast(c));
					}
					else if(preoperant=='^'){
						f=left_var^temp;
						var->deleteVar();
						var->setVariable(f.cast(c));
					}
					else if(preoperant=='|'){
						f=left_var|temp;
						var->deleteVar();
						var->setVariable(f.cast(c));
					}
					else if(preoperant=='<'){
						f=left_var<temp;
						var->deleteVar();
						var->setVariable(f.cast(c));
					}
					else if(preoperant=='>'){
						f=left_var>temp;
						var->deleteVar();
						var->setVariable(f.cast(c));
					}
					else
					{
						var->deleteVar();
						var->setVariable(temp.cast(c));
					}
					//left_var.setValue(m_size,m);
				}

				//////////////////////////////////////////////////////////////////////////
			}
			lastName=name;
			if(right[right.size()-1]!=';')
				display=true;
		}
		return temp;
	}
	
	
}


inline void hCommandParser::removeSpaces(string & s)
{
	int i=(int)s.length()-1;
	while( i>=0 )
	{
		if ( s[i]==' ' )
		{
			s.erase(i,1);
		}
		--i;
	}
}

inline void hCommandParser::removeEdgeSpaces(string & s)
{
	if (!s.empty())
	{
		if (s[s.length()-1]==' ')
			s.erase(s.find_last_not_of(" ")+1);
		if (s[0]==' ')
			s.erase(0,s.find_first_not_of(" "));
	}
}

hVariable hCommandParser::createDefaultVariable(const string & type,const string & name,unsigned int dim,unsigned long *size)
{
	//hVariable tempVar;
	
	unsigned int data_count = 1;
	unsigned int i;
	std::vector<unsigned int> size2;
	for( i=0; i<dim; ++i ){
		data_count *= size[i];
		size2.push_back(size[i]);
	}	

	// hard-coded check, maybe I should change this
	if ( type == "int" || type=="signed int" || type=="long int" || type=="signed long int" || type=="long")
	{
		hVariable tempVar(size2,(signed long)0);
		return memory->insertNode(name,tempVar,false);
		//return tempVar;
	}
	else if ( type == "float" )
	{
		hVariable tempVar(size2,(float)0);
		return memory->insertNode(name,tempVar,false);
		//return tempVar;
	}
	else if ( type == "double" )
	{
		hVariable tempVar(size2,(double)0);
		return memory->insertNode(name,tempVar,false);
		//return tempVar;
	}
	else if ( type == "unsigned char" )
	{
		hVariable tempVar(size2,(unsigned char)0);
		return memory->insertNode(name,tempVar,false);
		//return tempVar;
	}
	else if ( type == "char" || type == "signed char" )
	{
		hVariable tempVar(size2,(signed char)0);
		return memory->insertNode(name,tempVar,false);
		//return tempVar;
	}
	else if ( type == "unsigned int" || type=="unsigned long int" || type=="unsigned long")
	{
		hVariable tempVar(size2,(unsigned long)0);
		return memory->insertNode(name,tempVar,false);
		//return tempVar;
	}
	else if ( type == "short int" || type=="signed short int" || type=="short" || type=="signed short")
	{
		hVariable tempVar(size2,(signed short)0);
		return memory->insertNode(name,tempVar,false);
		//return tempVar;
	}
	else if ( type == "unsigned short int" || type=="unsigned short")
	{
		hVariable tempVar(size2,(unsigned short)0);
		return memory->insertNode(name,tempVar,false);
		//return tempVar;
	}
	else if ( type == "long double" )
	{
 
		hVariable tempVar(size2,(long double)0);
		return memory->insertNode(name,tempVar,false);
		//return tempVar;
	}
	else if (type=="char const")
	{
		hVariable tempVar(size2,(signed char)0);
		return memory->insertNode(name,tempVar,true);
		//return tempVar;
	}
	else if (type=="int const")
	{
		hVariable tempVar(size2,(signed long int)0);
		return memory->insertNode(name,tempVar,true);
		//return tempVar;
	}
	else if (type=="float const")
	{
		hVariable tempVar(size2,(float)0);
		return memory->insertNode(name,tempVar,true);
		//return tempVar;
	}
	else if ( type == "const" || type=="double const")
	{
		hVariable tempVar(size2,(double)0);
		return memory->insertNode(name,tempVar,true);
		//return tempVar;
	}
	else if (type=="complex const")
	{
		std::complex<double> a;
		hVariable tempVar(size2,a);
		return memory->insertNode(name,tempVar,true);
		//return tempVar;
	}
	else if ( type == "complex" || type=="float complex")
	{
		std::complex<float> a;
		hVariable tempVar(size2,a);
		return memory->insertNode(name,tempVar,false);
		//return tempVar;
	}
	else if ( type == "double complex")
	{
		std::complex<double> a;
		hVariable tempVar(size2,a);
		return memory->insertNode(name,tempVar,false);
		//return tempVar;
	}
	else if ( type == "long double complex")
	{
		std::complex<long double> a;
		hVariable tempVar(size2,a);
		return memory->insertNode(name,tempVar,false);
		//return tempVar;
	}
	else
	{
		throw hException("hCommandParser","Invalid variable type '"+type+"'",hDataType);
	}

	//return tempVar;
	//delete tempVar;
}


hVariable hCommandParser::createVariableFromValues(const string & type,const string & name,const hVariable & var)
{
	hVariable tempVar=var;

	// hard-coded check, maybe I should change this
	if ( type == "int" || type=="signed int" || type=="long int" || type=="signed long int" || type=="long")
	{
		//tempVar = &(var.convert<signed long int>());
		//tempVar = var.cast(hsInt);
		return memory->insertNode(name,tempVar.cast(hsInt),false);
	}
	else if ( type == "float" )
	{
		//tempVar = &(var.convert<float>());
		//tempVar = var.cast(hFloat);
		return memory->insertNode(name,tempVar.cast(hFloat),false);
	}

	else if ( type == "double" )
	{
		//tempVar = &(var.convert<double>());
		//tempVar = var.cast(hDouble);
		return memory->insertNode(name,tempVar.cast(hDouble),false);
	}
	else if ( type == "unsigned char" )
	{
		//tempVar = &(var.convert<signed char>());
		//tempVar = var.cast(huChar);
		return memory->insertNode(name,tempVar.cast(huChar),false);
	}
	else if ( type == "char" || type == "signed char" )
	{
		//tempVar = &(var.convert<signed char>());
		//tempVar = var.cast(hsChar);
		return memory->insertNode(name,tempVar.cast(hsChar),false);
	}
	else if ( type == "unsigned int" || type=="unsigned long int" || type=="unsigned long")
	{
		//tempVar = &(var.convert<signed char>());
		//tempVar = var.cast(huInt);
		return memory->insertNode(name,tempVar.cast(huInt),false);
	}
	else if ( type == "unsigned short int" || type=="unsigned short" )
	{
		//tempVar = &(var.convert<signed char>());
		//tempVar = var.cast(huShortInt);
		return memory->insertNode(name,tempVar.cast(huShortInt),false);
	}
	else if ( type == "short int" || type=="signed short int" || type=="short" || type=="signed short")
	{
		//tempVar = &(var.convert<signed char>());
		//tempVar = var.cast(hsShortInt);
		return memory->insertNode(name,tempVar.cast(hsShortInt),false);
	}
	else if ( type == "long double" )
	{
		//tempVar = &(var.convert<signed char>());
		//tempVar = var.cast(hLDouble);
		return memory->insertNode(name,tempVar.cast(hLDouble),false);
	}
	else if ( type == "char const" )
	{
		//tempVar = var.cast(hsChar);
		return memory->insertNode(name,tempVar.cast(hsChar),true);
	}
	else if ( type == "int const" )
	{
		//tempVar = var.cast(hsInt);
		return memory->insertNode(name,tempVar.cast(hsInt),true);
	}
	else if ( type == "float const" )
	{
		//tempVar = var.cast(hFloat);
		return memory->insertNode(name,tempVar.cast(hFloat),true);
	}
	else if ( type == "const" || type=="double const" )
	{
		//tempVar = var.cast(hDouble);
		return memory->insertNode(name,tempVar.cast(hDouble),true);
	}
	else if ( type == "complex const" )
	{
		//tempVar = var.cast(hComplex);
		return memory->insertNode(name,tempVar.cast(hComplex),true);
	}
	else if ( type == "complex" || type=="float complex")
	{
		//tempVar = var.cast(hComplex);
		return memory->insertNode(name,tempVar.cast(hComplex),false);
	}
	else if ( type=="double complex")
	{
		//tempVar = var.cast(hDComplex);
		return memory->insertNode(name,tempVar.cast(hDComplex),false);
	}
	else if ( type=="long double complex")
	{
		//tempVar = var.cast(hLDComplex);
		return memory->insertNode(name,tempVar.cast(hLDComplex),false);
	}
	else
	{
		throw hException("hCommandParser","Invalid variable type '"+type+"'",hDataType);
	}
}

inline bool hCommandParser::isNameValid(const string & name)
{
	if ( name.find_first_of(invalid_chars) != std::string::npos )
		return false;
	
	if ( isNumber(name[0]) || name=="")
		return false;

	int i;
	bool r=false;
	for(i=0;i<name.size();i++)
	{
		if(name[i]!='_')
		{ 
			r=true;
			break;
		}
	}
	if(r!=true) return false;
	/////////////////////////////////////////////////////////////////////////
	string temp = name+" ";
	//////////////////////////////////////////////////////////////////////////
	for(i=0;i<reg_words_count;++i)
	{
		if (temp==registered_words[i])
			return false;
	}
	if(name=="exit" || name=="quit" || name=="about" || name=="exec" || name=="delete"|| name=="clear"|| name=="lsmem"|| name=="history"|| name=="lsfunc"|| name=="help")
		return false;

	return true;
}

inline bool hCommandParser::isValidExpression(const string & expr)
{
	STRING_INDEX i=0, j = 0;
	i=expr.find(" ");
	j=expr.find("=");

	while (i!=std::string::npos)
	{
		i=expr.find(" ",i+1);
	}

	if ( isSymbol(expr[expr.length()-1]))
	{
		return false;
	}

	return true;
}

inline bool hCommandParser::isNumber(char c)
{
	if ( c=='0' || c=='1' || c=='2' || c=='3' || c=='4' || c=='5' || c=='6' ||
		c=='7' || c=='8' || c=='9' )
		return true;

	return false;
}
inline bool hCommandParser::isSymbol(char c)
{
	if ( c=='+' || c=='/' || c=='-' || c=='*' )
		return true;

	return false;
}


inline void hCommandParser::setCmdAnswer(const hVariable & var)
{
	hNodeTreeVariable *ansVar = memory->returnNode("ans");
	hVariable newVar =var;
	if( ansVar==NULL )
	{
		// ans doesn't exist, create it
		memory->insertNode("ans",newVar,false);
	}
	else
	{
		// ans exists, clear it
		ansVar->deleteVar();
		ansVar->setVariable(newVar);
	}
}

inline STRING_INDEX hCommandParser::findAssignment(const string &cmd){
	STRING_INDEX i,r;
	r=cmd.find('=');
	if(r!=std::string::npos){
		i=cmd.find("==");
		if(i==r)
			r=std::string::npos;
		i=cmd.find("!=");
		if(r==i+1)
			r=std::string::npos;
		i=cmd.find(">=");
		if(r==i+1)
			r=std::string::npos;
		i=cmd.find("<=");
		if(r==i+1)
			r=std::string::npos;
	}
	return r;
}

inline bool hCommandParser::checkSize(const unsigned int &dim1,const unsigned long &dim2,const unsigned long * const size1,const std::vector<unsigned int> size2)
{
	//bool check=true;

	if(dim1!=dim2)
		return false;
	for( unsigned int i=0;i<dim1;++i )
	{
		if ( size1[i]!=size2[i] )
			return false;
	}

	return true;
}

inline bool hCommandParser::checkSize(const unsigned int &dim1,const unsigned long &dim2,const vector<unsigned int> size1,const unsigned long * const size2)
{
	//bool check=true;

	if(dim1!=dim2)
		return false;
	for( unsigned int i=0;i<dim1;++i )
	{
		if ( size1[i]!=size2[i] )
			return false;
	}

	return true;
}

inline bool hCommandParser::checkSize(const unsigned int &dim1,const unsigned long &dim2,const vector<unsigned int> size1,const vector<unsigned int> size2){
	//bool check=true;

	if(dim1!=dim2)
		return false;
	for( unsigned int i=0;i<dim1;++i )
	{
		if ( size1[i]!=size2[i] )
			return false;
	}

	return true;
}

inline bool hCommandParser::checkIdx(const unsigned int &var_dim,const unsigned long &idx_dim,const vector<unsigned int> var_size,const unsigned long * const idx)
{
	if(var_dim!=idx_dim)
		return false;

	for( unsigned int i=0;i<var_dim;++i )
	{
		if ( idx[i]>=var_size[i] )
			return false;
	}

	return true;
}

inline bool hCommandParser::isArgValid(hVariable & arg)
{
	signed long int temp;
	if( arg.getType() > hsInt || arg.getType()==hNoType )
		return false;

	if( arg.getValue(temp)<0 )
		return false;
	return true;
}

inline bool hCommandParser::isSimpleVar(hVariable &var)
{
	if(var.getDim()==1)
	{
		std::vector<unsigned int> size=var.getSize();
		if( size[0]==1)
			return true;
	}

	return false;
	
}

void hCommandParser::checkForInvalidSpaces(std::string command)
{
	int i;
	char prev='+';
	bool space=false;
	char a,z,A,Z,zero,nine;
	a='a';
	z='z';
	A='A';
	Z='Z';
	zero='0';
	nine='9';
	prev='+';
	for(i=0;i<command.size();i++)
	{
		if(command[i]==' ')
		{
			space=true;
			continue;
		}
		else if((command[i]>=a && command[i]<=z) || (command[i]>=A && command[i]<=Z) || (command[i]>=zero && command[i]<=nine))
		{
			if(space)
			{
				if((prev>=a && prev<=z) || (prev>=A && prev<=Z) || (prev>=zero && prev<=nine))
					throw hException("hCommandParser","Invalid space(s) in expression",hError);
			}
		}
		space=false;
		prev=command[i];  
	}
}
