/***************************************************************************
 *   Copyright (C) 2007 by Harry Serenis,poumpa                            *
 *   bobomastoras@users.sf.net,poumpa@users.sf.net                         *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "hException.h"


//const char ex_typename[][] = { {} };

hException::hException(const std::string name, const std::string msg,HEXCEPTION_TYPE id) :
						exceptionId(id), next(NULL)
{
	className=name;
	errMsg=msg;
}

/*hException::hException(void) throw(){
	exceptionId=0;
	next=NULL;
}*/

hException::~hException() throw(){
}

/*
// NOTE: The destructor clears the "list" that starts from this object, "triggering"
// successive calls to the destructors of all the elements in the list
hException::~hException()
{
	if (className)
		delete className;
	if (errMsg)
		delete errMsg;
	if (next)
		delete next;
}
*/

const char * hException::what()
{
	if (errMsg.size())
	{
		return errMsg.c_str();
	}
	else
	{
		return "not initialized hException";
	}
}

void hException::clear()
{
	if (className.size())
	{
		className.clear();
	}
	if (errMsg.size())
	{
		errMsg.clear();
	}
}

void hException::clearAll()
{
	hException *temp=this;
	while (temp!=NULL)//(!temp)
	{
		temp->clear();
		temp=temp->next;
	}
}

void hException::setException(hException *e) throw()
{
	hException *t;
	t=this;
	while(t->next!=NULL)
		t=t->next;
	t->next=e;
}

void hException::printMsg()
{
	if (errMsg.size())
	{
		std::cout << "\tException: " << className << ": " << errMsg<<std::endl;// << std::endl;
	}
}

void hException::printAll()
{
	hException *temp=this;
	while (temp!=NULL)
	{
		temp->printMsg();
		temp=temp->next;
	}
	std::cout<<std::endl;
}
