/***************************************************************************
 *   Copyright (C) 2007 by Harry Serenis,poumpa                            *
 *   bobomastoras@users.sf.net,poumpa@users.sf.net                         *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef HEXCEPTION_H
#define HEXCEPTION_H

#include <iostream>
#include <exception>
#include <string>
#include "hVarTempExcep.h"

class hException: public std::exception
{
	HEXCEPTION_TYPE exceptionId;
	hException *next;
	std::string className;
	std::string errMsg;
public:
	hException(void) throw() : exceptionId(hError), next(NULL), 
							className(), errMsg() {}
	hException(const std::string name, const std::string msg,HEXCEPTION_TYPE id);
	~hException() throw();

	// getters
	HEXCEPTION_TYPE		getId(void) throw() { return exceptionId; }
	std::string	const	getMsg(void) throw() { return errMsg; }
	std::string	const	getClassName(void) throw() {return className; }
	hException * const	getNext(void) throw() { return next; }

	// setters
	void setException(hException *e) throw();

	// overload function for standard exception usage
	virtual const char * what();

	// release memory allocated for msg's
    void clear();

	// release memory of all objects in the list
	void clearAll();

	// print the message (for now in cout)
	// the printing format is: Exception_class <className> : errMsg
	void printMsg();

	// prints the msg's of all the exceptions that are connected to this
	void printAll();
};



#endif
