/***************************************************************************
 *   Copyright (C) 2007 by aurelius,,,   *
 *   aurelius@aurelius-laptop   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "hExpressionNode.h"
#include <iostream>

/////////////////////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////                          PUBLIC FUNCTIONS                /////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////////////////////

using namespace std;

// Ο constructor της κλασης, στον οποιο γινεται αρχικοποιηση των μεταβλητων
hExpressionNode::hExpressionNode()
{
   property = arguments = 0 ;
   name = "" ;
}

void hExpressionNode::set_arguments(int args)
{
   arguments = args ;
}

int hExpressionNode::get_arguments()
{
   return arguments ;
}

void hExpressionNode::set_property(int pro)
{
   property = pro ;
}

int hExpressionNode::get_property()
{
   return property ;
}
/*
void *hExpressionNode::operator new(size_t siz)
{
  void *p ;
  
  fstream out ;
  out.open((log_dir+"mem_log_file").c_str(), ios::app) ;
  
  p = malloc(siz) ;
  
  out<<endl<<"-----------------------------------------"<<endl;
  
  out<<"Operator new : "<<p<<endl ;
  out.close();
  
  /*
  if(!p)
  {
    bas_alloc ba;
    throw ba;
  }
  //
}

void *hExpressionNode::operator new[](size_t siz)
{
  void *p ;
  
  fstream out ;
  out.open((log_dir+"mem_log_file").c_str(), ios::app) ;
  
  p = malloc(siz) ;
  
  out<<endl<<"-----------------------------------------"<<endl;
  
  out<<"Operator new : "<<p<<endl ;
  out.close();
}

void hExpressionNode::operator delete(void *p)
{
  fstream out ;
  out.open((log_dir+"mem_log_file").c_str(), ios::app) ;
  
  out<<endl<<"-----------------------------------------"<<endl;
  
  out<<"Operator delete : "<<p<<endl ;
  
  free(p) ;
  out.close();
}

void hExpressionNode::operator delete[](void *p)
{
  fstream out ;
  out.open((log_dir+"mem_log_file").c_str(), ios::app) ;
  
  out<<endl<<"-----------------------------------------"<<endl;
  
  out<<"Operator delete : "<<p<<endl ;
  
  free(p) ;
  out.close();
}
*/


//------------------------------------------------------------------------------------------------------------
// Η συναρτηση αυτη θέτει τις πιθανές διαστασεις αν εχουμε πινακα
void hExpressionNode::setDimensions(vector<unsigned int> dims)
{
	dimensions=dims;
}

// Η συναρτηση αυτη επιστρεφει τις διαστασεις του κομβου
vector<unsigned int> hExpressionNode::getDimensions()
{
	return dimensions;
}

//------------------------------------------------------------------------------------------------------------
// Η συναρτηση αυτη θετει το ονομα του κομβου
void hExpressionNode::setName(string nameT)
{
	name=nameT;
}

// Η συναρτηση αυτη επιστρεφει το ονομα του κομβου
string hExpressionNode::getName()
{
	return name;
}

//------------------------------------------------------------------------------------------------------------
// Η συναρτηση αυτή θετει την τιμη στο συμβολο που αντιστοιχει στον κομβο
void hExpressionNode::setValue(hVariable val)
{
	value=val;
}

// Συναρτηση που θετει τιμη  με βαση την κλαση hVariable για double μεταβλητες
void hExpressionNode::setValue(const unsigned int &dim, unsigned int *size, double *data)
{
	std::vector<unsigned int> temp;
	for(unsigned long i=0;i<dim;++i)
		temp.push_back(size[i]);
	try
	{
		value=hVariable(temp, data);
	}
	catch(hException &e)
	{
		throw hException("hExpressionNode::setValue", "Cannot initialize hVariable variable.\n", hBadHVariable);
	}
}
	
// Συναρτηση που θετει τιμη  με βαση την κλαση hVariable για signed long int μεταβλητες
void hExpressionNode::setValue(const unsigned int &dim, unsigned int *size, signed long int *data)
{
	std::vector<unsigned int> temp;
	for(unsigned long i=0;i<dim;++i)
		temp.push_back(size[i]);
	try
	{
		value=hVariable(temp, data);
	}
	catch(hException &e)
	{
		throw hException("hExpressionNode::setValue", "Cannot initialize hVariable variable.\n", hBadHVariable);
	}
}

void hExpressionNode::setValue(const unsigned int &dim, unsigned int *size, signed char *data)
{
	std::vector<unsigned int> temp;
	for(unsigned long i=0;i<dim;++i)
		temp.push_back(size[i]);
	try
	{
		value=hVariable(temp, data);
	}
	catch(hException &e)
	{
		throw hException("hExpressionNode::setValue", "Cannot initialize hVariable variable.\n", hBadHVariable);
	}
}

void hExpressionNode::setValue(std::vector<signed char> &var)
{
	try
	{
		value=hVariable(var);
	}
	catch(hException &e)
	{
		throw hException("hExpressionNode::setValue", "Cannot initialize hVariable variable.\n", hBadHVariable);
	}
}

// Η συναρτηση αυτη επιστρφει την τιμη του συμβολου του κομβου
hVariable& hExpressionNode::getValue()
{
	return value;
}
