/***************************************************************************
 *   Copyright (C) 2007 by aurelius,,,   *
 *   aurelius@aurelius-laptop   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef HEXPRESSIONNODE_H
#define HEXPRESSIONNODE_H

/**
	@author aurelius,,, <aurelius@aurelius-laptop>
*/

#include "hVariable.h"
#include "hVariableTree.h"
#include <string>
#include <vector>

using namespace std  ;

/**
	Η κλαση αυτη δημιουργει τους κομβους που σχηματιζονται κατα την αναλυση του string που δινεται
	σαν εισοδος απο τον χρηστη στην γραμμη εντολων.
*/

class hExpressionNode{
	string name;
	//
	int property ;
	//
	int arguments ;
	//
	// Η τιμη του κομβου
	hVariable value;
	vector<unsigned int> dimensions;
public:
    hExpressionNode();
		
	void set_property(int pro) ;
	int get_property();
	
	void set_arguments(int args) ;
	int get_arguments() ;
	
	void setDimensions(vector<unsigned int> dims);
	/**
	Η συναρτηση αυτη επιστρεφει τις διαστασεις του κομβου
	*/
	vector<unsigned int> getDimensions();
	
	/**
	Η συναρτηση αυτη θετει το ονομα του κομβου

	\param nameT Το ονομα του κομβου
	*/
	void setName(string name);
	/**
	Η συναρτηση αυτη επιστρεφει το ονομα του κομβου
	*/
	string getName();
	
	/**
	Η πρωτη εκδοση της συναρτησης setValue. Η συναρτηση αυτή θετει την τιμη στον κομβο

	\param val Η τιμη που θα θετουμε στον κομβο μορφης hVariable
	*/
	void setValue(hVariable var);
	/**
	Η δευτερη εκδοση της συναρτησης setValue. Ειναι συναρτηση που θετει τιμη στον κομβο χρησιμοποιωντας
	τον constructor της hVariable. Η τιμη δινεται ως πινακας double

	\param dim Ο αριθμος των διαστασεων του πινακα που εχει τις τιμες που θα εισαχθουν

	\param size Ο πινακας που διαθετει τις διαστασεις του πινακα

	\param data Ο πινακας που διαθετει τις τιμες που θα εισαχθουν
	*/
	void setValue(const unsigned int &dim, unsigned int *size, double *data);
	/**
	Τριτη εκδοση της συναρτησης setValue. Συναρτηση που θετει τιμη χρησιμοποιωντας
	τον constructor της hVariable. Η τιμη δινεται ως πινακας signed long int
	
	\param dim Ο αριθμος των διαστασεων του πινακα που εχει τις τιμες που θα εισαχθουν

	\param size Ο πινακας που διαθετει τις διαστασεις του πινακα

	\param data Ο πινακας που διαθετει τις τιμες που θα εισαχθουν
	*/
	void setValue(const unsigned int &dim, unsigned int *size, signed long int *data);
	//
	void setValue(const unsigned int &dim, unsigned int *size, signed char *data);
	//
	void setValue(std::vector<signed char> &var) ;
	/**
	Η συναρτηση αυτη επιστρφει την τιμη του κομβου
	*/
	hVariable& getValue();	
};

#endif
