/***************************************************************************
 *   Copyright (C) 2007 by aurelius,,,   *
 *   aurelius@aurelius-laptop   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "hExpressionParser.h"
#include "hTools.h"
#include <iostream>
#include <vector>
#include <stack>

using namespace std;

///////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////// TODO //////////////////////////////////////////////////////////

template <class T> bool from_string(T& t, const std::string& s, std::ios_base& (*f)(std::ios_base&))
{
	std::istringstream iss(s);
	return !(iss >> f >> t).fail();
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////                          PUBLIC FUNCTIONS                /////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////////////////////
/**
 * Η συναρτηση constructor της κλασης μας είναι απλα για να δεσμεύσει ενα αντικέιμενο τύπου hExpressionParser. * Παίρνει ένα όρισμα.Αυτό το ορισμα θα ειναι ένας πίνακας απο char, ο οποιος θα περιεχει την αριθμητική *έκφραση που θέλει κάποιος να υπολογίσει. Αυτή η συνάρτηση θα κατασκευάζει το δέντρο.
 */

string excep_expression[28] =
{
"Cannot allocate memory",                                                        // 0
   
"Cannot make the operation.",                                                 // 1

"Variable ",                                                                     // 2

" does not exist",

"Cannot initialise hVariable variable",

"An arithmentic expression cannot start with this operand",

"Invalid expression. Be careful !!!",

"The arithmentic expression has different number of left and right parenthesis\n",

"The index must be a positive integer",

"Error during make the operation '+'",

"Error during make the operation '-'",

"Error during make the operation '*'",

"Error during make the operation '/'",

"Error during make the operation '^'",

"Error during make the operation '<'",

"Error during make the operation '>'",

"Error during make the operation '%'",

"Error during make the operation '<='",

"Error during make the operation '>='",

"Error during make the operation '=='",

"Error during make the operation '!='",

"Error during make the operation '.*'",

"Error during make the operation './'",

"Error during make the operation '.^'",

"Error during make the operation '&&'",

"Error during make the operation '||'",

"Error during make the operation '&'",

"Error during make the operation '|'",
};


//
void hExpressionParser::setExpression(string expression)
{
	//---------------------------------------------------------------------------------------------------------
	// Αποθηκευω την αριθμητικη εκφραση μεσα στην κλαση
   hTools tools;
   string temp1 = expression.substr(0,1), temp2 = expression.substr(0,2);
   
   if((expression[0] == '-' && expression[1] != '-')  || (expression[0] == '+' &&  expression[1] != '+'))
   {
	  string temp = "0" ;
	  temp += expression ;
	  expression = temp ;
   }
   else if(expression[0] == '-' && expression[1] == '-')
   {
	   throw hException("hExpressionParser::setExpression", excep_expression[6]+"An expression cannot start with symbol --", hInvalidExpression) ;
   }
   else if(expression[0] == '+' && expression[1] == '+')
   {
	   throw hException("hExpressionParser::setExpression", excep_expression[6]+"An expression cannot start with symbol ++", hInvalidExpression) ;
   }
   else if(tools.isSymbol(temp1) && temp1 != "!")// and others
   {
	  throw hException("hExpressionParser::setExpression", excep_expression[6]+" An expression cannot start with symbol "+ temp1, hInvalidExpression) ;
   }
   else if(tools.isSymbol(temp2))// and others
   {
	  throw hException("hExpressionParser::setExpression", excep_expression[6]+". An expression cannot start with symbol "+ temp2, hInvalidExpression) ;
   }

   arithmeticExpression=expression;
	// 2ος ελεγχος
	/* Στην αρχη ελεγχουμε αν η εκφραση ξεκιναει με + ή -, οποτε θα πρεπει να προσθεσουμε απλα ενα 0 στην αρχη.
	Επισης ελεγχουμε αν ξεκινανε με αλλα συμβολα, π.χ. *, / κτλ. Σε αυτες τις περιπτωσεις βγαζουμε σφαμα. 
	*/
	
   clear() ;
   
	try
	{
		crossExpression();
	}
	catch(hException &e)
	{
	   hException *e1;
	   e1 = new hException("hExpressionParser::hExpressionParser", excep_expression[6]+'\n', hInvalidExpression) ;
	   e.setException(e1) ;
	   throw e ;
	}
}

//
void hExpressionParser::setExpression(string expression, std::string &error, int &error_code)
{
	//---------------------------------------------------------------------------------------------------------
	// Αποθηκευω την αριθμητικη εκφραση μεσα στην κλαση
	error.clear() ;
   hTools tools;
   string temp1 = expression.substr(0,1), temp2 = expression.substr(0,2);
   
   if((expression[0] == '-' && expression[1] != '-')  || (expression[0] == '+' &&  expression[1] != '+'))
   {
	  string temp = "0" ;
	  temp += expression ;
	  expression = temp ;
   }
   else if(expression[0] == '-' && expression[1] == '-')
   {
	   if(error.empty())
	   {
		   error = excep_expression[6]+"An expression cannot start with symbol --" ;
		   error_code = 4 ;
	   }
	   else
	   {
		   return ;
	   }
   }
   else if(expression[0] == '+' && expression[1] == '+')
   {
	   if(error.empty())
	   {
		   error = excep_expression[6]+"An expression cannot start with symbol ++" ;
		   error_code = 4 ;
	   }
	   else
	   {
		   return ;
	   }
   }
   else if(tools.isSymbol(temp1) && temp1 != "!")// and others
   {
	  //throw hException("hExpressionParser::setExpression", excep_expression[6]+" An expression cannot start with symbol "+ temp1, hInvalidExpression) ;
	   if(error.empty())
	   {
		   error = excep_expression[6]+" An expression cannot start with symbol "+ temp1 ;
		   error_code = 4 ;
	   }
	   else
	   {
		   return ;
	   }
   }
   else if(tools.isSymbol(temp2))// and others
   {
	  //throw hException("hExpressionParser::setExpression", excep_expression[6]+". An expression cannot start with symbol "+ temp2, hInvalidExpression) ;
	  if(error.empty())
	  {
		  error = excep_expression[6]+" An expression cannot start with symbol "+ temp1 ;
		  error_code = 4 ;
	  }
	  else
	  {
		  return ;
	  }
   }

   arithmeticExpression=expression;
	// 2ος ελεγχος
	/* Στην αρχη ελεγχουμε αν η εκφραση ξεκιναει με + ή -, οποτε θα πρεπει να προσθεσουμε απλα ενα 0 στην αρχη.
	Επισης ελεγχουμε αν ξεκινανε με αλλα συμβολα, π.χ. *, / κτλ. Σε αυτες τις περιπτωσεις βγαζουμε σφαμα. 
	*/
	
   clear() ;
   
	//try
	//{
		crossExpression(error, error_code);
	//}
	/*catch(hException &e)
	{
	   hException *e1;
	   e1 = new hException("hExpressionParser::hExpressionParser", excep_expression[6]+'\n', hInvalidExpression) ;
	   e.setException(e1) ;
	   throw e ;
	}*/
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////FOR SYNTAX CHECK/////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////////////////


/**
 * Η συνάρτηση αυτή θα υπολογίζει μια δεδομένη αριθμητική έκφραση. Η συνάρτηση στο τέλος επιστρέφει το *αποτέλεσμα της αριθμητικής έκφρασης σε μορφή hVariable. Το όρισμα τηςείναι ένα αντικείμενο τυπου *hVariableTree.  Αυτό θα έχει το δέντρο των μεταβλητών που θα έχουν δεσμευτει. Αυτό χρειάζεται για να δούμε *αν οι όποιες μεταβλητές της έκφρασης υπαρχουν και αν ναι ποια είναι η τιμή τους. Το όρισμα αυτό μπαίνει σε *αυτή την συνάρτηση και όχι στον constructor, διότι μπορεί να έχουμε μια αριθμητική έκφραση μέσα σε μια for. *Έτσι το δέντρο μένει κάθε φορά το ίδιο, αλλά οι τιμές των μεταβλητών που διαθέτει στους κόμβους θα αλλάζουν.
 */

hVariable hExpressionParser::calculate(hVariableTree *varRoot, hFunction functions)
{
	int i = 0, j = 0 ;
	std::deque<hVariable> result ;
	for(i = 0 ; i < output.size() ; i++)
	{
	   if(output[i]->get_property() == 0 || output[i]->get_property() == 12)
	   {
		  hExpressionNode *temp= output[i];
		  result.push_back(output[i]->getValue());
	   }
	   else if(output[i]->get_property() == 8)
	   {
		  if(varRoot->returnNode((char*)output[i]->getName().c_str()) != NULL)
		  {
			  result.push_back(varRoot->returnNode((char*)output[i]->getName().c_str())->returnVar());
		  }
		  else
		  {
			throw hException("hExpressionParser::calculate", excep_expression[2]+output[i]->getName() + excep_expression[3]+'\n', hVariableDoesNotExist);
		  }
	   }
	   else if(output[i]->get_property() == 4 || output[i]->get_property() == 5)
	   {
		  hVariable res ;
		  if(output[i]->getName() == "!")
		  {
			 hVariable op2 ;
			 res = makeOperation("!", result.back(), op2) ;
			 result.pop_back();
			 result.push_back(res) ;
		  }
		  else if(output[i]->getName() == "++" || output[i]->getName() == "--")
		  {
			  if(!result.empty())
			  {
				  hVariable op1 ;
				  res = makeOperation(output[i]->getName(), result.back(), op1) ;
				  result.pop_back();
				  int j = i - 1 ;
				  while(j >= 0)
				  {
					  if(output[j]->get_property() != 4 && output[j]->get_property() != 5)
						  break ;
					  else
						  j-- ;
				  }
				  if(output[j]->get_property() == 8)
					  varRoot->returnNode((char*)output[j]->getName().c_str())->setVariable(res);
				  result.push_back(res) ;
			  }
			  else
				  throw hException("hExpressionParser::calculate", excep_expression[6]+". Possibly mismatched operator. \n", hInvalidExpression) ;
		  }
		  /*else if(output[i]->getName() == "--")
		  {
			  hVariable op1, op2;
			  if(!result.empty())
			  {
				  op2 = result.back() ;
				  result.pop_back();
			  }
			  else
				  throw hException("hExpressionParser::calculate", excep_expression[6]+". Possibly mismatched operator. \n", hInvalidExpression) ;
			 
			  res = makeOperation(output[i]->getName(), op2, op1) ;
			  int j = i - 1 ;
			  while(j >= 0)
			  {
				  if(output[j]->get_property() != 4 && output[j]->get_property() != 5)
					  break ;
				  else
					  j-- ;
			  }
			  if(output[j]->get_property() == 8)
				  varRoot->returnNode((char*)output[j]->getName().c_str())->setVariable(res);
			  result.push_back(res) ;
		  }*/
		  else
		  {
			 if(result.size() > 1)
			 {
			   res = makeOperation(output[i]->getName(), result[result.size() - 2], result.back()) ;
			   result.pop_back();
			   result.pop_back();
			   result.push_back(res) ;
			 }
			 else
				throw hException("hExpressionParser::calculate", excep_expression[6]+". Possibly mismatched operator. \n", hInvalidExpression) ;
		  }
	   }
	   else if(output[i]->get_property() == 1)
	   {
		 int arg_num = output[i]->get_arguments() , res_siz = result.size() ;
		 hStructure ret, args;
		 if(res_siz - arg_num < 0)
		 {
			 throw hException("hExpressionParser::calculate", excep_expression[6]+". Mismatched operator", hInvalidExpression) ;
		 }
		 else
		 {
			for(int k = arg_num ; k > 0 ; k--)
			{
				//cout<<result[res_siz - k]<<endl<<endl;
				args.push_back(result[res_siz - k]) ;
			}
			
			for(int k = 0 ; k < arg_num ; k++)
				result.pop_back() ;
		 }
		 // Αυτο θα το κανω μονο οταν φτιαχτει το αντιστοιχο δεντρο. Θα ειναι παρομοιο με το απο πανω
		 
		 ret = functions.execute(output[i]->getName(), args);
		 if(!ret.empty())
		    result.push_back(ret[0]) ;
	   }
	   // Mode 9 = matrix to create [[1,2],[3,4]]
	   else if(output[i]->get_property() == 9)
	   {
		unsigned int k;
		 
		 vector<unsigned int> dims ;
		 int aa, bb, cc;
		 try
		 {
			dims = findDimensions(output[i]->getName()) ;
			aa=dims[0]; bb=dims[1] ; cc=dims.size() ;
		 }
		 catch(hException &e)
		 {
			hException *e1 ;
			e1 = new hException("hExpressionParser::calculate", excep_expression[6] + '\n', hInvalidExpression) ;
	        	e.setException(e1) ;
	        	throw e ;
		 }
		 try
		 {
			 valid_dimensions(output[i]->getName(), dims) ;
		 }
		 catch(hException &e)
		 {
			 hException *e1 ;
			 e1 = new hException("hExpressionParser::calculate", "Matrix cannot have these dimensions", hInvalidExpression) ;
			 e.setException(e1) ;
			 throw e ;
		 }
		 
		 unsigned int num = 1, res_siz = result.size();
		  
		 bool d = false ;

		 for(k=0;k<dims.size();k++)
		 {
			num *= dims[k] ;
		 }
		  
		  for(int k = 0 ; k < num ; k++)
		  {
			 if(result[res_siz - k - 1].getType() == 7 || result[res_siz - k - 1].getType() == 8 || result[res_siz - k - 1].getType() == 9) d = true ;
		  }
		  
		  if(d)
			{
			   double *data;
			   try
			   {
				  data=new double[num];
			   }
			   catch(std::exception &e)
			   {
				  throw hException("hExpressionParser::calculate", "Cannot allocate memory", hAlloc);
			   }
			   for(int k = num ; k > 0 ; k--)
				result[res_siz-k].getValue(data[num-k]);
			   for(int k=0 ; k < num ; k++)
				  result.pop_back();
			   try
			   {
				  hVariable var(dims, data);
				  result.push_back(var) ;
			   }
			   catch(hException &e )
			   {
				delete[] data;
				  throw hException("hExpressionParser::calculate", "Cannot initialise hVariable variable.\n", hAlloc);
			   }
			   delete[] data;
			}
			else
			{
			   signed long int *data;
			   try
			   {
				  data=new signed long int[num];
			   }
			   catch(std::exception &e)
			   {
				  throw hException("hExpressionParser::calculate", "Cannot allocate memory.\n", hAlloc);
			   }
			   for(int k = num ; k > 0 ; k--)
				result[res_siz - k].getValue(data[num - k]);
			   for(int k=0 ; k < num ; k++)
				  result.pop_back();
			   try
			   {
				  hVariable var(dims, data);
				  result.push_back(var) ;
			   }
			   catch(hException &e)
			   {
				delete[] data;
				  throw hException("hExpressionParser::calculate", "Cannot initialise hVariable variable.\n", hAlloc);
			   }
			   delete[] data;
			}
	   }
	   // Mode 2 = matrix
	   else if(output[i]->get_property() == 2)
	   {
		   int res_siz = result.size() ;
		   unsigned int k, dims=output[i]->get_arguments();
		   std::vector<unsigned int> index;
		   unsigned long temp;
		   if(dims==1)
		   {
			   index.push_back(result.back().getValue(temp));
			   result.pop_back();
		   }	
		   else
		   {
			   if(res_siz - (int)dims < 0)
			   {
				   throw hException("hExpressionParser::calculate", excep_expression[6]+". Mismatched operator", hInvalidExpression) ;
			   }
			   else
			   {
				for(int k = dims ; k > 0 ; k--)
					index.push_back(result[res_siz - k].getValue(temp));
				for(int k=0 ; k < dims ; k++)
					result.pop_back();
			   }
		   }
		 if(varRoot->returnNode((char*)output[i]->getName().c_str())!=NULL)
		 {
			 try
			 {
				 result.push_back(varRoot->returnNode((char*)output[i]->getName().c_str())->returnVar().getValue(index));
			 }
			 catch(hException &e)
			 {
				 hException *e1;
				 e1 = new hException("hExpressionParser::calculate", "Matrix out of bounds", hMatrixOutOfBounds) ;
				 e.setException(e1) ;
				 throw e ;
			 }
		 }
		 else 
		 {
			throw hException("hExpressionParser::calculate", excep_expression[2]+output[i]->getName() + excep_expression[3], hVariableDoesNotExist);
		 }
	   }
	}
	if(!result.empty())
	{
		if(result.size() == 1)
	  		return result[0];
		else
		{
			throw hException("hExpressionParser::calculate", "Invalid expression. Probably misplaced operators", hError) ;
		}
	}
	else
	{
	  hVariable a;
	  return a;
	}
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////              PRIVATE OR PROTECTED FUNCTIONS              /////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////////////////////

void hExpressionParser::clear()
{
   output.clear() ;
   stack.clear() ;
   were_values.clear() ;
   arg_cnt.clear() ;
   is_function.clear() ;
   brackets.clear() ;
   // Να φτιαξω συναρτηση που να τα σβηνει σωστα...
   for(int i = 0 ; i < token.size() ; i++)
   {
	  delete token[i] ;
   }
   token.clear() ;
}


/**
   In order to develop the EngLab parser, we implement a modified version of shunting yard algorithm, according
   to the blog http://www.kallisti.net.nz/blog/2008/02/extension-to-the-shunting-yard-algorithm-to-allow-variable-numbers-of-arguments-to-functions/
   with some changes, in order to parse matrices too.
*/

void hExpressionParser::crossExpression()
{
	//---------------------------------------------------------------------------------------------------------
	// Variable declaration
   int i = 0, j = 0, status;
   string tok_str, tok = "", tok_prev = "", matrix ;
   hTools tools;
   int end = 0, comma = 0;
   
   bool start_matrix = false, stop_matrix = false ;

   while(end < 2)
   {
	  if(end == 1) end = 2 ;
	  
	  if(!tools.is_valid_char(arithmeticExpression[i]))
	  {
		 throw hException("hExpressionParser::crossExpression", excep_expression[6]+". Possibly invalid character", hInvalidExpression) ;
	  }
	  
	  // Added to support valid gaps inside the expression and throw an exception for invald gaps
	  if(arithmeticExpression[i] == ' ')
	  {
		  string temp_str;
		  int temp_i = i ;
		  if(i > 0)
		  {
			temp_str = arithmeticExpression[i - 1] ;
		  }
		  temp_str += arithmeticExpression[i] ;
		  i++ ;
		  tok_str += arithmeticExpression[i] ;
		  temp_str += arithmeticExpression[i] ;
		  if(change_token(tok_str) == -1)
		  {
			  throw hException("hExpressionParser::crossExpression", "Expression \' "+ temp_str + " \' contains invalid gaps", hInvalidExpression) ;
		  }
		  //i = temp_i ;
	  }
	  else
	  {
	  	tok_str += arithmeticExpression[i] ;
	  }
	  
	  if(tok_str == "][" || tok_str == "[]" || tok_str == "(," || tok_str == ",(" || tok_str == ",)" /*|| tok_str == "),"*/ || tok_str == "[," || tok_str == ",]")
		 throw hException("hExpressionParser::crossExpression", excep_expression[6], hInvalidExpression) ;
	  
	  status = change_token(tok_str) ;
	  if(tok_str[0] == '=' && tok_str[1] != '=' )
		  throw hException("hExpressionParser::crossExpression", excep_expression[6], hInvalidExpression) ;

	  // 34 is in ASCII code the "
	  // this code finds char variables
	  if(tok_str[0] == 34)
	  {
		 //tok = "\"" ;
		 tok="";
		 i++ ;
		 while(arithmeticExpression[i] != 34)
		 {
			tok += arithmeticExpression[i] ;
			i++ ;
			if(i == arithmeticExpression.length()) throw hException("hExpressionParser::crossExpression", excep_expression[6]+". Misbalanced \" ", hInvalidExpression) ;
		 }
		 //tok += arithmeticExpression[i] ;
		 i++;
		 status = 12 ;
	  }
	  
	  if(status != -1)
	  {
		  tok_prev = tok ;
		 if(status == 4)
		 {
			tok = tok_str.substr(0, tok_str.length());
			i++;
		 }
		 else
		 {
			if(status != 12)
			   tok = tok_str.substr(0, tok_str.length() - 1);
		 }
		 
		 hExpressionNode *node;
		 node = new hExpressionNode;
		 node->setName(tok);
		 node->set_property(status) ;
		 
		 token.push_back(node) ;

         if(status == number)
		 {
			try
			{
			   findNumber(node) ;
			}
			catch(hException &e)
			{
			   hException *t ;
			   t = new hException("hExpressionParser::crossExpression", "Error during finding number", hInvalidExpression) ;
			   e.setException(t) ;
			   throw e ;
			}
			output.push_back(node) ;
			
			if(!were_values.empty())
			{
			   were_values.pop_back();
			   were_values.push_back(true) ;
			}
		 }
		 else if(status == char_var)
		 {
			//Expression is a char vector enclosed in `"'
			// A char variable is treated like a number during algorithm

			std::vector<unsigned char> var ;
			
			unsigned char* ch ;
			
			ch = (unsigned char*)node->getName().c_str() ;

			for(int k = 0 ; k < node->getName().length() ; k++)
			{
				var.push_back(ch[k]) ;
			}
			
			node->setValue(var);
			
			output.push_back(node) ;
			
			if(!were_values.empty())
			{
			   were_values.pop_back();
			   were_values.push_back(true) ;
			}
		 }
		 else if(status == func_or_matr)
		 {
			// In that case, we have an expression like 1+a
			if(end == 2)
			{
				node->set_property(variable) ;
			   stack.push_back(node) ;
			   
			   // I dont know if this is right.
			   if(!were_values.empty())
			   {
				  were_values.pop_back();
				  were_values.push_back(true) ;
			   }
			   
			   if(!arg_cnt.empty())
			      arg_cnt.pop_back() ;
			   continue ;
			}
			stack.push_back(node) ;

			// This is an addition for a[0,b]
			/*if(!arg_cnt.empty())
			{
				int a = arg_cnt.back() ;
				arg_cnt.pop_back() ;
				a++ ;
				arg_cnt.push_back(a) ;
			}
			else
			{*/
			arg_cnt.push_back(0) ;
			//}
			
			if(!were_values.empty())
			{
			   were_values.pop_back();
			   were_values.push_back(true);
			}
			were_values.push_back(false);
		 }
		 else if(status == arg_separ)
		 {
			if(!stack.empty())
			{
			   // It is initially set as a function. Now is set as variable.
			   if(stack.back()->get_property() == 1)
			   {
				  stack.back()->set_property(8) ;
				  
				  hExpressionNode *temp = stack.back();
				  output.push_back(temp);
				  stack.pop_back() ;
			   }
			   
			   if(!were_values.empty())
			   {
				  were_values.pop_back();
				  were_values.push_back(true) ;
			   }
			}
			if(is_function.size() != 0 && is_function.back() == 0)
			{
			   while(stack.back()->get_property() != 6)
			   {
				  hExpressionNode *temp = stack.back();
				  output.push_back(temp);
				  stack.pop_back() ;
				  if( stack.empty() )
				  {
					 throw hException("hExpressionParser::crossExpression", excep_expression[6] + "Possibly mismatched parenthesis or comma", hInvalidExpression) ;
				  }
			   }

			   // ADDITION: to correct the fact that in every new variable the progarm pushes back 0 in arg_cnt, like in a, b, c
			   if(arg_cnt.size() > 1  && arg_cnt.back() == 0)
			   {
				   arg_cnt.pop_back() ;
			   }
			   
			   bool w = were_values.back();
			   were_values.pop_back() ;
			   if(w)
			   {
				  int a = arg_cnt.back() ;
				  arg_cnt.pop_back() ;
				  a++ ;
				  arg_cnt.push_back(a) ;
			   }
			   were_values.push_back(false) ;
			}
			else if(is_function.size() != 0 && (is_function.back() == 1 || is_function.back() == 2))
			{
			   while(stack.size() != 0 && stack.back()->get_property() != 10)
			   {
				  hExpressionNode *temp = stack.back();
				  output.push_back(temp);
				  stack.pop_back() ;
			   }
			   // ADDITION: to correct the fact that in every new variable the progarm pushes back 0 in arg_cnt, like in a, b, c
			   //if(arg_cnt.size() > 1  && arg_cnt.back() == 0)
			   //{
				//   arg_cnt.pop_back() ;
			   //}
			   
			   bool w = were_values.back();
			   were_values.pop_back() ;
			   if(w)
			   {
				  int a = arg_cnt.back() ;
				  arg_cnt.pop_back() ;
				  a++ ;
				  arg_cnt.push_back(a) ;
			   }
			   were_values.push_back(false) ;
			}
			else if(is_function.size() == 0)
			{
			   throw hException("hExpressionParser::crossExpression", excep_expression[6] + ". Possibly misplaced comma separator", hInvalidExpression) ;
			}
			/*
			else if(stack.back()->get_property() == 9)
			{
			   hExpressionNode *t=brackets.back();
			   if(!brackets.back()->getNodeIfReady())
			   {
				  int comma = matr_dims.back() ;
				  matr_dims.pop_back() ;
				  comma++;
				  matr_dims.push_back(comma) ;
			   }
			}*/
			
			string temp1 = arithmeticExpression.substr(i,1), temp2 = arithmeticExpression.substr(i,2);
			
			// In case there is a symbol after ,
			if(arithmeticExpression[i] == '-' || arithmeticExpression[i] == '+')
			{
			   string temp = arithmeticExpression.substr(0, i) ;
			   temp += "0" ;
			   temp += arithmeticExpression.substr(i) ;
			   arithmeticExpression = temp ;
			}
			else if(tools.isSymbol(temp1) && temp1 != "!")// and others
			{
			   throw hException("hExpressionParser::setExpression", excep_expression[6]+" An expression cannot start with symbol "+ temp1, hInvalidExpression) ;
			}
			else if(tools.isSymbol(temp2))// and others
			{
			   throw hException("hExpressionParser::setExpression", excep_expression[6]+". An expression cannot start with symbol "+ temp2, hInvalidExpression) ;
			}
		 }
		 else if(status == one_sym_oper || status == two_sym_oper)
		 {
			if(!stack.empty())
			{
			   // It is initially set as a function. Now is set as variable.
			   if(stack.back()->get_property() == func_or_matr)
			   {
				  stack.back()->set_property(variable) ;
				  
				  hExpressionNode *temp = stack.back();
				  output.push_back(temp);
				  stack.pop_back() ;
			   }
			}
			
			   //hExpressionNode *temp=stack.back();
			while(!stack.empty() && (stack.back()->get_property() == one_sym_oper || stack.back()->get_property() == two_sym_oper) )
			   {
				  if(tools.getSymbolPower(node->getName()) >= tools.getSymbolPower(stack.back()->getName()) )
				  {
					 hExpressionNode *temp = stack.back();
					 output.push_back(temp);
					 stack.pop_back() ;
				  }
				  else
					 break ;
			   }
			
			stack.push_back(node) ;
		 }
		 else if(status == left_par)
		 {
			stack.push_back(node) ;
			if(token.size() > 1 && token[token.size() - 2]->get_property() == func_or_matr)
			   is_function.push_back(0) ;
			
			string temp1 = arithmeticExpression.substr(i,1), temp2 = arithmeticExpression.substr(i,2);
			
			// In case there is a symbol after (
			if(arithmeticExpression[i] == '-' || arithmeticExpression[i] == '+')
			{
			   string temp = arithmeticExpression.substr(0, i) ;
			   temp += "0" ;
			   temp += arithmeticExpression.substr(i) ;
			   arithmeticExpression = temp ;
			}
			else if(tools.isSymbol(temp1) && temp1 != "!")// and others
			{
			   throw hException("hExpressionParser::setExpression", excep_expression[6]+" An expression cannot start with symbol "+ temp1, hInvalidExpression) ;
			}
			else if(tools.isSymbol(temp2))// and others
			{
			   throw hException("hExpressionParser::setExpression", excep_expression[6]+". An expression cannot start with symbol "+ temp2, hInvalidExpression) ;
			}
		 }
		 else if(status == right_par)
		 {
			 bool is_func = false ;
			if(!stack.empty())
			{
			   // It is initially set as a function. Now is set as variable.
				if(stack.back()->get_property() == func_or_matr)
			   {
				   stack.back()->set_property(variable) ;
				  
				  hExpressionNode *temp = stack.back();
				  output.push_back(temp);
				  stack.pop_back() ;
				  
				  arg_cnt.pop_back() ;
			   }
			   if(!were_values.empty())
			   {
				  were_values.pop_back();
				  were_values.push_back(true) ;
			   }
			   
			}
			else
			{
				throw hException("hExpressionParser::crossExpression", excep_expression[6] + ". Possibly unbalanced parenthesis", hInvalidExpression) ;
			}
			// For example 2*3+4*(2+5)
			bool in = false ;
			while(!stack.empty() && !(stack.back()->get_property() == left_par) )
			{
			   in = true ;
			   hExpressionNode *temp = stack.back();
			   output.push_back(temp);
			   stack.pop_back() ;
			   if(stack.empty())
			   {
				  throw hException("hExpressionParser::crossExpression", excep_expression[6] + ". Possibly unbalanced parenthesis", hInvalidExpression) ;
			   }
			}
			if(!stack.empty() && stack.back()->get_property() == left_par/* && !in*/)
			{
				stack.pop_back() ;
			}
			else
				throw hException("hExpressionParser::setExpression", excep_expression[6], hInvalidExpression) ;
			
			//if(stack.size() > 1)
				
			
			if(!stack.empty() && stack.back()->get_property() == func_or_matr)
			{
			   is_func = true ;
			   hExpressionNode *f = stack.back() ;
			   stack.pop_back() ;
			   int a = arg_cnt.back() ;
			   arg_cnt.pop_back() ;
			   bool w = were_values.back() ;
			   were_values.pop_back() ;
			   
			   if(w && tok_prev != "(")
			   {
				  a++ ;
			   }
			   f->set_arguments(a) ;
			   output.push_back(f) ;
			   is_function.pop_back();
			}
			if(!in && !is_func)
			{
				throw hException("hExpressionParser::crossExpression", excep_expression[6] + ". There is a pair of () forgotten", hInvalidExpression) ;
			}
		 }
		 else if(status == left_brack)
		 {
			
			//if(!stack.empty() && stack.back()->get_property() == 1)
			hExpressionNode *temp = token.back();
			if(!stack.empty() && token.size() > 1 && token[token.size() - 2]->get_property() == func_or_matr)
			{
			   stack.back()->set_property(matr) ;
			   stack.push_back(node) ;
			   
			   is_function.push_back(1) ;
			   
			   /*
			   if(!were_values.empty())mat[i]
			   {
				  were_values.pop_back();
				  were_values.push_back(true);
			   }
			   were_values.push_back(false);*/
			}
			else
			{
			   if(brackets.empty())
			   {
				  hExpressionNode *mat_node;
		          	  mat_node = new hExpressionNode;
		          	  mat_node->setName("mat:");
				  mat_node->set_property(9) ;
				  stack.push_back(mat_node) ;
				  matrix = '[' ;
				  is_function.push_back(2) ;
				  start_matrix = true ;
	
				  arg_cnt.push_back(0) ;
			
				  if(!were_values.empty())
				  {
					 were_values.pop_back();
					 were_values.push_back(true);
				  }
				  were_values.push_back(false);
			   }
			   stack.push_back(node) ;
			   //node->setNodeAsReady(false) ;
			   //brackets.push_back(node) ;
			}
			brackets.push_back(node) ;
			
			// In case there is a symbol after [
			string temp1 = arithmeticExpression.substr(i,1), temp2 = arithmeticExpression.substr(i,2);
			
			if(arithmeticExpression[i] == '-' || arithmeticExpression[i] == '+')
			{
			   string temp = arithmeticExpression.substr(0, i) ;
			   temp += "0" ;
			   temp += arithmeticExpression.substr(i) ;
			   arithmeticExpression = temp ;
			}
			else if(tools.isSymbol(temp1) && temp1 != "!")// and others
			{
			   throw hException("hExpressionParser::setExpression", excep_expression[6]+" An expression cannot start with symbol "+ temp1, hInvalidExpression) ;
			}
			else if(tools.isSymbol(temp2))// and others
			{
			   throw hException("hExpressionParser::setExpression", excep_expression[6]+". An expression cannot start with symbol "+ temp2, hInvalidExpression) ;
			}
		 }
		 else if(status == right_brack)
		 {
			
			
			brackets.pop_back();
			if(brackets.empty())
			{
			   start_matrix = false ;
			   stop_matrix = true ;
			}
			if(is_function.size() != 0 && is_function.back() == 1)
			{
			   while( !(stack.back()->get_property() == 10) )
			   {
				  if(stack.back()->get_property() == 1)
				  {
				  	stack.back()->set_property(8) ;
					//This is an addition. It was been added to check, if it can correct bug a[b].

					// It seems to work. For any other bugs please check.
					were_values.pop_back() ;
				  }
				  hExpressionNode *temp = stack.back();
				  output.push_back(temp);
				  stack.pop_back() ;
				  /*if(stack.empty())
				  {
					 //throw hException("hExpressionParser::crossExpression", excep_expression[6] + ". Possibly unbalanced brackets.\n", hInvalidExpression) ;
				  }*/
			   }
			   stack.pop_back() ;
			}
			else if(is_function.size() != 0 && is_function.back() == 2)
			{
			   while( !(stack.back()->get_property() == 10) )
			   {
				  hExpressionNode *temp = stack.back();
				  output.push_back(temp);
				  stack.pop_back() ;
				  if(stack.empty())
				  {
					 throw hException("hExpressionParser::crossExpression", excep_expression[6] + ". Possibly unbalanced brackets", hInvalidExpression) ;
				  }
			   }
			   stack.pop_back() ;
			}
			
			if(!stack.empty() && (stack.back()->get_property() == matr || stack.back()->get_property() == matr_to_create))
			{
			   hExpressionNode *f = stack.back() ;
			   stack.pop_back() ;
			   ///////////
			   // This an addition to fix bug a[0, b]. the logic is, that if you reach ], then the only case there is a 0 last element
			   // in arg_cnt is only when the previous token was a variable.
			   /*if(arg_cnt.back() == 0)
			   {
				   arg_cnt.pop_back() ;
			   }*/
			   ///////////
			   // ADDITION: to correct the fact that in every new variable the progarm pushes back 0 in arg_cnt, like in a, b, c
			   if(arg_cnt.size() > 1  && arg_cnt.back() == 0)
			   {
				   arg_cnt.pop_back() ;
			   }
			   int a = arg_cnt.back() ;
			   //arg_cnt.pop_back() ;
			   bool w = were_values.back() ;
			   were_values.pop_back() ;
		
			   if(w)
			   {
				  a++ ;
			   }
			   f->set_arguments(a) ;
			   if(f->get_property() == 9)
			   {
				  f->setName(matrix) ;
			   }
			   output.push_back(f) ;
			   is_function.pop_back() ;
			   // Added, because after some changes the a[b[0,0],0] didn't work
			   arg_cnt.pop_back() ;
			}
		 }
 		 tok_str = "" ;
		 
   		 /*cout<<"output"<<" : ";
		 for(j=0;j<output.size();j++)
			cout<<output[j]->getName()<<" ";
		 cout<<endl ;
		 cout<<"stack"<<" : ";
		 for(j=0;j<stack.size();j++)
			cout<<stack[j]->getName()<<" ";
		 cout<<endl ;
		 cout<<"wv"<<" : ";
		 for(j=0;j<were_values.size();j++)
			cout<<were_values[j]<<" ";
		 cout<<endl ;
		 cout<<"ac"<<" : ";
		 for(j=0;j<arg_cnt.size();j++)
			cout<<arg_cnt[j]<<" ";
		 cout<<endl<<endl ;
		 /*cout<<"br"<<" : ";
		 for(j=0;j<brackets.size();j++)
		    cout<<brackets[j]->getName()<<" ";
		 cout<<endl ;
		 cout<<"if"<<" : ";
		 for(j=0;j<is_function.size();j++)
		    cout<<is_function[j]<<" ";
		 cout<<endl ;
		 cout<<endl<<endl ;*/
	  }
	  else
	  {
		 if(start_matrix)
		 {
			matrix += arithmeticExpression[i] ;
		 }
		 else if(stop_matrix)
		 {
			stop_matrix = false ;
			start_matrix = false ;
			matrix = "" ;
		 }
		 
		 // We do that in order to prevent getting out of array when having char variables
		 if(arithmeticExpression[i] != '\0')
		 {
			i++ ;
			if(arithmeticExpression[i] == '\0')
			   end = 1 ;
		 }
		 else
			end = 1 ;
	  }
   }
   while( ! stack.empty() )
   {
	  if(stack.back()->get_property() == 6 || stack.back()->get_property() == 7 || stack.back()->get_property() == 10 || stack.back()->get_property() == 11 )
	  {
		 throw hException("hExpressionParser::crossExpression", excep_expression[6] + ". Possibly unbalanced parenthesis or bracket", hInvalidExpression) ;
	  }
	  else
	  {
		 hExpressionNode *temp = stack.back();
		 output.push_back(temp);
		 stack.pop_back() ;
	  }
   }
   if(!brackets.empty())
	  throw hException("hExpressionParser::crossExpression", excep_expression[6]+". Possibly misbalanced brackets", hInvalidExpression) ;
}



bool hExpressionParser::valid_dimensions(string mat, vector<unsigned int> dims)
{
	unsigned int N = dims.size() ;
	int cnt[N], i = 0;
	int bracks = 0 ;

	if(dims[0] == 1)
	{
		dims[0] = dims[1] ;
		dims.pop_back() ;
	}

	for(i = 0 ; i < N ; i++)
		cnt[i] = 0 ;

	i = 0 ;

	bool n = false ;
	
	while(mat[i] != '\0')
	{
		if(mat[i] == '[')
		{
			bracks++ ;
		}
		else if(mat[i] == ']')
		{
			if(mat[i - 1] != ']')
				cnt[N - bracks]++ ;
			if(cnt[N - bracks] != dims[bracks - 1])
			{
				throw hException("hExpressionParser::valid_dimensions", "Matrix cannot have these dimensions", hError);
			}
			cnt[N - bracks] = 0 ;
			bracks-- ;
			cnt[N - bracks]++ ;
		}
		else if(mat[i] == '(')
		{
			n = true ;
		}
		else if(mat[i] == ')')
		{
			n = false ;
		}
		else if(mat[i] == ',' && mat[i - 1] != ']' && !n)
		{
			cnt[N - bracks]++ ;
		}
		i++ ;
	}
}



int hExpressionParser::change_token(string tok)
{
   hTools tools ;
   if(tok == "") return -1 ;
   if(tok.size() == 0) return -1 ;
   
   string tok_1 = tok.substr(0, tok.length() - 1 );
   
   if(tok_1 == "") return -1 ;
   
   int st = tools.same_type(tok, tok_1) ;
   
   return st ;
}

// Εχουμε για παραδειγμα τον πινακα [[2, 3][4, 5]][[6, 7][8, 9]]. Θελουμε να βρουμε τις διαστασεις του πινακα
vector<unsigned int> hExpressionParser::findDimensions(string expression)
{
	//-----------------------------------------------------------------------------------------------------------
	// Δηλωση μεταβλητων
	unsigned int i, pointSt = 0, pointEnd=expression.length()-1, leftBracket=0, rightBracket=0, dimension = 0, commaPoint = expression.length() - 1;
	vector<unsigned int> dims;
	string initial = expression ;
	bool first=false, sec=false, out=false, un=true, n = false, vec_hor = true;

	hTools tools;
	
	i = 0;
	while(expression.find(',') != string::npos)
	{
		while(i < expression.length())
		{
			if(expression[i] == '[')
			{
				leftBracket++ ;
				if(i != 0 && !(expression[i - 1] == '[' || expression[i - 1] == ','))
				{
					throw hException("hExpressionParser::findDimensions", excep_expression[6], hInvalidExpression) ;
				}
			}
			if(expression[i] == ']')
			{
				rightBracket++ ;
				if(i != 0 && !(expression[i + 1] == ']' || expression[i + 1] == ',' || expression[i + 1] == '\0'))
				{
					throw hException("hExpressionParser::findDimensions", excep_expression[6], hInvalidExpression) ;
				}
			}
			if(expression[i] == '(')
			{
				n = true ;
			}
			if(expression[i] == ')')
			{
				n = false ;
			}
			if(leftBracket - rightBracket == 0 && expression[i] == ',')
			{ 
				if(expression[i] == ',' && !n)
				{
					if(dimension == 1)
					{
						if(expression[i - 1] == ']')
							commaPoint = i - 1 ;
						else
							commaPoint = i ;
					}
					dimension++ ;
				}
				else if(expression[i] == ',' && n)
				{
					expression[i] = '|';
				}
			}
			i++ ;
		}
		expression = expression.substr(1, commaPoint - 1) ;
		i = 0;
		if(dimension != 0)
		{
			dims.push_back(dimension) ;
		}
		dimension = 1 ;
		if(expression.find('[') != string::npos && vec_hor)
		{
			vec_hor = false ;
		}
	}
	// This can be better
	if(initial.substr(1).find('[') == string::npos)
	{
		if(!dims.empty())
		{
		 // unsigned int temp = dims[0] ;
	     //dims[0] = 1 ;
	     //dims.push_back(temp);
		}
		else
			dims.push_back(1);
	}
	if(initial.substr(1).find('[') != string::npos && initial.substr(1).find(',') == string::npos)
	{
	   throw hException("hExpressionParser:findDimensions", excep_expression[6] + ". Matrices are intialized like [[a, b], [c, d]]", hInvalidExpression) ;
	}
	if(dims.size() == 1 && !vec_hor)
	{
		dims.push_back(1);
	}
	return dims ;
}



hVariable hExpressionParser::makeOperation(string symbol, hVariable &first_operator, hVariable &second_operator)
{
	if(symbol==string("+"))
	{
		try
		{
			return first_operator+second_operator;
		}
		catch(hException &e)
		{
			throw hException("hExpressionParser::makeOperation ", excep_expression[9], hBadOperation);
		}
	}
	else if(symbol==string("-"))
	{
		try
		{
			return first_operator-second_operator;
		}
		catch(hException &e)
		{
			throw hException("hExpressionParser::makeOperation ", excep_expression[10], hBadOperation);
		}
		catch(std::exception &e2)
		{
			throw hException("hExpressionParser::makeOperation ", excep_expression[10], hBadOperation);
		}
	}
	else if(symbol==string("*"))
	{
		try
		{
			return first_operator*second_operator;
		}
		catch(hException &e)
		{
			throw hException("hExpressionParser::makeOperation ", excep_expression[11], hBadOperation);
		}
		catch(std::exception &e2)
		{
			throw hException("hExpressionParser::makeOperation ", excep_expression[11], hBadOperation);
		}
	}
	else if(symbol==string("/"))
	{
		try
		{
			//rint &error_codeeturn first_operator/second_operator;
		   return first_operator/second_operator;
		}
		catch(hException &e)
		{
			throw hException("hExpressionParser::makeOperation ", excep_expression[12], hBadOperation);
		}
		catch(std::exception &e2)
		{
			throw hException("hExpressionParser::makeOperation ", excep_expression[12], hBadOperation);
		}
	}
	else if(symbol==string("^"))
	{
		try
		{
			return first_operator^second_operator;
		}
		catch(hException &e)
		{
			throw hException("hExpressionParser::makeOperation ", excep_expression[13], hBadOperation);
		}
		catch(std::exception &e2)
		{
			throw hException("hExpressionParser::makeOperation ", excep_expression[13], hBadOperation);
		}
	}
	else if(symbol==string("<"))
	{
		try
		{
			return first_operator<second_operator;
		}
		catch(hException &e)
		{
			throw hException("hExpressionParser::makeOperation ", excep_expression[14], hBadOperation);
		}
		catch(std::exception &e2)
		{
			throw hException("hExpressionParser::makeOperation ", excep_expression[14], hBadOperation);
		}
	}
	else if(symbol==string(">"))
	{
		try
		{
			return first_operator>second_operator;
		}
		catch(hException &e)
		{
			throw hException("hExpressionParser::makeOperation ", excep_expression[15], hBadOperation);
		}
		catch(std::exception &e2)
		{
			throw hException("hExpressionParser::makeOperation ", excep_expression[15], hBadOperation);
		}
	}
	else if(symbol==string("%"))
	{
		try
		{
			return first_operator%second_operator;
		}
		catch(hException &e)
		{
			throw hException("hExpressionParser::makeOperation ", excep_expression[16], hBadOperation);
		}
		catch(std::exception &e2)
		{
			throw hException("hExpressionParser::makeOperation ", excep_expression[16], hBadOperation);
		}
	}
	else if(symbol==string("**"))
	{
		try
		{
			return first_operator * second_operator;
		}
		catch(hException &e)
		{
			throw hException("hExpressionParser::makeOperation ", excep_expression[17], hBadOperation);
		}
		catch(std::exception &e2)
		{
			throw hException("hExpressionParser::makeOperation ", excep_expression[17], hBadOperation);
		}
	}
	else if(symbol==string("++"))
	{
		try
		{
			return first_operator + 1;
		}
		catch(hException &e)
		{
			throw hException("hExpressionParser::makeOperation ", excep_expression[17], hBadOperation);
		}
		catch(std::exception &e2)
		{
			throw hException("hExpressionParser::makeOperation ", excep_expression[17], hBadOperation);
		}
	}
	else if(symbol==string("--"))
	{
		try
		{
			return first_operator - 1 ;
		}
		catch(hException &e)
		{
			throw hException("hExpressionParser::makeOperation ", excep_expression[17], hBadOperation);
		}
		catch(std::exception &e2)
		{
			throw hException("hExpressionParser::makeOperation ", excep_expression[17], hBadOperation);
		}
	}
	else if(symbol==string("<="))
	{
		try
		{
			return first_operator<=second_operator;
		}
		catch(hException &e)
		{
			throw hException("hExpressionParser::makeOperation ", excep_expression[17], hBadOperation);
		}
		catch(std::exception &e2)
		{
			throw hException("hExpressionParser::makeOperation ", excep_expression[17], hBadOperation);
		}
	}
	else if(symbol==string(">="))
	{
		try
		{
			return first_operator>=second_operator;
		}
		catch(hException &e)
		{
			throw hException("hExpressionParser::makeOperation ", excep_expression[18], hBadOperation);
		}
		catch(std::exception &e2)
		{
			throw hException("hExpressionParser::makeOperation ", excep_expression[18], hBadOperation);
		}
	}	
	else if(symbol==string("=="))
	{
		try
		{
			return first_operator==second_operator;
		}
		catch(hException &e)
		{
			throw hException("hExpressionParser::makeOperation ", excep_expression[19], hBadOperation);
		}
		catch(std::exception &e2)
		{
			throw hException("hExpressionParser::makeOperation ", excep_expression[19], hBadOperation);
		}
	}
	else if(symbol==string("!="))
	{
		try
		{
			return first_operator!=second_operator;
		}
		catch(hException &e)
		{
			throw hException("hExpressionParser::makeOperation ", excep_expression[20], hBadOperation);
		}
		catch(std::exception &e2)
		{
			throw hException("hExpressionParser::makeOperation ", excep_expression[20], hBadOperation);
		}
	}
	else if(symbol==string(".*"))
	{
		try
		{
			return first_operator*second_operator;
		}
		catch(hException &e)
		{
			throw hException("hExpressionParser::makeOperation ", excep_expression[21], hBadOperation);
		}
		catch(std::exception &e2)
		{
			throw hException("hExpressionParser::makeOperation ", excep_expression[21], hBadOperation);
		}
	}
	else if(symbol==string("./"))
	{
		try
		{
			return first_operator/second_operator;
		}
		catch(hException &e)
		{
			throw hException("hExpressionParser::makeOperation ", excep_expression[22], hBadOperation);
		}
		catch(std::exception &e2)
		{
			throw hException("hExpressionParser::makeOperation ", excep_expression[22], hBadOperation);
		}
	}
	else if(symbol==string(".^"))
	{
		try
		{
			//return first_operator/second_operator;
		}
		catch(hException &e)
		{
			throw hException("hExpressionParser::makeOperation ", excep_expression[23], hBadOperation);
		}
		catch(std::exception &e2)
		{
			throw hException("hExpressionParser::makeOperation ", excep_expression[23], hBadOperation);
		}
	}
	else if(symbol==string("&&"))
	{
		try
		{
			return first_operator&&second_operator;
		}
		catch(hException &e)
		{
			throw hException("hExpressionParser::makeOperation ", excep_expression[24], hBadOperation);
		}
		catch(std::exception &e2)
		{
			throw hException("hExpressionParser::makeOperation ", excep_expression[24], hBadOperation);
		}
	}
	else if(symbol==string("||"))
	{
		try
		{
			return first_operator||second_operator;
		}
		catch(hException &e)
		{
			throw hException("hExpressionParser::makeOperation ", excep_expression[25], hBadOperation);
		}
		catch(std::exception &e2)
		{
			throw hException("hExpressionParser::makeOperation ", excep_expression[25], hBadOperation);
		}
	}
	else if(symbol==string("&"))
	{
		try
		{
			return first_operator&second_operator;
		}
		catch(hException &e)
		{
			throw hException("hExpressionParser::makeOperation ", excep_expression[26], hBadOperation);
		}
		catch(std::exception &e2)
		{
			throw hException("hExpressionParser::makeOperation ", excep_expression[26], hBadOperation);
		}
	}
	else if(symbol==string("|"))
	{
		try
		{
			return first_operator/second_operator;
		}
		catch(hException &e)
		{
			throw hException("hExpressionParser::makeOperation ", excep_expression[27], hBadOperation);
		}
		catch(std::exception &e2)
		{
			throw hException("hExpressionParser::makeOperation ", excep_expression[27], hBadOperation);
		}
	}
	else if(symbol==string("!"))
	{
		try
		{
			return !first_operator;
		}
		catch(hException &e)
		{
			throw hException("hExpressionParser::makeOperation ", excep_expression[27], hBadOperation);
		}
		catch(std::exception &e2)
		{
			throw hException("hExpressionParser::makeOperation ", excep_expression[27], hBadOperation);
		}
	}
}

void hExpressionParser::findNumber(hExpressionNode *p)
{
	// Απο την στιγμη που καλειται αυτη η συναρτηση ενω ειμασταν στο crossGivenExpression, αρα σημαινει οτι 
	// ειναι αριθμος. Αρα αρχικα θετουμε τον κομβο p ως αριθμο.
		
	//---------------------------------------------------------------------------------------------------------
	// Δηλωση μεταβλητων
	string localExpression;
	hTools tools;
	int points;
	
	//---------------------------------------------------------------------------------------------------------
	// Παιρνουμε αρχικα το ονομα, το οποιο θα αναλυσουμε για να βγαλουμε ποιος αριθμος ειναι
	// Αρχικοποιουμε τις μεταβλητες
	localExpression=p->getName();
	//if(dimensions[u]->getType()==3 || dimensions[u]->getType()==5 || (dimensions[u]->getType()==4 && dimensions[u]>0) || (dimensions[u]->getType()==4 && dimensions[u]>0)) 
	points=localExpression.find('.');
	if(points!=string::npos)
	{
		if(points == localExpression.length()-1)
		{
		   throw hException("hExpressionParser::findNumber", "The arithmetic expression is invalid.\nPossibly a point after a number e.g. 3. It should be 3.0 if double wanted", hAlloc);
		}
		else if(points==0)
		{
			localExpression="0"+localExpression;
			p->setName(localExpression);
		}
		double numD;
		points=tools.numberContainsValidChars(localExpression);
		if(points==0)
		{
			throw hException("hExpressionParser::findNumber", "The arithmetic expression is not acceptable. Possible errors: \n1)A letter or other invalid character is right next to a number.\n2) A decimal is seperated with a ',' instead of '.'.", hAlloc);
		}
		from_string<double>(numD, localExpression, std::dec);
		p->setValue(numD);
	}
	else
	{
		signed long int numSLI;
		points=tools.numberContainsValidChars(localExpression);
		if(points==0)
		{
			throw hException("hExpressionParser::findNumber", "The arithmetic expression is not acceptable. Possible errors: \n1)A letter or other invalid character is right next to a number.\n2) A decimal is seperated with a ',' instead of '.'", hAlloc);
		}
		from_string<signed long int>(numSLI, localExpression, std::dec);
		p->setValue(numSLI);
	}
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////FOR SYNTAX CHECK/////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////////////////


hVariable hExpressionParser::calculate(hVariableTree *varRoot, hFunction functions, std::string &error, int &error_code)
{
	int i = 0, j = 0 ;
	std::deque<hVariable> result ;
	
	for(i = 0 ; i < output.size() ; i++)
	{
		if(output[i]->get_property() == 0 || output[i]->get_property() == 12)
		{
			hExpressionNode *temp= output[i];
			result.push_back(output[i]->getValue());
		}
		else if(output[i]->get_property() == 8)
		{
			hVariable a;
			result.push_back(a) ;
			continue ;
			//hVariable var ;

			/*if(varRoot->returnNode((char*)output[i]->getName().c_str())!=NULL)
			{				   
				var=(varRoot->returnNode((char*)output[i]->getName().c_str())->returnVar());
			}
			else
			{
				throw hException("hExpressionParser::calculate", excep_expression[2]+output[i]->getName() + excep_expression[3]+'\n', hVariableDoesNotExist);
			}*/
			//result.push_back(var);
		}
		else if(output[i]->get_property() == 4 || output[i]->get_property() == 5)
		{
			hVariable res ;
			if(output[i]->getName() == "!")
			{
				hVariable op1 = result.back() ;
				result.pop_back();
				hVariable op2 ;
				res = makeOperation("!", op1, op2) ;
				result.push_back(res) ;
			}
			else if(output[i]->getName() == "++")
			{
				hVariable op1, op2;
				if(!result.empty())
				{
					op2 = result.back() ;
					result.pop_back();
				}
				else
				{
					if(error.empty())
					{
						error =  excep_expression[6]+". Possibly mismatched operator" ;
						error_code = 5 ;
					}
					hVariable a ;
					return a ;
					//throw hException("hExpressionParser::calculate", excep_expression[6]+". Possibly mismatched operator. \n", hInvalidExpression) ;
				}
			 
				//res = makeOperation(output[i]->getName(), op2, op1) ;
				/*int j = i - 1 ;
				while(j >= 0)
				{
					if(output[j]->get_property() != 4 && output[j]->get_property() != 5)
						break ;
					else
						j-- ;
				}
				if(output[j]->get_property() == 8)
					varRoot->returnNode((char*)output[j]->getName().c_str())->setVariable(res);*/
				result.push_back(res) ;
			}
			else if(output[i]->getName() == "--")
			{
				hVariable op1, op2;
				if(!result.empty())
				{
					op2 = result.back() ;
					result.pop_back();
				}
				else
				{
					if(error.empty())
					{
						error =  excep_expression[6]+". Possibly mismatched operator" ;
						error_code = 5 ;
					}
					hVariable a ;
					return a ;
					//throw hException("hExpressionParser::calculate", excep_expression[6]+". Possibly mismatched operator. \n", hInvalidExpression) ;
				}
			 
				/*res = makeOperation(output[i]->getName(), op2, op1) ;
				int j = i - 1 ;
				while(j >= 0)
				{
					if(output[j]->get_property() != 4 && output[j]->get_property() != 5)
						break ;
					else
						j-- ;
				}
				if(output[j]->get_property() == 8)
					varRoot->returnNode((char*)output[j]->getName().c_str())->setVariable(res);*/
				result.push_back(res) ;
			}
			else
			{
				hVariable op1, op2;
				if(!result.empty())
				{
					result.pop_back();
				}
				else
				{
					if(error.empty())
					{
						error =  excep_expression[6]+". Possibly mismatched operator" ;
						error_code = 5 ;
					}
					hVariable a ;
					return a ;
					//throw hException("hExpressionParser::calculate", excep_expression[6]+". Possibly mismatched operator. \n", hInvalidExpression) ;
				}
			 
				if(!result.empty())
				{
					result.pop_back();
				}
				else
				{
					if(error.empty())
					{
						error =  excep_expression[6]+". Possibly mismatched operator" ;
						error_code = 5 ;
					}
					hVariable a ;
					return a ;
					//throw hException("hExpressionParser::calculate", excep_expression[6]+". Possibly mismatched operator. \n", hInvalidExpression) ;
				}
				//res = makeOperation(output[i]->getName(), op1, op2) ;
				result.push_back(res) ;
			}
		}
		else if(output[i]->get_property() == 1)
		{
			int arg_num = output[i]->get_arguments() , res_siz = result.size() ;
			/*hStructure ret, args;
			for(int k = arg_num ; k > 0 ; k--)
			{
			//cout<<result[res_siz - k]<<endl<<endl;
				args.push_back(result[res_siz - k]) ;
			}*/
		 
			for(int k = 0 ; k < arg_num ; k++)
				result.pop_back() ;
		 // Αυτο θα το κανω μονο οταν φτιαχτει το αντιστοιχο δεντρο. Θα ειναι παρομοιο με το απο πανω
		 	bool ck = false ;
			std::vector<std::string> toolbox = functions.getToolBoxNames() ;
			for(int t = 0 ; t < toolbox.size() ; t++)
			{
				std::vector<std::string> fun_tool = functions.getToolBoxFunctions(toolbox[t]) ;
				for(int r = 0 ; r < fun_tool.size() ; r++)
				{
					if(fun_tool[r] == output[i]->getName())
					{
						ck = true ;
					}
				}
			}
			
			if(!ck)
			{
				if(error.empty())
				{
					error =  excep_expression[6]+"There is no function "+output[i]->getName() ;
					error_code = 6 ;
				}
				hVariable a ;
				return a ;
			}
			
			//ret = functions.execute(output[i]->getName(), args);
			hVariable a ;
			result.push_back(a) ;
		}
		else if(output[i]->get_property() == 9)
		{
			unsigned int k;
		 
			vector<unsigned int> dims ;
			int aa, bb, cc;
// 			try
// 			{
				dims = findDimensions(output[i]->getName(), error, error_code) ;
				if(!error.empty())
				{
					hVariable a;
					return a;
				}
				aa=dims[0]; bb=dims[1] ; cc=dims.size() ;
			/*}
			catch(hException &e)
			{
				hException *e1 ;
				e1 = new hException("hExpressionParser::calculate", excep_expression[6] + '\n', hInvalidExpression) ;
				e.setException(e1) ;
				throw e ;
			}*/
// 			try
// 			{
				valid_dimensions(output[i]->getName(), dims, error, error_code) ;
				if(!error.empty())
				{
					hVariable a;
					return a;
				}
// 			}
// 			catch(hException &e)
// 			{
// 				hException *e1 ;
// 				e1 = new hException("hExpressionParser::calculate", "Matrix cannot have these dimensions", hInvalidExpression) ;
// 				e.setException(e1) ;
// 				throw e ;
// 			}
		 
			unsigned int num = 1, res_siz = result.size();
		  
			bool d = false ;

			for(k=0;k<dims.size();k++)
			{
				num *= dims[k] ;
			}
		  
			for(int k = 0 ; k < num ; k++)
			{
				if(result[res_siz - k - 1].getType() == 7 || result[res_siz - k - 1].getType() == 8 || result[res_siz - k - 1].getType() == 9) d = true ;
			}
		  
			if(d)
			{
// 				double *data;
// 				try
// 				{
// 					data=new double[num];
// 				}
// 				catch(std::exception &e)
// 				{
// 					throw hException("hExpressionParser::calculate", "Cannot allocate memory", hAlloc);
// 				}
// 				for(int k = num ; k > 0 ; k--)
// 					result[res_siz-k].getValue(data[num-k]);
				for(int k=0 ; k < num ; k++)
					result.pop_back();
// 				try
// 				{
					hVariable a ;
					result.push_back(a) ;
// 				}
// 				catch(hException &e )
// 				{
// 					delete[] data;
// 					throw hException("hExpressionParser::calculate", "Cannot initialize hVariable variable.\n", hAlloc);
// 				}
// 				delete[] data;
			}
			else
			{
// 				signed long int *data;
// 				try
// 				{
// 					data=new signed long int[num];
// 				}
// 				catch(std::exception &e)
// 				{
// 					throw hException("hExpressionParser::calculate", "Cannot allocate memory.\n", hAlloc);
// 				}
// 				for(int k = num ; k > 0 ; k--)
// 					result[res_siz - k].getValue(data[num - k]);
				for(int k=0 ; k < num ; k++)
					result.pop_back();
// 				try
// 				{
					hVariable a ;
					result.push_back(a) ;
// 				}
// 				catch(hException &e)
// 				{
// 					delete[] data;
// 					throw hException("hExpressionParser::calculate", "Cannot initialise hVariable variable.\n", hAlloc);
// 				}
// 				delete[] data;
			}
		}
	   // Mode 2 = matrix
		else if(output[i]->get_property() == 2)
		{
			hVariable a;
			result.push_back(a);
			continue ;
			/*hVariable var ;
			if(varRoot->returnNode((char*)output[i]->getName().c_str())!=NULL)
			{
				var=varRoot->returnNode((char*)output[i]->getName().c_str())->returnVar();
			}
			else 
			{
				throw hException("hExpressionParser::calculate", excep_expression[2]+output[i]->getName() + excep_expression[3], hVariableDoesNotExist);
			}
		 
			int res_siz = result.size() ;
			unsigned int k, dims=output[i]->get_arguments();
			std::vector<unsigned int> index2,index;
//		index2.push_back(0);
//		index2.push_back(0);
//		index.push_back(0);
//		index.push_back(0);
			unsigned long temp;
			if(dims==1)
			{
				std::vector<unsigned int> dm = var.getSize() ;
				if(dims == var.getDim())
				{
			result.push_back(var.getValue(index));		index.push_back(result.back().getValue(temp));
				}
				else
				{
					throw hException("hExpressionParser::calculate", "Wrong dimensions.", hError) ;
				}

/*		   if(dm[0] == 1 && dm[1] != 1)
				{
				index.push_back(result.back().getValue(temp));
			}
				else if(dm[0] != 1 && dm[1] == 1)
				{
//			  index[0]=result.back().getValue(index2,temp));
				index.push_back(result.back().getValue(index2,temp));
//			  index[1] = 0 ;
			}
				else
				{
//		       index[0] = 0 ;
				index.push_back(0);
				index.push_back(result.back().getValue(index2,temp));
			}*/
			/*	result.pop_back();
			}	
			else
			{
				for(int k = dims ; k > 0 ; k--)
					index.push_back(result[res_siz - k].getValue(temp));
				for(int k=0 ; k < dims ; k++)
					result.pop_back();
			}
			try
			{
				result.push_back(var.getValue(index));
			}
			catch(hException &e)
			{
				hException *e1;
				e1 = new hException("hExpressionParser::calculate", "Matrix out of bounds", hMatrixOutOfBounds) ;
				e.setException(e1) ;
				throw e ;
			}*/
		}
	}
	if(!result.empty())
		return result[0];
	else
	{
		hVariable a;  
		return a;
	}
}



void hExpressionParser::crossExpression(std::string &error, int &error_code)
{
	//---------------------------------------------------------------------------------------------------------
	// Variable declaration
	int i = 0, j = 0, status;
	string tok_str, tok, matrix ;
	hTools tools;
	int end = 0, comma = 0;
   
	bool start_matrix = false, stop_matrix = false ;

	while(end < 2)
	{
		if(end == 1) end = 2 ;
	  
		if(!tools.is_valid_char(arithmeticExpression[i]))
		{
			//throw hException("hExpressionParser::crossExpression", excep_expression[6]+". Possibly invalid character", hInvalidExpression) ;
			if(error.empty())
			{
				error = excep_expression[6]+". Possibly invalid character" ;
				error_code = 1 ;
			}
			else
			{
				return ;
			}
		}
		tok_str += arithmeticExpression[i] ;
	  
		if(tok_str == "][" || tok_str == "[]" || tok_str == "(," || tok_str == ",(" || tok_str == ",)" /*|| tok_str == "),"*/ || tok_str == "[," || tok_str == ",]")
		{
			//throw hException("hExpressionParser::crossExpression", excep_expression[6], hInvalidExpression) ;
			if(error.empty())
			{
				error = excep_expression[6];
				error_code = 1 ;
			}
			return ;
		}
	  
		status = change_token(tok_str, error, error_code) ;
		if(!error.empty())
			return ;
		if(tok_str[0] == '=' && tok_str[1] != '=' )
		{
			//	throw hException("hExpressionParser::crossExpression", excep_expression[6], hInvalidExpression) ;
			if(error.empty())
			{
				error = excep_expression[6];
			}
			return ;
		}

	  // 34 is in ASCII code the "
	  // this code finds char variables
		if(tok_str[0] == 34)
		{
		 //tok = "\"" ;
			tok="";
			i++ ;
			while(arithmeticExpression[i] != 34)
			{
				tok += arithmeticExpression[i] ;
				i++ ;
				//if(i == arithmeticExpression.length()) throw hException("hExpressionParser::crossExpression", excep_expression[6]+". Misbalanced \" ", hInvalidExpression) ;
				if(error.empty())
				{
					error = excep_expression[6]+". Misbalanced \" ";
					error_code = 3 ;
				}
				return ;
			}
		 //tok += arithmeticExpression[i] ;
			i++;
			status = 12 ;
		}
	  
		if(status != -1)
		{
			if(status == 4)
			{
				tok = tok_str.substr(0, tok_str.length());
				i++;
			}
			else
			{
				if(status != 12)
					tok = tok_str.substr(0, tok_str.length() - 1);
			}
		 
			hExpressionNode *node;
			node = new hExpressionNode;
			node->setName(tok);
			node->set_property(status) ;
		 
			token.push_back(node) ;

			if(status == 0)
			{
				//try
				//{
				findNumber(node, error, error_code) ;
				if(!error.empty())
					return ;
				//}
				/*catch(hException &e)
				{
				hException *t ;
				t = new hException("hExpressionParser::crossExpression", "Error during finding number", hInvalidExpression) ;
				e.setException(t) ;
				throw e ;
			}*/
				output.push_back(node) ;
			
				if(!were_values.empty())
				{
					were_values.pop_back();
					were_values.push_back(true) ;
				}
			}
			else if(status == 12)
			{
			//Expression is a char vector enclosed in `"'
			// A char variable is treated like a number during algorithm

				std::vector<signed char> var ;
			
				signed char* ch ;
			
				ch = (signed char*)node->getName().c_str() ;

				for(int k = 0 ; k < node->getName().length() ; k++)
				{
					var.push_back(ch[k]) ;
				}
			
				node->setValue(var);
			
				output.push_back(node) ;
			
				if(!were_values.empty())
				{
					were_values.pop_back();
					were_values.push_back(true) ;
				}
			}
			else if(status == 1)
			{
			// In that case, we have an expression like 1+a
				if(end == 2)
				{
					node->set_property(8) ;
					stack.push_back(node) ;
			   
			   // I dont know if this is right.
					if(!were_values.empty())
					{
						were_values.pop_back();
						were_values.push_back(true) ;
					}
			   
					if(!arg_cnt.empty())
						arg_cnt.pop_back() ;
					continue ;
				}
				stack.push_back(node) ;

			// This is an addition for a[0,b]
			/*if(!arg_cnt.empty())
				{
				int a = arg_cnt.back() ;
				arg_cnt.pop_back() ;
				a++ ;
				arg_cnt.push_back(a) ;
			}
				else
				{*/
				arg_cnt.push_back(0) ;
			//}
			
				if(!were_values.empty())
				{
					were_values.pop_back();
					were_values.push_back(true);
				}
				were_values.push_back(false);
			}
			else if(status == 3)
			{
				if(!stack.empty())
				{
			   // It is initially set as a function. Now is set as variable.
					if(stack.back()->get_property() == 1)
					{
						stack.back()->set_property(8) ;
				  
						hExpressionNode *temp = stack.back();
						output.push_back(temp);
						stack.pop_back() ;
					}
			   
					if(!were_values.empty())
					{
						were_values.pop_back();
						were_values.push_back(true) ;
					}
				}
				if(is_function.size() != 0 && is_function.back() == 0)
				{
					while(stack.back()->get_property() != 6)
					{
						hExpressionNode *temp = stack.back();
						output.push_back(temp);
						stack.pop_back() ;
						if( stack.empty() )
						{
							//throw hException("hExpressionParser::crossExpression", excep_expression[6] + "Possibly mismatched parenthesis or comma", hInvalidExpression) ;
							if(error.empty())
							{
								error = excep_expression[6]+"Possibly mismatched parenthesis or comma";
								error_code = 3 ;
							}
							return ;
						}
					}

			   // ADDITION: to correct the fact that in every new variable the progarm pushes back 0 in arg_cnt, like in a, b, c
					if(arg_cnt.size() > 1  && arg_cnt.back() == 0)
					{
						arg_cnt.pop_back() ;
					}
			   
					bool w = were_values.back();
					were_values.pop_back() ;
					if(w)
					{
						int a = arg_cnt.back() ;
						arg_cnt.pop_back() ;
						a++ ;
						arg_cnt.push_back(a) ;
					}
					were_values.push_back(false) ;
				}
				else if(is_function.size() != 0 && (is_function.back() == 1 || is_function.back() == 2))
				{
					while(stack.size() != 0 && stack.back()->get_property() != 10)
					{
						hExpressionNode *temp = stack.back();
						output.push_back(temp);
						stack.pop_back() ;
					}
			   // ADDITION: to correct the fact that in every new variable the progarm pushes back 0 in arg_cnt, like in a, b, c
					if(arg_cnt.size() > 1  && arg_cnt.back() == 0)
					{
						arg_cnt.pop_back() ;
					}
			   
					bool w = were_values.back();
					were_values.pop_back() ;
					if(w)
					{
						int a = arg_cnt.back() ;
						arg_cnt.pop_back() ;
						a++ ;
						arg_cnt.push_back(a) ;
					}
					were_values.push_back(false) ;
				}
				else if(is_function.size() == 0)
				{
					//throw hException("hExpressionParser::crossExpression", excep_expression[6] + ". Possibly misplaced comma separator", hInvalidExpression) ;
					if(error.empty())
					{
						error = excep_expression[6]+ ". Possibly misplaced comma separator";
						error_code = 5 ;
					}
					return ;
				}
			/*
				else if(stack.back()->get_property() == 9)
				{
				hExpressionNode *t=brackets.back();
				if(!brackets.back()->getNodeIfReady())
				{
				int comma = matr_dims.back() ;
				matr_dims.pop_back() ;
				comma++;
				matr_dims.push_back(comma) ;
			}
			}*/
			
				string temp1 = arithmeticExpression.substr(i,1), temp2 = arithmeticExpression.substr(i,2);
			
			// In case there is a symbol after ,
				if(arithmeticExpression[i] == '-' || arithmeticExpression[i] == '+')
				{
					string temp = arithmeticExpression.substr(0, i) ;
					temp += "0" ;
					temp += arithmeticExpression.substr(i) ;
					arithmeticExpression = temp ;
				}
				else if(tools.isSymbol(temp1) && temp1 != "!")// and others
				{
					//throw hException("hExpressionParser::setExpression", excep_expression[6]+" An expression cannot start with symbol "+ temp1, hInvalidExpression) ;
					if(error.empty())
					{
						error = excep_expression[6]+" An expression cannot start with symbol "+ temp1;
						error_code = 4 ;
					}
					return ;
				}
				/////////////////////////////////////////////////////////////////////////////////////////////////////////
				////////////////////////////////////////////FOR SYNTAX CHECK/////////////////////////////////////////////
				/////////////////////////////////////////////////////////////////////////////////////////////////////////
				else if(tools.isSymbol(temp2))// and others
				{
					//throw hException("hExpressionParser::setExpression", excep_expression[6]+". An expression cannot start with symbol "+ temp2, hInvalidExpression) ;
					if(error.empty())
					{
						error = excep_expression[6]+". An expression cannot start with symbol "+ temp2;
						error_code = 4 ;
					}
					return ;
				}
			}
			else if(status == 4 || status == 5)
			{
				if(!stack.empty())
				{
			   // It is initially set as a function. Now is set as variable.
					if(stack.back()->get_property() == 1)
					{
						stack.back()->set_property(8) ;
				  
						hExpressionNode *temp = stack.back();
						output.push_back(temp);
						stack.pop_back() ;
					}
				}
			
			   //hExpressionNode *temp=stack.back();
				while(!stack.empty() && (stack.back()->get_property() == 4 || stack.back()->get_property() == 5) )
				{
					if(tools.getSymbolPower(node->getName()) >= tools.getSymbolPower(stack.back()->getName()) )
					{
						hExpressionNode *temp = stack.back();
						output.push_back(temp);
						stack.pop_back() ;
					}
					else
						break ;
				}
			
				stack.push_back(node) ;
			}
			else if(status == 6)
			{
				stack.push_back(node) ;
				if(token.size() > 1 && token[token.size() - 2]->get_property() == 1)
					is_function.push_back(0) ;
			
				string temp1 = arithmeticExpression.substr(i,1), temp2 = arithmeticExpression.substr(i,2);
			
			// In case there is a symbol after (
				if(arithmeticExpression[i] == '-' || arithmeticExpression[i] == '+')
				{
					string temp = arithmeticExpression.substr(0, i) ;
					temp += "0" ;
					temp += arithmeticExpression.substr(i) ;
					arithmeticExpression = temp ;
				}
				else if(tools.isSymbol(temp1) && temp1 != "!")// and others
				{
					//throw hException("hExpressionParser::setExpression", excep_expression[6]+" An expression cannot start with symbol "+ temp1, hInvalidExpression) ;
					if(error.empty())
					{
						error = excep_expression[6]+" An expression cannot start with symbol "+ temp1;
						error_code = 4 ;
					}
					return ;
				}
				else if(tools.isSymbol(temp2))// and others
				{
					//throw hException("hExpressionParser::setExpression", excep_expression[6]+". An expression cannot start with symbol "+ temp2, hInvalidExpression) ;
					if(error.empty())
					{
						error = excep_expression[6]+". An expression cannot start with symbol "+ temp2;
						error_code = 4 ;
					}
					return ;
				}
			}
			else if(status == 7)
			{
				if(!stack.empty())
				{
			   // It is initially set as a function. Now is set as variable.
					if(stack.back()->get_property() == 1)
					{
						stack.back()->set_property(8) ;
				  
						hExpressionNode *temp = stack.back();
						output.push_back(temp);
						stack.pop_back() ;
				  
						arg_cnt.pop_back() ;
					}
			   
					if(!were_values.empty())
					{
						were_values.pop_back();
						were_values.push_back(true) ;
					}
				}
				else
				{
					//throw hException("hExpressionParser::crossExpression", excep_expression[6] + ". Possibly unbalanced parenthesis", hInvalidExpression) ;
					if(error.empty())
					{
						error = excep_expression[6]+ ". Possibly unbalanced parenthesis";
						error_code = 3 ;
					}
					return ;
				}
			// For example 2*3+4*(2+5)
				bool in = false ;
				while(!stack.empty() && !(stack.back()->get_property() == 6) )
				{
					in = true ;
					hExpressionNode *temp = stack.back();
					output.push_back(temp);
					stack.pop_back() ;
					if(stack.empty())
					{
						//throw hException("hExpressionParser::crossExpression", excep_expression[6] + ". Possibly unbalanced parenthesis", hInvalidExpression) ;
						if(error.empty())
						{
							error = excep_expression[6]+ ". Possibly unbalanced parenthesis";
							error_code = 3 ;
						}
						return ;
					}
				}
				if(stack.back()->get_property() == 6/* && !in*/)
				{
					stack.pop_back() ;
				/*if(!in)
					{
					were_values.pop_back();
					were_values.push_back(false) ;
					//stack.back()
				}*/
				}
				else
				{	
					//throw hException("hExpressionParser::setExpression", excep_expression[6], hInvalidExpression) ;
					if(error.empty())
					{
						error = excep_expression[6];
					}
					return ;
				}
				
			
				if(!stack.empty() && stack.back()->get_property() == 1)
				{
					hExpressionNode *f = stack.back() ;
					stack.pop_back() ;
					int a = arg_cnt.back() ;
					arg_cnt.pop_back() ;
					bool w = were_values.back() ;
					were_values.pop_back() ;
			   
					if(w)
					{
						a++ ;
					}
					f->set_arguments(a) ;
					output.push_back(f) ;
					is_function.pop_back();
				}
			}
			else if(status == 10)
			{
			
			//if(!stack.empty() && stack.back()->get_property() == 1)
				hExpressionNode *temp = token.back();
				if(token.size() > 1 && token[token.size() - 2]->get_property() == 1)
				{
					stack.back()->set_property(2) ;
					stack.push_back(node) ;
			   
					is_function.push_back(1) ;
			   
			   /*
					if(!were_values.empty())mat[i]
					{
					were_values.pop_back();
					were_values.push_back(true);
				}
					were_values.push_back(false);*/
				}
				else
				{/////////////////////////////////////////////////////////////////////////////////////////////////////////
					////////////////////////////////////////////FOR SYNTAX CHECK/////////////////////////////////////////////
					/////////////////////////////////////////////////////////////////////////////////////////////////////////

					if(brackets.empty())
					{
						hExpressionNode *mat_node;
						mat_node = new hExpressionNode;
						mat_node->setName("mat:");
						mat_node->set_property(9) ;
						stack.push_back(mat_node) ;
						matrix = '[' ;
						is_function.push_back(2) ;
						start_matrix = true ;
	
						arg_cnt.push_back(0) ;
			
						if(!were_values.empty())
						{
							were_values.pop_back();
							were_values.push_back(true);
						}
						were_values.push_back(false);
					}
					stack.push_back(node) ;
			   //node->setNodeAsReady(false) ;
			   //brackets.push_back(node) ;
				}
				brackets.push_back(node) ;
			
			// In case there is a symbol after [
				string temp1 = arithmeticExpression.substr(i,1), temp2 = arithmeticExpression.substr(i,2);
			
				if(arithmeticExpression[i] == '-' || arithmeticExpression[i] == '+')
				{
					string temp = arithmeticExpression.substr(0, i) ;
					temp += "0" ;
					temp += arithmeticExpression.substr(i) ;
					arithmeticExpression = temp ;
				}
				else if(tools.isSymbol(temp1) && temp1 != "!")// and others
				{
					//throw hException("hExpressionParser::setExpression", excep_expression[6]+" An expression cannot start with symbol "+ temp1, hInvalidExpression) ;
					if(error.empty())
					{
						error = excep_expression[6]+" An expression cannot start with symbol "+ temp1;
						error_code = 4 ;
					}
					return ;
				}
				else if(tools.isSymbol(temp2))// and others
				{
					//throw hException("hExpressionParser::setExpression", excep_expression[6]+". An expression cannot start with symbol "+ temp2, hInvalidExpression) ;
					if(error.empty())
					{
						error = excep_expression[6]+". An expression cannot start with symbol "+ temp2;
						error_code = 4 ;
					}
					return ;
				}
			}
			else if(status == 11)
			{
			
			
				brackets.pop_back();
				if(brackets.empty())
				{
					start_matrix = false ;
					stop_matrix = true ;
				}
				if(is_function.size() != 0 && is_function.back() == 1)
				{
					while( !(stack.back()->get_property() == 10) )
					{
						if(stack.back()->get_property() == 1)
						{
							stack.back()->set_property(8) ;
					//This is an addition. It was been added to check, if it can correct bug a[b].

					// It seems to work. For any other bugs please check.
							were_values.pop_back() ;
						}
						hExpressionNode *temp = stack.back();
						output.push_back(temp);
						stack.pop_back() ;
				  /*if(stack.empty())
						{
					 //throw hException("hExpressionParser::crossExpression", excep_expression[6] + ". Possibly unbalanced brackets.\n", hInvalidExpression) ;
					}*/
					}
					stack.pop_back() ;
				}
				else if(is_function.size() != 0 && is_function.back() == 2)
				{
					while( !(stack.back()->get_property() == 10) )
					{
						hExpressionNode *temp = stack.back();
						output.push_back(temp);
						stack.pop_back() ;
						if(stack.empty())
						{
							//throw hException("hExpressionParser::crossExpression", excep_expression[6] + ". Possibly unbalanced brackets", hInvalidExpression) ;
							if(error.empty())
							{
								error = excep_expression[6] + ". Possibly unbalanced brackets";
								error_code = 3 ;
							}
							return ;
						}
					}
					stack.pop_back() ;
				}
			
				if(!stack.empty() && (stack.back()->get_property() == 2 || stack.back()->get_property() == 9))
				{
					hExpressionNode *f = stack.back() ;
					stack.pop_back() ;
					///////////
			   // This an addition to fix bug a[0, b]. the logic is, that if you reach ], then the only case there is a 0 last element
			   // in arg_cnt is only when the previous token was a variable.
			   /*if(arg_cnt.back() == 0)
					{
					arg_cnt.pop_back() ;
				}*/
					///////////
			   // ADDITION: to correct the fact that in every new variable the progarm pushes back 0 in arg_cnt, like in a, b, c
					if(arg_cnt.size() > 1  && arg_cnt.back() == 0)
					{
						arg_cnt.pop_back() ;
					}
					int a = arg_cnt.back() ;
					arg_cnt.pop_back() ;
					bool w = were_values.back() ;
					were_values.pop_back() ;
		
					if(w)
					{
						a++ ;
					}
					f->set_arguments(a) ;
					if(f->get_property() == 9)
					{
						f->setName(matrix) ;
					}
					output.push_back(f) ;
					is_function.pop_back() ;
				}
			}
			tok_str = "" ;
		 
   		 /*cout<<"output"<<" : ";
			for(j=0;j<output.size();j++)
			cout<<output[j]->getName()<<" ";
			cout<<endl ;
			cout<<"stack"<<" : ";
			for(j=0;j<stack.size();j++)
			cout<<stack[j]->getName()<<" ";
			cout<<endl ;
			cout<<"wv"<<" : ";
			for(j=0;j<were_values.size();j++)
			cout<<were_values[j]<<" ";
			cout<<endl ;
			cout<<"ac"<<" : ";
			for(j=0;j<arg_cnt.size();j++)
			cout<<arg_cnt[j]<<" ";
			cout<<endl<<endl ;
		 /*cout<<"br"<<" : ";
			for(j=0;j<brackets.size();j++)
			cout<<brackets[j]->getName()<<" ";
			cout<<endl ;
			cout<<"if"<<" : ";
			for(j=0;j<is_function.size();j++)
			cout<<is_function[j]<<" ";
			cout<<endl ;
			cout<<endl<<endl ;*/
		}
		else
		{
			if(start_matrix)
			{
				matrix += arithmeticExpression[i] ;
			}
			else if(stop_matrix)
			{
				stop_matrix = false ;
				start_matrix = false ;
				matrix = "" ;
			}
		 
		 // We do that in order to prevent getting out of array when having char variables
			if(arithmeticExpression[i] != '\0')
			{
				i++ ;
				if(arithmeticExpression[i] == '\0')
					end = 1 ;
			}
			else
				end = 1 ;
		}
	}
   
	while( ! stack.empty() )
	{
		if(stack.back()->get_property() == 6 || stack.back()->get_property() == 7 || stack.back()->get_property() == 10 || stack.back()->get_property() == 11 )
		{
			//throw hException("hExpressionParser::crossExpression", excep_expression[6] + ". Possibly unbalanced parenthesis or bracket", hInvalidExpression) ;
			if(error.empty())
			{
				error = excep_expression[6] + ". Possibly unbalanced parenthesis or bracket";
				error_code = 3 ;
			}
			return ;
		}
		else
		{
			hExpressionNode *temp = stack.back();
			output.push_back(temp);
			stack.pop_back() ;
		}
	}
	if(!brackets.empty())
	{
		//throw hException("hExpressionParser::crossExpression", excep_expression[6]+". Possibly misbalanced brackets", hInvalidExpression) ;
		if(error.empty())
		{
			error = excep_expression[6]+". Possibly misbalanced brackets";
			error_code = 3 ;
		}
		return ;
	}
}


bool hExpressionParser::valid_dimensions(string mat, vector<unsigned int> dims, std::string &error, int &error_code)
{
	unsigned int N = dims.size() ;
	int cnt[N], i = 0;
	int bracks = 0 ;

	if(dims[0] == 1)
	{
		dims[0] = dims[1] ;
		dims.pop_back() ;
	}

	for(i = 0 ; i < N ; i++)
		cnt[i] = 0 ;

	i = 0 ;

	bool n = false ;
	
	while(mat[i] != '\0')
	{
		if(mat[i] == '[')
		{
			bracks++ ;
		}
		else if(mat[i] == ']')
		{
			if(mat[i - 1] != ']')
				cnt[N - bracks]++ ;
			if(cnt[N - bracks] != dims[bracks - 1])
			{
				//throw hException("hExpressionParser::valid_dimensions", "Matrix cannot have these dimensions", hError);
				if(error.empty())
				{
					error = "Matrix cannot have these dimensions";
					error_code = 2 ;
				}
				return false ;
			}
			cnt[N - bracks] = 0 ;
			bracks-- ;
			cnt[N - bracks]++ ;
		}
		else if(mat[i] == '(')
		{
			n = true ;
		}
		else if(mat[i] == ')')
		{
			n = false ;
		}
		else if(mat[i] == ',' && mat[i - 1] != ']' && !n)
		{
			cnt[N - bracks]++ ;
		}
		i++ ;
	}
}


// Εχουμε για παραδειγμα τον πινακα [[2, 3][4, 5]][[6, 7][8, 9]]. Θελουμε να βρουμε τις διαστασεις του πινακα
vector<unsigned int> hExpressionParser::findDimensions(string expression, std::string &error, int &error_code)
{
	//------------------/////////////////////////////////////////////////////////////////////////////////////////////////////////
	////////////////////////////////////////////FOR SYNTAX CHECK/////////////////////////////////////////////
	/////////////////////////////////////////////////////////////////////////////////////////////////////////
	// Δηλωση μεταβλητων
	unsigned int i, pointSt = 0, pointEnd=expression.length()-1, leftBracket=0, rightBracket=0, dimension = 0, commaPoint = expression.length() - 1;
	vector<unsigned int> dims;
	string initial = expression ;
	bool first=false, sec=false, out=false, un=true, n = false, vec_hor = true;

	hTools tools;
	
	i = 0;
	while(expression.find(',') != string::npos)
	{
		while(i < expression.length())
		{
			if(expression[i] == '[')
			{
				leftBracket++ ;
				if(i != 0 && !(expression[i - 1] == '[' || expression[i - 1] == ','))
				{
				//throw hException("hExpressionParser::findDimensions", excep_expression[6], hInvalidExpression) ;
					if(error.empty())
					{
						error = excep_expression[6];
					}
					return dims ;
				}
			}
			if(expression[i] == ']')
			{
				rightBracket++ ;
				if(i != 0 && !(expression[i + 1] == ']' || expression[i + 1] == ',' || expression[i + 1] == '\0'))
				{
				//throw hException("hExpressionParser::findDimensions", excep_expression[6], hInvalidExpression) ;
					if(error.empty())
					{
						error = excep_expression[6];
					}
					return dims ;
				}
			}
			if(expression[i] == '(')
			{
				n = true ;
			}
			if(expression[i] == ')')
			{
				n = false ;
			}
			if(leftBracket - rightBracket == 0 && expression[i] == ',')
			{ 
				if(expression[i] == ',' && !n)
				{
					if(dimension == 1)
					{
						if(expression[i - 1] == ']')
							commaPoint = i - 1 ;
						else
							commaPoint = i ;
					}
					dimension++ ;
				}
				else if(expression[i] == ',' && n)
				{
					expression[i] = '|';
				}
			}
			i++ ;
		}
		expression = expression.substr(1, commaPoint - 1) ;
		i = 0;
		if(dimension != 0)
		{
			dims.push_back(dimension) ;
		}
		dimension = 1 ;
		if(expression.find('[') != string::npos && vec_hor)
		{
			vec_hor = false ;
		}
	}
	// This can be better
	if(initial.substr(1).find('[') == string::npos)
	{
		if(!dims.empty())
		{
		 // unsigned int temp = dims[0] ;
	     //dims[0] = 1 ;
	     //dims.push_back(temp);
		}
		else
			dims.push_back(1);
	}
	if(initial.substr(1).find('[') != string::npos && initial.substr(1).find(',') == string::npos)
	{
	   //throw hException("hExpressionParser:findDimensions", excep_expression[6] + ". Matrices are intialized like [[a, b], [c, d]]", hInvalidExpression) ;
		if(error.empty())
		{
			error = excep_expression[6] + ". Matrices are intialized like [[a, b], [c, d]]";
			error_code = 2 ;
		}
		return dims ;
	}
	if(dims.size() == 1 && !vec_hor)
	{
		dims.push_back(1);
	}
	return dims ;
}



void hExpressionParser::findNumber(hExpressionNode *p, std::string &error, int &error_code)
{
	// Απο την στιγμη που καλειται αυτη η συναρτηση ενω ειμασταν στο crossGivenExpression, αρα σημαινει οτι 
	// ειναι αριθμος. Αρα αρχικα θετουμε τον κομβο p ως αριθμο.
		
	//---------------------------------------------------------------------------------------------------------
	// Δηλωση μεταβλητων
	string localExpression;
	hTools tools;
	int points;
	
	//---------------------------------------------------------------------------------------------------------
	// Παιρνουμε αρχικα το ονομα, το οποιο θα αναλυσουμε για να βγαλουμε ποιος αριθμος ειναι
	// Αρχικοποιουμε τις μεταβλητες
	localExpression=p->getName();
	//if(dimensions[u]->getType()==3 || dimensions[u]->getType()==5 || (dimensions[u]->getType()==4 && dimensions[u]>0) || (dimensions[u]->getType()==4 && dimensions[u]>0)) 
	points=localExpression.find('.');
	if(points!=string::npos)
	{
		if(points == localExpression.length()-1)
		{
		   //throw hException("hExpressionParser::findNumber", "The arithmetic expression is invalid.\nPossibly a point after a number e.g. 3. It should be 3.0 if double wanted", hAlloc);
			if(error.empty())
			{
				error = excep_expression[6] + ". Matrices are intialized like [[a, b], [c, d]]";
				error_code = 2 ;
			}
			return ;
		}
		else if(points==0)
		{
			localExpression="0"+localExpression;
			p->setName(localExpression);
		}
		double numD;
		points=tools.numberContainsValidChars(localExpression);
		if(points==0)
		{
			//throw hException("hExpressionParser::findNumber", "The arithmetic expression is not acceptable. Possible errors: \n1)A letter or other invalid character is right next to a number.\n2) A decimal is seperated with a ',' instead of '.'.", hAlloc);
			if(error.empty())
			{
				error = "The arithmetic expression is not acceptable. Possible errors: \n1)A letter or other invalid character is right next to a number.\n2) A decimal is seperated with a ',' instead of '.'.";
				error_code = 1 ;
			}
			return ;
		}
		from_string<double>(numD, localExpression, std::dec);
		p->setValue(numD);
	}
	else
	{
		signed long int numSLI;
		points=tools.numberContainsValidChars(localExpression);
		if(points==0)
		{
			//throw hException("hExpressionParser::findNumber", "The arithmetic expression is not acceptable. Possible errors: \n1)A letter or other invalid character is right next to a number.\n2) A decimal is seperated with a ',' instead of '.'", hAlloc);
			if(error.empty())
			{
				error = "The arithmetic expression is not acceptable. Possible errors: \n1)A letter or other invalid character is right next to a number.\n2) A decimal is seperated with a ',' instead of '.'";
				error_code = 1 ;
			}
			return ;
		}
		from_string<signed long int>(numSLI, localExpression, std::dec);
		p->setValue(numSLI);
	}
}

int hExpressionParser::change_token(string tok, std::string &error, int &error_code)
{
	hTools tools ;
	string tok_1 = tok.substr(0, tok.length() - 1 );
   
	if(tok_1 == "") return -1 ;
   
	int st = tools.same_type(tok, tok_1, error, error_code) ;
   
	return st ;
}

void hExpressionParser::check_syntax(std::string expression, std::string &error, int &error_code, hVariableTree * varRoot, hFunction functions)
{
	error_code = 0;
	setExpression(expression, error, error_code) ;
	if(!error.empty())
		return ;
	calculate(varRoot, functions, error, error_code) ;
}

