/***************************************************************************
 *   Copyright (C) 2007 by aurelius,,,   *
 *   aurelius@aurelius-laptop   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef HEXPRESSIONPARSER_H
#define HEXPRESSIONPARSER_H

#include <string>
#include <vector>
#include <stack>

/**
	@author aurelius,,, <aurelius@aurelius-laptop>
 */

#include "hExpressionNode.h"
#include "hTools.h"
#include "hException.h"
#include "hFunction.h"
#include "hVarAlgebra.h"

using namespace std;

class hExpressionParser{
   private:
	// Ενα string στο οποιο θα αποθηκευεται η εκφραη που μου δινεται
	string arithmeticExpression;
	// Κοιτα το .cpp
	void crossExpression();
	// Κοιτα το .cpp
	void crossExpression(std::string &error, int &error_code);
	// Κοιτα το .cpp
	vector<unsigned int> findDimensions(string expression);
	// Κοιτα το .cpp
	vector<unsigned int> findDimensions(string expression, std::string &error, int &error_code);
	//
	hVariable makeOperation(string symbol, hVariable &first_operator, hVariable &second_operator);
	//
	int change_token(std::string tok) ;
	//
	int change_token(std::string tok, std::string &error, int &error_code) ;
	//
	void findNumber(hExpressionNode *p) ;
	//
	void findNumber(hExpressionNode *p, std::string &error, int &error_code) ;
	//
	bool valid_dimensions(string mat, vector<unsigned int> dims) ;
	//
	bool valid_dimensions(string mat, vector<unsigned int> dims, std::string &error, int &error_code) ;
	
   public:
	
	  std::vector<hExpressionNode*> token ;
	  std::deque<int> is_function ;
	  std::deque<bool> were_values ;
	  std::deque<int> arg_cnt ;
	  std::deque<hExpressionNode*> output ;
	  std::deque<hExpressionNode*> stack ;
	  std::deque<hExpressionNode*> brackets ;
	  
	  void setExpression(string expression);
	//
	  void setExpression(string expression, std::string &error, int &error_code) ;
	  //
	  hVariable calculate(hVariableTree *varRoot, hFunction functions);
	  //
	  hVariable calculate(hVariableTree *varRoot, hFunction functions, std::string &error, int &error_code);
	  //
	  void check_syntax(std::string expression, std::string &error, int &error_code, hVariableTree * varRoot, hFunction functions);
	  //
	  void clear() ;
	
};

#endif
