/***************************************************************************
 *   Copyright (C) 2007 by Harry Serenis                                   *
 *   bobomastoras@users.sf.net                                             *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef HFUNCTION_H
#define HFUNCTION_H

#include "hFunctionHeaders.h"
#include "hPackages.h"
#include <list>

typedef std::vector<hAbstractFunction *> AbsFuncVector;
//class hToolBox;

class hKernel;

class hFunction
{
	functionTable data;
	std::list<hToolBox *> boxNames;
	void insertFunction(const std::string &name, hAbstractFunction *func);
	void insertFunction(functionTable functions);
public:
	hFunction() : data() {}
	void loadToolBox(hToolBox *toolBox);
	//void insertFunction(const char * const name, hAbstractFunction *func);
	void removeFunction(const std::string &name);
	std::string getHelp(std::vector<std::string> argv);

	//AbsFuncVector getFunctions(const std::string &name);
	//hAbstractFunction * getFunction(const std::string &name,unsigned short args,unsigned short output);
	hStructure execute(std::string name,hStructure &args);
	std::vector<std::string> getAllNames(void);
	std::vector<std::string> getToolBoxNames(void);
	std::vector<std::string> getToolBoxFunctions(std::string name);
};

class hUserFunction:public hAbstractFunction{

};

#endif
