/***************************************************************************
 *   Copyright (C) 2007 by Harry Serenis,manos                             *
 *   bobomastoras@users.sf.net,etsardou@users.sf.net                       *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "hGlobals.h"

#ifdef UNIX
std::string hGlobals::slash="/";
#endif
#ifdef WINDOWS
std::string hGlobals::slash="\\";
#endif

std::vector<std::string> hGlobals::parseSpace(std::string arg){
	using namespace std;
	vector<string> ret;
	unsigned int i,j;
	i=j=0;
	i=arg.find(' ',j);
	while(i!=string::npos){
		ret.push_back(arg.substr(j,i-j));
		j=i+1;
		i=arg.find(' ',j);
	}
	ret.push_back(arg.substr(j,i-j));
	return ret;
	
}

unsigned long int hGlobals::u_long_str=0;
std::string hGlobals::optionsDir="./";
std::string hGlobals::libsfile="libs.conf";
std::string hGlobals::initialcode="initial_code";
std::string hGlobals::home="./";
std::string hGlobals::initFile="autoexec.eng";


std::vector<std::string> hGlobals::solibnames=std::vector<std::string>();
std::vector<std::string> hGlobals::solibpaths=std::vector<std::string>();
std::vector<std::string> hGlobals::solibtoolnames=std::vector<std::string>();
std::vector<int> hGlobals::solibenable=std::vector<int>();


void hGlobals::initialize(void){
	std::stringstream t;
	t<<ULONG_MAX;
	home=getenv("HOME");
	optionsDir=home+slash+".englab"+slash;
	libsfile=optionsDir+libsfile;
	initialcode=optionsDir+initialcode;
	initFile=optionsDir+initFile;
	u_long_str=t.str().size();
	try{
		importLibs();
	}catch(hException &e){
		e.printAll();
	}
}

void hGlobals::importLibs(void){
	using namespace std;
	ifstream infile;
	unsigned int pos;
	bool foundglobal=false,found=false;
	std::string temp,temp2;
	char tempc[200];
	vector<string> templibs;
	infile.open(libsfile.c_str(),ifstream::in);
	if(!infile.good()){
		throw hException("hGlobals::importLibs","Cannot open englab toolbox file ",hError);
	}

	while(infile.good()){
		infile.getline(tempc,200);
		temp=tempc;
		if(temp.compare(""))
			templibs.push_back(temp);
	}
	int place,oldplace;
	string tl;
	for(int i=0;i<templibs.size();i++)
	{
		place=templibs[i].find(' ',0);
		tl=templibs[i].substr(0,place);
		solibtoolnames.push_back(tl);
		tl.clear();
		oldplace=place;
		place=templibs[i].find(' ',oldplace+1);
		tl=templibs[i].substr(oldplace+1,place-oldplace-1);
		solibnames.push_back(tl);
		tl.clear();
		oldplace=place;
		place=templibs[i].find(' ',oldplace+1);
		tl=templibs[i].substr(oldplace+1,place-oldplace-1);
		solibpaths.push_back(tl);
		tl.clear();


		tl=templibs[i].substr(place+1);
		if(!tl.compare("1"))
			solibenable.push_back(1);
		else if(!tl.compare("0"))
			solibenable.push_back(0);
		tl.clear();	
	}
	infile.close();
}

void hGlobals::initialize(std::string homeDir){
	std::stringstream t;
	t<<ULONG_MAX;
	home=homeDir;
	optionsDir=home+slash;
	initFile=optionsDir+initFile;
	u_long_str=t.str().size();

	try{
		importLibs();
	}catch(hException &e){
		e.printAll();
	}


}


std::string hGlobals::trim(std::string str){
	std::string newString;
	unsigned int i=0;
	while(str[i]==0x20)
		i++;
	do{
		newString+=str[i];
		i++;
		if(str[i]==0x20){
			newString+=str[i];
			i++;
			while(str[i]==0x20)
				i++;
		}
	}while(str[i]);
	if(newString[newString.size()-1]==0x20)
		newString.erase(newString.size()-1,1);
	return newString;
}

std::vector<std::string> hGlobals::trim(std::vector<std::string> str){
	unsigned int i;
	std::vector<std::string> vec;
	for(i=0;i<str.size();i++)
		vec.push_back(trim(str[i]));
	return vec;
}

std::deque<std::string> hGlobals::trim(std::deque<std::string> str){
	std::deque<std::string>::iterator i;
	std::deque<std::string> ls;
	for(i=str.begin();i!=str.end();i++)
		ls.push_back(trim(*i));
	return ls;
}

template <class type>
hStack<type>::hStack(void){
	ok=true;
}

template <class type>
hStack<type>::hStack(unsigned long reserve){
	try{
		stack.reserve(reserve);
		ok=true;
	}catch(std::exception &e){
		ok=false;
		std::string msg("Cannot allocate stack: ");
		msg+=std::string(e.what());
		throw hException("hStack::hStack",msg,hError);
	}
}

template <class type>
void hStack<type>::push(type data){
	if(!ok)
		throw hException("hStack::push","Stack is at erroneous state",hError);
	try{
		stack.push_back(data);
	}catch(std::exception &e){
		ok=false;
		std::string msg("Cannot push data: ");
		msg+=std::string(e.what());
		throw hException("hStack::push",msg,hError);
	}
}

template <class type>
type hStack<type>::pop(void){
	if(!ok)
		throw hException("hStack::pop","Stack is at erroneous state",hError);
	if(!stack.size()){
		throw hException("hStack::pop","Stack underflow",hError);
		ok=false;
	}
	try{
		type ret;
		ret=stack.back();
		stack.pop_back();
		return ret;
	}catch(std::exception &e){
		ok=false;
		std::string msg("Cannot pop data: ");
		msg+=std::string(e.what());
		throw hException("hStack::pop",msg,hError);
	}
}

template <class type>
unsigned long hStack<type>::size(void){
	if(!ok)
		throw hException("hStack::size","Stack is at erroneous state",hError);
	try{
		unsigned long ret;
		ret=stack.size();
		return ret;
	}catch(std::exception &e){
		ok=false;
		std::string msg("Cannot get stack size: ");
		msg+=std::string(e.what());
		throw hException("hStack::size",msg,hError);
	}
}

template <class type>
void hStack<type>::flush(void){
	try{
		stack.clear();
		ok=true;
	}catch(std::exception &e){
		ok=false;
		std::string msg("Cannot flush stack: ");
		msg+=std::string(e.what());
		throw hException("hStack::flush",msg,hError);
	}
}

