/***************************************************************************
 *   Copyright (C) 2007 by Harry Serenis,manos                             *
 *   bobomastoras@users.sf.net,etsardou@users.sf.net                       *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef HGLOBALS_H
#define HGLOBALS_H

#include "hException.h"
#include "config.h"
#include <cstdio>
#include <iostream>
#include <fstream>
#include <string>
#include <vector>
#include <deque>
#include <dirent.h>
#include <sstream>

#define NUM 93
#define FONTS 3

class hGlobals{
public:
	static std::string optionsDir;
	static std::string slash;
	static std::string home,initFile,libsfile,initialcode;
	static unsigned long int u_long_str;
	static void initialize(void);
	static void initialize(std::string homeDir);
	static void importLibs(void);
	static std::string trim(std::string str);
	static std::vector<std::string> trim(std::vector<std::string> str);
	static std::deque<std::string> trim(std::deque<std::string> str);
	static std::vector<std::string> parseSpace(std::string arg);
	static std::vector<std::string> solibnames;
	static std::vector<std::string> solibpaths;
	static std::vector<std::string> solibtoolnames;
	static std::vector<int> solibenable;
};

template <class type>
class hStack{
	std::vector<type> stack;
	bool ok;
public:
	void push(type data);
	type pop(void);
	unsigned long size(void);
	void flush(void);
	hStack(void);
	hStack(unsigned long reserve);
};

#endif


