/***************************************************************************
 *   Copyright (C) 2007 by Harry Serenis                                   *
 *   bobomastoras@users.sf.net                                             * 
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "hParametricExecution.h"

void hParametricExecution::clear(void){
	unsigned int i;
	keywords.clear();
	for(i=0;i<params.size();i++)
		params[i].clear();
	params.clear();
/*	for(i=0;i<cmds.size();i++)
		cmds[i].clear();*/
//	cmds.clear();
}

void hParametricExecution::setExecution(std::string key,std::string userParams,hAbstractCommand userCmds){
	int i,j;
	std::string temp;
	std::vector<std::string> parse;
	keywords.push_back(key);
	cmds=userCmds;
	i=userParams.find('(',0);
	j=userParams.find_last_of(')',userParams.size()-1);
	temp=userParams.substr(i+1,j-i-1);
	j=0;
	i=temp.find(';',0);
	while(i!=-1){
		parse.push_back(temp.substr(j,i-j));
		i=temp.find(';',j=i+1);
	}
	parse.push_back(temp.substr(j,temp.size()-j));	
	params.push_back(parse);
}

/*void hParametricExecution::setExecution(std::string key,std::string userParams,std::vector<std::string> userCmds){
	int i,j;
	std::string temp;
	std::vector<std::string> parse;
	keywords.push_back(key);
	cmds.push_back(userCmds);
	i=userParams.find('(',0);
	j=userParams.find_last_of(')',userParams.size()-1);
	temp=userParams.substr(i+1,j-i-1);
	j=0;
	i=temp.find(';',0);
	while(i!=-1){
		parse.push_back(temp.substr(j,i-j));
		i=temp.find(';',j=i+1);
	}
	parse.push_back(temp.substr(j,temp.size()-j));	
	params.push_back(parse);
}*/

std::vector<std::string> hParametricExecution::getKeywords(void){
	return keywords;
}

std::vector<std::vector<std::string> > hParametricExecution::getParams(void){
	return params;
}

hAbstractCommand hParametricExecution::getCmds(void){
	return cmds;
}
