/***************************************************************************
 *   Copyright (C) 2007 by manos                                           *
 *   etsardou@users.sf.net                                                 * 
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef HSTAT_H
#define HSTAT_H

#include "hFunctionHeaders.h"
#include "hMath.h"

class hMean:public hAbstractFunction{
private:
	static const unsigned short inArgs=1,outArgs=1;
public:
  	hStructure execute(hStructure &arg);
	///Returns the name of the function that the class implements
	std::string getName(void){return "mean";}
	///Returns the number of input arguments
	unsigned short getNumberOfArgs(void){return inArgs;}
	///Returns the number of output arguments
	unsigned short getNumberOfOut(void){return outArgs;}
	std::string getHelp(void);
};

class hStddev:public hAbstractFunction{
private:
	static const unsigned short inArgs=1,outArgs=1;
public:
  	hStructure execute(hStructure &arg);
	///Returns the name of the function that the class implements
	std::string getName(void){return "stddev";}
	///Returns the number of input arguments
	unsigned short getNumberOfArgs(void){return inArgs;}
	///Returns the number of output arguments
	unsigned short getNumberOfOut(void){return outArgs;}
	std::string getHelp(void);
};
class hGeomean:public hAbstractFunction{
private:
	static const unsigned short inArgs=1,outArgs=1;
public:
  	hStructure execute(hStructure &arg);
	///Returns the name of the function that the class implements
	std::string getName(void){return "geomean";}
	///Returns the number of input arguments
	unsigned short getNumberOfArgs(void){return inArgs;}
	///Returns the number of output arguments
	unsigned short getNumberOfOut(void){return outArgs;}
};
class hHarmean:public hAbstractFunction{
private:
	static const unsigned short inArgs=1,outArgs=1;
public:
  	hStructure execute(hStructure &arg);
	///Returns the name of the function that the class implements
	std::string getName(void){return "harmean";}
	///Returns the number of input arguments
	unsigned short getNumberOfArgs(void){return inArgs;}
	///Returns the number of output arguments
	unsigned short getNumberOfOut(void){return outArgs;}
};
class hSort:public hAbstractFunction{
private:
	static const unsigned short inArgs=1,outArgs=1;
public:
  	hStructure execute(hStructure &arg);
	///Returns the name of the function that the class implements
	std::string getName(void){return "sort";}
	///Returns the number of input arguments
	unsigned short getNumberOfArgs(void){return inArgs;}
	///Returns the number of output arguments
	unsigned short getNumberOfOut(void){return outArgs;}
};
class hMedian:public hAbstractFunction{
private:
	static const unsigned short inArgs=1,outArgs=1;
public:
  	hStructure execute(hStructure &arg);
	///Returns the name of the function that the class implements
	std::string getName(void){return "median";}
	///Returns the number of input arguments
	unsigned short getNumberOfArgs(void){return inArgs;}
	///Returns the number of output arguments
	unsigned short getNumberOfOut(void){return outArgs;}
};
class hMode:public hAbstractFunction{
private:
	static const unsigned short inArgs=1,outArgs=1;
public:
  	hStructure execute(hStructure &arg);
	///Returns the name of the function that the class implements
	std::string getName(void){return "mode";}
	///Returns the number of input arguments
	unsigned short getNumberOfArgs(void){return inArgs;}
	///Returns the number of output arguments
	unsigned short getNumberOfOut(void){return outArgs;}
};
class hRange:public hAbstractFunction{
private:
	static const unsigned short inArgs=1,outArgs=1;
public:
  	hStructure execute(hStructure &arg);
	///Returns the name of the function that the class implements
	std::string getName(void){return "range";}
	///Returns the number of input arguments
	unsigned short getNumberOfArgs(void){return inArgs;}
	///Returns the number of output arguments
	unsigned short getNumberOfOut(void){return outArgs;}
};
class hMadev:public hAbstractFunction{
private:
	static const unsigned short inArgs=1,outArgs=1;
public:
  	hStructure execute(hStructure &arg);
	///Returns the name of the function that the class implements
	std::string getName(void){return "madev";}
	///Returns the number of input arguments
	unsigned short getNumberOfArgs(void){return inArgs;}
	///Returns the number of output arguments
	unsigned short getNumberOfOut(void){return outArgs;}
};
class hVar:public hAbstractFunction{
private:
	static const unsigned short inArgs=1,outArgs=1;
public:
  	hStructure execute(hStructure &arg);
	///Returns the name of the function that the class implements
	std::string getName(void){return "var";}
	///Returns the number of input arguments
	unsigned short getNumberOfArgs(void){return inArgs;}
	///Returns the number of output arguments
	unsigned short getNumberOfOut(void){return outArgs;}
	std::string getHelp(void);
};
class hSvar:public hAbstractFunction{
private:
	static const unsigned short inArgs=1,outArgs=1;
public:
  	hStructure execute(hStructure &arg);
	///Returns the name of the function that the class implements
	std::string getName(void){return "svar";}
	///Returns the number of input arguments
	unsigned short getNumberOfArgs(void){return inArgs;}
	///Returns the number of output arguments
	unsigned short getNumberOfOut(void){return outArgs;}
	std::string getHelp(void);
};
class hSstddev:public hAbstractFunction{
private:
	static const unsigned short inArgs=1,outArgs=1;
public:
  	hStructure execute(hStructure &arg);
	///Returns the name of the function that the class implements
	std::string getName(void){return "sstddev";}
	///Returns the number of input arguments
	unsigned short getNumberOfArgs(void){return inArgs;}
	///Returns the number of output arguments
	unsigned short getNumberOfOut(void){return outArgs;}
	std::string getHelp(void);
};
class hCoevar:public hAbstractFunction{
private:
	static const unsigned short inArgs=1,outArgs=1;
public:
  	hStructure execute(hStructure &arg);
	///Returns the name of the function that the class implements
	std::string getName(void){return "coevar";}
	///Returns the number of input arguments
	unsigned short getNumberOfArgs(void){return inArgs;}
	///Returns the number of output arguments
	unsigned short getNumberOfOut(void){return outArgs;}
};
class hAssym1:public hAbstractFunction{
private:
	static const unsigned short inArgs=1,outArgs=1;
public:
  	hStructure execute(hStructure &arg);
	///Returns the name of the function that the class implements
	std::string getName(void){return "assym1";}
	///Returns the number of input arguments
	unsigned short getNumberOfArgs(void){return inArgs;}
	///Returns the number of output arguments
	unsigned short getNumberOfOut(void){return outArgs;}
};
class hAssym2:public hAbstractFunction{
private:
	static const unsigned short inArgs=1,outArgs=1;
public:
  	hStructure execute(hStructure &arg);
	///Returns the name of the function that the class implements
	std::string getName(void){return "assym2";}
	///Returns the number of input arguments
	unsigned short getNumberOfArgs(void){return inArgs;}
	///Returns the number of output arguments
	unsigned short getNumberOfOut(void){return outArgs;}
};
class hAssym3:public hAbstractFunction{
private:
	static const unsigned short inArgs=1,outArgs=1;
public:
  	hStructure execute(hStructure &arg);
	///Returns the name of the function that the class implements
	std::string getName(void){return "assym3";}
	///Returns the number of input arguments
	unsigned short getNumberOfArgs(void){return inArgs;}
	///Returns the number of output arguments
	unsigned short getNumberOfOut(void){return outArgs;}
};
class hRopi:public hAbstractFunction{
private:
	static const unsigned short inArgs=3,outArgs=1;
public:
  	hStructure execute(hStructure &arg);
	///Returns the name of the function that the class implements
	std::string getName(void){return "ropi";}
	///Returns the number of input arguments
	unsigned short getNumberOfArgs(void){return inArgs;}
	///Returns the number of output arguments
	unsigned short getNumberOfOut(void){return outArgs;}
};
class hGassym1:public hAbstractFunction{
private:
	static const unsigned short inArgs=1,outArgs=1;
public:
  	hStructure execute(hStructure &arg);
	///Returns the name of the function that the class implements
	std::string getName(void){return "gassym1";}
	///Returns the number of input arguments
	unsigned short getNumberOfArgs(void){return inArgs;}
	///Returns the number of output arguments
	unsigned short getNumberOfOut(void){return outArgs;}
};
class hGassym2:public hAbstractFunction{
private:
	static const unsigned short inArgs=1,outArgs=1;
public:
  	hStructure execute(hStructure &arg);
	///Returns the name of the function that the class implements
	std::string getName(void){return "gassym2";}
	///Returns the number of input arguments
	unsigned short getNumberOfArgs(void){return inArgs;}
	///Returns the number of output arguments
	unsigned short getNumberOfOut(void){return outArgs;}
};
class hBgpline:public hAbstractFunction{
private:
	static const unsigned short inArgs=1,outArgs=1;
public:
  	hStructure execute(hStructure &arg);
	///Returns the name of the function that the class implements
	std::string getName(void){return "bgpline";}
	///Returns the number of input arguments
	unsigned short getNumberOfArgs(void){return inArgs;}
	///Returns the number of output arguments
	unsigned short getNumberOfOut(void){return outArgs;}
};
class hAgpline:public hAbstractFunction{
private:
	static const unsigned short inArgs=1,outArgs=1;
public:
  	hStructure execute(hStructure &arg);
	///Returns the name of the function that the class implements
	std::string getName(void){return "agpline";}
	///Returns the number of input arguments
	unsigned short getNumberOfArgs(void){return inArgs;}
	///Returns the number of output arguments
	unsigned short getNumberOfOut(void){return outArgs;}
};
class hCorr:public hAbstractFunction{
private:
	static const unsigned short inArgs=1,outArgs=1;
public:
  	hStructure execute(hStructure &arg);
	///Returns the name of the function that the class implements
	std::string getName(void){return "corr";}
	///Returns the number of input arguments
	unsigned short getNumberOfArgs(void){return inArgs;}
	///Returns the number of output arguments
	unsigned short getNumberOfOut(void){return outArgs;}
};
class hStat:public hToolBox{
	//std::map<std::string,hAbstractFunction *> functionNames;
	hMean statMean;
	hStddev statStddev;
	hGeomean statGeomean;
	hHarmean statHarmean;
	hSort statSort;
	hMedian statMedian;
	hMode statMode;
	hRange statRange;
	hMadev statMadev;
	hVar statVar;
	hSvar statSvar;
	hSstddev statSstddev;
	hCoevar statCoevar;
	hAssym1 statAssym1;
	hAssym2 statAssym2;
	hAssym3 statAssym3;
	hRopi statRopi;
	hGassym1 statGassym1;
	hGassym2 statGassym2;
	hBgpline statBgpline;
	hAgpline statAgpline;
	hCorr statCorr;
public:
	hStat(void);
	std::map<std::string,hAbstractFunction *> getNames(void);
	std::string toolBoxName(void){return name;}
};


#endif
