/***************************************************************************
 *   Copyright (C) 2007 by aurelius                                        *
 *   sg_aurelius@users.sf.net                                              *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef HTOOLS_H
#define HTOOLS_H

/**
	@author aurelius,,, <aurelius@aurelius-laptop>
*/

#include <string>
#include "hException.h"

enum hTokenType{
 number=0,		//0
 func_or_matr,		//1
 matr,			//2
 arg_separ,		//3
 one_sym_oper,		//4
 two_sym_oper,		//5
 left_par,		//6
 right_par,		//7
 variable,		//8
 matr_to_create,	//9
 left_brack,		//10
 right_brack,		//11
 char_var		//12
};

using namespace std;

class hSymbol
{
   public:
	hSymbol(string op,int pow):sym(op),power(pow){}
	  void set_symbol(string sym, int pow) ;
	  string get_symbol_expression();
	  int get_symbol_power();
   private:
	  string sym ;
	  int power ;
};

#define _SYMBOL_NUMBER 24

class hTools{
   int static symbol_number ;
   static hSymbol symbols[_SYMBOL_NUMBER];
public:
	//unsigned int getStringSize(char* expression);
	//char* copyFromString(char *input, unsigned int mode, unsigned int position1, unsigned int position2);
   hTools() ;
   hSymbol* getSymbols() ;
   int getSymbolNumber() ;
   int getSymbolPower(std::string str) ;
   
   bool is_valid_char(char ch) ;   
   int same_type(std::string tok, std::string tok_1) ;
   int same_type(std::string tok, std::string tok_1, std::string &error, int &error_code) ;
   bool isSymbol(std::string str);
   bool isNumber(std::string str);
   bool isAlpharithmetic(string str) ;
	bool isNumber(char ch);
	bool isLetter(char ch);
	int isSymbol(char ch1, char ch2, string *symbols, unsigned int siz, unsigned int repeat);
	int isSymbol(char ch1, char ch2, string *symbols, unsigned int siz);
	bool containsLetter(string num);
	int numberContainsValidChars(string num);
	int findSymbol(string expression, int &pos, string *symbols, unsigned int siz);
	string invertStringForDivision(string str);
};

#endif

