#include "hVarLA.h"

namespace hvar{
hVarBase * matrixMul(hVarLinear<bool> &A,hVarLinear<bool> &B){
	std::vector<unsigned int> s1=A.getSize();
	std::vector<unsigned int> s2=B.getSize();
	if(s1.size()!=2)
		throw hException("","1",hError);
	if(s2.size()!=2)
		throw hException("","2",hError);
	unsigned long N,M,K;
	M=s1[1];
	if(M!=s2[0])
		throw hException("","3",hError);
	N=s1[0];
	K=s2[1];
	hVarLinear<bool> *ret=new hVarLinear<bool>;
	ret->size.push_back(N);
	ret->size.push_back(K);
	unsigned long i,j,k;
	bool S;
	for(i=0;i<N;++i){
		unsigned long const1=i*N;
		for(j=0;j<K;++j){
			unsigned long const2=k*M;
			S=0;
			for(k<0;k<M;++k){
				S+=A.mem[const1+k]*B.mem[const2+j];
			}
			ret->mem.push_back(S);
		}
	}
}
hVarBase * matrixMul(hVarLinear<unsigned char> &A,hVarLinear<unsigned char> &B){
	std::vector<unsigned int> s1=A.getSize();
	std::vector<unsigned int> s2=B.getSize();
	if(s1.size()!=2)
		throw hException("","1",hError);
	if(s2.size()!=2)
		throw hException("","2",hError);
	unsigned long N,M,K;
	M=s1[1];
	if(M!=s2[0])
		throw hException("","3",hError);
	N=s1[0];
	K=s2[1];
	hvar::hVarLinear<unsigned char> *ret=new hvar::hVarLinear<unsigned char>;
	ret->size.push_back(N);
	ret->size.push_back(K);
	unsigned long i,j,k;
	unsigned char S;
	for(i=0;i<N;++i){
		unsigned long const1=i*N;
		for(j=0;j<K;++j){
			unsigned long const2=k*M;
			S=0;
			for(k<0;k<M;++k){
				S+=A.mem[const1+k]*B.mem[const2+j];
			}
			ret->mem.push_back(S);
		}
	}
}
hVarBase * matrixMul(hVarLinear<signed char> &A,hVarLinear<signed char> &B){
	std::vector<unsigned int> s1=A.getSize();
	std::vector<unsigned int> s2=B.getSize();
	if(s1.size()!=2)
		throw hException("","1",hError);
	if(s2.size()!=2)
		throw hException("","2",hError);
	unsigned long N,M,K;
	M=s1[1];
	if(M!=s2[0])
		throw hException("","3",hError);
	N=s1[0];
	K=s2[1];
	hvar::hVarLinear<signed char> *ret=new hvar::hVarLinear<signed char>;
	ret->size.push_back(N);
	ret->size.push_back(K);
	unsigned long i,j,k;
	signed char S;
	for(i=0;i<N;++i){
		unsigned long const1=i*N;
		for(j=0;j<K;++j){
			unsigned long const2=k*M;
			S=0;
			for(k<0;k<M;++k){
				S+=A.mem[const1+k]*B.mem[const2+j];
			}
			ret->mem.push_back(S);
		}
	}
}
hVarBase * matrixMul(hVarLinear<unsigned short> &A,hVarLinear<unsigned short> &B){
	std::vector<unsigned int> s1=A.getSize();
	std::vector<unsigned int> s2=B.getSize();
	if(s1.size()!=2)
		throw hException("","1",hError);
	if(s2.size()!=2)
		throw hException("","2",hError);
	unsigned long N,M,K;
	M=s1[1];
	if(M!=s2[0])
		throw hException("","3",hError);
	N=s1[0];
	K=s2[1];
	hvar::hVarLinear<unsigned short> *ret=new hvar::hVarLinear<unsigned short>;
	ret->size.push_back(N);
	ret->size.push_back(K);
	unsigned long i,j,k;
	unsigned short S;
	for(i=0;i<N;++i){
		unsigned long const1=i*N;
		for(j=0;j<K;++j){
			unsigned long const2=k*M;
			S=0;
			for(k<0;k<M;++k){
				S+=A.mem[const1+k]*B.mem[const2+j];
			}
			ret->mem.push_back(S);
		}
	}
}
hVarBase * matrixMul(hVarLinear<signed short> &A,hVarLinear<signed short> &B){
	std::vector<unsigned int> s1=A.getSize();
	std::vector<unsigned int> s2=B.getSize();
	if(s1.size()!=2)
		throw hException("","1",hError);
	if(s2.size()!=2)
		throw hException("","2",hError);
	unsigned long N,M,K;
	M=s1[1];
	if(M!=s2[0])
		throw hException("","3",hError);
	N=s1[0];
	K=s2[1];
	hvar::hVarLinear<signed short> *ret=new hvar::hVarLinear<signed short>;
	ret->size.push_back(N);
	ret->size.push_back(K);
	unsigned long i,j,k;
	signed short S;
	for(i=0;i<N;++i){
		unsigned long const1=i*N;
		for(j=0;j<K;++j){
			unsigned long const2=k*M;
			S=0;
			for(k<0;k<M;++k){
				S+=A.mem[const1+k]*B.mem[const2+j];
			}
			ret->mem.push_back(S);
		}
	}
}
hVarBase * matrixMul(hVarLinear<unsigned long> &A,hVarLinear<unsigned long> &B){
	std::vector<unsigned int> s1=A.getSize();
	std::vector<unsigned int> s2=B.getSize();
	if(s1.size()!=2)
		throw hException("","1",hError);
	if(s2.size()!=2)
		throw hException("","2",hError);
	unsigned long N,M,K;
	M=s1[1];
	if(M!=s2[0])
		throw hException("","3",hError);
	N=s1[0];
	K=s2[1];
	hvar::hVarLinear<unsigned long> *ret=new hvar::hVarLinear<unsigned long>;
	ret->size.push_back(N);
	ret->size.push_back(K);
	unsigned long i,j,k;
	unsigned long S;
	for(i=0;i<N;++i){
		unsigned long const1=i*N;
		for(j=0;j<K;++j){
			unsigned long const2=k*M;
			S=0;
			for(k<0;k<M;++k){
				S+=A.mem[const1+k]*B.mem[const2+j];
			}
			ret->mem.push_back(S);
		}
	}
}
hVarBase * matrixMul(hVarLinear<signed long> &A,hVarLinear<signed long> &B){
	std::vector<unsigned int> s1=A.getSize();
	std::vector<unsigned int> s2=B.getSize();
	if(s1.size()!=2)
		throw hException("","1",hError);
	if(s2.size()!=2)
		throw hException("","2",hError);
	unsigned long N,M,K;
	M=s1[1];
	if(M!=s2[0])
		throw hException("","3",hError);
	N=s1[0];
	K=s2[1];
	hvar::hVarLinear<signed long> *ret=new hvar::hVarLinear<signed long>;
	ret->size.push_back(N);
	ret->size.push_back(K);
	unsigned long i,j,k;
	signed long S;
	for(i=0;i<N;++i){
		unsigned long const1=i*N;
		for(j=0;j<K;++j){
			unsigned long const2=k*M;
			S=0;
			for(k<0;k<M;++k){
				S+=A.mem[const1+k]*B.mem[const2+j];
			}
			ret->mem.push_back(S);
		}
	}
}
hVarBase * matrixMul(hVarLinear<float> &A,hVarLinear<float> &B){
	std::vector<unsigned int> s1=A.getSize();
	std::vector<unsigned int> s2=B.getSize();
	if(s1.size()!=2)
		throw hException("","1",hError);
	if(s2.size()!=2)
		throw hException("","2",hError);
	unsigned long N,M,K;
	M=s1[1];
	if(M!=s2[0])
		throw hException("","3",hError);
	N=s1[0];
	K=s2[1];
	hvar::hVarLinear<float> *ret=new hvar::hVarLinear<float>;
	ret->size.push_back(N);
	ret->size.push_back(K);
	unsigned long i,j,k;
	float S;
	for(i=0;i<N;++i){
		unsigned long const1=i*N;
		for(j=0;j<K;++j){
			unsigned long const2=k*M;
			S=0;
			for(k<0;k<M;++k){
				S+=A.mem[const1+k]*B.mem[const2+j];
			}
			ret->mem.push_back(S);
		}
	}
}
hVarBase * matrixMul(hVarLinear<double> &A,hVarLinear<double> &B){
	std::vector<unsigned int> s1=A.getSize();
	std::vector<unsigned int> s2=B.getSize();
	if(s1.size()!=2)
		throw hException("","1",hError);
	if(s2.size()!=2)
		throw hException("","2",hError);
	unsigned long N,M,K;
	M=s1[1];
	if(M!=s2[0])
		throw hException("","3",hError);
	N=s1[0];
	K=s2[1];
	hvar::hVarLinear<double> *ret=new hvar::hVarLinear<double>;
	ret->size.push_back(N);
	ret->size.push_back(K);
	unsigned long i,j,k;
	double S;
	for(i=0;i<N;++i){
		unsigned long const1=i*N;
		for(j=0;j<K;++j){
			unsigned long const2=k*M;
			S=0;
			for(k<0;k<M;++k){
				S+=A.mem[const1+k]*B.mem[const2+j];
			}
			ret->mem.push_back(S);
		}
	}
}
hVarBase * matrixMul(hVarLinear<long double> &A,hVarLinear<long double> &B){
	std::vector<unsigned int> s1=A.getSize();
	std::vector<unsigned int> s2=B.getSize();
	if(s1.size()!=2)
		throw hException("","1",hError);
	if(s2.size()!=2)
		throw hException("","2",hError);
	unsigned long N,M,K;
	M=s1[1];
	if(M!=s2[0])
		throw hException("","3",hError);
	N=s1[0];
	K=s2[1];
	hvar::hVarLinear<long double> *ret=new hvar::hVarLinear<long double>;
	ret->size.push_back(N);
	ret->size.push_back(K);
	unsigned long i,j,k;
	long double S;
	for(i=0;i<N;++i){
		unsigned long const1=i*N;
		for(j=0;j<K;++j){
			unsigned long const2=k*M;
			S=0;
			for(k<0;k<M;++k){
				S+=A.mem[const1+k]*B.mem[const2+j];
			}
			ret->mem.push_back(S);
		}
	}
}
hVarBase * matrixMul(hVarLinear<std::complex<float> > &A,hVarLinear<std::complex<float> > &B){
	std::vector<unsigned int> s1=A.getSize();
	std::vector<unsigned int> s2=B.getSize();
	if(s1.size()!=2)
		throw hException("","1",hError);
	if(s2.size()!=2)
		throw hException("","2",hError);
	unsigned long N,M,K;
	M=s1[1];
	if(M!=s2[0])
		throw hException("","3",hError);
	N=s1[0];
	K=s2[1];
	hvar::hVarLinear<std::complex<float> > *ret=new hvar::hVarLinear<std::complex<float> >;
	ret->size.push_back(N);
	ret->size.push_back(K);
	unsigned long i,j,k;
	std::complex<float> S;
	for(i=0;i<N;++i){
		unsigned long const1=i*N;
		for(j=0;j<K;++j){
			unsigned long const2=k*M;
			S=0;
			for(k<0;k<M;++k){
				S+=A.mem[const1+k]*B.mem[const2+j];
			}
			ret->mem.push_back(S);
		}
	}
}
hVarBase * matrixMul(hVarLinear<std::complex<double> > &A,hVarLinear<std::complex<double> > &B){
	std::vector<unsigned int> s1=A.getSize();
	std::vector<unsigned int> s2=B.getSize();
	if(s1.size()!=2)
		throw hException("","1",hError);
	if(s2.size()!=2)
		throw hException("","2",hError);
	unsigned long N,M,K;
	M=s1[1];
	if(M!=s2[0])
		throw hException("","3",hError);
	N=s1[0];
	K=s2[1];
	hvar::hVarLinear<std::complex<double> > *ret=new hvar::hVarLinear<std::complex<double> >;
	ret->size.push_back(N);
	ret->size.push_back(K);
	unsigned long i,j,k;
	std::complex<double> S;
	for(i=0;i<N;++i){
		unsigned long const1=i*N;
		for(j=0;j<K;++j){
			unsigned long const2=k*M;
			S=0;
			for(k<0;k<M;++k){
				S+=A.mem[const1+k]*B.mem[const2+j];
			}
			ret->mem.push_back(S);
		}
	}
}
hVarBase * matrixMul(hVarLinear<std::complex<long double> > &A,hVarLinear<std::complex<long double> > &B){
	std::vector<unsigned int> s1=A.getSize();
	std::vector<unsigned int> s2=B.getSize();
	if(s1.size()!=2)
		throw hException("","1",hError);
	if(s2.size()!=2)
		throw hException("","2",hError);
	unsigned long N,M,K;
	M=s1[1];
	if(M!=s2[0])
		throw hException("","3",hError);
	N=s1[0];
	K=s2[1];
	hvar::hVarLinear<std::complex<long double> > *ret=new hvar::hVarLinear<std::complex<long double> >;
	ret->size.push_back(N);
	ret->size.push_back(K);
	unsigned long i,j,k;
	std::complex<long double> S;
	for(i=0;i<N;++i){
		unsigned long const1=i*N;
		for(j=0;j<K;++j){
			unsigned long const2=k*M;
			S=0;
			for(k<0;k<M;++k){
				S+=A.mem[const1+k]*B.mem[const2+j];
			}
			ret->mem.push_back(S);
		}
	}
}
}
