/***************************************************************************
 *   Copyright (C) 2008 by Bob,,,   *
 *   bob@lab17   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef _HVARLINEAR_H
#define _HVARLINEAR_H

#include "hVarBase.h"
#include "hException.h"
#include <iostream>
#include <complex>

namespace hvar{
template <class dataType>
class hVarLinear:public hVarBase{
	std::vector<dataType> mem;
	std::vector<unsigned int> size;
	unsigned long int findIndex(std::vector<unsigned int> index);
	unsigned long int findIndex(const unsigned long * const index);
	template <class newType>
	hVarBase *typeCast(void);
public:
	
	hvar::allocation allocationMethod(void){
		return hvar::linear;
	}
	hVarLinear(void);

	hVarLinear(dataType data);

	hVarLinear(std::vector<unsigned int> size,dataType *data);
	hVarLinear(std::vector<unsigned int> size,const dataType & init);
	hVarLinear(std::vector<unsigned int> size,std::vector<dataType> data);
	~hVarLinear(void){};

	hVarLinear(std::vector<dataType> data);

	hVarBase * copy(void);
	unsigned int getDim(void);
	std::vector<unsigned int> getSize(void);
	unsigned int getSize(unsigned int dimension);
	void setValue(std::vector<unsigned int> index,hVarBase* data);
	void setValue(unsigned long *index,hVarBase* data);
	void setValue(hVarBase* data);

	void setValue(std::vector<unsigned int> index,const bool &data);
	void setValue(std::vector<unsigned int> index,const unsigned char &data);
	void setValue(std::vector<unsigned int> index,const signed char &data);
	void setValue(std::vector<unsigned int> index,const unsigned short int &data);
	void setValue(std::vector<unsigned int> index,const signed short int &data);
	void setValue(std::vector<unsigned int> index,const unsigned long int &data);
	void setValue(std::vector<unsigned int> index,const signed long int &data);
//	void setValue(std::vector<unsigned int> index,unsigned int &data);
//	void setValue(std::vector<unsigned int> index,signed int &data);
	void setValue(std::vector<unsigned int> index,const float &data);
	void setValue(std::vector<unsigned int> index,const double &data);
	void setValue(std::vector<unsigned int> index,const long double &data);
	void setValue(std::vector<unsigned int> index,const std::complex<float> &data);
	void setValue(std::vector<unsigned int> index,const std::complex<double> &data);
	void setValue(std::vector<unsigned int> index,const std::complex<long double> &data);

	void setValue(const bool &data);
	void setValue(const unsigned char &data);
	void setValue(const signed char &data);
	void setValue(const unsigned short int &data);
	void setValue(const signed short int &data);
	void setValue(const unsigned long int &data);
	void setValue(const signed long int &data);
//	void setValue(const unsigned int &data);
//	void setValue(const signed int &data);
	void setValue(const float &data);
	void setValue(const double &data);
	void setValue(const long double &data);
	void setValue(const std::complex<float> &data);
	void setValue(const std::complex<double> &data);
	void setValue(const std::complex<long double> &data);


	hVarBase* getValue(std::vector<unsigned int> index);
	hVarBase* getValue(void);
	bool getValue(bool &data);
	unsigned char getValue(unsigned char &data);
	signed char getValue(signed char &data);
	unsigned short getValue(unsigned short &data);
	signed short getValue(signed short &data);
	unsigned long getValue(unsigned long &data);
	signed long getValue(signed long &data);
	float getValue(float &data);
	double getValue(double &data);
	long double getValue(long double &data);
	std::complex<float> getValue(std::complex<float> &data);
	std::complex<double> getValue(std::complex<double> &data);
	std::complex<long double> getValue(std::complex<long double> &data);
	bool getValue(std::vector<unsigned int> index,bool &data);
	unsigned char getValue(std::vector<unsigned int> index,unsigned char &data);
	signed char getValue(std::vector<unsigned int> index,signed char &data);
	unsigned short getValue(std::vector<unsigned int> index,unsigned short &data);
	signed short getValue(std::vector<unsigned int> index,signed short &data);
	unsigned long getValue(std::vector<unsigned int> index,unsigned long &data);
	signed long getValue(std::vector<unsigned int> index,signed long &data);
	float getValue(std::vector<unsigned int> index,float &data);
	double getValue(std::vector<unsigned int> index,double &data);
	long double getValue(std::vector<unsigned int> index,long double &data);
	std::complex<float> getValue(std::vector<unsigned int> index,std::complex<float> &data);
	std::complex<double> getValue(std::vector<unsigned int> index,std::complex<double> &data);
	std::complex<long double> getValue(std::vector<unsigned int> index,std::complex<long double> &data);
	void get(bool *data);
	void get(unsigned char *data);
	void get(signed char *data);
	void get(unsigned short *data);
	void get(signed short *data);
	void get(unsigned long *data);
	void get(signed long *data);
	void get(float *data);
	void get(double *data);
	void get(long double *data);
	void get(std::complex<float> *data);
	void get(std::complex<double> *data);
	void get(std::complex<long double> *data);

	unsigned char getType(void);

	void clear(void);

	hVarBase* cast(unsigned char type);

	hVarBase* convert(bool);
	hVarBase* convert(unsigned char flank);
	hVarBase* convert(signed char flank);
	hVarBase* convert(unsigned short int flank);
	hVarBase* convert(signed short int flank);
	hVarBase* convert(unsigned long int flank);
	hVarBase* convert(signed long int flank);
//	hVarBase* convert(unsigned int flank);
//	hVarBase* convert(signed int flank);
	hVarBase* convert(float flank);
	hVarBase* convert(double flank);
	hVarBase* convert(long double flank);
	hVarBase* convert(std::complex<float> flank);
	hVarBase* convert(std::complex<double> flank);
	hVarBase* convert(std::complex<long double> flank);

	hVarBase* operator+(const dataType &op2);
	hVarBase* operator-(const dataType &op2);
	hVarBase* operator*(const dataType &op2);
	hVarBase* operator/(const dataType &op2);
	hVarBase* operator%(const dataType &op2);

	hVarBase* operator=(const dataType& op2);

	hVarBase* operator<(const dataType &op2);
	hVarBase* operator<=(const dataType &op2);
	hVarBase* operator>(const dataType &op2);
	hVarBase* operator>=(const dataType &op2);
	hVarBase* operator&&(const dataType &op2);
	hVarBase* operator||(const dataType &op2);
	hVarBase* operator==(const dataType &op2);
	hVarBase* operator!=(const dataType &op2);

	hVarBase* operator<<(const dataType &op2);
	hVarBase* operator>>(const dataType &op2);
	hVarBase* operator&(const dataType &op2);
	hVarBase* operator|(const dataType &op2);
	hVarBase* operator^(const dataType &op2);

	hVarBase* operator+(const hVarBase* op2);
	hVarBase* operator-(const hVarBase* op2);
	hVarBase* operator*(const hVarBase* op2);
	hVarBase* operator/(const hVarBase* op2);
	hVarBase* operator%(const hVarBase* op2);

	hVarBase* operator=(const hVarBase* op2);

	hVarBase* operator<(const hVarBase* op2);
	hVarBase* operator>(const hVarBase* op2);
	hVarBase* operator<=(const hVarBase* op2);
	hVarBase* operator>=(const hVarBase* op2);

	hVarBase* operator!(void);
	hVarBase* operator&&(const hVarBase* op2);
	hVarBase* operator||(const hVarBase* op2);
	hVarBase* operator==(const hVarBase* op2);
	hVarBase* operator!=(const hVarBase* op2);

	hVarBase* operator~(void);

	hVarBase* operator<<(const hVarBase* op2);
	hVarBase* operator>>(const hVarBase* op2);
	hVarBase* operator&(const hVarBase* op2);
	hVarBase* operator|(const hVarBase* op2);
	hVarBase* operator^(const hVarBase* op2);

	hVarBase* operator++(void);//++a
	hVarBase* operator--(void);

	hVarBase* operator[](unsigned int index);
	hVarBase* operator[](hVarBase* index);

	hVarBase* operator()(const hVarBase* op2);
	hVarBase* operator,(const hVarBase* op2);

	void print(std::ostream& output);

	hVarBase* traverse(dataType (*function)(dataType));
	
	hVarBase * matrixMul(hVarBase *B);

	friend class hVarLinear<bool>;
	friend class hVarLinear<unsigned char>;
	friend class hVarLinear<signed char>;
	friend class hVarLinear<unsigned short>;
	friend class hVarLinear<signed short>;
	friend class hVarLinear<unsigned long>;
	friend class hVarLinear<signed long>;
	friend class hVarLinear<float>;
	friend class hVarLinear<double>;
	friend class hVarLinear<long double>;
	friend class hVarLinear<std::complex<float> >;
	friend class hVarLinear<std::complex<double> >;
	friend class hVarLinear<std::complex<long double> >;

	friend hVarBase* operator+(const bool &op1,const hVarLinear<bool> &op2);
	friend hVarBase* operator-(const bool &op1,const hVarLinear<bool> &op2);
	friend hVarBase* operator*(const bool &op1,const hVarLinear<bool> &op2);
	friend hVarBase* operator/(const bool &op1,const hVarLinear<bool> &op2);
	friend hVarBase* operator%(const bool &op1,const hVarLinear<bool> &op2);

	friend hVarBase* operator<(const bool &op1,const hVarLinear<bool> &op2);
	friend hVarBase* operator<=(const bool &op1,const hVarLinear<bool> &op2);
	friend hVarBase* operator>(const bool &op1,const hVarLinear<bool> &op2);
	friend hVarBase* operator>=(const bool &op1,const hVarLinear<bool> &op2);

	friend hVarBase* operator&&(const bool &op1,const hVarLinear<bool> &op2);
	friend hVarBase* operator||(const bool &op1,const hVarLinear<bool> &op2);
	friend hVarBase* operator==(const bool &op1,const hVarLinear<bool> &op2);
	friend hVarBase* operator!=(const bool &op1,const hVarLinear<bool> &op2);

	friend hVarBase* operator<<(const bool &op1,const hVarLinear<bool> &op2);
	friend hVarBase* operator>>(const bool &op1,const hVarLinear<bool> &op2);
	friend hVarBase* operator&(const bool &op1,const hVarLinear<bool> &op2);
	friend hVarBase* operator|(const bool &op1,const hVarLinear<bool> &op2);
	friend hVarBase* operator^(const bool &op1,const hVarLinear<bool> &op2);

	friend hVarBase* operator+(const unsigned char &op1,const hVarLinear<unsigned char> &op2);
	friend hVarBase* operator-(const unsigned char &op1,const hVarLinear<unsigned char> &op2);
	friend hVarBase* operator*(const unsigned char &op1,const hVarLinear<unsigned char> &op2);
	friend hVarBase* operator/(const unsigned char &op1,const hVarLinear<unsigned char> &op2);
	friend hVarBase* operator%(const unsigned char &op1,const hVarLinear<unsigned char> &op2);

	friend hVarBase* operator<(const unsigned char &op1,const hVarLinear<unsigned char> &op2);
	friend hVarBase* operator<=(const unsigned char &op1,const hVarLinear<unsigned char> &op2);
	friend hVarBase* operator>(const unsigned char &op1,const hVarLinear<unsigned char> &op2);
	friend hVarBase* operator>=(const unsigned char &op1,const hVarLinear<unsigned char> &op2);

	friend hVarBase* operator&&(const unsigned char &op1,const hVarLinear<unsigned char> &op2);
	friend hVarBase* operator||(const unsigned char &op1,const hVarLinear<unsigned char> &op2);
	friend hVarBase* operator==(const unsigned char &op1,const hVarLinear<unsigned char> &op2);
	friend hVarBase* operator!=(const unsigned char &op1,const hVarLinear<unsigned char> &op2);

	friend hVarBase* operator<<(const unsigned char &op1,const hVarLinear<unsigned char> &op2);
	friend hVarBase* operator>>(const unsigned char &op1,const hVarLinear<unsigned char> &op2);
	friend hVarBase* operator&(const unsigned char &op1,const hVarLinear<unsigned char> &op2);
	friend hVarBase* operator|(const unsigned char &op1,const hVarLinear<unsigned char> &op2);
	friend hVarBase* operator^(const unsigned char &op1,const hVarLinear<unsigned char> &op2);

	friend hVarBase* operator+(const signed char &op1,const hVarLinear<signed char> &op2);
	friend hVarBase* operator-(const signed char &op1,const hVarLinear<signed char> &op2);
	friend hVarBase* operator*(const signed char &op1,const hVarLinear<signed char> &op2);
	friend hVarBase* operator/(const signed char &op1,const hVarLinear<signed char> &op2);
	friend hVarBase* operator%(const signed char &op1,const hVarLinear<signed char> &op2);

	friend hVarBase* operator<(const signed char &op1,const hVarLinear<signed char> &op2);
	friend hVarBase* operator<=(const signed char &op1,const hVarLinear<signed char> &op2);
	friend hVarBase* operator>(const signed char &op1,const hVarLinear<signed char> &op2);
	friend hVarBase* operator>=(const signed char &op1,const hVarLinear<signed char> &op2);

	friend hVarBase* operator&&(const signed char &op1,const hVarLinear<signed char> &op2);
	friend hVarBase* operator||(const signed char &op1,const hVarLinear<signed char> &op2);
	friend hVarBase* operator==(const signed char &op1,const hVarLinear<signed char> &op2);
	friend hVarBase* operator!=(const signed char &op1,const hVarLinear<signed char> &op2);

	friend hVarBase* operator<<(const signed char &op1,const hVarLinear<signed char> &op2);
	friend hVarBase* operator>>(const signed char &op1,const hVarLinear<signed char> &op2);
	friend hVarBase* operator&(const signed char &op1,const hVarLinear<signed char> &op2);
	friend hVarBase* operator|(const signed char &op1,const hVarLinear<signed char> &op2);
	friend hVarBase* operator^(const signed char &op1,const hVarLinear<signed char> &op2);

	friend hVarBase* operator+(const unsigned short &op1,const hVarLinear<unsigned short> &op2);
	friend hVarBase* operator-(const unsigned short &op1,const hVarLinear<unsigned short> &op2);
	friend hVarBase* operator*(const unsigned short &op1,const hVarLinear<unsigned short> &op2);
	friend hVarBase* operator/(const unsigned short &op1,const hVarLinear<unsigned short> &op2);
	friend hVarBase* operator%(const unsigned short &op1,const hVarLinear<unsigned short> &op2);

	friend hVarBase* operator<(const unsigned short &op1,const hVarLinear<unsigned short> &op2);
	friend hVarBase* operator<=(const unsigned short &op1,const hVarLinear<unsigned short> &op2);
	friend hVarBase* operator>(const unsigned short &op1,const hVarLinear<unsigned short> &op2);
	friend hVarBase* operator>=(const unsigned short &op1,const hVarLinear<unsigned short> &op2);

	friend hVarBase* operator&&(const unsigned short &op1,const hVarLinear<unsigned short> &op2);
	friend hVarBase* operator||(const unsigned short &op1,const hVarLinear<unsigned short> &op2);
	friend hVarBase* operator==(const unsigned short &op1,const hVarLinear<unsigned short> &op2);
	friend hVarBase* operator!=(const unsigned short &op1,const hVarLinear<unsigned short> &op2);

	friend hVarBase* operator<<(const unsigned short &op1,const hVarLinear<unsigned short> &op2);
	friend hVarBase* operator>>(const unsigned short &op1,const hVarLinear<unsigned short> &op2);
	friend hVarBase* operator&(const unsigned short &op1,const hVarLinear<unsigned short> &op2);
	friend hVarBase* operator|(const unsigned short &op1,const hVarLinear<unsigned short> &op2);
	friend hVarBase* operator^(const unsigned short &op1,const hVarLinear<unsigned short> &op2);

	friend hVarBase* operator+(const signed short &op1,const hVarLinear<signed short> &op2);
	friend hVarBase* operator-(const signed short &op1,const hVarLinear<signed short> &op2);
	friend hVarBase* operator*(const signed short &op1,const hVarLinear<signed short> &op2);
	friend hVarBase* operator/(const signed short &op1,const hVarLinear<signed short> &op2);
	friend hVarBase* operator%(const signed short &op1,const hVarLinear<signed short> &op2);

	friend hVarBase* operator<(const signed short &op1,const hVarLinear<signed short> &op2);
	friend hVarBase* operator<=(const signed short &op1,const hVarLinear<signed short> &op2);
	friend hVarBase* operator>(const signed short &op1,const hVarLinear<signed short> &op2);
	friend hVarBase* operator>=(const signed short &op1,const hVarLinear<signed short> &op2);

	friend hVarBase* operator&&(const signed short &op1,const hVarLinear<signed short> &op2);
	friend hVarBase* operator||(const signed short &op1,const hVarLinear<signed short> &op2);
	friend hVarBase* operator==(const signed short &op1,const hVarLinear<signed short> &op2);
	friend hVarBase* operator!=(const signed short &op1,const hVarLinear<signed short> &op2);

	friend hVarBase* operator<<(const signed short &op1,const hVarLinear<signed short> &op2);
	friend hVarBase* operator>>(const signed short &op1,const hVarLinear<signed short> &op2);
	friend hVarBase* operator&(const signed short &op1,const hVarLinear<signed short> &op2);
	friend hVarBase* operator|(const signed short &op1,const hVarLinear<signed short> &op2);
	friend hVarBase* operator^(const signed short &op1,const hVarLinear<signed short> &op2);

	friend hVarBase* operator+(const unsigned long &op1,const hVarLinear<unsigned long> &op2);
	friend hVarBase* operator-(const unsigned long &op1,const hVarLinear<unsigned long> &op2);
	friend hVarBase* operator*(const unsigned long &op1,const hVarLinear<unsigned long> &op2);
	friend hVarBase* operator/(const unsigned long &op1,const hVarLinear<unsigned long> &op2);
	friend hVarBase* operator%(const unsigned long &op1,const hVarLinear<unsigned long> &op2);

	friend hVarBase* operator<(const unsigned long &op1,const hVarLinear<unsigned long> &op2);
	friend hVarBase* operator<=(const unsigned long &op1,const hVarLinear<unsigned long> &op2);
	friend hVarBase* operator>(const unsigned long &op1,const hVarLinear<unsigned long> &op2);
	friend hVarBase* operator>=(const unsigned long &op1,const hVarLinear<unsigned long> &op2);

	friend hVarBase* operator&&(const unsigned long &op1,const hVarLinear<unsigned long> &op2);
	friend hVarBase* operator||(const unsigned long &op1,const hVarLinear<unsigned long> &op2);
	friend hVarBase* operator==(const unsigned long &op1,const hVarLinear<unsigned long> &op2);
	friend hVarBase* operator!=(const unsigned long &op1,const hVarLinear<unsigned long> &op2);

	friend hVarBase* operator<<(const unsigned long &op1,const hVarLinear<unsigned long> &op2);
	friend hVarBase* operator>>(const unsigned long &op1,const hVarLinear<unsigned long> &op2);
	friend hVarBase* operator&(const unsigned long &op1,const hVarLinear<unsigned long> &op2);
	friend hVarBase* operator|(const unsigned long &op1,const hVarLinear<unsigned long> &op2);
	friend hVarBase* operator^(const unsigned long &op1,const hVarLinear<unsigned long> &op2);

	friend hVarBase* operator+(const signed long &op1,const hVarLinear<signed long> &op2);
	friend hVarBase* operator-(const signed long &op1,const hVarLinear<signed long> &op2);
	friend hVarBase* operator*(const signed long &op1,const hVarLinear<signed long> &op2);
	friend hVarBase* operator/(const signed long &op1,const hVarLinear<signed long> &op2);
	friend hVarBase* operator%(const signed long &op1,const hVarLinear<signed long> &op2);

	friend hVarBase* operator<(const signed long &op1,const hVarLinear<signed long> &op2);
	friend hVarBase* operator<=(const signed long &op1,const hVarLinear<signed long> &op2);
	friend hVarBase* operator>(const signed long &op1,const hVarLinear<signed long> &op2);
	friend hVarBase* operator>=(const signed long &op1,const hVarLinear<signed long> &op2);

	friend hVarBase* operator&&(const signed long &op1,const hVarLinear<signed long> &op2);
	friend hVarBase* operator||(const signed long &op1,const hVarLinear<signed long> &op2);
	friend hVarBase* operator==(const signed long &op1,const hVarLinear<signed long> &op2);
	friend hVarBase* operator!=(const signed long &op1,const hVarLinear<signed long> &op2);

	friend hVarBase* operator<<(const signed long &op1,const hVarLinear<signed long> &op2);
	friend hVarBase* operator>>(const signed long &op1,const hVarLinear<signed long> &op2);
	friend hVarBase* operator&(const signed long &op1,const hVarLinear<signed long> &op2);
	friend hVarBase* operator|(const signed long &op1,const hVarLinear<signed long> &op2);
	friend hVarBase* operator^(const signed long &op1,const hVarLinear<signed long> &op2);

	friend hVarBase* operator+(const float &op1,const hVarLinear<float> &op2);
	friend hVarBase* operator-(const float &op1,const hVarLinear<float> &op2);
	friend hVarBase* operator*(const float &op1,const hVarLinear<float> &op2);
	friend hVarBase* operator/(const float &op1,const hVarLinear<float> &op2);
	friend hVarBase* operator%(const float &op1,const hVarLinear<float> &op2);

	friend hVarBase* operator<(const float &op1,const hVarLinear<float> &op2);
	friend hVarBase* operator<=(const float &op1,const hVarLinear<float> &op2);
	friend hVarBase* operator>(const float &op1,const hVarLinear<float> &op2);
	friend hVarBase* operator>=(const float &op1,const hVarLinear<float> &op2);

	friend hVarBase* operator&&(const float &op1,const hVarLinear<float> &op2);
	friend hVarBase* operator||(const float &op1,const hVarLinear<float> &op2);
	friend hVarBase* operator==(const float &op1,const hVarLinear<float> &op2);
	friend hVarBase* operator!=(const float &op1,const hVarLinear<float> &op2);

	friend hVarBase* operator<<(const float &op1,const hVarLinear<float> &op2);
	friend hVarBase* operator>>(const float &op1,const hVarLinear<float> &op2);
	friend hVarBase* operator&(const float &op1,const hVarLinear<float> &op2);
	friend hVarBase* operator|(const float &op1,const hVarLinear<float> &op2);
	friend hVarBase* operator^(const float &op1,const hVarLinear<float> &op2);

	friend hVarBase* operator+(const double &op1,const hVarLinear<double> &op2);
	friend hVarBase* operator-(const double &op1,const hVarLinear<double> &op2);
	friend hVarBase* operator*(const double &op1,const hVarLinear<double> &op2);
	friend hVarBase* operator/(const double &op1,const hVarLinear<double> &op2);
	friend hVarBase* operator%(const double &op1,const hVarLinear<double> &op2);

	friend hVarBase* operator<(const double &op1,const hVarLinear<double> &op2);
	friend hVarBase* operator<=(const double &op1,const hVarLinear<double> &op2);
	friend hVarBase* operator>(const double &op1,const hVarLinear<double> &op2);
	friend hVarBase* operator>=(const double &op1,const hVarLinear<double> &op2);

	friend hVarBase* operator&&(const double &op1,const hVarLinear<double> &op2);
	friend hVarBase* operator||(const double &op1,const hVarLinear<double> &op2);
	friend hVarBase* operator==(const double &op1,const hVarLinear<double> &op2);
	friend hVarBase* operator!=(const double &op1,const hVarLinear<double> &op2);

	friend hVarBase* operator<<(const double &op1,const hVarLinear<double> &op2);
	friend hVarBase* operator>>(const double &op1,const hVarLinear<double> &op2);
	friend hVarBase* operator&(const double &op1,const hVarLinear<double> &op2);
	friend hVarBase* operator|(const double &op1,const hVarLinear<double> &op2);
	friend hVarBase* operator^(const double &op1,const hVarLinear<double> &op2);

	friend hVarBase* operator+(const long double &op1,const hVarLinear<long double> &op2);
	friend hVarBase* operator-(const long double &op1,const hVarLinear<long double> &op2);
	friend hVarBase* operator*(const long double &op1,const hVarLinear<long double> &op2);
	friend hVarBase* operator/(const long double &op1,const hVarLinear<long double> &op2);
	friend hVarBase* operator%(const long double &op1,const hVarLinear<long double> &op2);

	friend hVarBase* operator<(const long double &op1,const hVarLinear<long double> &op2);
	friend hVarBase* operator<=(const long double &op1,const hVarLinear<long double> &op2);
	friend hVarBase* operator>(const long double &op1,const hVarLinear<long double> &op2);
	friend hVarBase* operator>=(const long double &op1,const hVarLinear<long double> &op2);

	friend hVarBase* operator&&(const long double &op1,const hVarLinear<long double> &op2);
	friend hVarBase* operator||(const long double &op1,const hVarLinear<long double> &op2);
	friend hVarBase* operator==(const long double &op1,const hVarLinear<long double> &op2);
	friend hVarBase* operator!=(const long double &op1,const hVarLinear<long double> &op2);

	friend hVarBase* operator<<(const long double &op1,const hVarLinear<long double> &op2);
	friend hVarBase* operator>>(const long double &op1,const hVarLinear<long double> &op2);
	friend hVarBase* operator&(const long double &op1,const hVarLinear<long double> &op2);
	friend hVarBase* operator|(const long double &op1,const hVarLinear<long double> &op2);
	friend hVarBase* operator^(const long double &op1,const hVarLinear<long double> &op2);

	friend hVarBase* operator+(const std::complex<float>  &op1,const hVarLinear<std::complex<float> > &op2);
	friend hVarBase* operator-(const std::complex<float>  &op1,const hVarLinear<std::complex<float> > &op2);
	friend hVarBase* operator*(const std::complex<float>  &op1,const hVarLinear<std::complex<float> > &op2);
	friend hVarBase* operator/(const std::complex<float>  &op1,const hVarLinear<std::complex<float> > &op2);
	friend hVarBase* operator%(const std::complex<float>  &op1,const hVarLinear<std::complex<float> > &op2);

	friend hVarBase* operator<(const std::complex<float>  &op1,const hVarLinear<std::complex<float> > &op2);
	friend hVarBase* operator<=(const std::complex<float>  &op1,const hVarLinear<std::complex<float> > &op2);
	friend hVarBase* operator>(const std::complex<float>  &op1,const hVarLinear<std::complex<float> > &op2);
	friend hVarBase* operator>=(const std::complex<float>  &op1,const hVarLinear<std::complex<float> > &op2);

	friend hVarBase* operator&&(const std::complex<float>  &op1,const hVarLinear<std::complex<float> > &op2);
	friend hVarBase* operator||(const std::complex<float>  &op1,const hVarLinear<std::complex<float> > &op2);
	friend hVarBase* operator==(const std::complex<float>  &op1,const hVarLinear<std::complex<float> > &op2);
	friend hVarBase* operator!=(const std::complex<float>  &op1,const hVarLinear<std::complex<float> > &op2);

	friend hVarBase* operator<<(const std::complex<float>  &op1,const hVarLinear<std::complex<float> > &op2);
	friend hVarBase* operator>>(const std::complex<float>  &op1,const hVarLinear<std::complex<float> > &op2);
	friend hVarBase* operator&(const std::complex<float>  &op1,const hVarLinear<std::complex<float> > &op2);
	friend hVarBase* operator|(const std::complex<float>  &op1,const hVarLinear<std::complex<float> > &op2);
	friend hVarBase* operator^(const std::complex<float>  &op1,const hVarLinear<std::complex<float> > &op2);

	friend hVarBase* operator+(const std::complex<double>  &op1,const hVarLinear<std::complex<double> > &op2);
	friend hVarBase* operator-(const std::complex<double>  &op1,const hVarLinear<std::complex<double> > &op2);
	friend hVarBase* operator*(const std::complex<double>  &op1,const hVarLinear<std::complex<double> > &op2);
	friend hVarBase* operator/(const std::complex<double>  &op1,const hVarLinear<std::complex<double> > &op2);
	friend hVarBase* operator%(const std::complex<double>  &op1,const hVarLinear<std::complex<double> > &op2);

	friend hVarBase* operator<(const std::complex<double>  &op1,const hVarLinear<std::complex<double> > &op2);
	friend hVarBase* operator<=(const std::complex<double>  &op1,const hVarLinear<std::complex<double> > &op2);
	friend hVarBase* operator>(const std::complex<double>  &op1,const hVarLinear<std::complex<double> > &op2);
	friend hVarBase* operator>=(const std::complex<double>  &op1,const hVarLinear<std::complex<double> > &op2);

	friend hVarBase* operator&&(const std::complex<double>  &op1,const hVarLinear<std::complex<double> > &op2);
	friend hVarBase* operator||(const std::complex<double>  &op1,const hVarLinear<std::complex<double> > &op2);
	friend hVarBase* operator==(const std::complex<double>  &op1,const hVarLinear<std::complex<double> > &op2);
	friend hVarBase* operator!=(const std::complex<double>  &op1,const hVarLinear<std::complex<double> > &op2);

	friend hVarBase* operator<<(const std::complex<double>  &op1,const hVarLinear<std::complex<double> > &op2);
	friend hVarBase* operator>>(const std::complex<double>  &op1,const hVarLinear<std::complex<double> > &op2);
	friend hVarBase* operator&(const std::complex<double>  &op1,const hVarLinear<std::complex<double> > &op2);
	friend hVarBase* operator|(const std::complex<double>  &op1,const hVarLinear<std::complex<double> > &op2);
	friend hVarBase* operator^(const std::complex<double>  &op1,const hVarLinear<std::complex<double> > &op2);

	friend hVarBase* operator+(const std::complex<long double>  &op1,const hVarLinear<std::complex<long double> > &op2);
	friend hVarBase* operator-(const std::complex<long double>  &op1,const hVarLinear<std::complex<long double> > &op2);
	friend hVarBase* operator*(const std::complex<long double>  &op1,const hVarLinear<std::complex<long double> > &op2);
	friend hVarBase* operator/(const std::complex<long double>  &op1,const hVarLinear<std::complex<long double> > &op2);
	friend hVarBase* operator%(const std::complex<long double>  &op1,const hVarLinear<std::complex<long double> > &op2);

	friend hVarBase* operator<(const std::complex<long double>  &op1,const hVarLinear<std::complex<long double> > &op2);
	friend hVarBase* operator<=(const std::complex<long double>  &op1,const hVarLinear<std::complex<long double> > &op2);
	friend hVarBase* operator>(const std::complex<long double>  &op1,const hVarLinear<std::complex<long double> > &op2);
	friend hVarBase* operator>=(const std::complex<long double>  &op1,const hVarLinear<std::complex<long double> > &op2);

	friend hVarBase* operator&&(const std::complex<long double>  &op1,const hVarLinear<std::complex<long double> > &op2);
	friend hVarBase* operator||(const std::complex<long double>  &op1,const hVarLinear<std::complex<long double> > &op2);
	friend hVarBase* operator==(const std::complex<long double>  &op1,const hVarLinear<std::complex<long double> > &op2);
	friend hVarBase* operator!=(const std::complex<long double>  &op1,const hVarLinear<std::complex<long double> > &op2);

	friend hVarBase* operator<<(const std::complex<long double>  &op1,const hVarLinear<std::complex<long double> > &op2);
	friend hVarBase* operator>>(const std::complex<long double>  &op1,const hVarLinear<std::complex<long double> > &op2);
	friend hVarBase* operator&(const std::complex<long double>  &op1,const hVarLinear<std::complex<long double> > &op2);
	friend hVarBase* operator|(const std::complex<long double>  &op1,const hVarLinear<std::complex<long double> > &op2);
	friend hVarBase* operator^(const std::complex<long double>  &op1,const hVarLinear<std::complex<long double> > &op2);

	friend hVarBase* sin(const hVarLinear<bool> & op);
	friend hVarBase* sin(const hVarLinear<unsigned char> & op);
	friend hVarBase* sin(const hVarLinear<signed char> & op);
	friend hVarBase* sin(const hVarLinear<unsigned short> & op);
	friend hVarBase* sin(const hVarLinear<signed short> & op);
	friend hVarBase* sin(const hVarLinear<unsigned long> & op);
	friend hVarBase* sin(const hVarLinear<signed long> & op);
	friend hVarBase* sin(const hVarLinear<float> & op);
	friend hVarBase* sin(const hVarLinear<double> & op);
	friend hVarBase* sin(const hVarLinear<long double> & op);
	friend hVarBase* sin(const hVarLinear<std::complex<float> > & op);
	friend hVarBase* sin(const hVarLinear<std::complex<double> > & op);
	friend hVarBase* sin(const hVarLinear<std::complex<long double> > & op);

	friend hVarBase* cos(const hVarLinear<bool> & op);
	friend hVarBase* cos(const hVarLinear<unsigned char> & op);
	friend hVarBase* cos(const hVarLinear<signed char> & op);
	friend hVarBase* cos(const hVarLinear<unsigned short> & op);
	friend hVarBase* cos(const hVarLinear<signed short> & op);
	friend hVarBase* cos(const hVarLinear<unsigned long> & op);
	friend hVarBase* cos(const hVarLinear<signed long> & op);
	friend hVarBase* cos(const hVarLinear<float> & op);
	friend hVarBase* cos(const hVarLinear<double> & op);
	friend hVarBase* cos(const hVarLinear<long double> & op);
	friend hVarBase* cos(const hVarLinear<std::complex<float> > & op);
	friend hVarBase* cos(const hVarLinear<std::complex<double> > & op);
	friend hVarBase* cos(const hVarLinear<std::complex<long double> > & op);

	friend hVarBase* tan(const hVarLinear<bool> & op);
	friend hVarBase* tan(const hVarLinear<unsigned char> & op);
	friend hVarBase* tan(const hVarLinear<signed char> & op);
	friend hVarBase* tan(const hVarLinear<unsigned short> & op);
	friend hVarBase* tan(const hVarLinear<signed short> & op);
	friend hVarBase* tan(const hVarLinear<unsigned long> & op);
	friend hVarBase* tan(const hVarLinear<signed long> & op);
	friend hVarBase* tan(const hVarLinear<float> & op);
	friend hVarBase* tan(const hVarLinear<double> & op);
	friend hVarBase* tan(const hVarLinear<long double> & op);
	friend hVarBase* tan(const hVarLinear<std::complex<float> > & op);
	friend hVarBase* tan(const hVarLinear<std::complex<double> > & op);
	friend hVarBase* tan(const hVarLinear<std::complex<long double> > & op);

	friend hVarBase* acos(const hVarLinear<bool> & op);
	friend hVarBase* acos(const hVarLinear<unsigned char> & op);
	friend hVarBase* acos(const hVarLinear<signed char> & op);
	friend hVarBase* acos(const hVarLinear<unsigned short> & op);
	friend hVarBase* acos(const hVarLinear<signed short> & op);
	friend hVarBase* acos(const hVarLinear<unsigned long> & op);
	friend hVarBase* acos(const hVarLinear<signed long> & op);
	friend hVarBase* acos(const hVarLinear<float> & op);
	friend hVarBase* acos(const hVarLinear<double> & op);
	friend hVarBase* acos(const hVarLinear<long double> & op);
	friend hVarBase* acos(const hVarLinear<std::complex<float> > & op);
	friend hVarBase* acos(const hVarLinear<std::complex<double> > & op);
	friend hVarBase* acos(const hVarLinear<std::complex<long double> > & op);

	friend hVarBase* asin(const hVarLinear<bool> & op);
	friend hVarBase* asin(const hVarLinear<unsigned char> & op);
	friend hVarBase* asin(const hVarLinear<signed char> & op);
	friend hVarBase* asin(const hVarLinear<unsigned short> & op);
	friend hVarBase* asin(const hVarLinear<signed short> & op);
	friend hVarBase* asin(const hVarLinear<unsigned long> & op);
	friend hVarBase* asin(const hVarLinear<signed long> & op);
	friend hVarBase* asin(const hVarLinear<float> & op);
	friend hVarBase* asin(const hVarLinear<double> & op);
	friend hVarBase* asin(const hVarLinear<long double> & op);
	friend hVarBase* asin(const hVarLinear<std::complex<float> > & op);
	friend hVarBase* asin(const hVarLinear<std::complex<double> > & op);
	friend hVarBase* asin(const hVarLinear<std::complex<long double> > & op);

	friend hVarBase* atan(const hVarLinear<bool> & op);
	friend hVarBase* atan(const hVarLinear<unsigned char> & op);
	friend hVarBase* atan(const hVarLinear<signed char> & op);
	friend hVarBase* atan(const hVarLinear<unsigned short> & op);
	friend hVarBase* atan(const hVarLinear<signed short> & op);
	friend hVarBase* atan(const hVarLinear<unsigned long> & op);
	friend hVarBase* atan(const hVarLinear<signed long> & op);
	friend hVarBase* atan(const hVarLinear<float> & op);
	friend hVarBase* atan(const hVarLinear<double> & op);
	friend hVarBase* atan(const hVarLinear<long double> & op);
	friend hVarBase* atan(const hVarLinear<std::complex<float> > & op);
	friend hVarBase* atan(const hVarLinear<std::complex<double> > & op);
	friend hVarBase* atan(const hVarLinear<std::complex<long double> > & op);

/*	friend hVarBase* atan2(const hVarLinear<bool> & op1,const hVarLinear<bool> & op2);
	friend hVarBase* atan2(const hVarLinear<unsigned char> & op1,const hVarLinear<unsigned char> & op2);
	friend hVarBase* atan2(const hVarLinear<signed char> & op1,const hVarLinear<signed char> & op2);
	friend hVarBase* atan2(const hVarLinear<unsigned short> & op1,const hVarLinear<unsigned short> & op2);
	friend hVarBase* atan2(const hVarLinear<signed short> & op1,const hVarLinear<signed short> & op2);
	friend hVarBase* atan2(const hVarLinear<unsigned long> & op1,const hVarLinear<unsigned long> & op2);
	friend hVarBase* atan2(const hVarLinear<signed long> & op1,const hVarLinear<signed long> & op2);
	friend hVarBase* atan2(const hVarLinear<float> & op1,const hVarLinear<float> & op2);
	friend hVarBase* atan2(const hVarLinear<double> & op1,const hVarLinear<double> & op2);
	friend hVarBase* atan2(const hVarLinear<long double> & op1,const hVarLinear<long double> & op2);
	friend hVarBase* atan2(const hVarLinear<std::complex<float> > & op1,const hVarLinear<std::complex<float> > & op2);
	friend hVarBase* atan2(const hVarLinear<std::complex<double> > & op1,const hVarLinear<std::complex<double> > & op2);
	friend hVarBase* atan2(const hVarLinear<std::complex<long double> > & op1,const hVarLinear<std::complex<long double> > & op2);*/

	friend hVarBase* cosh(const hVarLinear<bool> & op);
	friend hVarBase* cosh(const hVarLinear<unsigned char> & op);
	friend hVarBase* cosh(const hVarLinear<signed char> & op);
	friend hVarBase* cosh(const hVarLinear<unsigned short> & op);
	friend hVarBase* cosh(const hVarLinear<signed short> & op);
	friend hVarBase* cosh(const hVarLinear<unsigned long> & op);
	friend hVarBase* cosh(const hVarLinear<signed long> & op);
	friend hVarBase* cosh(const hVarLinear<float> & op);
	friend hVarBase* cosh(const hVarLinear<double> & op);
	friend hVarBase* cosh(const hVarLinear<long double> & op);
	friend hVarBase* cosh(const hVarLinear<std::complex<float> > & op);
	friend hVarBase* cosh(const hVarLinear<std::complex<double> > & op);
	friend hVarBase* cosh(const hVarLinear<std::complex<long double> > & op);

	friend hVarBase* sinh(const hVarLinear<bool> & op);
	friend hVarBase* sinh(const hVarLinear<unsigned char> & op);
	friend hVarBase* sinh(const hVarLinear<signed char> & op);
	friend hVarBase* sinh(const hVarLinear<unsigned short> & op);
	friend hVarBase* sinh(const hVarLinear<signed short> & op);
	friend hVarBase* sinh(const hVarLinear<unsigned long> & op);
	friend hVarBase* sinh(const hVarLinear<signed long> & op);
	friend hVarBase* sinh(const hVarLinear<float> & op);
	friend hVarBase* sinh(const hVarLinear<double> & op);
	friend hVarBase* sinh(const hVarLinear<long double> & op);
	friend hVarBase* sinh(const hVarLinear<std::complex<float> > & op);
	friend hVarBase* sinh(const hVarLinear<std::complex<double> > & op);
	friend hVarBase* sinh(const hVarLinear<std::complex<long double> > & op);

	friend hVarBase* tanh(const hVarLinear<bool> & op);
	friend hVarBase* tanh(const hVarLinear<unsigned char> & op);
	friend hVarBase* tanh(const hVarLinear<signed char> & op);
	friend hVarBase* tanh(const hVarLinear<unsigned short> & op);
	friend hVarBase* tanh(const hVarLinear<signed short> & op);
	friend hVarBase* tanh(const hVarLinear<unsigned long> & op);
	friend hVarBase* tanh(const hVarLinear<signed long> & op);
	friend hVarBase* tanh(const hVarLinear<float> & op);
	friend hVarBase* tanh(const hVarLinear<double> & op);
	friend hVarBase* tanh(const hVarLinear<long double> & op);
	friend hVarBase* tanh(const hVarLinear<std::complex<float> > & op);
	friend hVarBase* tanh(const hVarLinear<std::complex<double> > & op);
	friend hVarBase* tanh(const hVarLinear<std::complex<long double> > & op);

	friend hVarBase* exp(const hVarLinear<bool> & op);
	friend hVarBase* exp(const hVarLinear<unsigned char> & op);
	friend hVarBase* exp(const hVarLinear<signed char> & op);
	friend hVarBase* exp(const hVarLinear<unsigned short> & op);
	friend hVarBase* exp(const hVarLinear<signed short> & op);
	friend hVarBase* exp(const hVarLinear<unsigned long> & op);
	friend hVarBase* exp(const hVarLinear<signed long> & op);
	friend hVarBase* exp(const hVarLinear<float> & op);
	friend hVarBase* exp(const hVarLinear<double> & op);
	friend hVarBase* exp(const hVarLinear<long double> & op);
	friend hVarBase* exp(const hVarLinear<std::complex<float> > & op);
	friend hVarBase* exp(const hVarLinear<std::complex<double> > & op);
	friend hVarBase* exp(const hVarLinear<std::complex<long double> > & op);

	friend hVarBase* frexp(const hVarLinear<bool> & op);
	friend hVarBase* frexp(const hVarLinear<unsigned char> & op);
	friend hVarBase* frexp(const hVarLinear<signed char> & op);
	friend hVarBase* frexp(const hVarLinear<unsigned short> & op);
	friend hVarBase* frexp(const hVarLinear<signed short> & op);
	friend hVarBase* frexp(const hVarLinear<unsigned long> & op);
	friend hVarBase* frexp(const hVarLinear<signed long> & op);
	friend hVarBase* frexp(const hVarLinear<float> & op);
	friend hVarBase* frexp(const hVarLinear<double> & op);
	friend hVarBase* frexp(const hVarLinear<long double> & op);
	friend hVarBase* frexp(const hVarLinear<std::complex<float> > & op);
	friend hVarBase* frexp(const hVarLinear<std::complex<double> > & op);
	friend hVarBase* frexp(const hVarLinear<std::complex<long double> > & op);

	friend hVarBase* ldexp(const hVarLinear<bool> & op);
	friend hVarBase* ldexp(const hVarLinear<unsigned char> & op);
	friend hVarBase* ldexp(const hVarLinear<signed char> & op);
	friend hVarBase* ldexp(const hVarLinear<unsigned short> & op);
	friend hVarBase* ldexp(const hVarLinear<signed short> & op);
	friend hVarBase* ldexp(const hVarLinear<unsigned long> & op);
	friend hVarBase* ldexp(const hVarLinear<signed long> & op);
	friend hVarBase* ldexp(const hVarLinear<float> & op);
	friend hVarBase* ldexp(const hVarLinear<double> & op);
	friend hVarBase* ldexp(const hVarLinear<long double> & op);
	friend hVarBase* ldexp(const hVarLinear<std::complex<float> > & op);
	friend hVarBase* ldexp(const hVarLinear<std::complex<double> > & op);
	friend hVarBase* ldexp(const hVarLinear<std::complex<long double> > & op);

	friend hVarBase* log(const hVarLinear<bool> & op);
	friend hVarBase* log(const hVarLinear<unsigned char> & op);
	friend hVarBase* log(const hVarLinear<signed char> & op);
	friend hVarBase* log(const hVarLinear<unsigned short> & op);
	friend hVarBase* log(const hVarLinear<signed short> & op);
	friend hVarBase* log(const hVarLinear<unsigned long> & op);
	friend hVarBase* log(const hVarLinear<signed long> & op);
	friend hVarBase* log(const hVarLinear<float> & op);
	friend hVarBase* log(const hVarLinear<double> & op);
	friend hVarBase* log(const hVarLinear<long double> & op);
	friend hVarBase* log(const hVarLinear<std::complex<float> > & op);
	friend hVarBase* log(const hVarLinear<std::complex<double> > & op);
	friend hVarBase* log(const hVarLinear<std::complex<long double> > & op);

	friend hVarBase* log10(const hVarLinear<bool> & op);
	friend hVarBase* log10(const hVarLinear<unsigned char> & op);
	friend hVarBase* log10(const hVarLinear<signed char> & op);
	friend hVarBase* log10(const hVarLinear<unsigned short> & op);
	friend hVarBase* log10(const hVarLinear<signed short> & op);
	friend hVarBase* log10(const hVarLinear<unsigned long> & op);
	friend hVarBase* log10(const hVarLinear<signed long> & op);
	friend hVarBase* log10(const hVarLinear<float> & op);
	friend hVarBase* log10(const hVarLinear<double> & op);
	friend hVarBase* log10(const hVarLinear<long double> & op);
	friend hVarBase* log10(const hVarLinear<std::complex<float> > & op);
	friend hVarBase* log10(const hVarLinear<std::complex<double> > & op);
	friend hVarBase* log10(const hVarLinear<std::complex<long double> > & op);

	friend hVarBase* modf(const hVarLinear<bool> & op);
	friend hVarBase* modf(const hVarLinear<unsigned char> & op);
	friend hVarBase* modf(const hVarLinear<signed char> & op);
	friend hVarBase* modf(const hVarLinear<unsigned short> & op);
	friend hVarBase* modf(const hVarLinear<signed short> & op);
	friend hVarBase* modf(const hVarLinear<unsigned long> & op);
	friend hVarBase* modf(const hVarLinear<signed long> & op);
	friend hVarBase* modf(const hVarLinear<float> & op);
	friend hVarBase* modf(const hVarLinear<double> & op);
	friend hVarBase* modf(const hVarLinear<long double> & op);
	friend hVarBase* modf(const hVarLinear<std::complex<float> > & op);
	friend hVarBase* modf(const hVarLinear<std::complex<double> > & op);
	friend hVarBase* modf(const hVarLinear<std::complex<long double> > & op);


	friend hVarBase* pow(const hVarLinear<bool> & op);
	friend hVarBase* pow(const hVarLinear<unsigned char> & op);
	friend hVarBase* pow(const hVarLinear<signed char> & op);
	friend hVarBase* pow(const hVarLinear<unsigned short> & op);
	friend hVarBase* pow(const hVarLinear<signed short> & op);
	friend hVarBase* pow(const hVarLinear<unsigned long> & op);
	friend hVarBase* pow(const hVarLinear<signed long> & op);
	friend hVarBase* pow(const hVarLinear<float> & op);
	friend hVarBase* pow(const hVarLinear<double> & op);
	friend hVarBase* pow(const hVarLinear<long double> & op);
	friend hVarBase* pow(const hVarLinear<std::complex<float> > & op);
	friend hVarBase* pow(const hVarLinear<std::complex<double> > & op);
	friend hVarBase* pow(const hVarLinear<std::complex<long double> > & op);


	friend hVarBase* sqrt(const hVarLinear<bool> & op);
	friend hVarBase* sqrt(const hVarLinear<unsigned char> & op);
	friend hVarBase* sqrt(const hVarLinear<signed char> & op);
	friend hVarBase* sqrt(const hVarLinear<unsigned short> & op);
	friend hVarBase* sqrt(const hVarLinear<signed short> & op);
	friend hVarBase* sqrt(const hVarLinear<unsigned long> & op);
	friend hVarBase* sqrt(const hVarLinear<signed long> & op);
	friend hVarBase* sqrt(const hVarLinear<float> & op);
	friend hVarBase* sqrt(const hVarLinear<double> & op);
	friend hVarBase* sqrt(const hVarLinear<long double> & op);
	friend hVarBase* sqrt(const hVarLinear<std::complex<float> > & op);
	friend hVarBase* sqrt(const hVarLinear<std::complex<double> > & op);
	friend hVarBase* sqrt(const hVarLinear<std::complex<long double> > & op);


	friend hVarBase* ceil(const hVarLinear<bool> & op);
	friend hVarBase* ceil(const hVarLinear<unsigned char> & op);
	friend hVarBase* ceil(const hVarLinear<signed char> & op);
	friend hVarBase* ceil(const hVarLinear<unsigned short> & op);
	friend hVarBase* ceil(const hVarLinear<signed short> & op);
	friend hVarBase* ceil(const hVarLinear<unsigned long> & op);
	friend hVarBase* ceil(const hVarLinear<signed long> & op);
	friend hVarBase* ceil(const hVarLinear<float> & op);
	friend hVarBase* ceil(const hVarLinear<double> & op);
	friend hVarBase* ceil(const hVarLinear<long double> & op);
	friend hVarBase* ceil(const hVarLinear<std::complex<float> > & op);
	friend hVarBase* ceil(const hVarLinear<std::complex<double> > & op);
	friend hVarBase* ceil(const hVarLinear<std::complex<long double> > & op);

	friend hVarBase* fabs(const hVarLinear<bool> & op);
	friend hVarBase* fabs(const hVarLinear<unsigned char> & op);
	friend hVarBase* fabs(const hVarLinear<signed char> & op);
	friend hVarBase* fabs(const hVarLinear<unsigned short> & op);
	friend hVarBase* fabs(const hVarLinear<signed short> & op);
	friend hVarBase* fabs(const hVarLinear<unsigned long> & op);
	friend hVarBase* fabs(const hVarLinear<signed long> & op);
	friend hVarBase* fabs(const hVarLinear<float> & op);
	friend hVarBase* fabs(const hVarLinear<double> & op);
	friend hVarBase* fabs(const hVarLinear<long double> & op);
	friend hVarBase* fabs(const hVarLinear<std::complex<float> > & op);
	friend hVarBase* fabs(const hVarLinear<std::complex<double> > & op);
	friend hVarBase* fabs(const hVarLinear<std::complex<long double> > & op);

	friend hVarBase* floor(const hVarLinear<bool> & op);
	friend hVarBase* floor(const hVarLinear<unsigned char> & op);
	friend hVarBase* floor(const hVarLinear<signed char> & op);
	friend hVarBase* floor(const hVarLinear<unsigned short> & op);
	friend hVarBase* floor(const hVarLinear<signed short> & op);
	friend hVarBase* floor(const hVarLinear<unsigned long> & op);
	friend hVarBase* floor(const hVarLinear<signed long> & op);
	friend hVarBase* floor(const hVarLinear<float> & op);
	friend hVarBase* floor(const hVarLinear<double> & op);
	friend hVarBase* floor(const hVarLinear<long double> & op);
	friend hVarBase* floor(const hVarLinear<std::complex<float> > & op);
	friend hVarBase* floor(const hVarLinear<std::complex<double> > & op);
	friend hVarBase* floor(const hVarLinear<std::complex<long double> > & op);

	friend hVarBase* fmod(const hVarLinear<bool> & op);
	friend hVarBase* fmod(const hVarLinear<unsigned char> & op);
	friend hVarBase* fmod(const hVarLinear<signed char> & op);
	friend hVarBase* fmod(const hVarLinear<unsigned short> & op);
	friend hVarBase* fmod(const hVarLinear<signed short> & op);
	friend hVarBase* fmod(const hVarLinear<unsigned long> & op);
	friend hVarBase* fmod(const hVarLinear<signed long> & op);
	friend hVarBase* fmod(const hVarLinear<float> & op);
	friend hVarBase* fmod(const hVarLinear<double> & op);
	friend hVarBase* fmod(const hVarLinear<long double> & op);
	friend hVarBase* fmod(const hVarLinear<std::complex<float> > & op);
	friend hVarBase* fmod(const hVarLinear<std::complex<double> > & op);
	friend hVarBase* fmod(const hVarLinear<std::complex<long double> > & op);

};

//namespace hvar{
hVarBase* operator+(const bool &op1,const hVarLinear<bool> &op2);
hVarBase* operator-(const bool &op1,const hVarLinear<bool> &op2);
hVarBase* operator*(const bool &op1,const hVarLinear<bool> &op2);
hVarBase* operator/(const bool &op1,const hVarLinear<bool> &op2);
hVarBase* operator%(const bool &op1,const hVarLinear<bool> &op2);

hVarBase* operator<(const bool &op1,const hVarLinear<bool> &op2);
hVarBase* operator<=(const bool &op1,const hVarLinear<bool> &op2);
hVarBase* operator>(const bool &op1,const hVarLinear<bool> &op2);
hVarBase* operator>=(const bool &op1,const hVarLinear<bool> &op2);

hVarBase* operator&&(const bool &op1,const hVarLinear<bool> &op2);
hVarBase* operator||(const bool &op1,const hVarLinear<bool> &op2);
hVarBase* operator==(const bool &op1,const hVarLinear<bool> &op2);
hVarBase* operator!=(const bool &op1,const hVarLinear<bool> &op2);

hVarBase* operator<<(const bool &op1,const hVarLinear<bool> &op2);
hVarBase* operator>>(const bool &op1,const hVarLinear<bool> &op2);
hVarBase* operator&(const bool &op1,const hVarLinear<bool> &op2);
hVarBase* operator|(const bool &op1,const hVarLinear<bool> &op2);
hVarBase* operator^(const bool &op1,const hVarLinear<bool> &op2);

hVarBase* operator+(const unsigned char &op1,const hVarLinear<unsigned char> &op2);
hVarBase* operator-(const unsigned char &op1,const hVarLinear<unsigned char> &op2);
hVarBase* operator*(const unsigned char &op1,const hVarLinear<unsigned char> &op2);
hVarBase* operator/(const unsigned char &op1,const hVarLinear<unsigned char> &op2);
hVarBase* operator%(const unsigned char &op1,const hVarLinear<unsigned char> &op2);

hVarBase* operator<(const unsigned char &op1,const hVarLinear<unsigned char> &op2);
hVarBase* operator<=(const unsigned char &op1,const hVarLinear<unsigned char> &op2);
hVarBase* operator>(const unsigned char &op1,const hVarLinear<unsigned char> &op2);
hVarBase* operator>=(const unsigned char &op1,const hVarLinear<unsigned char> &op2);

hVarBase* operator&&(const unsigned char &op1,const hVarLinear<unsigned char> &op2);
hVarBase* operator||(const unsigned char &op1,const hVarLinear<unsigned char> &op2);
hVarBase* operator==(const unsigned char &op1,const hVarLinear<unsigned char> &op2);
hVarBase* operator!=(const unsigned char &op1,const hVarLinear<unsigned char> &op2);

hVarBase* operator<<(const unsigned char &op1,const hVarLinear<unsigned char> &op2);
hVarBase* operator>>(const unsigned char &op1,const hVarLinear<unsigned char> &op2);
hVarBase* operator&(const unsigned char &op1,const hVarLinear<unsigned char> &op2);
hVarBase* operator|(const unsigned char &op1,const hVarLinear<unsigned char> &op2);
hVarBase* operator^(const unsigned char &op1,const hVarLinear<unsigned char> &op2);

hVarBase* operator+(const signed char &op1,const hVarLinear<signed char> &op2);
hVarBase* operator-(const signed char &op1,const hVarLinear<signed char> &op2);
hVarBase* operator*(const signed char &op1,const hVarLinear<signed char> &op2);
hVarBase* operator/(const signed char &op1,const hVarLinear<signed char> &op2);
hVarBase* operator%(const signed char &op1,const hVarLinear<signed char> &op2);

hVarBase* operator<(const signed char &op1,const hVarLinear<signed char> &op2);
hVarBase* operator<=(const signed char &op1,const hVarLinear<signed char> &op2);
hVarBase* operator>(const signed char &op1,const hVarLinear<signed char> &op2);
hVarBase* operator>=(const signed char &op1,const hVarLinear<signed char> &op2);

hVarBase* operator&&(const signed char &op1,const hVarLinear<signed char> &op2);
hVarBase* operator||(const signed char &op1,const hVarLinear<signed char> &op2);
hVarBase* operator==(const signed char &op1,const hVarLinear<signed char> &op2);
hVarBase* operator!=(const signed char &op1,const hVarLinear<signed char> &op2);

hVarBase* operator<<(const signed char &op1,const hVarLinear<signed char> &op2);
hVarBase* operator>>(const signed char &op1,const hVarLinear<signed char> &op2);
hVarBase* operator&(const signed char &op1,const hVarLinear<signed char> &op2);
hVarBase* operator|(const signed char &op1,const hVarLinear<signed char> &op2);
hVarBase* operator^(const signed char &op1,const hVarLinear<signed char> &op2);

hVarBase* operator+(const unsigned short &op1,const hVarLinear<unsigned short> &op2);
hVarBase* operator-(const unsigned short &op1,const hVarLinear<unsigned short> &op2);
hVarBase* operator*(const unsigned short &op1,const hVarLinear<unsigned short> &op2);
hVarBase* operator/(const unsigned short &op1,const hVarLinear<unsigned short> &op2);
hVarBase* operator%(const unsigned short &op1,const hVarLinear<unsigned short> &op2);

hVarBase* operator<(const unsigned short &op1,const hVarLinear<unsigned short> &op2);
hVarBase* operator<=(const unsigned short &op1,const hVarLinear<unsigned short> &op2);
hVarBase* operator>(const unsigned short &op1,const hVarLinear<unsigned short> &op2);
hVarBase* operator>=(const unsigned short &op1,const hVarLinear<unsigned short> &op2);

hVarBase* operator&&(const unsigned short &op1,const hVarLinear<unsigned short> &op2);
hVarBase* operator||(const unsigned short &op1,const hVarLinear<unsigned short> &op2);
hVarBase* operator==(const unsigned short &op1,const hVarLinear<unsigned short> &op2);
hVarBase* operator!=(const unsigned short &op1,const hVarLinear<unsigned short> &op2);

hVarBase* operator<<(const unsigned short &op1,const hVarLinear<unsigned short> &op2);
hVarBase* operator>>(const unsigned short &op1,const hVarLinear<unsigned short> &op2);
hVarBase* operator&(const unsigned short &op1,const hVarLinear<unsigned short> &op2);
hVarBase* operator|(const unsigned short &op1,const hVarLinear<unsigned short> &op2);
hVarBase* operator^(const unsigned short &op1,const hVarLinear<unsigned short> &op2);

hVarBase* operator+(const signed short &op1,const hVarLinear<signed short> &op2);
hVarBase* operator-(const signed short &op1,const hVarLinear<signed short> &op2);
hVarBase* operator*(const signed short &op1,const hVarLinear<signed short> &op2);
hVarBase* operator/(const signed short &op1,const hVarLinear<signed short> &op2);
hVarBase* operator%(const signed short &op1,const hVarLinear<signed short> &op2);

hVarBase* operator<(const signed short &op1,const hVarLinear<signed short> &op2);
hVarBase* operator<=(const signed short &op1,const hVarLinear<signed short> &op2);
hVarBase* operator>(const signed short &op1,const hVarLinear<signed short> &op2);
hVarBase* operator>=(const signed short &op1,const hVarLinear<signed short> &op2);

hVarBase* operator&&(const signed short &op1,const hVarLinear<signed short> &op2);
hVarBase* operator||(const signed short &op1,const hVarLinear<signed short> &op2);
hVarBase* operator==(const signed short &op1,const hVarLinear<signed short> &op2);
hVarBase* operator!=(const signed short &op1,const hVarLinear<signed short> &op2);

hVarBase* operator<<(const signed short &op1,const hVarLinear<signed short> &op2);
hVarBase* operator>>(const signed short &op1,const hVarLinear<signed short> &op2);
hVarBase* operator&(const signed short &op1,const hVarLinear<signed short> &op2);
hVarBase* operator|(const signed short &op1,const hVarLinear<signed short> &op2);
hVarBase* operator^(const signed short &op1,const hVarLinear<signed short> &op2);

hVarBase* operator+(const unsigned long &op1,const hVarLinear<unsigned long> &op2);
hVarBase* operator-(const unsigned long &op1,const hVarLinear<unsigned long> &op2);
hVarBase* operator*(const unsigned long &op1,const hVarLinear<unsigned long> &op2);
hVarBase* operator/(const unsigned long &op1,const hVarLinear<unsigned long> &op2);
hVarBase* operator%(const unsigned long &op1,const hVarLinear<unsigned long> &op2);

hVarBase* operator<(const unsigned long &op1,const hVarLinear<unsigned long> &op2);
hVarBase* operator<=(const unsigned long &op1,const hVarLinear<unsigned long> &op2);
hVarBase* operator>(const unsigned long &op1,const hVarLinear<unsigned long> &op2);
hVarBase* operator>=(const unsigned long &op1,const hVarLinear<unsigned long> &op2);

hVarBase* operator&&(const unsigned long &op1,const hVarLinear<unsigned long> &op2);
hVarBase* operator||(const unsigned long &op1,const hVarLinear<unsigned long> &op2);
hVarBase* operator==(const unsigned long &op1,const hVarLinear<unsigned long> &op2);
hVarBase* operator!=(const unsigned long &op1,const hVarLinear<unsigned long> &op2);

hVarBase* operator<<(const unsigned long &op1,const hVarLinear<unsigned long> &op2);
hVarBase* operator>>(const unsigned long &op1,const hVarLinear<unsigned long> &op2);
hVarBase* operator&(const unsigned long &op1,const hVarLinear<unsigned long> &op2);
hVarBase* operator|(const unsigned long &op1,const hVarLinear<unsigned long> &op2);
hVarBase* operator^(const unsigned long &op1,const hVarLinear<unsigned long> &op2);

hVarBase* operator+(const signed long &op1,const hVarLinear<signed long> &op2);
hVarBase* operator-(const signed long &op1,const hVarLinear<signed long> &op2);
hVarBase* operator*(const signed long &op1,const hVarLinear<signed long> &op2);
hVarBase* operator/(const signed long &op1,const hVarLinear<signed long> &op2);
hVarBase* operator%(const signed long &op1,const hVarLinear<signed long> &op2);

hVarBase* operator<(const signed long &op1,const hVarLinear<signed long> &op2);
hVarBase* operator<=(const signed long &op1,const hVarLinear<signed long> &op2);
hVarBase* operator>(const signed long &op1,const hVarLinear<signed long> &op2);
hVarBase* operator>=(const signed long &op1,const hVarLinear<signed long> &op2);

hVarBase* operator&&(const signed long &op1,const hVarLinear<signed long> &op2);
hVarBase* operator||(const signed long &op1,const hVarLinear<signed long> &op2);
hVarBase* operator==(const signed long &op1,const hVarLinear<signed long> &op2);
hVarBase* operator!=(const signed long &op1,const hVarLinear<signed long> &op2);

hVarBase* operator<<(const signed long &op1,const hVarLinear<signed long> &op2);
hVarBase* operator>>(const signed long &op1,const hVarLinear<signed long> &op2);
hVarBase* operator&(const signed long &op1,const hVarLinear<signed long> &op2);
hVarBase* operator|(const signed long &op1,const hVarLinear<signed long> &op2);
hVarBase* operator^(const signed long &op1,const hVarLinear<signed long> &op2);

hVarBase* operator+(const float &op1,const hVarLinear<float> &op2);
hVarBase* operator-(const float &op1,const hVarLinear<float> &op2);
hVarBase* operator*(const float &op1,const hVarLinear<float> &op2);
hVarBase* operator/(const float &op1,const hVarLinear<float> &op2);
hVarBase* operator%(const float &op1,const hVarLinear<float> &op2);

hVarBase* operator<(const float &op1,const hVarLinear<float> &op2);
hVarBase* operator<=(const float &op1,const hVarLinear<float> &op2);
hVarBase* operator>(const float &op1,const hVarLinear<float> &op2);
hVarBase* operator>=(const float &op1,const hVarLinear<float> &op2);

hVarBase* operator&&(const float &op1,const hVarLinear<float> &op2);
hVarBase* operator||(const float &op1,const hVarLinear<float> &op2);
hVarBase* operator==(const float &op1,const hVarLinear<float> &op2);
hVarBase* operator!=(const float &op1,const hVarLinear<float> &op2);

hVarBase* operator<<(const float &op1,const hVarLinear<float> &op2);
hVarBase* operator>>(const float &op1,const hVarLinear<float> &op2);
hVarBase* operator&(const float &op1,const hVarLinear<float> &op2);
hVarBase* operator|(const float &op1,const hVarLinear<float> &op2);
hVarBase* operator^(const float &op1,const hVarLinear<float> &op2);

hVarBase* operator+(const double &op1,const hVarLinear<double> &op2);
hVarBase* operator-(const double &op1,const hVarLinear<double> &op2);
hVarBase* operator*(const double &op1,const hVarLinear<double> &op2);
hVarBase* operator/(const double &op1,const hVarLinear<double> &op2);
hVarBase* operator%(const double &op1,const hVarLinear<double> &op2);

hVarBase* operator<(const double &op1,const hVarLinear<double> &op2);
hVarBase* operator<=(const double &op1,const hVarLinear<double> &op2);
hVarBase* operator>(const double &op1,const hVarLinear<double> &op2);
hVarBase* operator>=(const double &op1,const hVarLinear<double> &op2);

hVarBase* operator&&(const double &op1,const hVarLinear<double> &op2);
hVarBase* operator||(const double &op1,const hVarLinear<double> &op2);
hVarBase* operator==(const double &op1,const hVarLinear<double> &op2);
hVarBase* operator!=(const double &op1,const hVarLinear<double> &op2);

hVarBase* operator<<(const double &op1,const hVarLinear<double> &op2);
hVarBase* operator>>(const double &op1,const hVarLinear<double> &op2);
hVarBase* operator&(const double &op1,const hVarLinear<double> &op2);
hVarBase* operator|(const double &op1,const hVarLinear<double> &op2);
hVarBase* operator^(const double &op1,const hVarLinear<double> &op2);

hVarBase* operator+(const long double &op1,const hVarLinear<long double> &op2);
hVarBase* operator-(const long double &op1,const hVarLinear<long double> &op2);
hVarBase* operator*(const long double &op1,const hVarLinear<long double> &op2);
hVarBase* operator/(const long double &op1,const hVarLinear<long double> &op2);
hVarBase* operator%(const long double &op1,const hVarLinear<long double> &op2);

hVarBase* operator<(const long double &op1,const hVarLinear<long double> &op2);
hVarBase* operator<=(const long double &op1,const hVarLinear<long double> &op2);
hVarBase* operator>(const long double &op1,const hVarLinear<long double> &op2);
hVarBase* operator>=(const long double &op1,const hVarLinear<long double> &op2);

hVarBase* operator&&(const long double &op1,const hVarLinear<long double> &op2);
hVarBase* operator||(const long double &op1,const hVarLinear<long double> &op2);
hVarBase* operator==(const long double &op1,const hVarLinear<long double> &op2);
hVarBase* operator!=(const long double &op1,const hVarLinear<long double> &op2);

hVarBase* operator<<(const long double &op1,const hVarLinear<long double> &op2);
hVarBase* operator>>(const long double &op1,const hVarLinear<long double> &op2);
hVarBase* operator&(const long double &op1,const hVarLinear<long double> &op2);
hVarBase* operator|(const long double &op1,const hVarLinear<long double> &op2);
hVarBase* operator^(const long double &op1,const hVarLinear<long double> &op2);

hVarBase* operator+(const std::complex<float>  &op1,const hVarLinear<std::complex<float> > &op2);
hVarBase* operator-(const std::complex<float>  &op1,const hVarLinear<std::complex<float> > &op2);
hVarBase* operator*(const std::complex<float>  &op1,const hVarLinear<std::complex<float> > &op2);
hVarBase* operator/(const std::complex<float>  &op1,const hVarLinear<std::complex<float> > &op2);
hVarBase* operator%(const std::complex<float>  &op1,const hVarLinear<std::complex<float> > &op2);

hVarBase* operator<(const std::complex<float>  &op1,const hVarLinear<std::complex<float> > &op2);
hVarBase* operator<=(const std::complex<float>  &op1,const hVarLinear<std::complex<float> > &op2);
hVarBase* operator>(const std::complex<float>  &op1,const hVarLinear<std::complex<float> > &op2);
hVarBase* operator>=(const std::complex<float>  &op1,const hVarLinear<std::complex<float> > &op2);

hVarBase* operator&&(const std::complex<float>  &op1,const hVarLinear<std::complex<float> > &op2);
hVarBase* operator||(const std::complex<float>  &op1,const hVarLinear<std::complex<float> > &op2);
hVarBase* operator==(const std::complex<float>  &op1,const hVarLinear<std::complex<float> > &op2);
hVarBase* operator!=(const std::complex<float>  &op1,const hVarLinear<std::complex<float> > &op2);

hVarBase* operator<<(const std::complex<float>  &op1,const hVarLinear<std::complex<float> > &op2);
hVarBase* operator>>(const std::complex<float>  &op1,const hVarLinear<std::complex<float> > &op2);
hVarBase* operator&(const std::complex<float>  &op1,const hVarLinear<std::complex<float> > &op2);
hVarBase* operator|(const std::complex<float>  &op1,const hVarLinear<std::complex<float> > &op2);
hVarBase* operator^(const std::complex<float>  &op1,const hVarLinear<std::complex<float> > &op2);

hVarBase* operator+(const std::complex<double>  &op1,const hVarLinear<std::complex<double> > &op2);
hVarBase* operator-(const std::complex<double>  &op1,const hVarLinear<std::complex<double> > &op2);
hVarBase* operator*(const std::complex<double>  &op1,const hVarLinear<std::complex<double> > &op2);
hVarBase* operator/(const std::complex<double>  &op1,const hVarLinear<std::complex<double> > &op2);
hVarBase* operator%(const std::complex<double>  &op1,const hVarLinear<std::complex<double> > &op2);

hVarBase* operator<(const std::complex<double>  &op1,const hVarLinear<std::complex<double> > &op2);
hVarBase* operator<=(const std::complex<double>  &op1,const hVarLinear<std::complex<double> > &op2);
hVarBase* operator>(const std::complex<double>  &op1,const hVarLinear<std::complex<double> > &op2);
hVarBase* operator>=(const std::complex<double>  &op1,const hVarLinear<std::complex<double> > &op2);

hVarBase* operator&&(const std::complex<double>  &op1,const hVarLinear<std::complex<double> > &op2);
hVarBase* operator||(const std::complex<double>  &op1,const hVarLinear<std::complex<double> > &op2);
hVarBase* operator==(const std::complex<double>  &op1,const hVarLinear<std::complex<double> > &op2);
hVarBase* operator!=(const std::complex<double>  &op1,const hVarLinear<std::complex<double> > &op2);

hVarBase* operator<<(const std::complex<double>  &op1,const hVarLinear<std::complex<double> > &op2);
hVarBase* operator>>(const std::complex<double>  &op1,const hVarLinear<std::complex<double> > &op2);
hVarBase* operator&(const std::complex<double>  &op1,const hVarLinear<std::complex<double> > &op2);
hVarBase* operator|(const std::complex<double>  &op1,const hVarLinear<std::complex<double> > &op2);
hVarBase* operator^(const std::complex<double>  &op1,const hVarLinear<std::complex<double> > &op2);

hVarBase* operator+(const std::complex<long double>  &op1,const hVarLinear<std::complex<long double> > &op2);
hVarBase* operator-(const std::complex<long double>  &op1,const hVarLinear<std::complex<long double> > &op2);
hVarBase* operator*(const std::complex<long double>  &op1,const hVarLinear<std::complex<long double> > &op2);
hVarBase* operator/(const std::complex<long double>  &op1,const hVarLinear<std::complex<long double> > &op2);
hVarBase* operator%(const std::complex<long double>  &op1,const hVarLinear<std::complex<long double> > &op2);

hVarBase* operator<(const std::complex<long double>  &op1,const hVarLinear<std::complex<long double> > &op2);
hVarBase* operator<=(const std::complex<long double>  &op1,const hVarLinear<std::complex<long double> > &op2);
hVarBase* operator>(const std::complex<long double>  &op1,const hVarLinear<std::complex<long double> > &op2);
hVarBase* operator>=(const std::complex<long double>  &op1,const hVarLinear<std::complex<long double> > &op2);

hVarBase* operator&&(const std::complex<long double>  &op1,const hVarLinear<std::complex<long double> > &op2);
hVarBase* operator||(const std::complex<long double>  &op1,const hVarLinear<std::complex<long double> > &op2);
hVarBase* operator==(const std::complex<long double>  &op1,const hVarLinear<std::complex<long double> > &op2);
hVarBase* operator!=(const std::complex<long double>  &op1,const hVarLinear<std::complex<long double> > &op2);

hVarBase* operator<<(const std::complex<long double>  &op1,const hVarLinear<std::complex<long double> > &op2);
hVarBase* operator>>(const std::complex<long double>  &op1,const hVarLinear<std::complex<long double> > &op2);
hVarBase* operator&(const std::complex<long double>  &op1,const hVarLinear<std::complex<long double> > &op2);
hVarBase* operator|(const std::complex<long double>  &op1,const hVarLinear<std::complex<long double> > &op2);
hVarBase* operator^(const std::complex<long double>  &op1,const hVarLinear<std::complex<long double> > &op2);

//}
}
#endif
