/***************************************************************************
 *   Copyright (C) 2008 by Bob,,,   *
 *   bob@lab17   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "hVariable.h"

#if __VAR_ALLOCATION == LINEAR
#define __VAR_CLASS hvar::hVarLinear

std::string hVariable::literalType(unsigned char t){
	switch (t){
	case hNoType:
		return "invalid type";
	case hBool:
		return "bool";
	case  huChar:
		return "unsigned char";
	case  hsChar:
		return "signed char";
	case  huShortInt:
		return "unsigned short int";
	case  hsShortInt:
		return "signed short int";
	case  huInt:
		return "unsigned long int";
	case  hsInt:
		return "signed long int";
	case  hFloat:
		return "float";
	case  hDouble:
		return "double";
	case  hLDouble:
		return "long double";
	case  hComplex:
		return "complex<float>";
	case  hDComplex:
		return "complex<double>";
	case  hLDComplex:
		return "complex<long double>";
	}
}

hVariable::hVariable(void){
	type=hNoType;
}

hVariable::hVariable(const hVariable& s){
	if(s.type!=hNoType){
		storage=s.storage->copy();
		type=s.type;
	}else
		type=hNoType;
}

hVariable::hVariable(bool data){
	storage=new __VAR_CLASS<bool>(data);
	type=hBool;
}

hVariable::hVariable(unsigned char data){
	storage=new __VAR_CLASS<unsigned char>(data);
	type=huChar;
}
hVariable::hVariable(signed char data){
	storage=new __VAR_CLASS<signed char>(data);
	type=hsChar;
}
hVariable::hVariable(unsigned short data){
	storage=new __VAR_CLASS<unsigned short int>(data);
	type=huShortInt;
}
hVariable::hVariable(signed short data){
	storage=new __VAR_CLASS<signed short int>(data);
	type=hsShortInt;
}
hVariable::hVariable(unsigned long data){
	storage=new __VAR_CLASS<unsigned long int>(data);
	type=huInt;
}
hVariable::hVariable(signed long data){
	storage=new __VAR_CLASS<signed long int>(data);
	type=hsInt;
}
///todo: type must be controlled by defined value __VAR_SIGNED
hVariable::hVariable(signed int data){
	storage=new __VAR_CLASS<__VAR_SIGNED>(data);
	type=hsInt;
}
hVariable::hVariable(unsigned int data){
	storage=new __VAR_CLASS<__VAR_UNSIGNED>(data);
	type=huInt;
}
hVariable::hVariable(float data){
	storage=new __VAR_CLASS<float>(data);
	type=hFloat;
}
hVariable::hVariable(double data){
	storage=new __VAR_CLASS<double>(data);
	type=hDouble;
}
hVariable::hVariable(long double data){
	storage=new __VAR_CLASS<long double>(data);
	type=hLDouble;
}
hVariable::hVariable(std::complex<float > data){
	storage=new __VAR_CLASS<std::complex<float> >(data);
	type=hComplex;
}
hVariable::hVariable(std::complex<double > data){
	storage=new __VAR_CLASS<std::complex<double> >(data);
	type=hDComplex;
}
hVariable::hVariable(std::complex<long double> data){
	storage=new __VAR_CLASS<std::complex<long double> >(data);
	type=hLDComplex;
}

hVariable::hVariable(std::vector<unsigned int> size,bool *data){
	storage=new __VAR_CLASS<bool>(size,data);
	type=hBool;
}
hVariable::hVariable(std::vector<unsigned int> size,unsigned char *data){
	storage=new __VAR_CLASS<unsigned char>(size,data);
	type=huChar;
}
hVariable::hVariable(std::vector<unsigned int> size,signed char *data){
	storage=new __VAR_CLASS<signed char>(size,data);
	type=hsChar;
}
hVariable::hVariable(std::vector<unsigned int> size,unsigned short *data){
	storage=new __VAR_CLASS<unsigned short>(size,data);
	type=huShortInt;
}
hVariable::hVariable(std::vector<unsigned int> size,signed short *data){
	storage=new __VAR_CLASS<signed short>(size,data);
	type=hsShortInt;
}
hVariable::hVariable(std::vector<unsigned int> size,unsigned long *data){
	storage=new __VAR_CLASS<unsigned long>(size,data);
	type=huInt;
}
hVariable::hVariable(std::vector<unsigned int> size,signed long *data){
	storage=new __VAR_CLASS<signed long>(size,data);
	type=hsInt;
}
/*hVariable::hVariable(std::vector<unsigned int> size,unsigned int *data){
	storage=new __VAR_CLASS<unsigned int>(size,data);
	empty=false;
}
hVariable::hVariable(std::vector<unsigned int> size,signed int *data){
	storage=new __VAR_CLASS<signed int>(size,data);
	empty=false;
}*/
hVariable::hVariable(std::vector<unsigned int> size,float *data){
	storage=new __VAR_CLASS<float>(size,data);
	type=hFloat;
}
hVariable::hVariable(std::vector<unsigned int> size,double *data){
	storage=new __VAR_CLASS<double>(size,data);
	type=hDouble;
}
hVariable::hVariable(std::vector<unsigned int> size,long double *data){
	storage=new __VAR_CLASS<long double>(size,data);
	type=hLDouble;
}
hVariable::hVariable(std::vector<unsigned int> size,std::complex<float > *data){
	storage=new __VAR_CLASS<std::complex<float> >(size,data);
	type=hComplex;
}
hVariable::hVariable(std::vector<unsigned int> size,std::complex<double > *data){
	storage=new __VAR_CLASS<std::complex<double> >(size,data);
	type=hDComplex;
}
hVariable::hVariable(std::vector<unsigned int> size,std::complex<long double> *data){
	storage=new __VAR_CLASS<std::complex<long double> >(size,data);
	type=hLDComplex;
}

hVariable::hVariable(std::vector<unsigned int> size,const bool &init){
	storage=new __VAR_CLASS<bool>(size,init);
	type=hBool;
}
hVariable::hVariable(std::vector<unsigned int> size,const unsigned char &init){
	storage=new __VAR_CLASS<unsigned char>(size,init);
	type=huChar;
}
hVariable::hVariable(std::vector<unsigned int> size,const signed char &init){
	storage=new __VAR_CLASS<signed char>(size,init);
	type=hsChar;
}
hVariable::hVariable(std::vector<unsigned int> size,const unsigned short &init){
	storage=new __VAR_CLASS<unsigned short>(size,init);
	type=huShortInt;
}
hVariable::hVariable(std::vector<unsigned int> size,const signed short &init){
	storage=new __VAR_CLASS<signed short>(size,init);
	type=hsShortInt;
}
hVariable::hVariable(std::vector<unsigned int> size,const unsigned long &init){
	storage=new __VAR_CLASS<unsigned long>(size,init);
	type=huInt;
}
hVariable::hVariable(std::vector<unsigned int> size,const signed long &init){
	storage=new __VAR_CLASS<signed long>(size,init);
	type=hsInt;
}
hVariable::hVariable(std::vector<unsigned int> size,const float &init){
	storage=new __VAR_CLASS<float>(size,init);
	type=hFloat;
}
hVariable::hVariable(std::vector<unsigned int> size,const double &init){
	storage=new __VAR_CLASS<double>(size,init);
	type=hDouble;
}
hVariable::hVariable(std::vector<unsigned int> size,const long double &init){
	storage=new __VAR_CLASS<long double>(size,init);
	type=hLDouble;
}
hVariable::hVariable(std::vector<unsigned int> size,const std::complex<float> &init){
	storage=new __VAR_CLASS<std::complex<float> >(size,init);
	type=hComplex;
}
hVariable::hVariable(std::vector<unsigned int> size,const std::complex<double> &init){
	storage=new __VAR_CLASS<std::complex<double> >(size,init);
	type=hDComplex;
}
hVariable::hVariable(std::vector<unsigned int> size,const std::complex<long double> &init){
	storage=new __VAR_CLASS<std::complex<long double> >(size,init);
	type=hLDComplex;
}

hVariable::hVariable(std::vector<unsigned int> size,const std::vector<bool> &data){
	storage=new __VAR_CLASS<bool>(size,data);
	type=hBool;
}
hVariable::hVariable(std::vector<unsigned int> size,const std::vector<unsigned char> &data){
	storage=new __VAR_CLASS<unsigned char>(size,data);
	type=huChar;
}
hVariable::hVariable(std::vector<unsigned int> size,const std::vector<signed char> &data){
	storage=new __VAR_CLASS<signed char>(size,data);
	type=hsChar;
}
hVariable::hVariable(std::vector<unsigned int> size,const std::vector<unsigned short> &data){
	storage=new __VAR_CLASS<unsigned short>(size,data);
	type=huShortInt;
}
hVariable::hVariable(std::vector<unsigned int> size,const std::vector<signed short> &data){
	storage=new __VAR_CLASS<signed short>(size,data);
	type=hsShortInt;
}
hVariable::hVariable(std::vector<unsigned int> size,const std::vector<unsigned long> &data){
	storage=new __VAR_CLASS<unsigned long>(size,data);
	type=huInt;
}
hVariable::hVariable(std::vector<unsigned int> size,const std::vector<signed long> &data){
	storage=new __VAR_CLASS<signed long>(size,data);
	type=hsInt;
}
//	hVariable(std::vector<unsigned int> size,std::vector<unsigned int> data){
//}
//	hVariable(std::vector<unsigned int> size,std::vector<signed int> data){
//}
hVariable::hVariable(std::vector<unsigned int> size,const std::vector<float> &data){
	storage=new __VAR_CLASS<float>(size,data);
	type=hFloat;
}
hVariable::hVariable(std::vector<unsigned int> size,const std::vector<double> &data){
	storage=new __VAR_CLASS<double>(size,data);
	type=hDouble;
}
hVariable::hVariable(std::vector<unsigned int> size,const std::vector<long double> &data){
	storage=new __VAR_CLASS<long double>(size,data);
	type=hLDouble;
}
hVariable::hVariable(std::vector<unsigned int> size,const std::vector<std::complex<float> > &data){
	storage=new __VAR_CLASS<std::complex<float> >(size,data);
	type=hComplex;
}
hVariable::hVariable(std::vector<unsigned int> size,const std::vector<std::complex<double> > &data){
	storage=new __VAR_CLASS<std::complex<double> >(size,data);
	type=hDComplex;
}
hVariable::hVariable(std::vector<unsigned int> size,const std::vector<std::complex<long double> > &data){
	storage=new __VAR_CLASS<std::complex<long double> >(size,data);
	type=hLDComplex;
}

hVariable::hVariable(std::vector<bool> data){
	storage=new __VAR_CLASS<bool>(data);
	type=hBool;
}
hVariable::hVariable(std::vector<unsigned char> data){
	storage=new __VAR_CLASS<unsigned char>(data);
	type=huChar;
}
hVariable::hVariable(std::vector<signed char> data){
	storage=new __VAR_CLASS<signed char>(data);
	type=hsChar;
}
hVariable::hVariable(std::vector<unsigned short> data){
	storage=new __VAR_CLASS<unsigned short>(data);
	type=huShortInt;
}
hVariable::hVariable(std::vector<signed short> data){
	storage=new __VAR_CLASS<signed short>(data);
	type=hsShortInt;
}
hVariable::hVariable(std::vector<unsigned long> data){
	storage=new __VAR_CLASS<unsigned long>(data);
	type=huInt;
}
hVariable::hVariable(std::vector<signed long> data){
	storage=new __VAR_CLASS<signed long>(data);
	type=hsInt;
}
//	hVariable(std::vector<unsigned int> data){
//}
//	hVariable(std::vector<signed int> data){
//}
hVariable::hVariable(std::vector<float> data){
	storage=new __VAR_CLASS<float>(data);
	type=hFloat;
}
hVariable::hVariable(std::vector<double> data){
	storage=new __VAR_CLASS<double>(data);
	type=hDouble;
}
hVariable::hVariable(std::vector<long double> data){
	storage=new __VAR_CLASS<long double>(data);
	type=hLDouble;
}
hVariable::hVariable(std::vector<std::complex<float> > data){
	storage=new __VAR_CLASS<std::complex<float> >(data);
	type=hComplex;
}
hVariable::hVariable(std::vector<std::complex<double> > data){
	storage=new __VAR_CLASS<std::complex<double> >(data);
	type=hDComplex;
}
hVariable::hVariable(std::vector<std::complex<long double> > data){
	storage=new __VAR_CLASS<std::complex<long double> >(data);
	type=hLDComplex;
}

hVariable::~hVariable(void){
	if(type!=hNoType){
		storage->clear();
//		delete storage;
	}
}

hVariable::hVariable(bool *data,unsigned long s0){
	using namespace std;
	vector<unsigned int> size;
	vector<bool> d;
	unsigned long i;
	size.push_back(s0);
	d.reserve(s0);
	for(i=0;i<s0;++i)
		d.push_back(data[i]);
	storage=new __VAR_CLASS<bool>(size,d);
	type=hBool;
}
hVariable::hVariable(unsigned char *data,unsigned long s0){
	using namespace std;
	vector<unsigned int> size;
	vector<unsigned char> d;
	unsigned long i;
	size.push_back(s0);
	d.reserve(s0);
	for(i=0;i<s0;++i)
		d.push_back(data[i]);
	storage=new __VAR_CLASS<unsigned char>(size,d);
	type=huChar;
}
hVariable::hVariable(signed char *data,unsigned long s0){
	using namespace std;
	vector<unsigned int> size;
	vector<signed char> d;
	unsigned long i;
	size.push_back(s0);
	d.reserve(s0);
	for(i=0;i<s0;++i)
		d.push_back(data[i]);
	storage=new __VAR_CLASS<signed char>(size,d);
	type=hsChar;
}
hVariable::hVariable(unsigned short *data,unsigned long s0){
	using namespace std;
	vector<unsigned int> size;
	vector<unsigned short> d;
	unsigned long i;
	size.push_back(s0);
	d.reserve(s0);
	for(i=0;i<s0;++i)
		d.push_back(data[i]);
	storage=new __VAR_CLASS<unsigned short>(size,d);
	type=huShortInt;
}
hVariable::hVariable(signed short *data,unsigned long s0){
	using namespace std;
	vector<unsigned int> size;
	vector<signed short> d;
	unsigned long i;
	size.push_back(s0);
	d.reserve(s0);
	for(i=0;i<s0;++i)
		d.push_back(data[i]);
	storage=new __VAR_CLASS<signed short>(size,d);
	type=hsShortInt;
}
hVariable::hVariable(unsigned long *data,unsigned long s0){
	using namespace std;
	vector<unsigned int> size;
	vector<unsigned long> d;
	unsigned long i;
	size.push_back(s0);
	d.reserve(s0);
	for(i=0;i<s0;++i)
		d.push_back(data[i]);
	storage=new __VAR_CLASS<unsigned long>(size,d);
	type=huInt;
}
hVariable::hVariable(signed long *data,unsigned long s0){
	using namespace std;
	vector<unsigned int> size;
	vector<signed long> d;
	unsigned long i;
	size.push_back(s0);
	d.reserve(s0);
	for(i=0;i<s0;++i)
		d.push_back(data[i]);
	storage=new __VAR_CLASS<signed long>(size,d);
	type=hsInt;
}
hVariable::hVariable(float *data,unsigned long s0){
	using namespace std;
	vector<unsigned int> size;
	vector<float> d;
	unsigned long i;
	size.push_back(s0);
	d.reserve(s0);
	for(i=0;i<s0;++i)
		d.push_back(data[i]);
	storage=new __VAR_CLASS<float>(size,d);
	type=hFloat;
}
hVariable::hVariable(double *data,unsigned long s0){
	using namespace std;
	vector<unsigned int> size;
	vector<double> d;
	unsigned long i;
	size.push_back(s0);
	d.reserve(s0);
	for(i=0;i<s0;++i)
		d.push_back(data[i]);
	storage=new __VAR_CLASS<double>(size,d);
	type=hDouble;
}
hVariable::hVariable(long double *data,unsigned long s0){
	using namespace std;
	vector<unsigned int> size;
	vector<long double> d;
	unsigned long i;
	size.push_back(s0);
	d.reserve(s0);
	for(i=0;i<s0;++i)
		d.push_back(data[i]);
	storage=new __VAR_CLASS<long double>(size,d);
	type=hLDouble;
}
hVariable::hVariable(std::complex<float> *data,unsigned long s0){
	using namespace std;
	vector<unsigned int> size;
	vector<std::complex<float> > d;
	unsigned long i;
	size.push_back(s0);
	d.reserve(s0);
	for(i=0;i<s0;++i)
		d.push_back(data[i]);
	storage=new __VAR_CLASS<std::complex<float> >(size,d);
	type=hComplex;
}
hVariable::hVariable(std::complex<double> *data,unsigned long s0){
	using namespace std;
	vector<unsigned int> size;
	vector<std::complex<double> > d;
	unsigned long i;
	size.push_back(s0);
	d.reserve(s0);
	for(i=0;i<s0;++i)
		d.push_back(data[i]);
	storage=new __VAR_CLASS<std::complex<double> >(size,d);
	type=hDComplex;
}
hVariable::hVariable(std::complex<long double> *data,unsigned long s0){
	using namespace std;
	vector<unsigned int> size;
	vector<std::complex<long double> > d;
	unsigned long i;
	size.push_back(s0);
	d.reserve(s0);
	for(i=0;i<s0;++i)
		d.push_back(data[i]);
	storage=new __VAR_CLASS<std::complex<long double> >(size,d);
	type=hLDComplex;
}

hVariable::hVariable(bool **data,unsigned long s0,unsigned long s1){
	#define LEVELS 2
	using namespace std;
	vector<unsigned int> size;
	vector<bool> d;
	unsigned long i;

	size.push_back(s0);
	size.push_back(s1);
	unsigned long level=1;
	unsigned long index[LEVELS]={0,0},TS=s0*s1;
	do{
		if(index[level]<size[level]){
			level=LEVELS-1;
			d.push_back(data[index[0]][index[1]]);
			index[level]++;
		}else{
			index[level]=0;
			level--;
			index[level]++;
		}
	}while(level || index[0]!=size[0]);
	storage=new __VAR_CLASS<bool>(size,d);
	type=hBool;
	#undef LEVELS
}
hVariable::hVariable(unsigned char **data,unsigned long s0,unsigned long s1){
	#define LEVELS 2
	using namespace std;
	vector<unsigned int> size;
	vector<unsigned char> d;
	unsigned long i;

	size.push_back(s0);
	size.push_back(s1);
	unsigned long level=1;
	unsigned long index[LEVELS]={0,0},TS=s0*s1;
	do{
		if(index[level]<size[level]){
			level=LEVELS-1;
			d.push_back(data[index[0]][index[1]]);
			index[level]++;
		}else{
			index[level]=0;
			level--;
			index[level]++;
		}
	}while(level || index[0]!=size[0]);
	storage=new __VAR_CLASS<unsigned char>(size,d);
	type=huChar;
	#undef LEVELS
}
hVariable::hVariable(signed char **data,unsigned long s0,unsigned long s1){
	#define LEVELS 2
	using namespace std;
	vector<unsigned int> size;
	vector<signed char> d;
	unsigned long i;

	size.push_back(s0);
	size.push_back(s1);
	unsigned long level=1;
	unsigned long index[LEVELS]={0,0},TS=s0*s1;
	do{
		if(index[level]<size[level]){
			level=LEVELS-1;
			d.push_back(data[index[0]][index[1]]);
			index[level]++;
		}else{
			index[level]=0;
			level--;
			index[level]++;
		}
	}while(level || index[0]!=size[0]);
	storage=new __VAR_CLASS<signed char>(size,d);
	type=hsChar;
	#undef LEVELS
}
hVariable::hVariable(unsigned short **data,unsigned long s0,unsigned long s1){
	#define LEVELS 2
	using namespace std;
	vector<unsigned int> size;
	vector<unsigned short> d;
	unsigned long i;

	size.push_back(s0);
	size.push_back(s1);
	unsigned long level=1;
	unsigned long index[LEVELS]={0,0},TS=s0*s1;
	do{
		if(index[level]<size[level]){
			level=LEVELS-1;
			d.push_back(data[index[0]][index[1]]);
			index[level]++;
		}else{
			index[level]=0;
			level--;
			index[level]++;
		}
	}while(level || index[0]!=size[0]);
	storage=new __VAR_CLASS<unsigned short>(size,d);
	type=huShortInt;
	#undef LEVELS
}
hVariable::hVariable(signed short **data,unsigned long s0,unsigned long s1){
	#define LEVELS 2
	using namespace std;
	vector<unsigned int> size;
	vector<signed short> d;
	unsigned long i;

	size.push_back(s0);
	size.push_back(s1);
	unsigned long level=1;
	unsigned long index[LEVELS]={0,0},TS=s0*s1;
	do{
		if(index[level]<size[level]){
			level=LEVELS-1;
			d.push_back(data[index[0]][index[1]]);
			index[level]++;
		}else{
			index[level]=0;
			level--;
			index[level]++;
		}
	}while(level || index[0]!=size[0]);
	storage=new __VAR_CLASS<signed short>(size,d);
	type=hsShortInt;
	#undef LEVELS
}
hVariable::hVariable(unsigned long **data,unsigned long s0,unsigned long s1){
	#define LEVELS 2
	using namespace std;
	vector<unsigned int> size;
	vector<unsigned long> d;
	unsigned long i;

	size.push_back(s0);
	size.push_back(s1);
	unsigned long level=1;
	unsigned long index[LEVELS]={0,0},TS=s0*s1;
	do{
		if(index[level]<size[level]){
			level=LEVELS-1;
			d.push_back(data[index[0]][index[1]]);
			index[level]++;
		}else{
			index[level]=0;
			level--;
			index[level]++;
		}
	}while(level || index[0]!=size[0]);
	storage=new __VAR_CLASS<unsigned long>(size,d);
	type=huInt;
	#undef LEVELS
}
hVariable::hVariable(signed long **data,unsigned long s0,unsigned long s1){
	#define LEVELS 2
	using namespace std;
	vector<unsigned int> size;
	vector<signed long> d;
	unsigned long i;

	size.push_back(s0);
	size.push_back(s1);
	unsigned long level=1;
	unsigned long index[LEVELS]={0,0},TS=s0*s1;
	do{
		if(index[level]<size[level]){
			level=LEVELS-1;
			d.push_back(data[index[0]][index[1]]);
			index[level]++;
		}else{
			index[level]=0;
			level--;
			index[level]++;
		}
	}while(level || index[0]!=size[0]);
	storage=new __VAR_CLASS<signed long>(size,d);
	type=hsInt;
	#undef LEVELS
}
hVariable::hVariable(float **data,unsigned long s0,unsigned long s1){
	#define LEVELS 2
	using namespace std;
	vector<unsigned int> size;
	vector<float> d;
	unsigned long i;

	size.push_back(s0);
	size.push_back(s1);
	unsigned long level=1;
	unsigned long index[LEVELS]={0,0},TS=s0*s1;
	do{
		if(index[level]<size[level]){
			level=LEVELS-1;
			d.push_back(data[index[0]][index[1]]);
			index[level]++;
		}else{
			index[level]=0;
			level--;
			index[level]++;
		}
	}while(level || index[0]!=size[0]);
	storage=new __VAR_CLASS<float>(size,d);
	type=hFloat;
	#undef LEVELS
}
hVariable::hVariable(double **data,unsigned long s0,unsigned long s1){
	#define LEVELS 2
	using namespace std;
	vector<unsigned int> size;
	vector<double> d;
	unsigned long i;

	size.push_back(s0);
	size.push_back(s1);
	unsigned long level=1;
	unsigned long index[LEVELS]={0,0},TS=s0*s1;
	do{
		if(index[level]<size[level]){
			level=LEVELS-1;
			d.push_back(data[index[0]][index[1]]);
			index[level]++;
		}else{
			index[level]=0;
			level--;
			index[level]++;
		}
	}while(level || index[0]!=size[0]);
	storage=new __VAR_CLASS<double>(size,d);
	type=hDouble;
	#undef LEVELS
}
hVariable::hVariable(long double **data,unsigned long s0,unsigned long s1){
	#define LEVELS 2
	using namespace std;
	vector<unsigned int> size;
	vector<long double> d;
	unsigned long i;

	size.push_back(s0);
	size.push_back(s1);
	unsigned long level=1;
	unsigned long index[LEVELS]={0,0},TS=s0*s1;
	do{
		if(index[level]<size[level]){
			level=LEVELS-1;
			d.push_back(data[index[0]][index[1]]);
			index[level]++;
		}else{
			index[level]=0;
			level--;
			index[level]++;
		}
	}while(level || index[0]!=size[0]);
	storage=new __VAR_CLASS<long double>(size,d);
	type=hLDouble;
	#undef LEVELS
}
hVariable::hVariable(std::complex<float> **data,unsigned long s0,unsigned long s1){
	#define LEVELS 2
	using namespace std;
	vector<unsigned int> size;
	vector<std::complex<float> > d;
	unsigned long i;

	size.push_back(s0);
	size.push_back(s1);
	unsigned long level=1;
	unsigned long index[LEVELS]={0,0},TS=s0*s1;
	do{
		if(index[level]<size[level]){
			level=LEVELS-1;
			d.push_back(data[index[0]][index[1]]);
			index[level]++;
		}else{
			index[level]=0;
			level--;
			index[level]++;
		}
	}while(level || index[0]!=size[0]);
	storage=new __VAR_CLASS<std::complex<float> >(size,d);
	type=hComplex;
	#undef LEVELS
}
hVariable::hVariable(std::complex<double> **data,unsigned long s0,unsigned long s1){
	#define LEVELS 2
	using namespace std;
	vector<unsigned int> size;
	vector<std::complex<double> > d;
	unsigned long i;

	size.push_back(s0);
	size.push_back(s1);
	unsigned long level=1;
	unsigned long index[LEVELS]={0,0},TS=s0*s1;
	do{
		if(index[level]<size[level]){
			level=LEVELS-1;
			d.push_back(data[index[0]][index[1]]);
			index[level]++;
		}else{
			index[level]=0;
			level--;
			index[level]++;
		}
	}while(level || index[0]!=size[0]);
	storage=new __VAR_CLASS<std::complex<double> >(size,d);
	type=hDComplex;
	#undef LEVELS
}
hVariable::hVariable(std::complex<long double> **data,unsigned long s0,unsigned long s1){
	#define LEVELS 2
	using namespace std;
	vector<unsigned int> size;
	vector<std::complex<long double> > d;
	unsigned long i;

	size.push_back(s0);
	size.push_back(s1);
	unsigned long level=1;
	unsigned long index[LEVELS]={0,0},TS=s0*s1;
	do{
		if(index[level]<size[level]){
			level=LEVELS-1;
			d.push_back(data[index[0]][index[1]]);
			index[level]++;
		}else{
			index[level]=0;
			level--;
			index[level]++;
		}
	}while(level || index[0]!=size[0]);
	storage=new __VAR_CLASS<std::complex<long double> >(size,d);
	type=hLDComplex;
	#undef LEVELS
}

hVariable::hVariable(bool ***data,unsigned long s0,unsigned long s1,unsigned long s2){
	#define LEVELS 3
	using namespace std;
	vector<unsigned int> size;
	vector<bool> d;
	unsigned long i;

	size.push_back(s0);
	size.push_back(s1);
	size.push_back(s2);
	unsigned long level=2;
	unsigned long index[LEVELS]={0,0,0},TS=s0*s1*s2;
	do{
		if(index[level]<size[level]){
			level=LEVELS-1;
			d.push_back(data[index[0]][index[1]][index[2]]);
			index[level]++;
		}else{
			index[level]=0;
			level--;
			index[level]++;
		}
	}while(level || index[0]!=size[0]);
	storage=new __VAR_CLASS<bool>(size,d);
	type=hBool;
	#undef LEVELS
}
hVariable::hVariable(unsigned char ***data,unsigned long s0,unsigned long s1,unsigned long s2){
	#define LEVELS 3
	using namespace std;
	vector<unsigned int> size;
	vector<unsigned char> d;
	unsigned long i;

	size.push_back(s0);
	size.push_back(s1);
	size.push_back(s2);
	unsigned long level=2;
	unsigned long index[LEVELS]={0,0,0},TS=s0*s1*s2;
	do{
		if(index[level]<size[level]){
			level=LEVELS-1;
			d.push_back(data[index[0]][index[1]][index[2]]);
			index[level]++;
		}else{
			index[level]=0;
			level--;
			index[level]++;
		}
	}while(level || index[0]!=size[0]);
	storage=new __VAR_CLASS<unsigned char>(size,d);
	type=huChar;
	#undef LEVELS
}
hVariable::hVariable(signed char ***data,unsigned long s0,unsigned long s1,unsigned long s2){
	#define LEVELS 3
	using namespace std;
	vector<unsigned int> size;
	vector<signed char> d;
	unsigned long i;

	size.push_back(s0);
	size.push_back(s1);
	size.push_back(s2);
	unsigned long level=2;
	unsigned long index[LEVELS]={0,0,0},TS=s0*s1*s2;
	do{
		if(index[level]<size[level]){
			level=LEVELS-1;
			d.push_back(data[index[0]][index[1]][index[2]]);
			index[level]++;
		}else{
			index[level]=0;
			level--;
			index[level]++;
		}
	}while(level || index[0]!=size[0]);
	storage=new __VAR_CLASS<signed char>(size,d);
	type=hsChar;
	#undef LEVELS
}
hVariable::hVariable(unsigned short ***data,unsigned long s0,unsigned long s1,unsigned long s2){
	#define LEVELS 3
	using namespace std;
	vector<unsigned int> size;
	vector<unsigned short> d;
	unsigned long i;

	size.push_back(s0);
	size.push_back(s1);
	size.push_back(s2);
	unsigned long level=2;
	unsigned long index[LEVELS]={0,0,0},TS=s0*s1*s2;
	do{
		if(index[level]<size[level]){
			level=LEVELS-1;
			d.push_back(data[index[0]][index[1]][index[2]]);
			index[level]++;
		}else{
			index[level]=0;
			level--;
			index[level]++;
		}
	}while(level || index[0]!=size[0]);
	storage=new __VAR_CLASS<unsigned short>(size,d);
	type=huShortInt;
	#undef LEVELS
}
hVariable::hVariable(signed short ***data,unsigned long s0,unsigned long s1,unsigned long s2){
	#define LEVELS 3
	using namespace std;
	vector<unsigned int> size;
	vector<signed short> d;
	unsigned long i;

	size.push_back(s0);
	size.push_back(s1);
	size.push_back(s2);
	unsigned long level=2;
	unsigned long index[LEVELS]={0,0,0},TS=s0*s1*s2;
	do{
		if(index[level]<size[level]){
			level=LEVELS-1;
			d.push_back(data[index[0]][index[1]][index[2]]);
			index[level]++;
		}else{
			index[level]=0;
			level--;
			index[level]++;
		}
	}while(level || index[0]!=size[0]);
	storage=new __VAR_CLASS<signed short>(size,d);
	type=hsShortInt;
	#undef LEVELS
}
hVariable::hVariable(unsigned long ***data,unsigned long s0,unsigned long s1,unsigned long s2){
	#define LEVELS 3
	using namespace std;
	vector<unsigned int> size;
	vector<unsigned long> d;
	unsigned long i;

	size.push_back(s0);
	size.push_back(s1);
	size.push_back(s2);
	unsigned long level=2;
	unsigned long index[LEVELS]={0,0,0},TS=s0*s1*s2;
	do{
		if(index[level]<size[level]){
			level=LEVELS-1;
			d.push_back(data[index[0]][index[1]][index[2]]);
			index[level]++;
		}else{
			index[level]=0;
			level--;
			index[level]++;
		}
	}while(level || index[0]!=size[0]);
	storage=new __VAR_CLASS<unsigned long>(size,d);
	type=huInt;
	#undef LEVELS
}
hVariable::hVariable(signed long ***data,unsigned long s0,unsigned long s1,unsigned long s2){
	#define LEVELS 3
	using namespace std;
	vector<unsigned int> size;
	vector<signed long> d;
	unsigned long i;

	size.push_back(s0);
	size.push_back(s1);
	size.push_back(s2);
	unsigned long level=2;
	unsigned long index[LEVELS]={0,0,0},TS=s0*s1*s2;
	do{
		if(index[level]<size[level]){
			level=LEVELS-1;
			d.push_back(data[index[0]][index[1]][index[2]]);
			index[level]++;
		}else{
			index[level]=0;
			level--;
			index[level]++;
		}
	}while(level || index[0]!=size[0]);
	storage=new __VAR_CLASS<signed long>(size,d);
	type=hsInt;
	#undef LEVELS
}
hVariable::hVariable(float ***data,unsigned long s0,unsigned long s1,unsigned long s2){
	#define LEVELS 3
	using namespace std;
	vector<unsigned int> size;
	vector<float> d;
	unsigned long i;

	size.push_back(s0);
	size.push_back(s1);
	size.push_back(s2);
	unsigned long level=2;
	unsigned long index[LEVELS]={0,0,0},TS=s0*s1*s2;
	do{
		if(index[level]<size[level]){
			level=LEVELS-1;
			d.push_back(data[index[0]][index[1]][index[2]]);
			index[level]++;
		}else{
			index[level]=0;
			level--;
			index[level]++;
		}
	}while(level || index[0]!=size[0]);
	storage=new __VAR_CLASS<float>(size,d);
	type=hFloat;
	#undef LEVELS
}
hVariable::hVariable(double ***data,unsigned long s0,unsigned long s1,unsigned long s2){
	#define LEVELS 3
	using namespace std;
	vector<unsigned int> size;
	vector<double> d;
	unsigned long i;

	size.push_back(s0);
	size.push_back(s1);
	size.push_back(s2);
	unsigned long level=2;
	unsigned long index[LEVELS]={0,0,0},TS=s0*s1*s2;
	do{
		if(index[level]<size[level]){
			level=LEVELS-1;
			d.push_back(data[index[0]][index[1]][index[2]]);
			index[level]++;
		}else{
			index[level]=0;
			level--;
			index[level]++;
		}
	}while(level || index[0]!=size[0]);
	storage=new __VAR_CLASS<double>(size,d);
	type=hDouble;
	#undef LEVELS
}
hVariable::hVariable(long double ***data,unsigned long s0,unsigned long s1,unsigned long s2){
	#define LEVELS 3
	using namespace std;
	vector<unsigned int> size;
	vector<long double> d;
	unsigned long i;

	size.push_back(s0);
	size.push_back(s1);
	size.push_back(s2);
	unsigned long level=2;
	unsigned long index[LEVELS]={0,0,0},TS=s0*s1*s2;
	do{
		if(index[level]<size[level]){
			level=LEVELS-1;
			d.push_back(data[index[0]][index[1]][index[2]]);
			index[level]++;
		}else{
			index[level]=0;
			level--;
			index[level]++;
		}
	}while(level || index[0]!=size[0]);
	storage=new __VAR_CLASS<long double>(size,d);
	type=hLDouble;
	#undef LEVELS
}
hVariable::hVariable(std::complex<float> ***data,unsigned long s0,unsigned long s1,unsigned long s2){
	#define LEVELS 3
	using namespace std;
	vector<unsigned int> size;
	vector<std::complex<float> > d;
	unsigned long i;

	size.push_back(s0);
	size.push_back(s1);
	size.push_back(s2);
	unsigned long level=2;
	unsigned long index[LEVELS]={0,0,0},TS=s0*s1*s2;
	do{
		if(index[level]<size[level]){
			level=LEVELS-1;
			d.push_back(data[index[0]][index[1]][index[2]]);
			index[level]++;
		}else{
			index[level]=0;
			level--;
			index[level]++;
		}
	}while(level || index[0]!=size[0]);
	storage=new __VAR_CLASS<std::complex<float> >(size,d);
	type=hComplex;
	#undef LEVELS
}
hVariable::hVariable(std::complex<double> ***data,unsigned long s0,unsigned long s1,unsigned long s2){
	#define LEVELS 3
	using namespace std;
	vector<unsigned int> size;
	vector<std::complex<double> > d;
	unsigned long i;

	size.push_back(s0);
	size.push_back(s1);
	size.push_back(s2);
	unsigned long level=2;
	unsigned long index[LEVELS]={0,0,0},TS=s0*s1*s2;
	do{
		if(index[level]<size[level]){
			level=LEVELS-1;
			d.push_back(data[index[0]][index[1]][index[2]]);
			index[level]++;
		}else{
			index[level]=0;
			level--;
			index[level]++;
		}
	}while(level || index[0]!=size[0]);
	storage=new __VAR_CLASS<std::complex<double> >(size,d);
	type=hDComplex;
	#undef LEVELS
}
hVariable::hVariable(std::complex<long double> ***data,unsigned long s0,unsigned long s1,unsigned long s2){
	#define LEVELS 3
	using namespace std;
	vector<unsigned int> size;
	vector<std::complex<long double> > d;
	unsigned long i;

	size.push_back(s0);
	size.push_back(s1);
	size.push_back(s2);
	unsigned long level=2;
	unsigned long index[LEVELS]={0,0,0},TS=s0*s1*s2;
	do{
		if(index[level]<size[level]){
			level=LEVELS-1;
			d.push_back(data[index[0]][index[1]][index[2]]);
			index[level]++;
		}else{
			index[level]=0;
			level--;
			index[level]++;
		}
	}while(level || index[0]!=size[0]);
	storage=new __VAR_CLASS<std::complex<long double> >(size,d);
	type=hLDComplex;
	#undef LEVELS
}

hVariable::hVariable(bool ****data,unsigned long s0,unsigned long s1,unsigned long s2,unsigned long s3){
	#define LEVELS 4
	using namespace std;
	vector<unsigned int> size;
	vector<bool> d;
	unsigned long i;

	size.push_back(s0);
	size.push_back(s1);
	size.push_back(s2);
	size.push_back(s3);
	unsigned long level=2;
	unsigned long index[LEVELS]={0,0,0,0},TS=s0*s1*s2*s3;
	do{
		if(index[level]<size[level]){
			level=LEVELS-1;
			d.push_back(data[index[0]][index[1]][index[2]][index[3]]);
			index[level]++;
		}else{
			index[level]=0;
			level--;
			index[level]++;
		}
	}while(level || index[0]!=size[0]);
	storage=new __VAR_CLASS<bool>(size,d);
	type=hBool;
	#undef LEVELS
}
hVariable::hVariable(unsigned char ****data,unsigned long s0,unsigned long s1,unsigned long s2,unsigned long s3){
	#define LEVELS 4
	using namespace std;
	vector<unsigned int> size;
	vector<unsigned char> d;
	unsigned long i;

	size.push_back(s0);
	size.push_back(s1);
	size.push_back(s2);
	size.push_back(s3);
	unsigned long level=2;
	unsigned long index[LEVELS]={0,0,0,0},TS=s0*s1*s2*s3;
	do{
		if(index[level]<size[level]){
			level=LEVELS-1;
			d.push_back(data[index[0]][index[1]][index[2]][index[3]]);
			index[level]++;
		}else{
			index[level]=0;
			level--;
			index[level]++;
		}
	}while(level || index[0]!=size[0]);
	storage=new __VAR_CLASS<unsigned char>(size,d);
	type=huChar;
	#undef LEVELS
}
hVariable::hVariable(signed char ****data,unsigned long s0,unsigned long s1,unsigned long s2,unsigned long s3){
	#define LEVELS 4
	using namespace std;
	vector<unsigned int> size;
	vector<signed char> d;
	unsigned long i;

	size.push_back(s0);
	size.push_back(s1);
	size.push_back(s2);
	size.push_back(s3);
	unsigned long level=2;
	unsigned long index[LEVELS]={0,0,0,0},TS=s0*s1*s2*s3;
	do{
		if(index[level]<size[level]){
			level=LEVELS-1;
			d.push_back(data[index[0]][index[1]][index[2]][index[3]]);
			index[level]++;
		}else{
			index[level]=0;
			level--;
			index[level]++;
		}
	}while(level || index[0]!=size[0]);
	storage=new __VAR_CLASS<signed char>(size,d);
	type=hsChar;
	#undef LEVELS
}
hVariable::hVariable(unsigned short ****data,unsigned long s0,unsigned long s1,unsigned long s2,unsigned long s3){
	#define LEVELS 4
	using namespace std;
	vector<unsigned int> size;
	vector<unsigned short> d;
	unsigned long i;

	size.push_back(s0);
	size.push_back(s1);
	size.push_back(s2);
	size.push_back(s3);
	unsigned long level=2;
	unsigned long index[LEVELS]={0,0,0,0},TS=s0*s1*s2*s3;
	do{
		if(index[level]<size[level]){
			level=LEVELS-1;
			d.push_back(data[index[0]][index[1]][index[2]][index[3]]);
			index[level]++;
		}else{
			index[level]=0;
			level--;
			index[level]++;
		}
	}while(level || index[0]!=size[0]);
	storage=new __VAR_CLASS<unsigned short>(size,d);
	type=huShortInt;
	#undef LEVELS
}
hVariable::hVariable(signed short ****data,unsigned long s0,unsigned long s1,unsigned long s2,unsigned long s3){
	#define LEVELS 4
	using namespace std;
	vector<unsigned int> size;
	vector<signed short> d;
	unsigned long i;

	size.push_back(s0);
	size.push_back(s1);
	size.push_back(s2);
	size.push_back(s3);
	unsigned long level=2;
	unsigned long index[LEVELS]={0,0,0,0},TS=s0*s1*s2*s3;
	do{
		if(index[level]<size[level]){
			level=LEVELS-1;
			d.push_back(data[index[0]][index[1]][index[2]][index[3]]);
			index[level]++;
		}else{
			index[level]=0;
			level--;
			index[level]++;
		}
	}while(level || index[0]!=size[0]);
	storage=new __VAR_CLASS<signed short>(size,d);
	type=hsShortInt;
	#undef LEVELS
}
hVariable::hVariable(unsigned long ****data,unsigned long s0,unsigned long s1,unsigned long s2,unsigned long s3){
	#define LEVELS 4
	using namespace std;
	vector<unsigned int> size;
	vector<unsigned long> d;
	unsigned long i;

	size.push_back(s0);
	size.push_back(s1);
	size.push_back(s2);
	size.push_back(s3);
	unsigned long level=2;
	unsigned long index[LEVELS]={0,0,0,0},TS=s0*s1*s2*s3;
	do{
		if(index[level]<size[level]){
			level=LEVELS-1;
			d.push_back(data[index[0]][index[1]][index[2]][index[3]]);
			index[level]++;
		}else{
			index[level]=0;
			level--;
			index[level]++;
		}
	}while(level || index[0]!=size[0]);
	storage=new __VAR_CLASS<unsigned long>(size,d);
	type=huInt;
	#undef LEVELS
}
hVariable::hVariable(signed long ****data,unsigned long s0,unsigned long s1,unsigned long s2,unsigned long s3){
	#define LEVELS 4
	using namespace std;
	vector<unsigned int> size;
	vector<signed long> d;
	unsigned long i;

	size.push_back(s0);
	size.push_back(s1);
	size.push_back(s2);
	size.push_back(s3);
	unsigned long level=2;
	unsigned long index[LEVELS]={0,0,0,0},TS=s0*s1*s2*s3;
	do{
		if(index[level]<size[level]){
			level=LEVELS-1;
			d.push_back(data[index[0]][index[1]][index[2]][index[3]]);
			index[level]++;
		}else{
			index[level]=0;
			level--;
			index[level]++;
		}
	}while(level || index[0]!=size[0]);
	storage=new __VAR_CLASS<signed long>(size,d);
	type=hsInt;
	#undef LEVELS
}
hVariable::hVariable(float ****data,unsigned long s0,unsigned long s1,unsigned long s2,unsigned long s3){
	#define LEVELS 4
	using namespace std;
	vector<unsigned int> size;
	vector<float> d;
	unsigned long i;

	size.push_back(s0);
	size.push_back(s1);
	size.push_back(s2);
	size.push_back(s3);
	unsigned long level=2;
	unsigned long index[LEVELS]={0,0,0,0},TS=s0*s1*s2*s3;
	do{
		if(index[level]<size[level]){
			level=LEVELS-1;
			d.push_back(data[index[0]][index[1]][index[2]][index[3]]);
			index[level]++;
		}else{
			index[level]=0;
			level--;
			index[level]++;
		}
	}while(level || index[0]!=size[0]);
	storage=new __VAR_CLASS<float>(size,d);
	type=hFloat;
	#undef LEVELS
}
hVariable::hVariable(double ****data,unsigned long s0,unsigned long s1,unsigned long s2,unsigned long s3){
	#define LEVELS 4
	using namespace std;
	vector<unsigned int> size;
	vector<double> d;
	unsigned long i;

	size.push_back(s0);
	size.push_back(s1);
	size.push_back(s2);
	size.push_back(s3);
	unsigned long level=2;
	unsigned long index[LEVELS]={0,0,0,0},TS=s0*s1*s2*s3;
	do{
		if(index[level]<size[level]){
			level=LEVELS-1;
			d.push_back(data[index[0]][index[1]][index[2]][index[3]]);
			index[level]++;
		}else{
			index[level]=0;
			level--;
			index[level]++;
		}
	}while(level || index[0]!=size[0]);
	storage=new __VAR_CLASS<double>(size,d);
	type=hDouble;
	#undef LEVELS
}
hVariable::hVariable(long double ****data,unsigned long s0,unsigned long s1,unsigned long s2,unsigned long s3){
	#define LEVELS 4
	using namespace std;
	vector<unsigned int> size;
	vector<long double> d;
	unsigned long i;

	size.push_back(s0);
	size.push_back(s1);
	size.push_back(s2);
	size.push_back(s3);
	unsigned long level=2;
	unsigned long index[LEVELS]={0,0,0,0},TS=s0*s1*s2*s3;
	do{
		if(index[level]<size[level]){
			level=LEVELS-1;
			d.push_back(data[index[0]][index[1]][index[2]][index[3]]);
			index[level]++;
		}else{
			index[level]=0;
			level--;
			index[level]++;
		}
	}while(level || index[0]!=size[0]);
	storage=new __VAR_CLASS<long double>(size,d);
	type=hLDouble;
	#undef LEVELS
}
hVariable::hVariable(std::complex<float> ****data,unsigned long s0,unsigned long s1,unsigned long s2,unsigned long s3){
	#define LEVELS 4
	using namespace std;
	vector<unsigned int> size;
	vector<std::complex<float> > d;
	unsigned long i;

	size.push_back(s0);
	size.push_back(s1);
	size.push_back(s2);
	size.push_back(s3);
	unsigned long level=2;
	unsigned long index[LEVELS]={0,0,0,0},TS=s0*s1*s2*s3;
	do{
		if(index[level]<size[level]){
			level=LEVELS-1;
			d.push_back(data[index[0]][index[1]][index[2]][index[3]]);
			index[level]++;
		}else{
			index[level]=0;
			level--;
			index[level]++;
		}
	}while(level || index[0]!=size[0]);
	storage=new __VAR_CLASS<std::complex<float> >(size,d);
	type=hComplex;
	#undef LEVELS
}
hVariable::hVariable(std::complex<double> ****data,unsigned long s0,unsigned long s1,unsigned long s2,unsigned long s3){
	#define LEVELS 4
	using namespace std;
	vector<unsigned int> size;
	vector<std::complex<double> > d;
	unsigned long i;

	size.push_back(s0);
	size.push_back(s1);
	size.push_back(s2);
	size.push_back(s3);
	unsigned long level=2;
	unsigned long index[LEVELS]={0,0,0,0},TS=s0*s1*s2*s3;
	do{
		if(index[level]<size[level]){
			level=LEVELS-1;
			d.push_back(data[index[0]][index[1]][index[2]][index[3]]);
			index[level]++;
		}else{
			index[level]=0;
			level--;
			index[level]++;
		}
	}while(level || index[0]!=size[0]);
	storage=new __VAR_CLASS<std::complex<double> >(size,d);
	type=hDComplex;
	#undef LEVELS
}
hVariable::hVariable(std::complex<long double> ****data,unsigned long s0,unsigned long s1,unsigned long s2,unsigned long s3){
	#define LEVELS 4
	using namespace std;
	vector<unsigned int> size;
	vector<std::complex<long double> > d;
	unsigned long i;

	size.push_back(s0);
	size.push_back(s1);
	size.push_back(s2);
	size.push_back(s3);
	unsigned long level=2;
	unsigned long index[LEVELS]={0,0,0,0},TS=s0*s1*s2*s3;
	do{
		if(index[level]<size[level]){
			level=LEVELS-1;
			d.push_back(data[index[0]][index[1]][index[2]][index[3]]);
			index[level]++;
		}else{
			index[level]=0;
			level--;
			index[level]++;
		}
	}while(level || index[0]!=size[0]);
	storage=new __VAR_CLASS<std::complex<long double> >(size,d);
	type=hLDComplex;
	#undef LEVELS
}

hVariable::hVariable(bool *****data,unsigned long s0,unsigned long s1,unsigned long s2,unsigned long s3,unsigned long s4){
	#define LEVELS 5
	using namespace std;
	vector<unsigned int> size;
	vector<bool> d;
	unsigned long i;

	size.push_back(s0);
	size.push_back(s1);
	size.push_back(s2);
	size.push_back(s3);
	size.push_back(s4);
	unsigned long level=2;
	unsigned long index[LEVELS]={0,0,0,0,0},TS=s0*s1*s2*s3*s4;
	do{
		if(index[level]<size[level]){
			level=LEVELS-1;
			d.push_back(data[index[0]][index[1]][index[2]][index[3]][index[4]]);
			index[level]++;
		}else{
			index[level]=0;
			level--;
			index[level]++;
		}
	}while(level || index[0]!=size[0]);
	storage=new __VAR_CLASS<bool>(size,d);
	type=hBool;
	#undef LEVELS
}
hVariable::hVariable(unsigned char *****data,unsigned long s0,unsigned long s1,unsigned long s2,unsigned long s3,unsigned long s4){
	#define LEVELS 5
	using namespace std;
	vector<unsigned int> size;
	vector<unsigned char> d;
	unsigned long i;

	size.push_back(s0);
	size.push_back(s1);
	size.push_back(s2);
	size.push_back(s3);
	size.push_back(s4);
	unsigned long level=2;
	unsigned long index[LEVELS]={0,0,0,0,0},TS=s0*s1*s2*s3*s4;
	do{
		if(index[level]<size[level]){
			level=LEVELS-1;
			d.push_back(data[index[0]][index[1]][index[2]][index[3]][index[4]]);
			index[level]++;
		}else{
			index[level]=0;
			level--;
			index[level]++;
		}
	}while(level || index[0]!=size[0]);
	storage=new __VAR_CLASS<unsigned char>(size,d);
	type=huChar;
	#undef LEVELS
}
hVariable::hVariable(signed char *****data,unsigned long s0,unsigned long s1,unsigned long s2,unsigned long s3,unsigned long s4){
	#define LEVELS 5
	using namespace std;
	vector<unsigned int> size;
	vector<signed char> d;
	unsigned long i;

	size.push_back(s0);
	size.push_back(s1);
	size.push_back(s2);
	size.push_back(s3);
	size.push_back(s4);
	unsigned long level=2;
	unsigned long index[LEVELS]={0,0,0,0,0},TS=s0*s1*s2*s3*s4;
	do{
		if(index[level]<size[level]){
			level=LEVELS-1;
			d.push_back(data[index[0]][index[1]][index[2]][index[3]][index[4]]);
			index[level]++;
		}else{
			index[level]=0;
			level--;
			index[level]++;
		}
	}while(level || index[0]!=size[0]);
	storage=new __VAR_CLASS<signed char>(size,d);
	type=hsChar;
	#undef LEVELS
}
hVariable::hVariable(unsigned short *****data,unsigned long s0,unsigned long s1,unsigned long s2,unsigned long s3,unsigned long s4){
	#define LEVELS 5
	using namespace std;
	vector<unsigned int> size;
	vector<unsigned short> d;
	unsigned long i;

	size.push_back(s0);
	size.push_back(s1);
	size.push_back(s2);
	size.push_back(s3);
	size.push_back(s4);
	unsigned long level=2;
	unsigned long index[LEVELS]={0,0,0,0,0},TS=s0*s1*s2*s3*s4;
	do{
		if(index[level]<size[level]){
			level=LEVELS-1;
			d.push_back(data[index[0]][index[1]][index[2]][index[3]][index[4]]);
			index[level]++;
		}else{
			index[level]=0;
			level--;
			index[level]++;
		}
	}while(level || index[0]!=size[0]);
	storage=new __VAR_CLASS<unsigned short>(size,d);
	type=huShortInt;
	#undef LEVELS
}
hVariable::hVariable(signed short *****data,unsigned long s0,unsigned long s1,unsigned long s2,unsigned long s3,unsigned long s4){
	#define LEVELS 5
	using namespace std;
	vector<unsigned int> size;
	vector<signed short> d;
	unsigned long i;

	size.push_back(s0);
	size.push_back(s1);
	size.push_back(s2);
	size.push_back(s3);
	size.push_back(s4);
	unsigned long level=2;
	unsigned long index[LEVELS]={0,0,0,0,0},TS=s0*s1*s2*s3*s4;
	do{
		if(index[level]<size[level]){
			level=LEVELS-1;
			d.push_back(data[index[0]][index[1]][index[2]][index[3]][index[4]]);
			index[level]++;
		}else{
			index[level]=0;
			level--;
			index[level]++;
		}
	}while(level || index[0]!=size[0]);
	storage=new __VAR_CLASS<signed short>(size,d);
	type=hsShortInt;
	#undef LEVELS
}
hVariable::hVariable(unsigned long *****data,unsigned long s0,unsigned long s1,unsigned long s2,unsigned long s3,unsigned long s4){
	#define LEVELS 5
	using namespace std;
	vector<unsigned int> size;
	vector<unsigned long> d;
	unsigned long i;

	size.push_back(s0);
	size.push_back(s1);
	size.push_back(s2);
	size.push_back(s3);
	size.push_back(s4);
	unsigned long level=2;
	unsigned long index[LEVELS]={0,0,0,0,0},TS=s0*s1*s2*s3*s4;
	do{
		if(index[level]<size[level]){
			level=LEVELS-1;
			d.push_back(data[index[0]][index[1]][index[2]][index[3]][index[4]]);
			index[level]++;
		}else{
			index[level]=0;
			level--;
			index[level]++;
		}
	}while(level || index[0]!=size[0]);
	storage=new __VAR_CLASS<unsigned long>(size,d);
	type=huInt;
	#undef LEVELS
}
hVariable::hVariable(signed long *****data,unsigned long s0,unsigned long s1,unsigned long s2,unsigned long s3,unsigned long s4){
	#define LEVELS 5
	using namespace std;
	vector<unsigned int> size;
	vector<signed long> d;
	unsigned long i;

	size.push_back(s0);
	size.push_back(s1);
	size.push_back(s2);
	size.push_back(s3);
	size.push_back(s4);
	unsigned long level=2;
	unsigned long index[LEVELS]={0,0,0,0,0},TS=s0*s1*s2*s3*s4;
	do{
		if(index[level]<size[level]){
			level=LEVELS-1;
			d.push_back(data[index[0]][index[1]][index[2]][index[3]][index[4]]);
			index[level]++;
		}else{
			index[level]=0;
			level--;
			index[level]++;
		}
	}while(level || index[0]!=size[0]);
	storage=new __VAR_CLASS<signed long>(size,d);
	type=hsInt;
	#undef LEVELS
}
hVariable::hVariable(float *****data,unsigned long s0,unsigned long s1,unsigned long s2,unsigned long s3,unsigned long s4){
	#define LEVELS 5
	using namespace std;
	vector<unsigned int> size;
	vector<float> d;
	unsigned long i;

	size.push_back(s0);
	size.push_back(s1);
	size.push_back(s2);
	size.push_back(s3);
	size.push_back(s4);
	unsigned long level=2;
	unsigned long index[LEVELS]={0,0,0,0,0},TS=s0*s1*s2*s3*s4;
	do{
		if(index[level]<size[level]){
			level=LEVELS-1;
			d.push_back(data[index[0]][index[1]][index[2]][index[3]][index[4]]);
			index[level]++;
		}else{
			index[level]=0;
			level--;
			index[level]++;
		}
	}while(level || index[0]!=size[0]);
	storage=new __VAR_CLASS<float>(size,d);
	type=hFloat;
	#undef LEVELS
}
hVariable::hVariable(double *****data,unsigned long s0,unsigned long s1,unsigned long s2,unsigned long s3,unsigned long s4){
	#define LEVELS 5
	using namespace std;
	vector<unsigned int> size;
	vector<double> d;
	unsigned long i;

	size.push_back(s0);
	size.push_back(s1);
	size.push_back(s2);
	size.push_back(s3);
	size.push_back(s4);
	unsigned long level=2;
	unsigned long index[LEVELS]={0,0,0,0,0},TS=s0*s1*s2*s3*s4;
	do{
		if(index[level]<size[level]){
			level=LEVELS-1;
			d.push_back(data[index[0]][index[1]][index[2]][index[3]][index[4]]);
			index[level]++;
		}else{
			index[level]=0;
			level--;
			index[level]++;
		}
	}while(level || index[0]!=size[0]);
	storage=new __VAR_CLASS<double>(size,d);
	type=hDouble;
	#undef LEVELS
}
hVariable::hVariable(long double *****data,unsigned long s0,unsigned long s1,unsigned long s2,unsigned long s3,unsigned long s4){
	#define LEVELS 5
	using namespace std;
	vector<unsigned int> size;
	vector<long double> d;
	unsigned long i;

	size.push_back(s0);
	size.push_back(s1);
	size.push_back(s2);
	size.push_back(s3);
	size.push_back(s4);
	unsigned long level=2;
	unsigned long index[LEVELS]={0,0,0,0,0},TS=s0*s1*s2*s3*s4;
	do{
		if(index[level]<size[level]){
			level=LEVELS-1;
			d.push_back(data[index[0]][index[1]][index[2]][index[3]][index[4]]);
			index[level]++;
		}else{
			index[level]=0;
			level--;
			index[level]++;
		}
	}while(level || index[0]!=size[0]);
	storage=new __VAR_CLASS<long double>(size,d);
	type=hLDouble;
	#undef LEVELS
}
hVariable::hVariable(std::complex<float> *****data,unsigned long s0,unsigned long s1,unsigned long s2,unsigned long s3,unsigned long s4){
	#define LEVELS 5
	using namespace std;
	vector<unsigned int> size;
	vector<std::complex<float> > d;
	unsigned long i;

	size.push_back(s0);
	size.push_back(s1);
	size.push_back(s2);
	size.push_back(s3);
	size.push_back(s4);
	unsigned long level=2;
	unsigned long index[LEVELS]={0,0,0,0,0},TS=s0*s1*s2*s3*s4;
	do{
		if(index[level]<size[level]){
			level=LEVELS-1;
			d.push_back(data[index[0]][index[1]][index[2]][index[3]][index[4]]);
			index[level]++;
		}else{
			index[level]=0;
			level--;
			index[level]++;
		}
	}while(level || index[0]!=size[0]);
	storage=new __VAR_CLASS<std::complex<float> >(size,d);
	type=hComplex;
	#undef LEVELS
}
hVariable::hVariable(std::complex<double> *****data,unsigned long s0,unsigned long s1,unsigned long s2,unsigned long s3,unsigned long s4){
	#define LEVELS 5
	using namespace std;
	vector<unsigned int> size;
	vector<std::complex<double> > d;
	unsigned long i;

	size.push_back(s0);
	size.push_back(s1);
	size.push_back(s2);
	size.push_back(s3);
	size.push_back(s4);
	unsigned long level=2;
	unsigned long index[LEVELS]={0,0,0,0,0},TS=s0*s1*s2*s3*s4;
	do{
		if(index[level]<size[level]){
			level=LEVELS-1;
			d.push_back(data[index[0]][index[1]][index[2]][index[3]][index[4]]);
			index[level]++;
		}else{
			index[level]=0;
			level--;
			index[level]++;
		}
	}while(level || index[0]!=size[0]);
	storage=new __VAR_CLASS<std::complex<double> >(size,d);
	type=hDComplex;
	#undef LEVELS
}
hVariable::hVariable(std::complex<long double> *****data,unsigned long s0,unsigned long s1,unsigned long s2,unsigned long s3,unsigned long s4){
	#define LEVELS 5
	using namespace std;
	vector<unsigned int> size;
	vector<std::complex<long double> > d;
	unsigned long i;

	size.push_back(s0);
	size.push_back(s1);
	size.push_back(s2);
	size.push_back(s3);
	size.push_back(s4);
	unsigned long level=2;
	unsigned long index[LEVELS]={0,0,0,0,0},TS=s0*s1*s2*s3*s4;
	do{
		if(index[level]<size[level]){
			level=LEVELS-1;
			d.push_back(data[index[0]][index[1]][index[2]][index[3]][index[4]]);
			index[level]++;
		}else{
			index[level]=0;
			level--;
			index[level]++;
		}
	}while(level || index[0]!=size[0]);
	storage=new __VAR_CLASS<std::complex<long double> >(size,d);
	type=hLDComplex;
	#undef LEVELS
}
hVariable::hVariable(bool ******data,unsigned long s0,unsigned long s1,unsigned long s2,unsigned long s3,unsigned long s4,unsigned long s5){}
hVariable::hVariable(unsigned char ******data,unsigned long s0,unsigned long s1,unsigned long s2,unsigned long s3,unsigned long s4,unsigned long s5){}
hVariable::hVariable(signed char ******data,unsigned long s0,unsigned long s1,unsigned long s2,unsigned long s3,unsigned long s4,unsigned long s5){}
hVariable::hVariable(unsigned short ******data,unsigned long s0,unsigned long s1,unsigned long s2,unsigned long s3,unsigned long s4,unsigned long s5){}
hVariable::hVariable(signed short ******data,unsigned long s0,unsigned long s1,unsigned long s2,unsigned long s3,unsigned long s4,unsigned long s5){}
hVariable::hVariable(unsigned long ******data,unsigned long s0,unsigned long s1,unsigned long s2,unsigned long s3,unsigned long s4,unsigned long s5){}
hVariable::hVariable(signed long ******data,unsigned long s0,unsigned long s1,unsigned long s2,unsigned long s3,unsigned long s4,unsigned long s5){}
hVariable::hVariable(float ******data,unsigned long s0,unsigned long s1,unsigned long s2,unsigned long s3,unsigned long s4,unsigned long s5){}
hVariable::hVariable(double ******data,unsigned long s0,unsigned long s1,unsigned long s2,unsigned long s3,unsigned long s4,unsigned long s5){}
hVariable::hVariable(long double ******data,unsigned long s0,unsigned long s1,unsigned long s2,unsigned long s3,unsigned long s4,unsigned long s5){}
hVariable::hVariable(std::complex<float> ******data,unsigned long s0,unsigned long s1,unsigned long s2,unsigned long s3,unsigned long s4,unsigned long s5){}
hVariable::hVariable(std::complex<double> ******data,unsigned long s0,unsigned long s1,unsigned long s2,unsigned long s3,unsigned long s4,unsigned long s5){}
hVariable::hVariable(std::complex<long double> ******data,unsigned long s0,unsigned long s1,unsigned long s2,unsigned long s3,unsigned long s4,unsigned long s5){}

const hVariable & hVariable::operator=(const bool &op2){
	if(type)
		storage->setValue(op2);
	else
		storage=new __VAR_CLASS<bool>(op2);
		type=hBool;
	return *this;
}
const hVariable & hVariable::operator=(const unsigned char &op2){
	if(type)
		storage->setValue(op2);
	else
		storage=new __VAR_CLASS<unsigned char>(op2);
		type=huChar;
	return *this;
}
const hVariable & hVariable::operator=(const signed char &op2){
	if(type)
		storage->setValue(op2);
	else
		storage=new __VAR_CLASS<signed char>(op2);
		type=hsChar;
	return *this;
}
const hVariable & hVariable::operator=(const unsigned short &op2){
	if(type)
		storage->setValue(op2);
	else
		storage=new __VAR_CLASS<unsigned short>(op2);
		type=huShortInt;
	return *this;
}
const hVariable & hVariable::operator=(const signed short &op2){
	if(type)
		storage->setValue(op2);
	else
		storage=new __VAR_CLASS<signed short>(op2);
		type=hsShortInt;
	return *this;
}
const hVariable & hVariable::operator=(const unsigned long &op2){
	if(type)
		storage->setValue(op2);
	else
		storage=new __VAR_CLASS<unsigned long>(op2);
		type=huInt;
	return *this;
}
const hVariable & hVariable::operator=(const signed long &op2){
	if(type)
		storage->setValue(op2);
	else
		storage=new __VAR_CLASS<signed long>(op2);
		type=hsInt;
	return *this;
}
const hVariable & hVariable::operator=(const float &op2){
	if(type)
		storage->setValue(op2);
	else
		storage=new __VAR_CLASS<float>(op2);
		type=hFloat;
	return *this;
}
const hVariable & hVariable::operator=(const double &op2){
	if(type)
		storage->setValue(op2);
	else
		storage=new __VAR_CLASS<double>(op2);
		type=hDouble;
	return *this;
}
const hVariable & hVariable::operator=(const long double &op2){
	if(type)
		storage->setValue(op2);
	else
		storage=new __VAR_CLASS<long double>(op2);
		type=hLDouble;
	return *this;
}
const hVariable & hVariable::operator=(const std::complex<float> &op2){
	if(type)
		storage->setValue(op2);
	else
		storage=new __VAR_CLASS<std::complex<float> >(op2);
		type=hComplex;
	return *this;
}
const hVariable & hVariable::operator=(const std::complex<double> &op2){
	if(type)
		storage->setValue(op2);
	else
		storage=new __VAR_CLASS<std::complex<double> >(op2);
		type=hDComplex;
	return *this;
}
const hVariable & hVariable::operator=(const std::complex<long double> &op2){
	if(type)
		storage->setValue(op2);
	else
		storage=new __VAR_CLASS<std::complex<long double> >(op2);
		type=hLDComplex;
	return *this;
}

const hVariable & hVariable::operator=(const unsigned &op2){
	if(type)
		storage->setValue((unsigned long)op2);
	else
		storage=new __VAR_CLASS<unsigned long>((unsigned long)op2);
		type=huInt;
	return *this;
}
const hVariable & hVariable::operator=(const signed &op2){
	if(type)
		storage->setValue((signed long)op2);
	else
		storage=new __VAR_CLASS<signed long>((signed long)op2);
		type=hsInt;
	return *this;
}

#undef __VAR_CLASS

#endif

unsigned int hVariable::getDim(void){
	return storage->getDim();
}

std::vector<unsigned int> hVariable::getSize(void){
	return storage->getSize();
}

unsigned int hVariable::getSize(unsigned int dimension){
	return storage->getSize(dimension);
}

void hVariable::setValue(std::vector<unsigned int> index,hVariable data){
	hVarBase *temp;
	temp=data.storage->cast(storage->getType());
	storage->setValue(index,temp);
	temp->clear();
}
void hVariable::setValue(unsigned long *index,const hVariable &data){
	storage->setValue(index,data.storage);
}
void hVariable::setValue(hVariable data){
	storage->setValue(data.storage);
}

void hVariable::setValue(std::vector<unsigned int> index,bool data){
	storage->setValue(index,data);
}
void hVariable::setValue(std::vector<unsigned int> index,unsigned char data){
	storage->setValue(index,data);
}
void hVariable::setValue(std::vector<unsigned int> index,signed char data){
	storage->setValue(index,data);
}
void hVariable::setValue(std::vector<unsigned int> index,unsigned short data){
	storage->setValue(index,data);
}
void hVariable::setValue(std::vector<unsigned int> index,signed short data){
	storage->setValue(index,data);
}
void hVariable::setValue(std::vector<unsigned int> index,unsigned long data){
	storage->setValue(index,data);
}
void hVariable::setValue(std::vector<unsigned int> index,signed long data){
	storage->setValue(index,data);
}
/*void hVariable::setValue(std::vector<unsigned int> index,unsigned int data){
	storage->setValue(index,data);
}
void hVariable::setValue(std::vector<unsigned int> index,signed int data){
	storage->setValue(index,data);
}*/
void hVariable::setValue(std::vector<unsigned int> index,float data){
	storage->setValue(index,data);
}
void hVariable::setValue(std::vector<unsigned int> index,double data){
	storage->setValue(index,data);
}
void hVariable::setValue(std::vector<unsigned int> index,long double data){
	storage->setValue(index,data);
}
void hVariable::setValue(std::vector<unsigned int> index,std::complex<float> data){
	storage->setValue(index,data);
}
void hVariable::setValue(std::vector<unsigned int> index,std::complex<double> data){
	storage->setValue(index,data);
}
void hVariable::setValue(std::vector<unsigned int> index,std::complex<long double> data){
	storage->setValue(index,data);
}

void hVariable::setValue(bool data){
	storage->setValue(data);
}
void hVariable::setValue(unsigned char data){
	storage->setValue(data);
}
void hVariable::setValue(signed char data){
	storage->setValue(data);
}
void hVariable::setValue(unsigned short data){
	storage->setValue(data);
}
void hVariable::setValue(signed short data){
	storage->setValue(data);
}
void hVariable::setValue(unsigned long data){
	storage->setValue(data);
}
void hVariable::setValue(signed long data){
	storage->setValue(data);
}
/*void hVariable::setValue(unsigned int data){
	storage->setValue(data);
}
void hVariable::setValue(signed int data){
	storage->setValue(data);
}*/
void hVariable::setValue(float data){
	storage->setValue(data);
}
void hVariable::setValue(double data){
	storage->setValue(data);
}
void hVariable::setValue(long double data){
	storage->setValue(data);
}
void hVariable::setValue(std::complex<float> data){
	storage->setValue(data);
}
void hVariable::setValue(std::complex<double> data){
	storage->setValue(data);
}
void hVariable::setValue(std::complex<long double> data){
	storage->setValue(data);
}

hVariable hVariable::getValue(std::vector<unsigned int> index){
	hVariable ret;
	ret.storage=storage->getValue(index);
	ret.type=type;
	return ret;
}
hVariable hVariable::getValue(void){
	hVariable ret;
	ret.storage=storage->getValue();
	ret.type=type;
	return ret;
}

bool hVariable::getValue(bool &data){
	return storage->getValue(data);
}	
unsigned char hVariable::getValue(unsigned char &data){
	return storage->getValue(data);
}
signed char hVariable::getValue(signed char &data){
	return storage->getValue(data);
}
unsigned short hVariable::getValue(unsigned short &data){
	return storage->getValue(data);
}
signed short hVariable::getValue(signed short &data){
	return storage->getValue(data);
}
unsigned long hVariable::getValue(unsigned long &data){
	return storage->getValue(data);
}
signed long hVariable::getValue(signed long &data){
	return storage->getValue(data);
}
float hVariable::getValue(float &data){
	return storage->getValue(data);
}
double hVariable::getValue(double &data){
	return storage->getValue(data);
}
long double hVariable::getValue(long double &data){
	return storage->getValue(data);
}
std::complex<float> hVariable::getValue(std::complex<float> &data){
	return storage->getValue(data);
}
std::complex<double> hVariable::getValue(std::complex<double> &data){
	return storage->getValue(data);
}
std::complex<long double> hVariable::getValue(std::complex<long double> &data){
	return storage->getValue(data);
}

bool hVariable::getValue(std::vector<unsigned int> index,bool &data){
	return storage->getValue(index,data);
}
unsigned char hVariable::getValue(std::vector<unsigned int> index,unsigned char &data){
	return storage->getValue(index,data);
}
signed char hVariable::getValue(std::vector<unsigned int> index,signed char &data){
	return storage->getValue(index,data);
}
unsigned short hVariable::getValue(std::vector<unsigned int> index,unsigned short &data){
	return storage->getValue(index,data);
}
signed short hVariable::getValue(std::vector<unsigned int> index,signed short &data){
	return storage->getValue(index,data);
}
unsigned long hVariable::getValue(std::vector<unsigned int> index,unsigned long &data){
	return storage->getValue(index,data);
}
signed long hVariable::getValue(std::vector<unsigned int> index,signed long &data){
	return storage->getValue(index,data);
}
float hVariable::getValue(std::vector<unsigned int> index,float &data){
	return storage->getValue(index,data);
}
double hVariable::getValue(std::vector<unsigned int> index,double &data){
	return storage->getValue(index,data);
}
long double hVariable::getValue(std::vector<unsigned int> index,long double &data){
	return storage->getValue(index,data);
}
std::complex<float> hVariable::getValue(std::vector<unsigned int> index,std::complex<float> &data){
	return storage->getValue(index,data);
}
std::complex<double> hVariable::getValue(std::vector<unsigned int> index,std::complex<double> &data){
	return storage->getValue(index,data);
}
std::complex<long double> hVariable::getValue(std::vector<unsigned int> index,std::complex<long double> &data){
	return storage->getValue(index,data);
}

void hVariable::get(bool *data){
	storage->get(data);
}
void hVariable::get(unsigned char *data){
	storage->get(data);
}
void hVariable::get(signed char *data){
	storage->get(data);
}
void hVariable::get(unsigned short *data){
	storage->get(data);
}
void hVariable::get(signed short *data){
	storage->get(data);
}
void hVariable::get(unsigned long *data){
	storage->get(data);
}
void hVariable::get(signed long *data){
	storage->get(data);
}
void hVariable::get(float *data){
	storage->get(data);
}
void hVariable::get(double *data){
	storage->get(data);
}
void hVariable::get(long double *data){
	storage->get(data);
}
void hVariable::get(std::complex<float> *data){
	storage->get(data);
}
void hVariable::get(std::complex<double> *data){
	storage->get(data);
}
void hVariable::get(std::complex<long double> *data){
	storage->get(data);
}

unsigned char hVariable::getType(void){
	return type;
}

void hVariable::clear(void){
	storage->clear();
	type=hNoType;
}

hVariable hVariable::cast(unsigned char type){
	hVariable ret;
	ret.storage=storage->cast(type);
	ret.type=type;
	return ret;
}

hVariable hVariable::convert(bool flank){
	return cast(hBool);
}
hVariable hVariable::convert(unsigned char flank){
	return cast(huChar);
}
hVariable hVariable::convert(signed char flank){
	return cast(hsChar);
}
hVariable hVariable::convert(unsigned short flank){
	return cast(huShortInt);
}
hVariable hVariable::convert(signed short flank){
	return cast(hsShortInt);
}
hVariable hVariable::convert(unsigned long flank){
	return cast(huInt);
}
hVariable hVariable::convert(signed long flank){
	return cast(hsInt);
}
/*hVariable hVariable::convert(unsigned int flank){
	return cast(hBool);
}
hVariable hVariable::convert(signed int flank){
	return cast(hBool);
}*/
hVariable hVariable::convert(float flank){
	return cast(hFloat);
}
hVariable hVariable::convert(double flank){
	return cast(hDouble);
}
hVariable hVariable::convert(long double flank){
	return cast(hLDouble);
}
hVariable hVariable::convert(std::complex<float> flank){
	return cast(hComplex);
}
hVariable hVariable::convert(std::complex<double> flank){
	return cast(hDComplex);
}
hVariable hVariable::convert(std::complex<long double> flank){
	return cast(hLDComplex);
}

hVariable hVariable::operator+(const hVariable &op2){
	#define __OPERATOR +
	unsigned char ftype,type2;
	hVarBase *top;
	hVariable ret;
	type2=op2.type;
	if(type<type2){
		top=storage->cast(type2);
		ret.storage=(*top) __OPERATOR op2.storage;
		top->clear();
//		delete top;
	}else if(type>type2){
		top=op2.storage->cast(type);
		ret.storage=*storage __OPERATOR top;
		top->clear();
//		delete top;
	}else{
		ret.storage=*storage __OPERATOR op2.storage;
	}
	ret.type=ret.storage->getType();
	return ret;
	#undef __OPERATOR
}
hVariable hVariable::operator-(const hVariable &op2){
	#define __OPERATOR -
	unsigned char ftype,type2;
	hVarBase *top;
	hVariable ret;
	type2=op2.type;
	if(type<type2){
		top=storage->cast(type2);
		ret.storage=(*top) __OPERATOR op2.storage;
		top->clear();
//		delete top;
	}else if(type>type2){
		top=op2.storage->cast(type);
		ret.storage=*storage __OPERATOR top;
		top->clear();
//		delete top;
	}else{
		ret.storage=*storage __OPERATOR op2.storage;
	}
	ret.type=ret.storage->getType();
	return ret;
	#undef __OPERATOR
}
hVariable hVariable::operator*(const hVariable &op2){
	#define __OPERATOR *
	unsigned char ftype,type2;
	hVarBase *top;
	hVariable ret;
	type2=op2.type;
	if(type<type2){
		top=storage->cast(type2);
		ret.storage=(*top) __OPERATOR op2.storage;
		top->clear();
//		delete top;
	}else if(type>type2){
		top=op2.storage->cast(type);
		ret.storage=*storage __OPERATOR top;
		top->clear();
//		delete top;
	}else{
		ret.storage=*storage __OPERATOR op2.storage;
	}
	ret.type=ret.storage->getType();
	return ret;
	#undef __OPERATOR
}
hVariable hVariable::operator/(const hVariable &op2){
	#define __OPERATOR /
	unsigned char ftype,type2;
	hVarBase *top;
	hVariable ret;
	type2=op2.type;
	if(type<type2){
		top=storage->cast(type2);
		ret.storage=(*top) __OPERATOR op2.storage;
		top->clear();
//		delete top;
	}else if(type>type2){
		top=op2.storage->cast(type);
		ret.storage=*storage __OPERATOR top;
		top->clear();
//		delete top;
	}else{
		ret.storage=*storage __OPERATOR op2.storage;
	}
	ret.type=ret.storage->getType();
	return ret;
	#undef __OPERATOR
}
hVariable hVariable::operator%(const hVariable &op2){
	#define __OPERATOR %
	unsigned char ftype,type2;
	hVarBase *top;
	hVariable ret;
	type2=op2.type;
	if(type<type2){
		top=storage->cast(type2);
		ret.storage=(*top) __OPERATOR op2.storage;
		top->clear();
//		delete top;
	}else if(type>type2){
		top=op2.storage->cast(type);
		ret.storage=*storage __OPERATOR top;
		top->clear();
//		delete top;
	}else{
		ret.storage=*storage __OPERATOR op2.storage;
	}
	ret.type=ret.storage->getType();
	return ret;
	#undef __OPERATOR
}

const hVariable & hVariable::operator=(const hVariable &op2){
	if(type){
		storage->clear();
//		delete storage;
		type=hNoType;
	}
	if(op2.type)
		storage=op2.storage->copy();
	type=op2.type;	
	return *this;
}

const hVariable & hVariable::operator+=(const hVariable &op2){
	hVariable temp;
	temp=*this+op2;
	this->storage->clear();
//	delete this->storage;
	*this=temp.cast(type);
	return *this;	
}
const hVariable & hVariable::operator-=(const hVariable &op2){
	hVariable temp;
	temp=*this-op2;
	this->storage->clear();
//	delete this->storage;
	*this=temp.cast(type);
	return *this;		
}
const hVariable & hVariable::operator*=(const hVariable &op2){
	hVariable temp;
	temp=*this*op2;
	this->storage->clear();
//	delete this->storage;
	*this=temp.cast(type);
	return *this;		
}
const hVariable & hVariable::operator/=(const hVariable &op2){
	hVariable temp;
	temp=*this/op2;
	this->storage->clear();
//	delete this->storage;
	*this=temp.cast(type);
	return *this;		
}
const hVariable & hVariable::operator%=(const hVariable &op2){
	hVariable temp;
	temp=*this%op2;
	this->storage->clear();
//	delete this->storage;
	*this=temp.cast(type);
	return *this;		
}

const hVariable & hVariable::operator>>=(const hVariable &op2){
	hVariable temp;
	temp=*this>>op2;
	this->storage->clear();
//	delete this->storage;
	*this=temp.cast(type);
	return *this;		
}
const hVariable & hVariable::operator<<=(const hVariable &op2){
	hVariable temp;
	temp=*this<<op2;
	this->storage->clear();
//	delete this->storage;
	*this=temp.cast(type);
	return *this;		
}
const hVariable & hVariable::operator&=(const hVariable &op2){
	hVariable temp;
	temp=*this&op2;
	this->storage->clear();
//	delete this->storage;
	*this=temp.cast(type);
	return *this;	
}
const hVariable & hVariable::operator^=(const hVariable &op2){
	hVariable temp;
	temp=*this^op2;
	this->storage->clear();
//	delete this->storage;
	*this=temp.cast(type);
	return *this;		
}
const hVariable & hVariable::operator|=(const hVariable &op2){
	hVariable temp;
	temp=*this|op2;
	this->storage->clear();
//	delete this->storage;
	*this=temp.cast(type);
	return *this;		
}

hVariable hVariable::operator<(const hVariable &op2){
	#define __OPERATOR <
	unsigned char ftype,type2;
	hVarBase *top;
	hVariable ret;
	type2=op2.type;
	if(type<type2){
		top=storage->cast(type2);
		ret.storage=(*top) __OPERATOR op2.storage;
		top->clear();
//		delete top;
	}else if(type>type2){
		top=op2.storage->cast(type);
		ret.storage=*storage __OPERATOR top;
		top->clear();
//		delete top;
	}else{
		ret.storage=*storage __OPERATOR op2.storage;
	}
	ret.type=ret.storage->getType();
	return ret;
	#undef __OPERATOR
}
hVariable hVariable::operator>(const hVariable &op2){
	#define __OPERATOR >
	unsigned char ftype,type2;
	hVarBase *top;
	hVariable ret;
	type2=op2.type;
	if(type<type2){
		top=storage->cast(type2);
		ret.storage=(*top) __OPERATOR op2.storage;
		top->clear();
//		delete top;
	}else if(type>type2){
		top=op2.storage->cast(type);
		ret.storage=*storage __OPERATOR top;
		top->clear();
//		delete top;
	}else{
		ret.storage=*storage __OPERATOR op2.storage;
	}
	ret.type=ret.storage->getType();
	return ret;
	#undef __OPERATOR
}
hVariable hVariable::operator<=(const hVariable &op2){
	#define __OPERATOR <=
	unsigned char ftype,type2;
	hVarBase *top;
	hVariable ret;
	type2=op2.type;
	if(type<type2){
		top=storage->cast(type2);
		ret.storage=(*top) __OPERATOR op2.storage;
		top->clear();
//		delete top;
	}else if(type>type2){
		top=op2.storage->cast(type);
		ret.storage=*storage __OPERATOR top;
		top->clear();
//		delete top;
	}else{
		ret.storage=*storage __OPERATOR op2.storage;
	}
	ret.type=ret.storage->getType();
	return ret;
	#undef __OPERATOR
}
hVariable hVariable::operator>=(const hVariable &op2){
	#define __OPERATOR >=
	unsigned char ftype,type2;
	hVarBase *top;
	hVariable ret;
	type2=op2.type;
	if(type<type2){
		top=storage->cast(type2);
		ret.storage=(*top) __OPERATOR op2.storage;
		top->clear();
//		delete top;
	}else if(type>type2){
		top=op2.storage->cast(type);
		ret.storage=*storage __OPERATOR top;
		top->clear();
//		delete top;
	}else{
		ret.storage=*storage __OPERATOR op2.storage;
	}
	ret.type=ret.storage->getType();
	return ret;
	#undef __OPERATOR
}

hVariable hVariable::operator!(void){
	hVariable ret;
	ret.storage=!(*storage);
	ret.type=hBool;
	return ret;
}
hVariable hVariable::operator&&(const hVariable &op2){
	hVarBase *top1,*top2;
	hVariable ret;
	unsigned char type2;
	type2=op2.type;
	if(type<type2){
		top1=storage->cast(type2);
		top2=op2.storage;
	}else if(type>type2){
		top1=storage;
		top2=op2.storage->cast(type);
	}else{
		top1=storage;
		top2=op2.storage;
	}
	ret.storage=(*top1)&&top2;
	ret.type=hBool;
	return ret;
}
hVariable hVariable::operator||(const hVariable &op2){
	hVarBase *top1,*top2;
	hVariable ret;
	unsigned char type2;
	type2=op2.type;
	if(type<type2){
		top1=storage->cast(type2);
		top2=op2.storage;
	}else if(type>type2){
		top1=storage;
		top2=op2.storage->cast(type);
	}else{
		top1=storage;
		top2=op2.storage;
	}
	ret.storage=(*top1)||top2;
	ret.type=hBool;
	return ret;
}
hVariable hVariable::operator==(const hVariable &op2){
	hVarBase *top1,*top2;
	hVariable ret;
	unsigned char type2;
	type2=op2.type;
	if(type<type2){
		top1=storage->cast(type2);
		top2=op2.storage;
	}else if(type>type2){
		top1=storage;
		top2=op2.storage->cast(type);
	}else{
		top1=storage;
		top2=op2.storage;
	}
	ret.storage=(*top1)==top2;
	ret.type=hBool;
	return ret;
}
hVariable hVariable::operator!=(const hVariable &op2){
	hVarBase *top1,*top2;
	hVariable ret;
	unsigned char type2;
	type2=op2.type;
	if(type<type2){
		top1=storage->cast(type2);
		top2=op2.storage;
	}else if(type>type2){
		top1=storage;
		top2=op2.storage->cast(type);
	}else{
		top1=storage;
		top2=op2.storage;
	}
	ret.storage=(*top1)!=top2;
	ret.type=ret.storage->getType();
	return ret;
}

hVariable hVariable::operator~(void){
	hVariable ret;
	ret.storage=~(*storage);
	ret.type=type;
	return ret;
}

hVariable hVariable::operator<<(const hVariable &op2){
	hVarBase *top1,*top2;
	hVariable ret;
	unsigned char type2;
	type2=op2.type;
	if(type<type2){
		top1=storage->cast(type2);
		top2=op2.storage;
	}else if(type>type2){
		top1=storage;
		top2=op2.storage->cast(type);
	}else{
		top1=storage;
		top2=op2.storage;
	}
	ret.storage=(*top1)<<top2;
	ret.type=ret.storage->getType();
	return ret;
}
hVariable hVariable::operator>>(const hVariable &op2){
	hVarBase *top1,*top2;
	hVariable ret;
	unsigned char type2;
	type2=op2.type;
	if(type<type2){
		top1=storage->cast(type2);
		top2=op2.storage;
	}else if(type>type2){
		top1=storage;
		top2=op2.storage->cast(type);
	}else{
		top1=storage;
		top2=op2.storage;
	}
	ret.storage=(*top1)>>top2;
	ret.type=ret.storage->getType();
	return ret;
}
hVariable hVariable::operator&(const hVariable &op2){
	unsigned char ftype,type2;
	hVarBase *top1,*top2;
	hVariable ret;
	type2=op2.type;
	if(type<type2){
		ftype=type2;
		top1=storage->cast(ftype);
		top2=op2.storage;
	}else if(type>type2){
		ftype=type;
		top1=storage;
		top2=op2.storage->cast(ftype);
	}else{
		ftype=type;
		top1=storage;
		top2=op2.storage;
	}
	ret.storage=(*top1)&top2;
	ret.type=ftype;
	return ret;
}
hVariable hVariable::operator|(const hVariable &op2){
	unsigned char ftype,type2;
	hVarBase *top1,*top2;
	hVariable ret;
	type2=op2.type;
	if(type<type2){
		ftype=type2;
		top1=storage->cast(ftype);
		top2=op2.storage;
	}else if(type>type2){
		ftype=type;
		top1=storage;
		top2=op2.storage->cast(ftype);
	}else{
		ftype=type;
		top1=storage;
		top2=op2.storage;
	}
	ret.storage=(*top1)|top2;
	ret.type=ftype;
	return ret;
}
hVariable hVariable::operator^(const hVariable &op2){
	unsigned char ftype,type2;
	hVarBase *top1,*top2;
	hVariable ret;
	type2=op2.type;
	if(type<type2){
		ftype=type2;
		top1=storage->cast(ftype);
		top2=op2.storage;
	}else if(type>type2){
		ftype=type;
		top1=storage;
		top2=op2.storage->cast(ftype);
	}else{
		ftype=type;
		top1=storage;
		top2=op2.storage;
	}
	ret.storage=(*top1)^top2;
	ret.type=ftype;
	return ret;
}

const hVariable hVariable::operator++(int){//a++
	hVariable ret;
	ret=*this;
	++(*storage);
	return ret;
}
const hVariable & hVariable::operator++(void){//++a
	++(*storage);
	return *this;
}
const hVariable hVariable::operator--(int){
	hVariable ret;
	ret=*this;
	--(*storage);
	return ret;
}
const hVariable & hVariable::operator--(void){
	--(*storage);
	return *this;
}

void hVariable::dump(std::ofstream &str){
/*	str<<type;
	storage.dump(str);*/
}

hVariable hVariable::operator[](unsigned int index){
	std::vector<unsigned int> in;
	in.push_back(index);
	return getValue(in);
}

hVariable hVariable::operator[](hVariable index){
	unsigned long value;
	index.getValue(value);
	std::vector<unsigned int> in;
	in.push_back(value);
	return getValue(in);	
}

std::ostream& operator<<(std::ostream& output,const hVariable& s){
	s.storage->print(output);
	return output;
}

hVariable operator+(int op1,const hVariable &op2){
	//throw hException("sada","dasd",hError);
}

hVariable hVariable::traverse(float (*function)(float)){
	hVariable ret;
	hVarBase *temp;
	temp=storage->cast(hFloat);
	ret.storage=temp->traverse(function);
	ret.type=hFloat;
	return ret;
}

hVariable hVariable::traverse(double (*function)(double)){
	hVariable ret;
	hVarBase *temp;
	temp=storage->cast(hDouble);
	ret.storage=temp->traverse(function);
	ret.type=hDouble;
	return ret;
}

