/***************************************************************************
 *   Copyright (C) 2008 by Bob,,,   *
 *   bob@lab17   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef _HVARIABLE_H
#define _HVARIABLE_H

#include <complex>
#include <vector>
#include <fstream>

//#include "hException.h"
#include "hVarLinear.h"

//#ifdef HAVE_CONFIG_H
//#include "config.h"
//#else
#include "options.h"
//#endif

class hVariable{
	hVarBase *storage;
	unsigned char type;
public:
	//!Does nothing
	hVariable(void);
	hVariable(const hVariable& s);

	//!Dims=1,Size[0]=1,Value=data
	hVariable(bool data);
	hVariable(unsigned char data);
	hVariable(signed char data);
	hVariable(unsigned short data);
	hVariable(signed short data);
	hVariable(unsigned long data);
	hVariable(signed long data);
	hVariable(signed int data);
	hVariable(unsigned int data);
	hVariable(float data);
	hVariable(double data);
	hVariable(long double data);
	hVariable(std::complex<float > data);
	hVariable(std::complex<double > data);
	hVariable(std::complex<long double> data);

	//!Dims=1,Size[0]=s0,value[]=copy of [*data]
	hVariable(bool *data,unsigned long s0);
	hVariable(unsigned char *data,unsigned long s0);
	hVariable(signed char *data,unsigned long s0);
	hVariable(unsigned short *data,unsigned long s0);
	hVariable(signed short *data,unsigned long s0);
	hVariable(unsigned long *data,unsigned long s0);
	hVariable(signed long *data,unsigned long s0);
	hVariable(float *data,unsigned long s0);
	hVariable(double *data,unsigned long s0);
	hVariable(long double *data,unsigned long s0);
	hVariable(std::complex<float> *data,unsigned long s0);
	hVariable(std::complex<double> *data,unsigned long s0);
	hVariable(std::complex<long double> *data,unsigned long s0);

	//!Dims=2,Size[2]={s0,s1},value[][]=copy of [*data]
	hVariable(bool **data,unsigned long s0,unsigned long s1);
	hVariable(unsigned char **data,unsigned long s0,unsigned long s1);
	hVariable(signed char **data,unsigned long s0,unsigned long s1);
	hVariable(unsigned short **data,unsigned long s0,unsigned long s1);
	hVariable(signed short **data,unsigned long s0,unsigned long s1);
	hVariable(unsigned long **data,unsigned long s0,unsigned long s1);
	hVariable(signed long **data,unsigned long s0,unsigned long s1);
	hVariable(float **data,unsigned long s0,unsigned long s1);
	hVariable(double **data,unsigned long s0,unsigned long s1);
	hVariable(long double **data,unsigned long s0,unsigned long s1);
	hVariable(std::complex<float> **data,unsigned long s0,unsigned long s1);
	hVariable(std::complex<double> **data,unsigned long s0,unsigned long s1);
	hVariable(std::complex<long double> **data,unsigned long s0,unsigned long s1);

	//!Dims=3,Size[3]={s0,s1,s2},value[][][]=copy of [*data]
	hVariable(bool ***data,unsigned long s0,unsigned long s1,unsigned long s2);
	hVariable(unsigned char ***data,unsigned long s0,unsigned long s1,unsigned long s2);
	hVariable(signed char ***data,unsigned long s0,unsigned long s1,unsigned long s2);
	hVariable(unsigned short ***data,unsigned long s0,unsigned long s1,unsigned long s2);
	hVariable(signed short ***data,unsigned long s0,unsigned long s1,unsigned long s2);
	hVariable(unsigned long ***data,unsigned long s0,unsigned long s1,unsigned long s2);
	hVariable(signed long ***data,unsigned long s0,unsigned long s1,unsigned long s2);
	hVariable(float ***data,unsigned long s0,unsigned long s1,unsigned long s2);
	hVariable(double ***data,unsigned long s0,unsigned long s1,unsigned long s2);
	hVariable(long double ***data,unsigned long s0,unsigned long s1,unsigned long s2);
	hVariable(std::complex<float> ***data,unsigned long s0,unsigned long s1,unsigned long s2);
	hVariable(std::complex<double> ***data,unsigned long s0,unsigned long s1,unsigned long s2);
	hVariable(std::complex<long double> ***data,unsigned long s0,unsigned long s1,unsigned long s2);

	//!Dims=4,Size[4]={s0,s1,s2,s3},value[][][][]=copy of [*data]
	hVariable(bool ****data,unsigned long s0,unsigned long s1,unsigned long s2,unsigned long s3);
	hVariable(unsigned char ****data,unsigned long s0,unsigned long s1,unsigned long s2,unsigned long s3);
	hVariable(signed char ****data,unsigned long s0,unsigned long s1,unsigned long s2,unsigned long s3);
	hVariable(unsigned short ****data,unsigned long s0,unsigned long s1,unsigned long s2,unsigned long s3);
	hVariable(signed short ****data,unsigned long s0,unsigned long s1,unsigned long s2,unsigned long s3);
	hVariable(unsigned long ****data,unsigned long s0,unsigned long s1,unsigned long s2,unsigned long s3);
	hVariable(signed long ****data,unsigned long s0,unsigned long s1,unsigned long s2,unsigned long s3);
	hVariable(float ****data,unsigned long s0,unsigned long s1,unsigned long s2,unsigned long s3);
	hVariable(double ****data,unsigned long s0,unsigned long s1,unsigned long s2,unsigned long s3);
	hVariable(long double ****data,unsigned long s0,unsigned long s1,unsigned long s2,unsigned long s3);
	hVariable(std::complex<float> ****data,unsigned long s0,unsigned long s1,unsigned long s2,unsigned long s3);
	hVariable(std::complex<double> ****data,unsigned long s0,unsigned long s1,unsigned long s2,unsigned long s3);
	hVariable(std::complex<long double> ****data,unsigned long s0,unsigned long s1,unsigned long s2,unsigned long s3);

	//!Dims=5,Size[5]={s0,s1,s2,s3,s4},value[][][][][]=copy of [*data]
	hVariable(bool *****data,unsigned long s0,unsigned long s1,unsigned long s2,unsigned long s3,unsigned long s4);
	hVariable(unsigned char *****data,unsigned long s0,unsigned long s1,unsigned long s2,unsigned long s3,unsigned long s4);
	hVariable(signed char *****data,unsigned long s0,unsigned long s1,unsigned long s2,unsigned long s3,unsigned long s4);
	hVariable(unsigned short *****data,unsigned long s0,unsigned long s1,unsigned long s2,unsigned long s3,unsigned long s4);
	hVariable(signed short *****data,unsigned long s0,unsigned long s1,unsigned long s2,unsigned long s3,unsigned long s4);
	hVariable(unsigned long *****data,unsigned long s0,unsigned long s1,unsigned long s2,unsigned long s3,unsigned long s4);
	hVariable(signed long *****data,unsigned long s0,unsigned long s1,unsigned long s2,unsigned long s3,unsigned long s4);
	hVariable(float *****data,unsigned long s0,unsigned long s1,unsigned long s2,unsigned long s3,unsigned long s4);
	hVariable(double *****data,unsigned long s0,unsigned long s1,unsigned long s2,unsigned long s3,unsigned long s4);
	hVariable(long double *****data,unsigned long s0,unsigned long s1,unsigned long s2,unsigned long s3,unsigned long s4);
	hVariable(std::complex<float> *****data,unsigned long s0,unsigned long s1,unsigned long s2,unsigned long s3,unsigned long s4);
	hVariable(std::complex<double> *****data,unsigned long s0,unsigned long s1,unsigned long s2,unsigned long s3,unsigned long s4);
	hVariable(std::complex<long double> *****data,unsigned long s0,unsigned long s1,unsigned long s2,unsigned long s3,unsigned long s4);

	//!Dims=6,Size[6]={s0,s1,s2,s3,s4,s5},value[][][][][][]=copy of [*data]
	hVariable(bool ******data,unsigned long s0,unsigned long s1,unsigned long s2,unsigned long s3,unsigned long s4,unsigned long s5);
	hVariable(unsigned char ******data,unsigned long s0,unsigned long s1,unsigned long s2,unsigned long s3,unsigned long s4,unsigned long s5);
	hVariable(signed char ******data,unsigned long s0,unsigned long s1,unsigned long s2,unsigned long s3,unsigned long s4,unsigned long s5);
	hVariable(unsigned short ******data,unsigned long s0,unsigned long s1,unsigned long s2,unsigned long s3,unsigned long s4,unsigned long s5);
	hVariable(signed short ******data,unsigned long s0,unsigned long s1,unsigned long s2,unsigned long s3,unsigned long s4,unsigned long s5);
	hVariable(unsigned long ******data,unsigned long s0,unsigned long s1,unsigned long s2,unsigned long s3,unsigned long s4,unsigned long s5);
	hVariable(signed long ******data,unsigned long s0,unsigned long s1,unsigned long s2,unsigned long s3,unsigned long s4,unsigned long s5);
	hVariable(float ******data,unsigned long s0,unsigned long s1,unsigned long s2,unsigned long s3,unsigned long s4,unsigned long s5);
	hVariable(double ******data,unsigned long s0,unsigned long s1,unsigned long s2,unsigned long s3,unsigned long s4,unsigned long s5);
	hVariable(long double ******data,unsigned long s0,unsigned long s1,unsigned long s2,unsigned long s3,unsigned long s4,unsigned long s5);
	hVariable(std::complex<float> ******data,unsigned long s0,unsigned long s1,unsigned long s2,unsigned long s3,unsigned long s4,unsigned long s5);
	hVariable(std::complex<double> ******data,unsigned long s0,unsigned long s1,unsigned long s2,unsigned long s3,unsigned long s4,unsigned long s5);
	hVariable(std::complex<long double> ******data,unsigned long s0,unsigned long s1,unsigned long s2,unsigned long s3,unsigned long s4,unsigned long s5);

	//!Dims=7,Size[7]={s0,s1,s2,s3,s4,s5,s6},value[][][][][][][]=copy of [*data]
	hVariable(bool *******data,unsigned long s0,unsigned long s1,unsigned long s2,unsigned long s3,unsigned long s4,unsigned long s5,unsigned long s6);
	hVariable(unsigned char *******data,unsigned long s0,unsigned long s1,unsigned long s2,unsigned long s3,unsigned long s4,unsigned long s5,unsigned long s6);
	hVariable(signed char *******data,unsigned long s0,unsigned long s1,unsigned long s2,unsigned long s3,unsigned long s4,unsigned long s5,unsigned long s6);
	hVariable(unsigned short *******data,unsigned long s0,unsigned long s1,unsigned long s2,unsigned long s3,unsigned long s4,unsigned long s5,unsigned long s6);
	hVariable(signed short *******data,unsigned long s0,unsigned long s1,unsigned long s2,unsigned long s3,unsigned long s4,unsigned long s5,unsigned long s6);
	hVariable(unsigned long *******data,unsigned long s0,unsigned long s1,unsigned long s2,unsigned long s3,unsigned long s4,unsigned long s5,unsigned long s6);
	hVariable(signed long *******data,unsigned long s0,unsigned long s1,unsigned long s2,unsigned long s3,unsigned long s4,unsigned long s5,unsigned long s6);
	hVariable(float *******data,unsigned long s0,unsigned long s1,unsigned long s2,unsigned long s3,unsigned long s4,unsigned long s5,unsigned long s6);
	hVariable(double *******data,unsigned long s0,unsigned long s1,unsigned long s2,unsigned long s3,unsigned long s4,unsigned long s5,unsigned long s6);
	hVariable(long double *******data,unsigned long s0,unsigned long s1,unsigned long s2,unsigned long s3,unsigned long s4,unsigned long s5,unsigned long s6);
	hVariable(std::complex<float> *******data,unsigned long s0,unsigned long s1,unsigned long s2,unsigned long s3,unsigned long s4,unsigned long s5,unsigned long s6);
	hVariable(std::complex<double> *******data,unsigned long s0,unsigned long s1,unsigned long s2,unsigned long s3,unsigned long s4,unsigned long s5,unsigned long s6);
	hVariable(std::complex<long double> *******data,unsigned long s0,unsigned long s1,unsigned long s2,unsigned long s3,unsigned long s4,unsigned long s5,unsigned long s6);

	//!Dims=size.size(),Size=size,value[]...[]=copy of [*data]
	hVariable(std::vector<unsigned int> size,bool *data);
	hVariable(std::vector<unsigned int> size,unsigned char *data);
	hVariable(std::vector<unsigned int> size,signed char *data);
	hVariable(std::vector<unsigned int> size,unsigned short *data);
	hVariable(std::vector<unsigned int> size,signed short *data);
	hVariable(std::vector<unsigned int> size,unsigned long *data);
	hVariable(std::vector<unsigned int> size,signed long *data);
//	hVariable(std::vector<unsigned int> size,unsigned int *data);
//	hVariable(std::vector<unsigned int> size,signed int *data);
	hVariable(std::vector<unsigned int> size,float *data);
	hVariable(std::vector<unsigned int> size,double *data);
	hVariable(std::vector<unsigned int> size,long double *data);
	hVariable(std::vector<unsigned int> size,std::complex<float > *data);
	hVariable(std::vector<unsigned int> size,std::complex<double > *data);
	hVariable(std::vector<unsigned int> size,std::complex<long double> *data);

	hVariable(std::vector<unsigned int> size,const bool &init);
	hVariable(std::vector<unsigned int> size,const unsigned char &init);
	hVariable(std::vector<unsigned int> size,const signed char &init);
	hVariable(std::vector<unsigned int> size,const unsigned short &init);
	hVariable(std::vector<unsigned int> size,const signed short &init);
	hVariable(std::vector<unsigned int> size,const unsigned long &init);
	hVariable(std::vector<unsigned int> size,const signed long &init);
	hVariable(std::vector<unsigned int> size,const float &init);
	hVariable(std::vector<unsigned int> size,const double &init);
	hVariable(std::vector<unsigned int> size,const long double &init);
	hVariable(std::vector<unsigned int> size,const std::complex<float> &init);
	hVariable(std::vector<unsigned int> size,const std::complex<double> &init);
	hVariable(std::vector<unsigned int> size,const std::complex<long double> &init);


	//!Dims=size.size(),Size=size,value[]...[]=copy of data
	hVariable(std::vector<unsigned int> size,const std::vector<bool> &data);
	hVariable(std::vector<unsigned int> size,const std::vector<unsigned char> &data);
	hVariable(std::vector<unsigned int> size,const std::vector<signed char> &data);
	hVariable(std::vector<unsigned int> size,const std::vector<unsigned short> &data);
	hVariable(std::vector<unsigned int> size,const std::vector<signed short> &data);
	hVariable(std::vector<unsigned int> size,const std::vector<unsigned long> &data);
	hVariable(std::vector<unsigned int> size,const std::vector<signed long> &data);
//	hVariable(std::vector<unsigned int> size,std::vector<unsigned int> data);
//	hVariable(std::vector<unsigned int> size,std::vector<signed int> data);
	hVariable(std::vector<unsigned int> size,const std::vector<float> &data);
	hVariable(std::vector<unsigned int> size,const std::vector<double> &data);
	hVariable(std::vector<unsigned int> size,const std::vector<long double> &data);
	hVariable(std::vector<unsigned int> size,const std::vector<std::complex<float> > &data);
	hVariable(std::vector<unsigned int> size,const std::vector<std::complex<double> > &data);
	hVariable(std::vector<unsigned int> size,const std::vector<std::complex<long double> > &data);

	//!Dims=1,Size=data.size(),value[]=copy of data
	hVariable(std::vector<bool> data);
	hVariable(std::vector<unsigned char> data);
	hVariable(std::vector<signed char> data);
	hVariable(std::vector<unsigned short> data);
	hVariable(std::vector<signed short> data);
	hVariable(std::vector<unsigned long> data);
	hVariable(std::vector<signed long> data);
//	hVariable(std::vector<unsigned int> data);
//	hVariable(std::vector<signed int> data);
	hVariable(std::vector<float> data);
	hVariable(std::vector<double> data);
	hVariable(std::vector<long double> data);
	hVariable(std::vector<std::complex<float> > data);
	hVariable(std::vector<std::complex<double> > data);
	hVariable(std::vector<std::complex<long double> > data);

	//!Deletes private variable storage
	~hVariable(void);

	//!Returns a string naming the variable's type (eg bool, unsigned long int ....)
	static std::string literalType(unsigned char t);

	//!return value=Number of dimenions
	unsigned int getDim(void);
	
	//!return value=Vector with size of each dimension. Return.size() is number of dimensions same as getDim()
	std::vector<unsigned int> getSize(void);
	//!return value=size of dimension "dimension". exception if dimension>=getDim() 
	unsigned int getSize(unsigned int dimension);

//!todo:debug all methods after this point

	//!value[index[0]][index[1]]...[index[n]]=data.value (data containes a single value)
	void setValue(std::vector<unsigned int> index,hVariable data);
	void setValue(unsigned long *index,const hVariable &data);
	//!value=data.value(data containes a single value)
	void setValue(hVariable data);

	//!value[index[0]][index[1]]...[index[n]]=data
	void setValue(std::vector<unsigned int> index,bool data);
	void setValue(std::vector<unsigned int> index,unsigned char data);
	void setValue(std::vector<unsigned int> index,signed char data);
	void setValue(std::vector<unsigned int> index,unsigned short data);
	void setValue(std::vector<unsigned int> index,signed short data);
	void setValue(std::vector<unsigned int> index,unsigned long data);
	void setValue(std::vector<unsigned int> index,signed long data);
//	void setValue(std::vector<unsigned int> index,unsigned int data);
//	void setValue(std::vector<unsigned int> index,signed int data);
	void setValue(std::vector<unsigned int> index,float data);
	void setValue(std::vector<unsigned int> index,double data);
	void setValue(std::vector<unsigned int> index,long double data);
	void setValue(std::vector<unsigned int> index,std::complex<float> data);
	void setValue(std::vector<unsigned int> index,std::complex<double> data);
	void setValue(std::vector<unsigned int> index,std::complex<long double> data);

	//!value=data;
	void setValue(bool data);
	void setValue(unsigned char data);
	void setValue(signed char data);
	void setValue(unsigned short data);
	void setValue(signed short data);
	void setValue(unsigned long data);
	void setValue(signed long data);
//	void setValue(unsigned int data);
//	void setValue(signed int data);
	void setValue(float data);
	void setValue(double data);
	void setValue(long double data);
	void setValue(std::complex<float> data);
	void setValue(std::complex<double> data);
	void setValue(std::complex<long double> data);

	//!return variable has dim=1,size[0]=1,data=variable.data[index[0]][index[1]]...[index[n]]
	hVariable getValue(std::vector<unsigned int> index);
	//!return variable has dim=1,size[0]=1,data=variable.value
	hVariable getValue(void);

	bool getValue(bool &data);
	unsigned char getValue(unsigned char &data);
	signed char getValue(signed char &data);
	unsigned short getValue(unsigned short &data);
	signed short getValue(signed short &data);
	unsigned long getValue(unsigned long &data);
	signed long getValue(signed long &data);
	float getValue(float &data);
	double getValue(double &data);
	long double getValue(long double &data);
	std::complex<float> getValue(std::complex<float> &data);
	std::complex<double> getValue(std::complex<double> &data);
	std::complex<long double> getValue(std::complex<long double> &data);

	//!data=variable.data[index[0]][index[1]]...[index[n]]
	bool getValue(std::vector<unsigned int> index,bool &data);
	unsigned char getValue(std::vector<unsigned int> index,unsigned char &data);
	signed char getValue(std::vector<unsigned int> index,signed char &data);
	unsigned short getValue(std::vector<unsigned int> index,unsigned short &data);
	signed short getValue(std::vector<unsigned int> index,signed short &data);
	unsigned long getValue(std::vector<unsigned int> index,unsigned long &data);
	signed long getValue(std::vector<unsigned int> index,signed long &data);
	float getValue(std::vector<unsigned int> index,float &data);
	double getValue(std::vector<unsigned int> index,double &data);
	long double getValue(std::vector<unsigned int> index,long double &data);
	std::complex<float> getValue(std::vector<unsigned int> index,std::complex<float> &data);
	std::complex<double> getValue(std::vector<unsigned int> index,std::complex<double> &data);
	std::complex<long double> getValue(std::vector<unsigned int> index,std::complex<long double> &data);
	
	//!data=new dataType[TOTAL_ELEMENTS],data[]=ALL ELEMENTS STORED BY LINE. 
	//!You must execute delete[] data after use. Otherwise u have a memory leak
	void get(bool *data);
	void get(unsigned char *data);
	void get(signed char *data);
	void get(unsigned short *data);
	void get(signed short *data);
	void get(unsigned long *data);
	void get(signed long *data);
	void get(float *data);
	void get(double *data);
	void get(long double *data);
	void get(std::complex<float> *data);
	void get(std::complex<double> *data);
	void get(std::complex<long double> *data);

	//!Return var is one of the ones defined in hVarType.h
	unsigned char getType(void);

	//!Probably broken.... Don't use it.
	//!todo:fix it :P
	void clear(void);

	//!return var is cast to type "type"
	hVariable cast(unsigned char type);

	//!same as cast, but uses a flank to indicate type
	hVariable convert(bool flank);
	hVariable convert(unsigned char flank);
	hVariable convert(signed char flank);
	hVariable convert(unsigned short flank);
	hVariable convert(signed short flank);
	hVariable convert(unsigned long flank);
	hVariable convert(signed long flank);
//	hVariable convert(unsigned int flank);
//	hVariable convert(signed int flank);
	hVariable convert(float flank);
	hVariable convert(double flank);
	hVariable convert(long double flank);
	hVariable convert(std::complex<float> flank);
	hVariable convert(std::complex<double> flank);
	hVariable convert(std::complex<long double> flank);

	//!You know what ;)
	hVariable operator+(const hVariable &op2);
	hVariable operator-(const hVariable &op2);
	hVariable operator*(const hVariable &op2);
	hVariable operator/(const hVariable &op2);
	hVariable operator%(const hVariable &op2);

	const hVariable & operator=(const hVariable &op2);
	const hVariable & operator=(const bool &op2);
	const hVariable & operator=(const unsigned char &op2);
	const hVariable & operator=(const signed char &op2);
	const hVariable & operator=(const unsigned short &op2);
	const hVariable & operator=(const signed short &op2);
	const hVariable & operator=(const unsigned long &op2);
	const hVariable & operator=(const signed long &op2);
	const hVariable & operator=(const float &op2);
	const hVariable & operator=(const double &op2);
	const hVariable & operator=(const long double &op2);
	const hVariable & operator=(const std::complex<float> &op2);
	const hVariable & operator=(const std::complex<double> &op2);
	const hVariable & operator=(const std::complex<long double> &op2);

	//Bonus operator=
	const hVariable & operator=(const unsigned &op2);
	const hVariable & operator=(const signed &op2);
	


	const hVariable & operator+=(const hVariable &op2);
	const hVariable & operator-=(const hVariable &op2);
	const hVariable & operator*=(const hVariable &op2);
	const hVariable & operator/=(const hVariable &op2);
	const hVariable & operator%=(const hVariable &op2);


	const hVariable & operator>>=(const hVariable &op2);
	const hVariable & operator<<=(const hVariable &op2);
	const hVariable & operator&=(const hVariable &op2);
	const hVariable & operator^=(const hVariable &op2);
	const hVariable & operator|=(const hVariable &op2);


	hVariable operator<(const hVariable &op2);
	hVariable operator>(const hVariable &op2);
	hVariable operator<=(const hVariable &op2);
	hVariable operator>=(const hVariable &op2);

	hVariable operator!(void);
	hVariable operator&&(const hVariable &op2);
	hVariable operator||(const hVariable &op2);
	hVariable operator==(const hVariable &op2);
	hVariable operator!=(const hVariable &op2);

	hVariable operator~(void);

	hVariable operator<<(const hVariable &op2);
	hVariable operator>>(const hVariable &op2);
	hVariable operator&(const hVariable &op2);
	hVariable operator|(const hVariable &op2);
	hVariable operator^(const hVariable &op2);

	const hVariable operator++(int);//a++
	const hVariable & operator++(void);//++a
	const hVariable operator--(int);
	const hVariable & operator--(void);
	void dump(std::ofstream &str);

//!todo: You know what!
	hVariable operator[](unsigned int index);
	hVariable operator[](hVariable index);

/*	hVariable operator()(const hVariable &op2);
	hVariable operator,(const hVariable $op2);

//	hVariable operator->(std::string name);

	void * operator new(size_t size);
	void * operator new[](size_t size);
	void operator delete(void *adr);
	void operator delete[](void *adr);*/

	hVariable traverse(float (*function)(float));
	hVariable traverse(double (*function)(double));


	//!Print is broken for tables more than 3 dimensions
	friend std::ostream& operator << (std::ostream& output, const hVariable& s);

	friend hVariable matrixMul(hVariable &A,hVariable &B);

};

//!todo:implement global operators
hVariable operator+(int op1,const hVariable &op2);

#endif
