/***************************************************************************
 *   Copyright (C) 2007 by manos                                           *
 *   etsardou@users.sf.net                                                 * 
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "hVariableTree.h"

hNodeTreeVariable** hVariableTreeVectorNode::returnAllData(hNodeTreeVariable **temp)
{
	hNodeTreeVariable *downLeft,*runner;
	int i;
	bool help=false;
	downLeft=root;
	downLeft=findLeftNode(downLeft);
	runner=downLeft;
	i=0;
	while(i!=indext)
	{
		if(runner->returnIsVisited()==false)
		{
			temp[i]=runner;
			help=true;
		}
		if(runner->returnRightChild()!=NULL && runner->returnIsVisited()==false)
		{
			runner=findLeftNode(runner->returnRightChild());
		}
		else
		{
			runner=runner->returnParent();
		}
		if(help==true)
		{
			temp[i]->setIsVisited(true);
			i++;
			help=false;
		}
	}
	for(i=0;i<indext;i++)
    	temp[i]->setIsVisited(false);
	return temp;
}

const int hVariableTreeVectorNode::returnIndext(void)
{
	return indext;
}

const hNodeTreeVariable* hVariableTreeVectorNode::returnRoot(void)
{
	return root;
}

hNodeTreeVariable* hVariableTreeVectorNode::returnNode(std::string name)
{
	hNodeTreeVariable *a;
	a=searchNode(name);
	if(a!=NULL)
	{
		if((a->returnName()).compare(name)==0)
			return a;
	}
	return NULL;
}

hVariableTreeVectorNode::hVariableTreeVectorNode(void)
{
	indext=0;
	try{
		root=new hNodeTreeVariable();
	}
	catch(std::exception& e){
		throw hException("hVariableTreeVectorNode::hVariableTreeVectorNode","Cannot allocate root",hAlloc);
	}
}

hNodeTreeVariable* hVariableTreeVectorNode::searchNode(std::string name)
{
	bool end=false;
	hNodeTreeVariable *k;
	if(indext!=0)
	{
		k=root;
	}
	else
	{
		return NULL;
	}
	while((k->returnName()).compare(name) && end==false)
	{
		if(name.compare(k->returnName())>0)
		{
			if(k->returnRightChild()!=NULL) 	//	?????????
				k=k->returnRightChild();
			else end=true;
		}
		else if (name.compare(k->returnName())<0)	//???????????????
		{
			if(k->returnLeftChild()!=NULL)
				k=k->returnLeftChild();
			else end=true;
		}
	}
	return k;
}

const hVariable & hVariableTreeVectorNode::insertNode(std::string name,const hVariable & v,bool con)
{
	hNodeTreeVariable *a;
	a=searchNode(name);
	if(a==NULL)
	{
		root->setName(name);
		indext++;
		root->setRightChild(NULL);
		root->setLeftChild(NULL);
		root->setIsVisited(false);
		root->setVariable(v);
		root->setConstant(con);
		return v;
	}
	else
	{
		if(name.compare(a->returnName())==0 && (a->getConstant())==false)
		{
			throw hException("hVariableTreeVectorNode::insertNode","Variable already exists",hAlloc);
		}
		else if(name.compare(a->returnName())==0 && (a->getConstant())==true && con==true)
		{
			throw hException("hVariableTreeVectorNode::insertNode","Variable is constant",hAlloc);
		} 
		else
		{
			hNodeTreeVariable *newNode;
			try{
				newNode=new hNodeTreeVariable;
			}
			catch(std::exception& e){
				throw hException("hVariableTreeVectorNode::insertNode","Cannot allocate new node",hAlloc);
			}
			newNode->setName(name);
			newNode->setParent(a);
			//Se auto to shmeio allazei kai to variable tou root
			newNode->setVariable(v);
			newNode->setConstant(con);
			if(name.compare(a->returnName())>0)
			{
				a->setRightChild(newNode);
			}
			else if(name.compare(a->returnName())<0)
			{
				a->setLeftChild(newNode);
			}
			else if(name.compare(a->returnName())==0 && a->getConstant()==true)
			{
				hVariable temp;
				hNodeTreeVariable *f,*lc,*rc;
				f=a->returnParent();
				lc=a->returnLeftChild();
				rc=a->returnRightChild();
				if(f!=NULL)
					newNode->setParent(f);
				newNode->setLeftChild(a);
				a->setParent(newNode);
				if(f->returnLeftChild()==a)
					f->setLeftChild(newNode);
				else f->setRightChild(newNode);
				
					
			}
			
			indext++;
			return v;
		}
	}
}

int hVariableTreeVectorNode::deleteNode(std::string name,bool constant)
{
	hNodeTreeVariable *a,*b,*c;
	int rightHeight,leftHeight;
	rightHeight=leftHeight=0;
	a=returnNode(name);
	if(a==NULL)
		throw hException("hVariableTreeVectorNode::deleteNode","Cannot delete an imaginary variable..",hAlloc);
	if(a->getConstant() && constant==false)
		throw hException("hVariableTreeVectorNode::deleteNode","Cannot delete a constant",hAlloc);
		//return 1;
	b=a->returnRightChild();
	c=a->returnLeftChild();
	if(b!=NULL)
	{
		rightHeight++;
		while(b->returnLeftChild()!=NULL)
		{
			b=b->returnLeftChild();
			rightHeight++;
		}

	}
	if(c!=NULL)
	{
		leftHeight++;
		while(c->returnRightChild()!=NULL)
		{
			c=c->returnRightChild();
			leftHeight++;
		}
	}
	if(rightHeight>=leftHeight && !(rightHeight==0 && leftHeight==0))
	{
		if(b->returnParent()!=a)
			(b->returnParent())->setLeftChild(NULL);
		if(a->returnParent()!=NULL)
		{
			if(((a->returnParent())->returnRightChild())!=a)
			{
				(a->returnParent())->setLeftChild(b);
			}
			else
			{
				(a->returnParent())->setRightChild(b);
			}
			b->setParent(a->returnParent());
		}
		else
		{
			root=b;
			root->setParent(NULL);
		}
		if(a->returnLeftChild()!=NULL && a->returnLeftChild()!=b)
			(a->returnLeftChild())->setParent(b);
		if(a->returnRightChild()!=NULL && a->returnRightChild()!=b)
			(a->returnRightChild())->setParent(b);
		if(b->returnRightChild()==NULL && b->returnLeftChild()==NULL)
		{
			if(a->returnLeftChild()!=b)
				b->setLeftChild(a->returnLeftChild());
			if(a->returnRightChild()!=b)
				b->setRightChild(a->returnRightChild());
		}
		a->deleteNode();
		delete a;
	}
	else if (rightHeight<leftHeight && !(rightHeight==0 && leftHeight==0))
	{
		if(c->returnParent()!=a)
			(c->returnParent())->setRightChild(NULL);
		if(a->returnParent()!=NULL)
		{
			if(((a->returnParent())->returnRightChild())!=a)
			{
				(a->returnParent())->setLeftChild(c);
			}
			else
			{
				(a->returnParent())->setRightChild(c);
			}
			c->setParent(a->returnParent());
		}
		else
		{
			root=c;
			root->setParent(NULL);
		}
		if(a->returnLeftChild()!=NULL && a->returnLeftChild()!=c){
			hNodeTreeVariable *temp;
			temp=c;
			while(c->returnLeftChild()!=NULL)
				c=c->returnLeftChild();
			(a->returnLeftChild())->setParent(c);
			c->setLeftChild(a->returnLeftChild());
			c=temp;
		}
		if(a->returnRightChild()!=NULL && a->returnRightChild()!=c){
			hNodeTreeVariable *temp;
			temp=c;
			while(c->returnRightChild()!=NULL)
				c=c->returnRightChild();
			(a->returnRightChild())->setParent(c);
			c->setLeftChild(a->returnLeftChild());
			c=temp;
		}
		if(c->returnRightChild()==NULL && c->returnLeftChild()==NULL)
		{
			if(a->returnLeftChild()!=c)
				c->setLeftChild(a->returnLeftChild());
			if(a->returnRightChild()!=c)
				c->setRightChild(a->returnRightChild());
		}
		a->deleteNode();
		delete a;
	}
	else
	{
		a->setName("");
		if(a->returnParent()!=NULL)
		{
			if(((a->returnParent())->returnRightChild())!=a)
			{
				(a->returnParent())->setLeftChild(NULL);
			}
			else
			{
				(a->returnParent())->setRightChild(NULL);
			}
		}
		a->setRightChild(NULL);
		a->setLeftChild(NULL);
		a->setIsVisited(false);
		a->deleteVar();
		if(a->returnParent()!=NULL)
			delete a;
	}
	indext--;
	return 0;
}

void hVariableTreeVectorNode::rearrangeTree(void)
{
	hNodeTreeVariable **temp,*downLeft,*runner;
	int i,height,j,input,helper,rootIndex;
	bool help=false;
	std::string rootName;
	rootName=root->returnName();
	hVariable v;
	v=root->returnVar();
	bool *isIn;
	try{
		isIn=new bool[indext];
	}
	catch(std::exception& e){
		throw hException("hVariableTreeVectorNode::rearrangeTree","Cannot allocate boolean table",hAlloc);
	}
	for(i=0;i<indext;i++)
	{
		isIn[i]=false;
	}
	try{
		temp=new hNodeTreeVariable*[indext];
	}
	catch(std::exception& e){
		throw hException("hVariableTreeVectorNode::deleteTree","Cannot allocate **hNodeTreeVariable",hAlloc);
	}
	downLeft=root;
	downLeft=findLeftNode(downLeft);
	runner=downLeft;
	i=0;
	while(i!=indext)
	{
		if(runner->returnIsVisited()==false)
		{
			temp[i]=runner;
			help=true;
		}
		if(runner->returnRightChild()!=NULL && runner->returnIsVisited()==false)
		{
			runner=findLeftNode(runner->returnRightChild());
		}
		else
		{
			runner=runner->returnParent();
		}
		if(help==true)
		{
			temp[i]->setIsVisited(true);
			i++;
			help=false;
		}
	}
	for(i=0;i<indext;i++)
	{
		if((temp[i]->returnName()).compare(root->returnName())==0)
		{
			rootIndex=i;
		}
	}
	helper=indext;
	indext=0;
	height=(int)(log((double)helper)/log(2.0));
	for(i=1;i<=height;i++)
	{
		for(j=1;j<=(pow(2.0,i)-1);j++)
		{
			input=(int)((helper*j)/(pow(2.0,i)));
			if(isIn[input]==false)
			{
				insertNode(temp[input]->returnName(),temp[input]->returnVar(),temp[input]->getConstant());
				if(input!=rootIndex)
					isIn[input]=true;
			}
		}
	}
	insertNode(rootName,v,root->getConstant());
	isIn[rootIndex]=true;
	for(i=0;i<helper;i++)
	{
		if(isIn[i]==false)
		{
			insertNode(temp[i]->returnName(),temp[i]->returnVar(),temp[input]->getConstant());
		}
	}

	for(i=0;i<helper;i++)
	{
		if(i!=rootIndex)
		{
			temp[i]->deleteNode();
			delete temp[i];
		}
	}
	delete[] isIn;
	delete[] temp;
	//delete[] rootName;
}

hNodeTreeVariable* hVariableTreeVectorNode::findLeftNode(hNodeTreeVariable *a)
{
	while(a->returnLeftChild()!=NULL)
		a=a->returnLeftChild();
	return a;
}

void hVariableTreeVectorNode::deleteTree(void)
{
	deleteVars();
	if(!root->getConstant())
		deleteNode(root->returnName(),false);
}

void hVariableTreeVectorNode::deleteTreeAndConst(void)
{
	deleteAllVars();
	delete root;
}

void hVariableTreeVectorNode::deleteAllVars(void)
{
	hNodeTreeVariable **temp,*downLeft,*runner;
	int i,helper,rootIndex;
	bool help=false;
	std::string rootName;
	rootName=root->returnName();
	bool *isIn;
	try{
		isIn=new bool[indext];
	}
	catch(std::exception& e){
		throw hException("hVariableTreeVectorNode::deleteTree","Cannot allocate bool table",hAlloc);
	}
	for(i=0;i<indext;i++)
	{
		isIn[i]=false;
	}
	try{
		temp=new hNodeTreeVariable*[indext];
	}
	catch(std::exception& e){
		throw hException("hVariableTreeVectorNode::deleteTree","Cannot allocate **hNodeTreeVariable",hAlloc);
	}
	downLeft=root;
	downLeft=findLeftNode(downLeft);
	runner=downLeft;
	i=0;
	while(i!=indext)
	{
		if(runner->returnIsVisited()==false)
		{
			temp[i]=runner;
			help=true;
		}
		if(runner->returnRightChild()!=NULL && runner->returnIsVisited()==false)
		{
			runner=findLeftNode(runner->returnRightChild());
		}
		else
		{
			runner=runner->returnParent();
		}
		if(help==true)
		{
			temp[i]->setIsVisited(true);
			i++;
			help=false;
		}
	}
	for(i=0;i<indext;i++)
	{
		temp[i]->setIsVisited(false);
		if((temp[i]->returnName()).compare(root->returnName())==0)
		{
			rootIndex=i;
		}
	}
	helper=indext;
	indext=0;
	for(i=0;i<helper;i++)
	{
		temp[i]->deleteNode();
		if(i!=rootIndex)
		{
			delete temp[i];
		}
	}
	root->setIsVisited(false);
	root->setName("");
	root->setLeftChild(NULL);
	root->setRightChild(NULL);
	root->setParent(NULL);
	delete[] isIn;
	delete[] temp;
}

void hVariableTreeVectorNode::deleteVars(void)
{
	hNodeTreeVariable **temp,*downLeft,*runner;
	int i,helper,rootIndex;
	bool help=false;
	std::string rootName;
	rootName=root->returnName();
	bool *isIn;
	try{
		isIn=new bool[indext];
	}
	catch(std::exception& e){
		throw hException("hVariableTreeVectorNode::deleteTree","Cannot allocate bool table",hAlloc);
	}
	for(i=0;i<indext;i++)
	{
		isIn[i]=false;
	}
	try{
		temp=new hNodeTreeVariable*[indext];
	}
	catch(std::exception& e){
		throw hException("hVariableTreeVectorNode::deleteTree","Cannot allocate **hNodeTreeVariable",hAlloc);
	}
	downLeft=root;
	downLeft=findLeftNode(downLeft);
	runner=downLeft;
	i=0;
	while(i!=indext)
	{
		if(runner->returnIsVisited()==false)
		{
			temp[i]=runner;
			help=true;
		}
		if(runner->returnRightChild()!=NULL && runner->returnIsVisited()==false)
		{
			runner=findLeftNode(runner->returnRightChild());
		}
		else
		{
			runner=runner->returnParent();
		}
		if(help==true)
		{
			temp[i]->setIsVisited(true);
			i++;
			help=false;
		}
	}
	for(i=0;i<indext;i++)
	{
		temp[i]->setIsVisited(false);
		if((temp[i]->returnName()).compare(root->returnName())==0)
		{
			rootIndex=i;
		}
	}
	helper=indext;
	for(i=0;i<helper;i++)
	{
		if(!temp[i]->getConstant())
		{
			if(i!=rootIndex)
			{
				deleteNode(temp[i]->returnName(),false);
			}
		}
	}
	if(!root->getConstant()){
		root->setIsVisited(false);
		root->setName("");
		root->setLeftChild(NULL);
		root->setRightChild(NULL);
		root->setParent(NULL);
	}
	delete[] isIn;
	delete[] temp;
}

const int hVariableTree::returnIndext(void){ return trees[trees.size()-1].returnIndext(); }
const hNodeTreeVariable* hVariableTree::returnRoot(void) { return trees[trees.size()-1].returnRoot(); }
hVariableTree::hVariableTree(void){
	hVariableTreeVectorNode temp;
	trees.clear();
	trees.push_back(temp);

}
const hVariable & hVariableTree::insertNode(std::string name,const hVariable & v,bool con){ return trees[trees.size()-1].insertNode(name,v,con); }
hNodeTreeVariable* hVariableTree::searchNode(std::string name){
	return trees[trees.size()-1].searchNode(name);
}
int hVariableTree::deleteNode(std::string name,bool constant) { return trees[trees.size()-1].deleteNode(name,constant); }
void hVariableTree::rearrangeTree(void){ trees[trees.size()-1].rearrangeTree(); }
hNodeTreeVariable* hVariableTree::returnNode(std::string name){ 
	int i;
	for(i=0;i<trees.size();i++)
	{
		if (trees[trees.size()-1-i].returnNode(name)==NULL)
			continue;
		else return trees[trees.size()-1-i].returnNode(name);
	}
return  NULL;
}
hNodeTreeVariable* hVariableTree::findLeftNode(hNodeTreeVariable *a){ return trees[trees.size()-1].findLeftNode(a); }
hNodeTreeVariable** hVariableTree::returnAllData(hNodeTreeVariable **temp){ return trees[trees.size()-1].returnAllData(temp); }
void hVariableTree::deleteTree(void){ trees[trees.size()-1].deleteTree(); }
void hVariableTree::deleteTreeAndConst(void){ trees[trees.size()-1].deleteTreeAndConst(); }
void hVariableTree::deleteVars(void){ trees[trees.size()-1].deleteVars(); }
void hVariableTree::deleteAllVars(void){ trees[trees.size()-1].deleteAllVars(); }

void hVariableTree::push(void){
	hVariableTreeVectorNode temp;
	trees.push_back(temp);
}
void hVariableTree::pop(void){
	trees[trees.size()-1].deleteTreeAndConst();
	trees.pop_back();
}
