/***************************************************************************
 *   Copyright (C) 2007 by manos                                           *
 *   etsardou@users.sf.net                                                 * 
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef HVARIABLETREE_H
#define HVARIABLETREE_H


#define sizeName 20



#include "hNodeTreeVariable.h"
#include <string>
#include <cmath>
#include <math.h>



class hVariableTreeVectorNode
{
private:
	int indext;
	hNodeTreeVariable *root;
public:
	const int returnIndext(void);
	const hNodeTreeVariable* returnRoot(void);
	hVariableTreeVectorNode(void);

	const hVariable & insertNode(std::string name,const hVariable & v,bool con);

	hNodeTreeVariable* searchNode(std::string name);
	int deleteNode(std::string name,bool constant);
	void rearrangeTree(void);
	hNodeTreeVariable* returnNode(std::string name);
	hNodeTreeVariable* findLeftNode(hNodeTreeVariable *a);
	hNodeTreeVariable** returnAllData(hNodeTreeVariable **temp);
	void deleteTree(void);
	void deleteTreeAndConst(void);
	void deleteVars(void);
	void deleteAllVars(void);
};

class hVariableTree
{
public:
	std::vector <hVariableTreeVectorNode> trees;
	const int returnIndext(void);
	const hNodeTreeVariable* returnRoot(void);
	hVariableTree(void);

	const hVariable & insertNode(std::string name,const hVariable & v,bool con);

	hNodeTreeVariable* searchNode(std::string name);
	int deleteNode(std::string name,bool constant);
	void rearrangeTree(void);
	hNodeTreeVariable* returnNode(std::string name);
	hNodeTreeVariable* findLeftNode(hNodeTreeVariable *a);
	hNodeTreeVariable** returnAllData(hNodeTreeVariable **temp);
	void deleteTree(void);
	void deleteTreeAndConst(void);
	void deleteVars(void);
	void deleteAllVars(void);
	
	void push(void);
	void pop(void); 
};

#endif
