/***************************************************************************
 *   Copyright (C) 2008 by Bob,,,   *
 *   bob@lab17   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "hVarLinear.h"

namespace hvar{
template <class dataType>
unsigned long int hVarLinear<dataType>::findIndex(std::vector<unsigned int> index){
	unsigned long int i,s,f=1,s_index=0;
	//exception handling
	s=size.size();
	if(s<index.size())
		throw hException("hVarLinear<dataType>::findIndex","Too may dimensions",hError);
	for(i=s-1;i>0;--i){
		if(i<index.size())
			s_index+=f*index[i];
		f*=size[i];
	}
	s_index+=index[0]*f;
	if(s_index>=mem.size())
		throw hException("hVarLinear<dataType>::findIndex","Invalid index",hError);
	return s_index;
}

template <class dataType>
unsigned long int hVarLinear<dataType>::findIndex(const unsigned long * const index){
	unsigned long int i,s,f=1,s_index=0;
	//exception handling
	s=size.size();
	for(i=s-1;i>0;--i){
		s_index+=f*index[i];
		f*=size[i];
	}
	s_index+=index[0]*f;
	return s_index;
}


template <class dataType>
template <class newType>
hVarBase *hVarLinear<dataType>::typeCast(void){
	try{
		hVarLinear<newType> *ret;
		ret=new hVarLinear<newType>;
		unsigned long s,i;
		s=mem.size();
		for(i=0;i<s;++i)
			ret->mem.push_back((newType)mem[i]);
		ret->size=size;
		return ret;
	}catch(std::exception &e){
		throw hException("hVarLinear::typeCast","Out of memory",hError);
	}
	return NULL;
}
template <>
template <>
hVarBase * hVarLinear<std::complex<float> >::typeCast<bool>(void){
	throw hException("hVarLinear<std::complex<float> >::typeCast<bool>(void)","Cannot cast complex to bool",hError);
}
template <>
template <>
hVarBase *hVarLinear<std::complex<double> >::typeCast<bool>(void){
	throw hException("hVarLinear<std::complex<double> >::typeCast<bool>(void)","Cannot cast complex to bool",hError);
}
template <>
template <>
hVarBase *hVarLinear<std::complex<long double> >::typeCast<bool>(void){
	throw hException("hVarLinear<std::complex<long double> >::typeCast<bool>(void)","Cannot cast complex to bool",hError);
}
template <>
template <>
hVarBase *hVarLinear<std::complex<float> >::typeCast<unsigned char>(void){
	throw hException("hVarLinear<std::complex<float> >::typeCast<unsigned char>(void)","Cannot cast complex to char",hError);
}
template <>
template <>
hVarBase *hVarLinear<std::complex<double> >::typeCast<unsigned char>(void){
	throw hException("hVarLinear<std::complex<double> >::typeCast<unsigned char>(void)","Cannot cast complex to char",hError);
}
template <>
template <>
hVarBase *hVarLinear<std::complex<long double> >::typeCast<unsigned char>(void){
	throw hException("hVarLinear<std::complex<long double> >::typeCast<unsigned char>(void)","Cannot cast complex to char",hError);
}
template <>
template <>
hVarBase *hVarLinear<std::complex<float> >::typeCast<signed char>(void){
	throw hException("hVarLinear<std::complex<float> >::typeCast<signed char>(void)","Cannot cast complex to char",hError);
}
template <>
template <>
hVarBase *hVarLinear<std::complex<double> >::typeCast<signed char>(void){
	throw hException("hVarLinear<std::complex<double> >::typeCast<signed char>(void)","Cannot cast complex to char",hError);
}
template <>
template <>
hVarBase *hVarLinear<std::complex<long double> >::typeCast<signed char>(void){
	throw hException("hVarLinear<std::complex<long double> >::typeCast<signed char>(void)","Cannot cast complex to char",hError);
}
template <>
template <>
hVarBase *hVarLinear<std::complex<float> >::typeCast<unsigned short>(void){
	throw hException("hVarLinear<std::complex<float> >::typeCast<unsigned short>(void)","Cannot cast complex to integer",hError);
}
template <>
template <>
hVarBase *hVarLinear<std::complex<double> >::typeCast<unsigned short>(void){
	throw hException("hVarLinear<std::complex<double> >::typeCast<unsigned short>(void)","Cannot cast complex to integer",hError);
}
template <>
template <>
hVarBase *hVarLinear<std::complex<long double> >::typeCast<unsigned short>(void){
	throw hException("hVarLinear<std::complex<long double> >::typeCast<unsigned short>(void)","Cannot cast complex to integer",hError);
}
template <>
template <>
hVarBase *hVarLinear<std::complex<float> >::typeCast<signed short>(void){
	throw hException("hVarLinear<std::complex<float> >::typeCast<signed short>(void)","Cannot cast complex to integer",hError);
}
template <>
template <>
hVarBase *hVarLinear<std::complex<double> >::typeCast<signed short>(void){
	throw hException("hVarLinear<std::complex<double> >::typeCast<signed short>(void)","Cannot cast complex to integer",hError);
}
template <>
template <>
hVarBase *hVarLinear<std::complex<long double> >::typeCast<signed short>(void){
	throw hException("hVarLinear<std::complex<long double> >::typeCast<signed short>(void)","Cannot cast complex to integer",hError);
}
template <>
template <>
hVarBase *hVarLinear<std::complex<float> >::typeCast<unsigned long>(void){
	throw hException("hVarLinear<std::complex<float> >::typeCast<unsigned long>(void)","Cannot cast complex to integer",hError);
}
template <>
template <>
hVarBase *hVarLinear<std::complex<double> >::typeCast<unsigned long>(void){
	throw hException("hVarLinear<std::complex<double> >::typeCast<unsigned long>(void)","Cannot cast complex to integer",hError);
}
template <>
template <>
hVarBase *hVarLinear<std::complex<long double> >::typeCast<unsigned long>(void){
	throw hException("hVarLinear<std::complex<long double> >::typeCast<unsigned long>(void)","Cannot cast complex to integer",hError);
}
template <>
template <>
hVarBase *hVarLinear<std::complex<float> >::typeCast<signed long>(void){
	throw hException("hVarLinear<std::complex<float> >::typeCast<signed long>(void)","Cannot cast complex to integer",hError);
}
template <>
template <>
hVarBase *hVarLinear<std::complex<double> >::typeCast<signed long>(void){
	throw hException("hVarLinear<std::complex<double> >::typeCast<signed long>(void)","Cannot cast complex to integer",hError);
}
template <>
template <>
hVarBase *hVarLinear<std::complex<long double> >::typeCast<signed long>(void){
	throw hException("hVarLinear<std::complex<long double> >::typeCast<signed long>(void)","Cannot cast complex to integer",hError);
}
template <>
template <>
hVarBase *hVarLinear<std::complex<float> >::typeCast<float>(void){
	throw hException("hVarLinear<std::complex<float> >::typeCast<float>(void)","Cannot cast complex to floating point",hError);
}
template <>
template <>
hVarBase *hVarLinear<std::complex<double> >::typeCast<float>(void){
	throw hException("hVarLinear<std::complex<double> >::typeCast<float>(void)","Cannot cast complex to floating point",hError);
}
template <>
template <>
hVarBase *hVarLinear<std::complex<long double> >::typeCast<float>(void){
	throw hException("hVarLinear<std::complex<long double> >::typeCast<float>(void)","Cannot cast complex to floating point",hError);
}
template <>
template <>
hVarBase *hVarLinear<std::complex<float> >::typeCast<double>(void){
	throw hException("hVarLinear<std::complex<float> >::typeCast<double>(void)","Cannot cast complex to floating point",hError);
}
template <>
template <>
hVarBase *hVarLinear<std::complex<double> >::typeCast<double>(void){
	throw hException("hVarLinear<std::complex<double> >::typeCast<double>(void)","Cannot cast complex to floating point",hError);
}
template <>
template <>
hVarBase *hVarLinear<std::complex<long double> >::typeCast<double>(void){
	throw hException("hVarLinear<std::complex<long double> >::typeCast<double>(void)","Cannot cast complex to floating point",hError);
}
template <>
template <>
hVarBase *hVarLinear<std::complex<float> >::typeCast<long double>(void){
	throw hException("hVarLinear<std::complex<float> >::typeCast<long double>(void)","Cannot cast complex to floating point",hError);
}
template <>
template <>
hVarBase *hVarLinear<std::complex<double> >::typeCast<long double>(void){
	throw hException("hVarLinear<std::complex<double> >::typeCast<long double>(void)","Cannot cast complex to floating point",hError);
}
template <>
template <>
hVarBase *hVarLinear<std::complex<long double> >::typeCast<long double>(void){
	throw hException("hVarLinear<std::complex<long double> >::typeCast<long double>(void)","Cannot cast complex to floating point",hError);
}

template <class dataType>
hVarLinear<dataType>::hVarLinear(void){
}

///todo: exception handling in memory allocation
template <class dataType>
hVarLinear<dataType>::hVarLinear(dataType data){
	try{
		size.push_back(1);
		mem.push_back(data);
	}catch(std::exception &e){
		throw hException("hVarLinear::typeCast","Out of memory",hError);
	}
}

/**todo: exception handling in memory allocation
check for zero size
*/
template <class dataType>
hVarLinear<dataType>::hVarLinear(std::vector<unsigned int> size,dataType *data){
	unsigned long Tsize=1,dims,i;
	dims=size.size();
	for(i=0;i<dims;i++){
		Tsize*=size[i];
	}
	this->size=size;
	mem.reserve(Tsize);
	for(i=0;i<Tsize;i++){
		mem.push_back(data[i]);
	}
}

template <class dataType>
hVarLinear<dataType>::hVarLinear(std::vector<unsigned int> size,const dataType &init){
	unsigned long Tsize=1,dims,i;
	dims=size.size();
	for(i=0;i<dims;i++){
		Tsize*=size[i];
	}
	this->size=size;
	mem.reserve(Tsize);
	for(i=0;i<Tsize;i++){
		mem.push_back(init);
	}
}

/**todo: exception handling in memory allocation
check for zero size
*/
template <class dataType>
hVarLinear<dataType>::hVarLinear(std::vector<dataType> data){
	unsigned long s=data.size(),i;
	size.push_back(s);
	mem=data;
}

template <class dataType>
hVarLinear<dataType>::hVarLinear(std::vector<unsigned int> size,std::vector<dataType> data){
	this->size=size;
	mem=data;
}

template <class dataType>
hVarBase * hVarLinear<dataType>::copy(void){
	hVarLinear<dataType> *ret;
	ret=new hVarLinear<dataType>;
	ret->mem=mem;
	ret->size=size;
	return ret;
}

template <class dataType>
unsigned int hVarLinear<dataType>::getDim(void){
	return size.size();
}
template <class dataType>
std::vector<unsigned int> hVarLinear<dataType>::getSize(void){
	return size;
}
///todo:Better exception handling. Throw hException instead of exception
template <class dataType>
unsigned int hVarLinear<dataType>::getSize(unsigned int dimension){
	return size.at(dimension);
}
template <class dataType>
void hVarLinear<dataType>::setValue(std::vector<unsigned int> index,hVarBase* data){
	hVarLinear<dataType> *temp=(hVarLinear<dataType> *)data;
	unsigned long retSize,i,base;
	retSize=temp->mem.size();
	base=findIndex(index);
	for(i=0;i<retSize;++i)
		mem[base+i]=temp->mem[i];
}
template <class dataType>
void hVarLinear<dataType>::setValue(unsigned long *index,hVarBase* data){
//exception handling
	dataType value;
	data->getValue(value);
	mem[findIndex(index)]=value;
}
template <class dataType>
void hVarLinear<dataType>::setValue(hVarBase* data){
	dataType value;
	data->getValue(value);
	mem[0]=value;
}

template <>
void hVarLinear<bool>::setValue(std::vector<unsigned int> index,const std::complex<float> &data){
	throw hException("hVarLinear<bool>::setValue","Cannot cast complex to bool",hError);
}
template <>
void hVarLinear<bool>::setValue(std::vector<unsigned int> index,const std::complex<double> &data){
	throw hException("hVarLinear<bool>::setValue","Cannot cast complex to bool",hError);
}
template <>
void hVarLinear<bool>::setValue(std::vector<unsigned int> index,const std::complex<long double> &data){
	throw hException("hVarLinear<bool>::setValue","Cannot cast complex to bool",hError);
}
template <>
void hVarLinear<unsigned char>::setValue(std::vector<unsigned int> index,const std::complex<float> &data){
	throw hException("hVarLinear<unsigned char>::setValue","Cannot cast complex to char",hError);
}
template <>
void hVarLinear<unsigned char>::setValue(std::vector<unsigned int> index,const std::complex<double> &data){
	throw hException("hVarLinear<unsigned char>::setValue","Cannot cast complex to char",hError);
}
template <>
void hVarLinear<unsigned char>::setValue(std::vector<unsigned int> index,const std::complex<long double> &data){
	throw hException("hVarLinear<unsigned char>::setValue","Cannot cast complex to char",hError);
}
template <>
void hVarLinear<signed char>::setValue(std::vector<unsigned int> index,const std::complex<float> &data){
	throw hException("hVarLinear<signed char>::setValue","Cannot cast complex to char",hError);
}
template <>
void hVarLinear<signed char>::setValue(std::vector<unsigned int> index,const std::complex<double> &data){
	throw hException("hVarLinear<signed char>::setValue","Cannot cast complex to char",hError);
}
template <>
void hVarLinear<signed char>::setValue(std::vector<unsigned int> index,const std::complex<long double> &data){
	throw hException("hVarLinear<signed char>::setValue","Cannot cast complex to char",hError);
}
template <>
void hVarLinear<unsigned short>::setValue(std::vector<unsigned int> index,const std::complex<float> &data){
	throw hException("hVarLinear<unsigned short>::setValue","Cannot cast complex to integer",hError);
}
template <>
void hVarLinear<unsigned short>::setValue(std::vector<unsigned int> index,const std::complex<double> &data){
	throw hException("hVarLinear<unsigned short>::setValue","Cannot cast complex to integer",hError);
}
template <>
void hVarLinear<unsigned short>::setValue(std::vector<unsigned int> index,const std::complex<long double> &data){
	throw hException("hVarLinear<unsigned short>::setValue","Cannot cast complex to integer",hError);
}
template <>
void hVarLinear<signed short>::setValue(std::vector<unsigned int> index,const std::complex<float> &data){
	throw hException("hVarLinear<signed short>::setValue","Cannot cast complex to integer",hError);
}
template <>
void hVarLinear<signed short>::setValue(std::vector<unsigned int> index,const std::complex<double> &data){
	throw hException("hVarLinear<signed short>::setValue","Cannot cast complex to integer",hError);
}
template <>
void hVarLinear<signed short>::setValue(std::vector<unsigned int> index,const std::complex<long double> &data){
	throw hException("hVarLinear<signed short>::setValue","Cannot cast complex to integer",hError);
}
template <>
void hVarLinear<unsigned long>::setValue(std::vector<unsigned int> index,const std::complex<float> &data){
	throw hException("hVarLinear<unsigned long>::setValue","Cannot cast complex to integer",hError);
}
template <>
void hVarLinear<unsigned long>::setValue(std::vector<unsigned int> index,const std::complex<double> &data){
	throw hException("hVarLinear<unsigned long>::setValue","Cannot cast complex to integer",hError);
}
template <>
void hVarLinear<unsigned long>::setValue(std::vector<unsigned int> index,const std::complex<long double> &data){
	throw hException("hVarLinear<unsigned long>::setValue","Cannot cast complex to integer",hError);
}
template <>
void hVarLinear<signed long>::setValue(std::vector<unsigned int> index,const std::complex<float> &data){
	throw hException("hVarLinear<signed long>::setValue","Cannot cast complex to integer",hError);
}
template <>
void hVarLinear<signed long>::setValue(std::vector<unsigned int> index,const std::complex<double> &data){
	throw hException("hVarLinear<signed long>::setValue","Cannot cast complex to integer",hError);
}
template <>
void hVarLinear<signed long>::setValue(std::vector<unsigned int> index,const std::complex<long double> &data){
	throw hException("hVarLinear<signed long>::setValue","Cannot cast complex to integer",hError);
}
template <>
void hVarLinear<float>::setValue(std::vector<unsigned int> index,const std::complex<float> &data){
	throw hException("hVarLinear<float>::setValue","Cannot cast complex to floating point",hError);
}
template <>
void hVarLinear<float>::setValue(std::vector<unsigned int> index,const std::complex<double> &data){
	throw hException("hVarLinear<float>::setValue","Cannot cast complex to floating point",hError);
}
template <>
void hVarLinear<float>::setValue(std::vector<unsigned int> index,const std::complex<long double> &data){
	throw hException("hVarLinear<float>::setValue","Cannot cast complex to floating point",hError);
}
template <>
void hVarLinear<double>::setValue(std::vector<unsigned int> index,const std::complex<float> &data){
	throw hException("hVarLinear<double>::setValue","Cannot cast complex to floating point",hError);
}
template <>
void hVarLinear<double>::setValue(std::vector<unsigned int> index,const std::complex<double> &data){
	throw hException("hVarLinear<double>::setValue","Cannot cast complex to floating point",hError);
}
template <>
void hVarLinear<double>::setValue(std::vector<unsigned int> index,const std::complex<long double> &data){
	throw hException("hVarLinear<double>::setValue","Cannot cast complex to floating point",hError);
}
template <>
void hVarLinear<long double>::setValue(std::vector<unsigned int> index,const std::complex<float> &data){
	throw hException("hVarLinear<long double>::setValue","Cannot cast complex to floating point",hError);
}
template <>
void hVarLinear<long double>::setValue(std::vector<unsigned int> index,const std::complex<double> &data){
	throw hException("hVarLinear<long double>::setValue","Cannot cast complex to floating point",hError);
}
template <>
void hVarLinear<long double>::setValue(std::vector<unsigned int> index,const std::complex<long double> &data){
	throw hException("hVarLinear<long double>::setValue","Cannot cast complex to floating point",hError);
}


template <class dataType>
void hVarLinear<dataType>::setValue(std::vector<unsigned int> index,const bool &data){
	mem[findIndex(index)]=(dataType)data;
}

template <class dataType>
void hVarLinear<dataType>::setValue(std::vector<unsigned int> index,const unsigned char &data){
	mem[findIndex(index)]=(dataType)data;
}

template <class dataType>
void hVarLinear<dataType>::setValue(std::vector<unsigned int> index,const signed char &data){
	mem[findIndex(index)]=(dataType)data;
}

template <class dataType>
void hVarLinear<dataType>::setValue(std::vector<unsigned int> index,const unsigned short int &data){
	mem[findIndex(index)]=(dataType)data;
}

template <class dataType>
void hVarLinear<dataType>::setValue(std::vector<unsigned int> index,const signed short int &data){
	mem[findIndex(index)]=(dataType)data;
}

template <class dataType>
void hVarLinear<dataType>::setValue(std::vector<unsigned int> index,const unsigned long int &data){
	mem[findIndex(index)]=(dataType)data;
}

template <class dataType>
void hVarLinear<dataType>::setValue(std::vector<unsigned int> index,const signed long int &data){
	mem[findIndex(index)]=(dataType)data;
}

template <class dataType>
void hVarLinear<dataType>::setValue(std::vector<unsigned int> index,const float &data){
	mem[findIndex(index)]=(dataType)data;
}

template <class dataType>
void hVarLinear<dataType>::setValue(std::vector<unsigned int> index,const double &data){
	mem[findIndex(index)]=(dataType)data;
}

template <class dataType>
void hVarLinear<dataType>::setValue(std::vector<unsigned int> index,const long double &data){
	mem[findIndex(index)]=(dataType)data;
}

template <class dataType>
void hVarLinear<dataType>::setValue(std::vector<unsigned int> index,const std::complex<float> &data){
	mem[findIndex(index)]=(dataType)data;
}

template <class dataType>
void hVarLinear<dataType>::setValue(std::vector<unsigned int> index,const std::complex<double> &data){
	mem[findIndex(index)]=(dataType)data;
}

template <class dataType>
void hVarLinear<dataType>::setValue(std::vector<unsigned int> index,const std::complex<long double> &data){
	mem[findIndex(index)]=(dataType)data;
}

template <>
void hVarLinear<bool>::setValue(const std::complex<float> &data){
	throw hException("hVarLinear<bool>::setValue","Cannot cast complex to bool",hError);
}
template <>
void hVarLinear<bool>::setValue(const std::complex<double> &data){
	throw hException("hVarLinear<bool>::setValue","Cannot cast complex to bool",hError);
}
template <>
void hVarLinear<bool>::setValue(const std::complex<long double> &data){
	throw hException("hVarLinear<bool>::setValue","Cannot cast complex to bool",hError);
}
template <>
void hVarLinear<unsigned char>::setValue(const std::complex<float> &data){
	throw hException("hVarLinear<unsigned char>::setValue","Cannot cast complex to char",hError);
}
template <>
void hVarLinear<unsigned char>::setValue(const std::complex<double> &data){
	throw hException("hVarLinear<unsigned char>::setValue","Cannot cast complex to char",hError);
}
template <>
void hVarLinear<unsigned char>::setValue(const std::complex<long double> &data){
	throw hException("hVarLinear<unsigned char>::setValue","Cannot cast complex to char",hError);
}
template <>
void hVarLinear<signed char>::setValue(const std::complex<float> &data){
	throw hException("hVarLinear<signed char>::setValue","Cannot cast complex to char",hError);
}
template <>
void hVarLinear<signed char>::setValue(const std::complex<double> &data){
	throw hException("hVarLinear<signed char>::setValue","Cannot cast complex to char",hError);
}
template <>
void hVarLinear<signed char>::setValue(const std::complex<long double> &data){
	throw hException("hVarLinear<signed char>::setValue","Cannot cast complex to char",hError);
}
template <>
void hVarLinear<unsigned short>::setValue(const std::complex<float> &data){
	throw hException("hVarLinear<unsigned short>::setValue","Cannot cast complex to integer",hError);
}
template <>
void hVarLinear<unsigned short>::setValue(const std::complex<double> &data){
	throw hException("hVarLinear<unsigned short>::setValue","Cannot cast complex to integer",hError);
}
template <>
void hVarLinear<unsigned short>::setValue(const std::complex<long double> &data){
	throw hException("hVarLinear<unsigned short>::setValue","Cannot cast complex to integer",hError);
}
template <>
void hVarLinear<signed short>::setValue(const std::complex<float> &data){
	throw hException("hVarLinear<igned short>::setValue","Cannot cast complex to integer",hError);
}
template <>
void hVarLinear<signed short>::setValue(const std::complex<double> &data){
	throw hException("hVarLinear<igned short>::setValue","Cannot cast complex to integer",hError);
}
template <>
void hVarLinear<signed short>::setValue(const std::complex<long double> &data){
	throw hException("hVarLinear<igned short>::setValue","Cannot cast complex to integer",hError);
}
template <>
void hVarLinear<unsigned long>::setValue(const std::complex<float> &data){
	throw hException("hVarLinear<unsigned long>::setValue","Cannot cast complex to integer",hError);
}
template <>
void hVarLinear<unsigned long>::setValue(const std::complex<double> &data){
	throw hException("hVarLinear<unsigned long>::setValue","Cannot cast complex to integer",hError);
}
template <>
void hVarLinear<unsigned long>::setValue(const std::complex<long double> &data){
	throw hException("hVarLinear<unsigned long>::setValue","Cannot cast complex to integer",hError);
}
template <>
void hVarLinear<signed long>::setValue(const std::complex<float> &data){
	throw hException("hVarLinear<igned long>::setValue","Cannot cast complex to integer",hError);
}
template <>
void hVarLinear<signed long>::setValue(const std::complex<double> &data){
	throw hException("hVarLinear<igned long>::setValue","Cannot cast complex to integer",hError);
}
template <>
void hVarLinear<signed long>::setValue(const std::complex<long double> &data){
	throw hException("hVarLinear<igned long>::setValue","Cannot cast complex to integer",hError);
}
template <>
void hVarLinear<float>::setValue(const std::complex<float> &data){
	throw hException("hVarLinear<float>::setValue","Cannot cast complex to floating point",hError);
}
template <>
void hVarLinear<float>::setValue(const std::complex<double> &data){
	throw hException("hVarLinear<float>::setValue","Cannot cast complex to floating point",hError);
}
template <>
void hVarLinear<float>::setValue(const std::complex<long double> &data){
	throw hException("hVarLinear<float>::setValue","Cannot cast complex to floating point",hError);
}
template <>
void hVarLinear<double>::setValue(const std::complex<float> &data){
	throw hException("hVarLinear<double>::setValue","Cannot cast complex to floating point",hError);
}
template <>
void hVarLinear<double>::setValue(const std::complex<double> &data){
	throw hException("hVarLinear<double>::setValue","Cannot cast complex to floating point",hError);
}
template <>
void hVarLinear<double>::setValue(const std::complex<long double> &data){
	throw hException("hVarLinear<double>::setValue","Cannot cast complex to floating point",hError);
}
template <>
void hVarLinear<long double>::setValue(const std::complex<float> &data){
	throw hException("hVarLinear<long double>::setValue","Cannot cast complex to floating point",hError);
}
template <>
void hVarLinear<long double>::setValue(const std::complex<double> &data){
	throw hException("hVarLinear<long double>::setValue","Cannot cast complex to floating point",hError);
}
template <>
void hVarLinear<long double>::setValue(const std::complex<long double> &data){
	throw hException("hVarLinear<long double>::setValue","Cannot cast complex to floating point",hError);
}

template <class dataType>
void hVarLinear<dataType>::setValue(const bool &data){
	mem[0]=(dataType)data;
}

template <class dataType>
void hVarLinear<dataType>::setValue(const unsigned char &data){
	mem[0]=(dataType)data;
}

template <class dataType>
void hVarLinear<dataType>::setValue(const signed char &data){
	mem[0]=(dataType)data;
}

template <class dataType>
void hVarLinear<dataType>::setValue(const unsigned short int &data){
	mem[0]=(dataType)data;
}

template <class dataType>
void hVarLinear<dataType>::setValue(const signed short int &data){
	mem[0]=(dataType)data;
}

template <class dataType>
void hVarLinear<dataType>::setValue(const unsigned long int &data){
	mem[0]=(dataType)data;
}

template <class dataType>
void hVarLinear<dataType>::setValue(const signed long int &data){
	mem[0]=(dataType)data;
}

/*template <class dataType>
void hVarLinear<dataType>::setValue(unsigned int data){
}

template <class dataType>
void hVarLinear<dataType>::setValue(signed int data){
}*/

template <class dataType>
void hVarLinear<dataType>::setValue(const float &data){
	mem[0]=(dataType)data;
}

template <class dataType>
void hVarLinear<dataType>::setValue(const double &data){
	mem[0]=(dataType)data;
}

template <class dataType>
void hVarLinear<dataType>::setValue(const long double &data){
	mem[0]=(dataType)data;
}

template <class dataType>
void hVarLinear<dataType>::setValue(const std::complex<float> &data){
	mem[0]=(dataType)data;
}

template <class dataType>
void hVarLinear<dataType>::setValue(const std::complex<double> &data){
	mem[0]=(dataType)data;
}

template <class dataType>
void hVarLinear<dataType>::setValue(const std::complex<long double> &data){
	mem[0]=(dataType)data;
}

template <class dataType>
hVarBase* hVarLinear<dataType>::getValue(std::vector<unsigned int> index){
	hVarLinear<dataType> *ret;
	ret=new hVarLinear<dataType>;
	unsigned long retSize=1,i,base;
	for(i=index.size();i<size.size();++i){
		retSize*=size[i];
		ret->size.push_back(size[i]);
	}
	base=findIndex(index);
	for(i=0;i<retSize;++i)
		ret->mem.push_back(mem[base+i]);
	if(!ret->size.size())
		ret->size.push_back(1);
	return ret;
}
template <class dataType>
hVarBase* hVarLinear<dataType>::getValue(void){
	hVarLinear<dataType> *ret;
	ret=new hVarLinear<dataType>;
	ret->mem.push_back(mem[0]);
	ret->size.push_back(1);
	return ret;
}

template <>
bool hVarLinear<std::complex<float> >::getValue(bool &data){
	throw hException("hVarLinear<std::complex<float> >::getValue","Cannot cast complex to bool",hError);
}
template <>
bool hVarLinear<std::complex<double> >::getValue(bool &data){
	throw hException("hVarLinear<std::complex<double> >::getValue","Cannot cast complex to bool",hError);
}
template <>
bool hVarLinear<std::complex<long double> >::getValue(bool &data){
	throw hException("hVarLinear<std::complex<long double> >::getValue","Cannot cast complex to bool",hError);
}
template <>
unsigned char hVarLinear<std::complex<float> >::getValue(unsigned char &data){
	throw hException("hVarLinear<std::complex<float> >::getValue","Cannot cast complex to char",hError);
}
template <>
unsigned char hVarLinear<std::complex<double> >::getValue(unsigned char &data){
	throw hException("hVarLinear<std::complex<double> >::getValue","Cannot cast complex to char",hError);
}
template <>
unsigned char hVarLinear<std::complex<long double> >::getValue(unsigned char &data){
	throw hException("hVarLinear<std::complex<long double> >::getValue","Cannot cast complex to char",hError);
}
template <>
signed char hVarLinear<std::complex<float> >::getValue(signed char &data){
	throw hException("hVarLinear<std::complex<float> >::getValue","Cannot cast complex to integer",hError);
}
template <>
signed char hVarLinear<std::complex<double> >::getValue(signed char &data){
	throw hException("hVarLinear<std::complex<double> >::getValue","Cannot cast complex to integer",hError);
}
template <>
signed char hVarLinear<std::complex<long double> >::getValue(signed char &data){
	throw hException("hVarLinear<std::complex<long double> >::getValue","Cannot cast complex to integer",hError);
}
template <>
unsigned short hVarLinear<std::complex<float> >::getValue(unsigned short &data){
	throw hException("hVarLinear<std::complex<float> >::getValue","Cannot cast complex to integer",hError);
}
template <>
unsigned short hVarLinear<std::complex<double> >::getValue(unsigned short &data){
	throw hException("hVarLinear<std::complex<double> >::getValue","Cannot cast complex to integer",hError);
}
template <>
unsigned short hVarLinear<std::complex<long double> >::getValue(unsigned short &data){
	throw hException("hVarLinear<std::complex<long double> >::getValue","Cannot cast complex to integer",hError);
}
template <>
signed short hVarLinear<std::complex<float> >::getValue(signed short &data){
	throw hException("hVarLinear<std::complex<float> >::getValue","Cannot cast complex to integer",hError);
}
template <>
signed short hVarLinear<std::complex<double> >::getValue(signed short &data){
	throw hException("hVarLinear<std::complex<double> >::getValue","Cannot cast complex to integer",hError);
}
template <>
signed short hVarLinear<std::complex<long double> >::getValue(signed short &data){
	throw hException("hVarLinear<std::complex<long double> >::getValue","Cannot cast complex to integer",hError);
}
template <>
unsigned long hVarLinear<std::complex<float> >::getValue(unsigned long &data){
	throw hException("hVarLinear<std::complex<float> >::getValue","Cannot cast complex to integer",hError);
}
template <>
unsigned long hVarLinear<std::complex<double> >::getValue(unsigned long &data){
	throw hException("hVarLinear<std::complex<double> >::getValue","Cannot cast complex to integer",hError);
}
template <>
unsigned long hVarLinear<std::complex<long double> >::getValue(unsigned long &data){
	throw hException("hVarLinear<std::complex<long double> >::getValue","Cannot cast complex to integer",hError);
}
template <>
signed long hVarLinear<std::complex<float> >::getValue(signed long &data){
	throw hException("hVarLinear<std::complex<float> >::getValue","Cannot cast complex to integer",hError);
}
template <>
signed long hVarLinear<std::complex<double> >::getValue(signed long &data){
	throw hException("hVarLinear<std::complex<double> >::getValue","Cannot cast complex to integer",hError);
}
template <>
signed long hVarLinear<std::complex<long double> >::getValue(signed long &data){
	throw hException("hVarLinear<std::complex<long double> >::getValue","Cannot cast complex to integer",hError);
}
template <>
float hVarLinear<std::complex<float> >::getValue(float &data){
	throw hException("hVarLinear<std::complex<float> >::getValue","Cannot cast complex to floating point",hError);
}
template <>
float hVarLinear<std::complex<double> >::getValue(float &data){
	throw hException("hVarLinear<std::complex<double> >::getValue","Cannot cast complex to floating point",hError);
}
template <>
float hVarLinear<std::complex<long double> >::getValue(float &data){
	throw hException("hVarLinear<std::complex<long double> >::getValue","Cannot cast complex to floating point",hError);
}
template <>
double hVarLinear<std::complex<float> >::getValue(double &data){
	throw hException("hVarLinear<std::complex<float> >::getValue","Cannot cast complex to floating point",hError);
}
template <>
double hVarLinear<std::complex<double> >::getValue(double &data){
	throw hException("hVarLinear<std::complex<double> >::getValue","Cannot cast complex to floating point",hError);
}
template <>
double hVarLinear<std::complex<long double> >::getValue(double &data){
	throw hException("hVarLinear<std::complex<long double> >::getValue","Cannot cast complex to floating point",hError);
}
template <>
long double hVarLinear<std::complex<float> >::getValue(long double &data){
	throw hException("hVarLinear<std::complex<float> >::getValue","Cannot cast complex to floating point",hError);
}
template <>
long double hVarLinear<std::complex<double> >::getValue(long double &data){
	throw hException("hVarLinear<std::complex<double> >::getValue","Cannot cast complex to floating point",hError);
}
template <>
long double hVarLinear<std::complex<long double> >::getValue(long double &data){
	throw hException("hVarLinear<std::complex<long double> >::getValue","Cannot cast complex to floating point",hError);
}

template <class dataType>
bool hVarLinear<dataType>::getValue(bool &data){
	if(mem.size()!=1)
		throw hException("hVarLinear::getValue","Non-scalar variable",hError);
	data=(bool)mem[0];
	return data;
}
template <class dataType>
unsigned char hVarLinear<dataType>::getValue(unsigned char &data){
	if(mem.size()!=1)
		throw hException("hVarLinear::getValue","Non-scalar variable",hError);
	data=(unsigned char)mem[0];
	return data;
}
template <class dataType>
signed char hVarLinear<dataType>::getValue(signed char &data){
	if(mem.size()!=1)
		throw hException("hVarLinear::getValue","Non-scalar variable",hError);
	data=(signed char)mem[0];
	return data;
}
template <class dataType>
unsigned short hVarLinear<dataType>::getValue(unsigned short &data){
	if(mem.size()!=1)
		throw hException("hVarLinear::getValue","Non-scalar variable",hError);
	data=(unsigned short)mem[0];
	return data;
}
template <class dataType>
signed short hVarLinear<dataType>::getValue(signed short &data){
	if(mem.size()!=1)
		throw hException("hVarLinear::getValue","Non-scalar variable",hError);
	data=(signed short)mem[0];
	return data;
}
template <class dataType>
unsigned long hVarLinear<dataType>::getValue(unsigned long &data){
	if(mem.size()!=1)
		throw hException("hVarLinear::getValue","Non-scalar variable",hError);
	data=(unsigned long)mem[0];
	return data;
}
template <class dataType>
signed long hVarLinear<dataType>::getValue(signed long &data){
	if(mem.size()!=1)
		throw hException("hVarLinear::getValue","Non-scalar variable",hError);
	data=(signed long)mem[0];
	return data;
}
template <class dataType>
float hVarLinear<dataType>::getValue(float &data){
	if(mem.size()!=1)
		throw hException("hVarLinear::getValue","Non-scalar variable",hError);
	data=(float)mem[0];
	return data;
}
template <class dataType>
double hVarLinear<dataType>::getValue(double &data){
	if(mem.size()!=1)
		throw hException("hVarLinear::getValue","Non-scalar variable",hError);
	data=(double)mem[0];
	return data;
}
template <class dataType>
long double hVarLinear<dataType>::getValue(long double &data){
	if(mem.size()!=1)
		throw hException("hVarLinear::getValue","Non-scalar variable",hError);
	data=(long double)mem[0];
	return data;
}
template <class dataType>
std::complex<float> hVarLinear<dataType>::getValue(std::complex<float> &data){
	if(mem.size()!=1)
		throw hException("hVarLinear::getValue","Non-scalar variable",hError);
	data=(std::complex<float>)mem[0];
	return data;
}
template <class dataType>
std::complex<double> hVarLinear<dataType>::getValue(std::complex<double> &data){
	if(mem.size()!=1)
		throw hException("hVarLinear::getValue","Non-scalar variable",hError);
	data=(std::complex<double>)mem[0];
	return data;
}
template <class dataType>
std::complex<long double> hVarLinear<dataType>::getValue(std::complex<long double> &data){
	if(mem.size()!=1)
		throw hException("hVarLinear::getValue","Non-scalar variable",hError);
	data=(std::complex<long double>)mem[0];
	return data;
}

template <>
bool hVarLinear<std::complex<float> >::getValue(std::vector<unsigned int> index,bool &data){
	throw hException("hVarLinear<std::complex<float> >::get","Cannot cast complex to bool",hError);
}
template <>
bool hVarLinear<std::complex<double> >::getValue(std::vector<unsigned int> index,bool &data){
	throw hException("hVarLinear<std::complex<double> >::get","Cannot cast complex to bool",hError);
}
template <>
bool hVarLinear<std::complex<long double> >::getValue(std::vector<unsigned int> index,bool &data){
	throw hException("hVarLinear<std::complex<long double> >::get","Cannot cast complex to bool",hError);
}
template <>
unsigned char hVarLinear<std::complex<float> >::getValue(std::vector<unsigned int> index,unsigned char &data){
	throw hException("hVarLinear<std::complex<float> >::get","Cannot cast complex to char",hError);
}
template <>
unsigned char hVarLinear<std::complex<double> >::getValue(std::vector<unsigned int> index,unsigned char &data){
	throw hException("hVarLinear<std::complex<double> >::get","Cannot cast complex to char",hError);
}
template <>
unsigned char hVarLinear<std::complex<long double> >::getValue(std::vector<unsigned int> index,unsigned char &data){
	throw hException("hVarLinear<std::complex<long double> >::get","Cannot cast complex to char",hError);
}
template <>
signed char hVarLinear<std::complex<float> >::getValue(std::vector<unsigned int> index,signed char &data){
	throw hException("hVarLinear<std::complex<float> >::get","Cannot cast complex to char",hError);
}
template <>
signed char hVarLinear<std::complex<double> >::getValue(std::vector<unsigned int> index,signed char &data){
	throw hException("hVarLinear<std::complex<double> >::get","Cannot cast complex to char",hError);
}
template <>
signed char hVarLinear<std::complex<long double> >::getValue(std::vector<unsigned int> index,signed char &data){
	throw hException("hVarLinear<std::complex<long double> >::get","Cannot cast complex to char",hError);
}
template <>
unsigned short hVarLinear<std::complex<float> >::getValue(std::vector<unsigned int> index,unsigned short &data){
	throw hException("hVarLinear<std::complex<float> >::get","Cannot cast complex to integer",hError);
}
template <>
unsigned short hVarLinear<std::complex<double> >::getValue(std::vector<unsigned int> index,unsigned short &data){
	throw hException("hVarLinear<std::complex<double> >::get","Cannot cast complex to integer",hError);
}
template <>
unsigned short hVarLinear<std::complex<long double> >::getValue(std::vector<unsigned int> index,unsigned short &data){
	throw hException("hVarLinear<std::complex<long double> >::get","Cannot cast complex to integer",hError);
}
template <>
signed short hVarLinear<std::complex<float> >::getValue(std::vector<unsigned int> index,signed short &data){
	throw hException("hVarLinear<std::complex<float> >::get","Cannot cast complex to integer",hError);
}
template <>
signed short hVarLinear<std::complex<double> >::getValue(std::vector<unsigned int> index,signed short &data){
	throw hException("hVarLinear<std::complex<double> >::get","Cannot cast complex to integer",hError);
}
template <>
signed short hVarLinear<std::complex<long double> >::getValue(std::vector<unsigned int> index,signed short &data){
	throw hException("hVarLinear<std::complex<long double> >::get","Cannot cast complex to integer",hError);
}
template <>
unsigned long hVarLinear<std::complex<float> >::getValue(std::vector<unsigned int> index,unsigned long &data){
	throw hException("hVarLinear<std::complex<float> >::get","Cannot cast complex to integer",hError);
}
template <>
unsigned long hVarLinear<std::complex<double> >::getValue(std::vector<unsigned int> index,unsigned long &data){
	throw hException("hVarLinear<std::complex<double> >::get","Cannot cast complex to integer",hError);
}
template <>
unsigned long hVarLinear<std::complex<long double> >::getValue(std::vector<unsigned int> index,unsigned long &data){
	throw hException("hVarLinear<std::complex<long double> >::get","Cannot cast complex to integer",hError);
}
template <>
signed long hVarLinear<std::complex<float> >::getValue(std::vector<unsigned int> index,signed long &data){
	throw hException("hVarLinear<std::complex<float> >::get","Cannot cast complex to integer",hError);
}
template <>
signed long hVarLinear<std::complex<double> >::getValue(std::vector<unsigned int> index,signed long &data){
	throw hException("hVarLinear<std::complex<double> >::get","Cannot cast complex to integer",hError);
}
template <>
signed long hVarLinear<std::complex<long double> >::getValue(std::vector<unsigned int> index,signed long &data){
	throw hException("hVarLinear<std::complex<long double> >::get","Cannot cast complex to integer",hError);
}
template <>
float hVarLinear<std::complex<float> >::getValue(std::vector<unsigned int> index,float &data){
	throw hException("hVarLinear<std::complex<float> >::get","Cannot cast complex to floating point",hError);
}
template <>
float hVarLinear<std::complex<double> >::getValue(std::vector<unsigned int> index,float &data){
	throw hException("hVarLinear<std::complex<double> >::get","Cannot cast complex to floating point",hError);
}
template <>
float hVarLinear<std::complex<long double> >::getValue(std::vector<unsigned int> index,float &data){
	throw hException("hVarLinear<std::complex<long double> >::get","Cannot cast complex to floating point",hError);
}
template <>
double hVarLinear<std::complex<float> >::getValue(std::vector<unsigned int> index,double &data){
	throw hException("hVarLinear<std::complex<float> >::get","Cannot cast complex to floating point",hError);
}
template <>
double hVarLinear<std::complex<double> >::getValue(std::vector<unsigned int> index,double &data){
	throw hException("hVarLinear<std::complex<double> >::get","Cannot cast complex to floating point",hError);
}
template <>
double hVarLinear<std::complex<long double> >::getValue(std::vector<unsigned int> index,double &data){
	throw hException("hVarLinear<std::complex<long double> >::get","Cannot cast complex to floating point",hError);
}
template <>
long double hVarLinear<std::complex<float> >::getValue(std::vector<unsigned int> index,long double &data){
	throw hException("hVarLinear<std::complex<float> >::get","Cannot cast complex to floating point",hError);
}
template <>
long double hVarLinear<std::complex<double> >::getValue(std::vector<unsigned int> index,long double &data){
	throw hException("hVarLinear<std::complex<double> >::get","Cannot cast complex to floating point",hError);
}
template <>
long double hVarLinear<std::complex<long double> >::getValue(std::vector<unsigned int> index,long double &data){
	throw hException("hVarLinear<std::complex<long double> >::get","Cannot cast complex to floating point",hError);
}
template <class dataType>
bool hVarLinear<dataType>::getValue(std::vector<unsigned int> index,bool &data){
	dataType ret;
	ret=mem[findIndex(index)];
	return data=(bool)ret;
}
template <class dataType>
unsigned char hVarLinear<dataType>::getValue(std::vector<unsigned int> index,unsigned char &data){
	dataType ret;
	ret=mem[findIndex(index)];
	return data=(unsigned char)ret;
}
template <class dataType>
signed char hVarLinear<dataType>::getValue(std::vector<unsigned int> index,signed char &data){
	dataType ret;
	ret=mem[findIndex(index)];
	return data=(signed char)ret;
}
template <class dataType>
unsigned short hVarLinear<dataType>::getValue(std::vector<unsigned int> index,unsigned short &data){
	dataType ret;
	ret=mem[findIndex(index)];
	return data=(unsigned short)ret;
}
template <class dataType>
signed short hVarLinear<dataType>::getValue(std::vector<unsigned int> index,signed short &data){
	dataType ret;
	ret=mem[findIndex(index)];
	return data=(signed short)ret;
}
template <class dataType>
unsigned long hVarLinear<dataType>::getValue(std::vector<unsigned int> index,unsigned long &data){
	dataType ret;
	ret=mem[findIndex(index)];
	return data=(unsigned long)ret;
}
template <class dataType>
signed long hVarLinear<dataType>::getValue(std::vector<unsigned int> index,signed long &data){
	dataType ret;
	ret=mem[findIndex(index)];
	return data=(signed long)ret;
}
template <class dataType>
float hVarLinear<dataType>::getValue(std::vector<unsigned int> index,float &data){
	dataType ret;
	ret=mem[findIndex(index)];
	return data=(float)ret;
}
template <class dataType>
double hVarLinear<dataType>::getValue(std::vector<unsigned int> index,double &data){
	dataType ret;
	ret=mem[findIndex(index)];
	return data=(double)ret;
}
template <class dataType>
long double hVarLinear<dataType>::getValue(std::vector<unsigned int> index,long double &data){
	dataType ret;
	ret=mem[findIndex(index)];
	return data=(long double)ret;
}
template <class dataType>
std::complex<float> hVarLinear<dataType>::getValue(std::vector<unsigned int> index,std::complex<float> &data){
	dataType ret;
	ret=mem[findIndex(index)];
	return data=(std::complex<float>)ret;
}
template <class dataType>
std::complex<double> hVarLinear<dataType>::getValue(std::vector<unsigned int> index,std::complex<double> &data){
	dataType ret;
	ret=mem[findIndex(index)];
	return data=(std::complex<double>)ret;
}
template <class dataType>
std::complex<long double> hVarLinear<dataType>::getValue(std::vector<unsigned int> index,std::complex<long double> &data){
	dataType ret;
	ret=mem[findIndex(index)];
	return data=(std::complex<long double>)ret;
}
template <class dataType>
void hVarLinear<dataType>::get(bool *data){
	unsigned long int s,i;
	std::vector<bool> dedomena;
	hVarLinear<bool> *temp;
	temp=(hVarLinear<bool> *)cast(hBool);
	dedomena=temp->mem;
	delete temp;
	s=dedomena.size();
	data=new bool[s];
	for(i=0;i<s;++i)
		data[i]=dedomena[i];
}
template <class dataType>
void hVarLinear<dataType>::get(unsigned char *data){
	unsigned long int s,i;
	std::vector<unsigned char> dedomena;
	hVarLinear<unsigned char> *temp;
	temp=(hVarLinear<unsigned char> *)cast(huChar);
	dedomena=temp->mem;
	delete temp;
	s=dedomena.size();
	data=new unsigned char[s];
	for(i=0;i<s;++i)
		data[i]=dedomena[i];
}
template <class dataType>
void hVarLinear<dataType>::get(signed char *data){
	unsigned long int s,i;
	std::vector<signed char> dedomena;
	hVarLinear<signed char> *temp;
	temp=(hVarLinear<signed char> *)cast(hsChar);
	dedomena=temp->mem;
	delete temp;
	s=dedomena.size();
	data=new signed char[s];
	for(i=0;i<s;++i)
		data[i]=dedomena[i];
}
template <class dataType>
void hVarLinear<dataType>::get(unsigned short *data){
	unsigned long int s,i;
	std::vector<unsigned short> dedomena;
	hVarLinear<unsigned short> *temp;
	temp=(hVarLinear<unsigned short> *)cast(huShortInt);
	dedomena=temp->mem;
	delete temp;
	s=dedomena.size();
	data=new unsigned short[s];
	for(i=0;i<s;++i)
		data[i]=dedomena[i];
}
template <class dataType>
void hVarLinear<dataType>::get(signed short *data){
	unsigned long int s,i;
	std::vector<signed short> dedomena;
	hVarLinear<signed short> *temp;
	temp=(hVarLinear<signed short> *)cast(hsShortInt);
	dedomena=temp->mem;
	delete temp;
	s=dedomena.size();
	data=new signed short[s];
	for(i=0;i<s;++i)
		data[i]=dedomena[i];
}
template <class dataType>
void hVarLinear<dataType>::get(unsigned long *data){
	unsigned long int s,i;
	std::vector<unsigned long> dedomena;
	hVarLinear<unsigned long> *temp;
	temp=(hVarLinear<unsigned long> *)cast(huInt);
	dedomena=temp->mem;
	delete temp;
	s=dedomena.size();
	data=new unsigned long[s];
	for(i=0;i<s;++i)
		data[i]=dedomena[i];
}
template <class dataType>
void hVarLinear<dataType>::get(signed long *data){
	unsigned long int s,i;
	std::vector<signed long> dedomena;
	hVarLinear<signed long> *temp;
	temp=(hVarLinear<signed long> *)cast(hsInt);
	dedomena=temp->mem;
	delete temp;
	s=dedomena.size();
	data=new signed long[s];
	for(i=0;i<s;++i)
		data[i]=dedomena[i];
}
template <class dataType>
void hVarLinear<dataType>::get(float *data){
	unsigned long int s,i;
	std::vector<float> dedomena;
	hVarLinear<float> *temp;
	temp=(hVarLinear<float> *)cast(hFloat);
	dedomena=temp->mem;
	delete temp;
	s=dedomena.size();
	data=new float[s];
	for(i=0;i<s;++i)
		data[i]=dedomena[i];
}
template <class dataType>
void hVarLinear<dataType>::get(double *data){
	unsigned long int s,i;
	std::vector<double> dedomena;
	hVarLinear<double> *temp;
	temp=(hVarLinear<double> *)cast(hDouble);
	dedomena=temp->mem;
	delete temp;
	s=dedomena.size();
	data=new double[s];
	for(i=0;i<s;++i)
		data[i]=dedomena[i];
}
template <class dataType>
void hVarLinear<dataType>::get(long double *data){
	unsigned long int s,i;
	std::vector<long double> dedomena;
	hVarLinear<long double> *temp;
	temp=(hVarLinear<long double> *)cast(hLDouble);
	dedomena=temp->mem;
	delete temp;
	s=dedomena.size();
	data=new long double[s];
	for(i=0;i<s;++i)
		data[i]=dedomena[i];
}
template <class dataType>
void hVarLinear<dataType>::get(std::complex<float> *data){
	unsigned long int s,i;
	std::vector<std::complex<float> > dedomena;
	hVarLinear<std::complex<float> > *temp;
	temp=(hVarLinear<std::complex<float> > *)cast(hComplex);
	dedomena=temp->mem;
	delete temp;
	s=dedomena.size();
	data=new std::complex<float>[s];
	for(i=0;i<s;++i)
		data[i]=dedomena[i];
}
template <class dataType>
void hVarLinear<dataType>::get(std::complex<double> *data){
	unsigned long int s,i;
	std::vector<std::complex<double> > dedomena;
	hVarLinear<std::complex<double> > *temp;
	temp=(hVarLinear<std::complex<double> > *)cast(hDComplex);
	dedomena=temp->mem;
	delete temp;
	s=dedomena.size();
	data=new std::complex<double>[s];
	for(i=0;i<s;++i)
		data[i]=dedomena[i];
}
template <class dataType>
void hVarLinear<dataType>::get(std::complex<long double> *data){
	unsigned long int s,i;
	std::vector<std::complex<long double> > dedomena;
	hVarLinear<std::complex<long double> > *temp;
	temp=(hVarLinear<std::complex<long double> > *)cast(hLDComplex);
	dedomena=temp->mem;
	delete temp;
	s=dedomena.size();
	data=new std::complex<long double>[s];
	for(i=0;i<s;++i)
		data[i]=dedomena[i];
}

template <>
unsigned char hVarLinear<bool>::getType(void){
	return hBool;
}
template <>
unsigned char hVarLinear<unsigned char>::getType(void){
	return huChar;
}
template <>
unsigned char hVarLinear<signed char>::getType(void){
	return hsChar;
}
template <>
unsigned char hVarLinear<unsigned short>::getType(void){
	return huShortInt;
}
template <>
unsigned char hVarLinear<signed short>::getType(void){
	return hsShortInt;
}
template <>
unsigned char hVarLinear<unsigned long>::getType(void){
	return huInt;
}
template <>
unsigned char hVarLinear<signed long>::getType(void){
	return hsInt;
}
template <>
unsigned char hVarLinear<float>::getType(void){
	return hFloat;
}
template <>
unsigned char hVarLinear<double>::getType(void){
	return hDouble;
}
template <>
unsigned char hVarLinear<long double>::getType(void){
	return hLDouble;
}
template <>
unsigned char hVarLinear<std::complex<float> >::getType(void){
	return hComplex;
}
template <>
unsigned char hVarLinear<std::complex<double> >::getType(void){
	return hDComplex;
}
template <>
unsigned char hVarLinear<std::complex<long double> >::getType(void){
	return hLDComplex;
}

template <class dataType>
unsigned char hVarLinear<dataType>::getType(void){
	return hNoType;
}

template <class dataType>
void hVarLinear<dataType>::clear(void){
	mem.clear();
	size.clear();
	delete this;
}

template <class dataType>
hVarBase* hVarLinear<dataType>::cast(unsigned char type){
	switch(type){
	case hBool:
		return typeCast<bool>();
	case huChar:
		return typeCast<unsigned char>();
	case hsChar:
		return typeCast<signed char>();
	case huShortInt:
		return typeCast<unsigned short>();
	case hsShortInt:
		return typeCast<signed short>();
	case huInt:
		return typeCast<unsigned long>();
	case hsInt:
		return typeCast<signed long>();
	case hFloat:
		return typeCast<float>();
	case hDouble:
		return typeCast<double>();
	case hLDouble:
		return typeCast<long double>();
	case hComplex:
		return typeCast<std::complex<float> >();
	case hDComplex:
		return typeCast<std::complex<double> >();
	case hLDComplex:
		return typeCast<std::complex<long double> >();
	default:
		throw hException("hVarLinear<dataType>::cast","Invalid Type",hError);
	}	
}

template <class dataType>
hVarBase* hVarLinear<dataType>::convert(bool){
	return typeCast<bool>();
}
template <class dataType>
hVarBase* hVarLinear<dataType>::convert(unsigned char flank){
	return typeCast<unsigned char>();
}

template <class dataType>
hVarBase* hVarLinear<dataType>::convert(signed char flank){
	return typeCast<signed char>();
}

template <class dataType>
hVarBase* hVarLinear<dataType>::convert(unsigned short int flank){
	return typeCast<unsigned short>();
}

template <class dataType>
hVarBase* hVarLinear<dataType>::convert(signed short int flank){
	return typeCast<signed short>();
}

template <class dataType>
hVarBase* hVarLinear<dataType>::convert(unsigned long int flank){
	return typeCast<unsigned long>();
}

template <class dataType>
hVarBase* hVarLinear<dataType>::convert(signed long int flank){
	return typeCast<signed long>();
}

/*template <class dataType>
hVarBase* hVarLinear<dataType>::convert(unsigned int flank){
	return typeCast<bool>();
}

template <class dataType>
hVarBase* hVarLinear<dataType>::convert(signed int flank){
	return typeCast<bool>();
}*/

template <class dataType>
hVarBase* hVarLinear<dataType>::convert(float flank){
	return typeCast<float>();
}

template <class dataType>
hVarBase* hVarLinear<dataType>::convert(double flank){
	return typeCast<double>();
}

template <class dataType>
hVarBase* hVarLinear<dataType>::convert(long double flank){
	return typeCast<long double>();
}

template <class dataType>
hVarBase* hVarLinear<dataType>::convert(std::complex<float> flank){
	return typeCast<std::complex<float> >();
}

template <class dataType>
hVarBase* hVarLinear<dataType>::convert(std::complex<double> flank){
	return typeCast<std::complex<double> >();
}

template <class dataType>
hVarBase* hVarLinear<dataType>::convert(std::complex<long double> flank){
	return typeCast<std::complex<long double> >();
}

template <>
hVarBase* hVarLinear<bool>::operator+(const bool &op2){
	unsigned long int i,s;
	hVarLinear<bool> *ret;
	ret=new hVarLinear<bool>;
	s=mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back((bool)mem[i]+op2);
	ret->size=size;
	return ret;
}
template <>
hVarBase* hVarLinear<bool>::operator-(const bool &op2){
	unsigned long int i,s;
	hVarLinear<bool> *ret;
	ret=new hVarLinear<bool>;
	s=mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back((bool)mem[i]-op2);
	ret->size=size;
	return ret;
}
template <>
hVarBase* hVarLinear<bool>::operator*(const bool &op2){
	unsigned long int i,s;
	hVarLinear<bool> *ret;
	ret=new hVarLinear<bool>;
	s=mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back((bool)mem[i]*op2);
	ret->size=size;
	return ret;
}
template <>
hVarBase* hVarLinear<bool>::operator/(const bool &op2){
	unsigned long int i,s;
	hVarLinear<bool> *ret;
	ret=new hVarLinear<bool>;
	s=mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back((bool)mem[i]/op2);
	ret->size=size;
	return ret;
}
template <>
hVarBase* hVarLinear<bool>::operator%(const bool &op2){
	unsigned long int i,s;
	hVarLinear<bool> *ret;
	ret=new hVarLinear<bool>;
	s=mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back((bool)mem[i]%op2);
	ret->size=size;
	return ret;
}
template <>
hVarBase* hVarLinear<bool>::operator<(const bool &op2){
	unsigned long int i,s;
	hVarLinear<bool> *ret;
	ret=new hVarLinear<bool>;
	s=mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back((bool)mem[i]<op2);
	ret->size=size;
	return ret;
}
template <>
hVarBase* hVarLinear<bool>::operator<=(const bool &op2){
	unsigned long int i,s;
	hVarLinear<bool> *ret;
	ret=new hVarLinear<bool>;
	s=mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back((bool)mem[i]<=op2);
	ret->size=size;
	return ret;
}
template <>
hVarBase* hVarLinear<bool>::operator>(const bool &op2){
	unsigned long int i,s;
	hVarLinear<bool> *ret;
	ret=new hVarLinear<bool>;
	s=mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back((bool)mem[i]>op2);
	ret->size=size;
	return ret;
}
template <>
hVarBase* hVarLinear<bool>::operator>=(const bool &op2){
	unsigned long int i,s;
	hVarLinear<bool> *ret;
	ret=new hVarLinear<bool>;
	s=mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back((bool)mem[i]>=op2);
	ret->size=size;
	return ret;
}
template <>
hVarBase* hVarLinear<bool>::operator&&(const bool &op2){
	unsigned long int i,s;
	hVarLinear<bool> *ret;
	ret=new hVarLinear<bool>;
	s=mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back((bool)mem[i]&&op2);
	ret->size=size;
	return ret;
}
template <>
hVarBase* hVarLinear<bool>::operator||(const bool &op2){
	unsigned long int i,s;
	hVarLinear<bool> *ret;
	ret=new hVarLinear<bool>;
	s=mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back((bool)mem[i]||op2);
	ret->size=size;
	return ret;
}
template <>
hVarBase* hVarLinear<bool>::operator==(const bool &op2){
	unsigned long int i,s;
	hVarLinear<bool> *ret;
	ret=new hVarLinear<bool>;
	s=mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back((bool)mem[i]==op2);
	ret->size=size;
	return ret;
}
template <>
hVarBase* hVarLinear<bool>::operator!=(const bool &op2){
	unsigned long int i,s;
	hVarLinear<bool> *ret;
	ret=new hVarLinear<bool>;
	s=mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back((bool)mem[i]!=op2);
	ret->size=size;
	return ret;
}
template <>
hVarBase* hVarLinear<bool>::operator<<(const bool &op2){
	unsigned long int i,s;
	hVarLinear<bool> *ret;
	ret=new hVarLinear<bool>;
	s=mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back((bool)mem[i]<<op2);
	ret->size=size;
	return ret;
}
template <>
hVarBase* hVarLinear<bool>::operator>>(const bool &op2){
	unsigned long int i,s;
	hVarLinear<bool> *ret;
	ret=new hVarLinear<bool>;
	s=mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back((bool)mem[i]>>op2);
	ret->size=size;
	return ret;
}
template <>
hVarBase* hVarLinear<bool>::operator&(const bool &op2){
	unsigned long int i,s;
	hVarLinear<bool> *ret;
	ret=new hVarLinear<bool>;
	s=mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back((bool)mem[i]&op2);
	ret->size=size;
	return ret;
}
template <>
hVarBase* hVarLinear<bool>::operator|(const bool &op2){
	unsigned long int i,s;
	hVarLinear<bool> *ret;
	ret=new hVarLinear<bool>;
	s=mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back((bool)mem[i]|op2);
	ret->size=size;
	return ret;
}
template <>
hVarBase* hVarLinear<bool>::operator^(const bool &op2){
	unsigned long int i,s;
	hVarLinear<bool> *ret;
	ret=new hVarLinear<bool>;
	s=mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back((bool)mem[i]^op2);
	ret->size=size;
	return ret;
}

template <class dataType>
hVarBase* hVarLinear<dataType>::operator+(const dataType &op2){
	unsigned long int i,s;
	hVarLinear<dataType> *ret;
	ret=new hVarLinear<dataType>;
	s=mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(mem[i]+op2);
	ret->size=size;
	return ret;
}
template <class dataType>
hVarBase* hVarLinear<dataType>::operator-(const dataType &op2){
	unsigned long int i,s;
	hVarLinear<dataType> *ret;
	ret=new hVarLinear<dataType>;
	s=mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(mem[i]-op2);
	ret->size=size;
	return ret;
}
template <class dataType>
hVarBase* hVarLinear<dataType>::operator*(const dataType &op2){
	unsigned long int i,s;
	hVarLinear<dataType> *ret;
	ret=new hVarLinear<dataType>;
	s=mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(mem[i]*op2);
	ret->size=size;
	return ret;
}
template <class dataType>
hVarBase* hVarLinear<dataType>::operator/(const dataType &op2){
	unsigned long int i,s;
	hVarLinear<dataType> *ret;
	ret=new hVarLinear<dataType>;
	s=mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(mem[i]/op2);
	ret->size=size;
	return ret;
}

template <>
hVarBase* hVarLinear<float>::operator%(const float &op2){
	throw hException("hVarLinear<float>::operator%","Operator % doesn't exist for floating point variables",hError);
}
template <>
hVarBase* hVarLinear<double>::operator%(const double &op2){
	throw hException("hVarLinear<double>::operator%","Operator % doesn't exist for floating point variables",hError);
}
template <>
hVarBase* hVarLinear<long double>::operator%(const long double &op2){
	throw hException("hVarLinear<long double>::operator%","Operator % doesn't exist for floating point variables",hError);
}
template <>
hVarBase* hVarLinear<std::complex<float> >::operator%(const std::complex<float> &op2){
	throw hException("hVarLinear<float>::operator%","Operator % doesn't exist for complex variables",hError);
}
template <>
hVarBase* hVarLinear<std::complex<double> >::operator%(const std::complex<double> &op2){
	throw hException("hVarLinear<double>::operator%","Operator % doesn't exist for complex variables",hError);
}
template <>
hVarBase* hVarLinear<std::complex<long double> >::operator%(const std::complex<long double> &op2){
	throw hException("hVarLinear<long double>::operator%","Operator % doesn't exist for complex variables",hError);
}
template <class dataType>
hVarBase* hVarLinear<dataType>::operator%(const dataType &op2){
	unsigned long int i,s;
	hVarLinear<dataType> *ret;
	ret=new hVarLinear<dataType>;
	s=mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(mem[i]%op2);
	ret->size=size;
	return ret;
}

template <class dataType>
hVarBase* hVarLinear<dataType>::operator=(const dataType &op2){
	unsigned long int i,s;
	if(!size.size()){
		size.push_back(1);
		mem.push_back(op2);
	}else if(mem.size()==1){
		mem[0]=op2;
	}else{
		throw hException("hVarLinear<dataType>::operator=","Cannot assign a scalar variable to a non-scalar",hError);
	}
	return this;
}

template <>
hVarBase* hVarLinear<std::complex<float> >::operator<(const std::complex<float> &op2){
	throw hException("hVarLinear<std::complex<float> >::operator<","Operator `<' doesn't exist for complex variables",hError);
}
template <>
hVarBase* hVarLinear<std::complex<double> >::operator<(const std::complex<double> &op2){
	throw hException("hVarLinear<std::complex<double> >::operator<","Operator `<' doesn't exist for complex variables",hError);
}
template <>
hVarBase* hVarLinear<std::complex<long double> >::operator<(const std::complex<long double> &op2){
	throw hException("hVarLinear<std::complex<long double> >::operator<","Operator `<' doesn't exist for complex variables",hError);
}
template <>
hVarBase* hVarLinear<std::complex<float> >::operator>(const std::complex<float> &op2){
	throw hException("hVarLinear<std::complex<float> >::operator<","Operator `>' doesn't exist for complex variables",hError);
}
template <>
hVarBase* hVarLinear<std::complex<double> >::operator>(const std::complex<double> &op2){
	throw hException("hVarLinear<std::complex<double> >::operator<","Operator `>' doesn't exist for complex variables",hError);
}
template <>
hVarBase* hVarLinear<std::complex<long double> >::operator>(const std::complex<long double> &op2){
	throw hException("hVarLinear<std::complex<long double> >::operator<","Operator `>' doesn't exist for complex variables",hError);
}
template <>
hVarBase* hVarLinear<std::complex<float> >::operator<=(const std::complex<float> &op2){
	throw hException("hVarLinear<std::complex<float> >::operator<","Operator `<=' doesn't exist for complex variables",hError);
}
template <>
hVarBase* hVarLinear<std::complex<double> >::operator<=(const std::complex<double> &op2){
	throw hException("hVarLinear<std::complex<double> >::operator<","Operator `<=' doesn't exist for complex variables",hError);
}
template <>
hVarBase* hVarLinear<std::complex<long double> >::operator<=(const std::complex<long double> &op2){
	throw hException("hVarLinear<std::complex<long double> >::operator<","Operator `<=' doesn't exist for complex variables",hError);
}
template <>
hVarBase* hVarLinear<std::complex<float> >::operator>=(const std::complex<float> &op2){
	throw hException("hVarLinear<std::complex<float> >::operator<","Operator `>=' doesn't exist for complex variables",hError);
}
template <>
hVarBase* hVarLinear<std::complex<double> >::operator>=(const std::complex<double> &op2){
	throw hException("hVarLinear<std::complex<double> >::operator<","Operator `>=' doesn't exist for complex variables",hError);
}
template <>
hVarBase* hVarLinear<std::complex<long double> >::operator>=(const std::complex<long double> &op2){
	throw hException("hVarLinear<std::complex<long double> >::operator<","Operator `>=' doesn't exist for complex variables",hError);
}

template <class dataType>
hVarBase* hVarLinear<dataType>::operator<(const dataType &op2){
	unsigned long int i,s;
	hVarLinear<dataType> *ret;
	ret=new hVarLinear<dataType>;
	s=mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(mem[i]<op2);
	ret->size=size;
	return ret;
}
template <class dataType>
hVarBase* hVarLinear<dataType>::operator<=(const dataType &op2){
	unsigned long int i,s;
	hVarLinear<dataType> *ret;
	ret=new hVarLinear<dataType>;
	s=mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(mem[i]<=op2);
	ret->size=size;
	return ret;
}
template <class dataType>
hVarBase* hVarLinear<dataType>::operator>(const dataType &op2){
	unsigned long int i,s;
	hVarLinear<dataType> *ret;
	ret=new hVarLinear<dataType>;
	s=mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(mem[i]>op2);
	ret->size=size;
	return ret;
}
template <class dataType>
hVarBase* hVarLinear<dataType>::operator>=(const dataType &op2){
	unsigned long int i,s;
	hVarLinear<dataType> *ret;
	ret=new hVarLinear<dataType>;
	s=mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(mem[i]>=op2);
	ret->size=size;
	return ret;
}

template <>
hVarBase* hVarLinear<std::complex<float> >::operator&&(const std::complex<float> &op2){
	throw hException("hVarLinear<std::complex<float> >::operator&&","Operator `&&' doesn't exist for complex variables",hError);
}
template <>
hVarBase* hVarLinear<std::complex<double> >::operator&&(const std::complex<double> &op2){
	throw hException("hVarLinear<std::complex<double> >::operator&&","Operator `&&' doesn't exist for complex variables",hError);
}
template <>
hVarBase* hVarLinear<std::complex<long double> >::operator&&(const std::complex<long double> &op2){
	throw hException("hVarLinear<std::complex<long double> >::operator&&","Operator `&&' doesn't exist for complex variables",hError);
}
template <>
hVarBase* hVarLinear<std::complex<float> >::operator||(const std::complex<float> &op2){
	throw hException("hVarLinear<std::complex<float> >::operator||","Operator `||' doesn't exist for complex variables",hError);
}
template <>
hVarBase* hVarLinear<std::complex<double> >::operator||(const std::complex<double> &op2){
	throw hException("hVarLinear<std::complex<double> >::operator||","Operator `||' doesn't exist for complex variables",hError);
}
template <>
hVarBase* hVarLinear<std::complex<long double> >::operator||(const std::complex<long double> &op2){
	throw hException("hVarLinear<std::complex<long double> >::operator||","Operator `||' doesn't exist for complex variables",hError);
}
template <class dataType>
hVarBase* hVarLinear<dataType>::operator&&(const dataType &op2){
	unsigned long int i,s;
	hVarLinear<dataType> *ret;
	ret=new hVarLinear<dataType>;
	s=mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(mem[i]&&op2);
	ret->size=size;
	return ret;
}
template <class dataType>
hVarBase* hVarLinear<dataType>::operator||(const dataType &op2){
	unsigned long int i,s;
	hVarLinear<dataType> *ret;
	ret=new hVarLinear<dataType>;
	s=mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(mem[i]||op2);
	ret->size=size;
	return ret;
}
template <class dataType>
hVarBase* hVarLinear<dataType>::operator==(const dataType &op2){
	unsigned long int i,s;
	hVarLinear<dataType> *ret;
	ret=new hVarLinear<dataType>;
	s=mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(mem[i]==op2);
	ret->size=size;
	return ret;
}
template <class dataType>
hVarBase* hVarLinear<dataType>::operator!=(const dataType &op2){
	unsigned long int i,s;
	hVarLinear<dataType> *ret;
	ret=new hVarLinear<dataType>;
	s=mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(mem[i]!=op2);
	ret->size=size;
	return ret;
}
template <>
hVarBase* hVarLinear<float>::operator<<(const float &op2){
	throw hException("hVarLinear<float>::operator<<","Binary operator `<<' doesn't exist for floating point variables",hError);
}
template <>
hVarBase* hVarLinear<double>::operator<<(const double &op2){
	throw hException("hVarLinear<double>::operator<<","Binary operator `<<' doesn't exist for floating point variables",hError);
}
template <>
hVarBase* hVarLinear<long double>::operator<<(const long double &op2){
	throw hException("hVarLinear<long double>::operator<<","Binary operator `<<' doesn't exist for floating point variables",hError);
}
template <>
hVarBase* hVarLinear<float>::operator>>(const float &op2){
	throw hException("hVarLinear<float>::operator>>","Binary operator `>>' doesn't exist for floating point variables",hError);
}
template <>
hVarBase* hVarLinear<double>::operator>>(const double &op2){
	throw hException("hVarLinear<double>::operator>>","Binary operator `>>' doesn't exist for floating point variables",hError);
}
template <>
hVarBase* hVarLinear<long double>::operator>>(const long double &op2){
	throw hException("hVarLinear<long double>::operator>>","Binary operator `>>' doesn't exist for floating point variables",hError);
}
template <>
hVarBase* hVarLinear<std::complex<float> >::operator<<(const std::complex<float> &op2){
	throw hException("hVarLinear<std::complex<float> >::operator<<","Operator `<<' doesn't exist for complex variables",hError);
}
template <>
hVarBase* hVarLinear<std::complex<double> >::operator<<(const std::complex<double> &op2){
	throw hException("hVarLinear<std::complex<double> >::operator<<","Operator `<<' doesn't exist for complex variables",hError);
}
template <>
hVarBase* hVarLinear<std::complex<long double> >::operator<<(const std::complex<long double> &op2){
	throw hException("hVarLinear<std::complex<long double> >::operator<<","Operator `<<' doesn't exist for complex variables",hError);
}
template <>
hVarBase* hVarLinear<std::complex<float> >::operator>>(const std::complex<float> &op2){
	throw hException("hVarLinear<std::complex<float> >::operator>>","Operator `>>' doesn't exist for complex variables",hError);
}
template <>
hVarBase* hVarLinear<std::complex<double> >::operator>>(const std::complex<double> &op2){
	throw hException("hVarLinear<std::complex<double> >::operator>>","Operator `>>' doesn't exist for complex variables",hError);
}
template <>
hVarBase* hVarLinear<std::complex<long double> >::operator>>(const std::complex<long double> &op2){
	throw hException("hVarLinear<std::complex<long double> >::operator>>","Operator `>>' doesn't exist for complex variables",hError);
}

template <class dataType>
hVarBase* hVarLinear<dataType>::operator<<(const dataType &op2){
	unsigned long int i,s;
	hVarLinear<dataType> *ret;
	ret=new hVarLinear<dataType>;
	s=mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(mem[i]<<op2);
	ret->size=size;
	return ret;
}
template <class dataType>
hVarBase* hVarLinear<dataType>::operator>>(const dataType &op2){
	unsigned long int i,s;
	hVarLinear<dataType> *ret;
	ret=new hVarLinear<dataType>;
	s=mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(mem[i]>>op2);
	ret->size=size;
	return ret;
}
template <>
hVarBase* hVarLinear<float>::operator&(const float &op2){
	throw hException("hVarLinear<float>::operator&","Binary operator `&' doesn't exist for floating point variables",hError);
}
template <>
hVarBase* hVarLinear<double>::operator&(const double &op2){
	throw hException("hVarLinear<double>::operator&","Binary operator `&' doesn't exist for floating point variables",hError);
}
template <>
hVarBase* hVarLinear<long double>::operator&(const long double &op2){
	throw hException("hVarLinear<long double>::operator&","Binary operator `&' doesn't exist for floating point variables",hError);
}
template <>
hVarBase* hVarLinear<float>::operator|(const float &op2){
	throw hException("hVarLinear<float>::operator|","Binary operator `|' doesn't exist for floating point variables",hError);
}
template <>
hVarBase* hVarLinear<double>::operator|(const double &op2){
	throw hException("hVarLinear<double>::operator|","Binary operator `|' doesn't exist for floating point variables",hError);
}
template <>
hVarBase* hVarLinear<long double>::operator|(const long double &op2){
	throw hException("hVarLinear<long double>::operator|","Binary operator `|' doesn't exist for floating point variables",hError);
}
template <>
hVarBase* hVarLinear<float>::operator^(const float &op2){
	throw hException("hVarLinear<float>::operator^","Binary operator `^' doesn't exist for floating point variables",hError);
}
template <>
hVarBase* hVarLinear<double>::operator^(const double &op2){
	throw hException("hVarLinear<double>::operator^","Binary operator `^' doesn't exist for floating point variables",hError);
}
template <>
hVarBase* hVarLinear<long double>::operator^(const long double &op2){
	throw hException("hVarLinear<long double>::operator^","Binary operator `^' doesn't exist for floating point variables",hError);
}
template <>
hVarBase* hVarLinear<std::complex<float> >::operator&(const std::complex<float> &op2){
	throw hException("hVarLinear<std::complex<float> >::operator&","Operator `&' doesn't exist for complex variables",hError);
}
template <>
hVarBase* hVarLinear<std::complex<double> >::operator&(const std::complex<double> &op2){
	throw hException("hVarLinear<std::complex<double> >::operator&","Operator `&' doesn't exist for complex variables",hError);
}
template <>
hVarBase* hVarLinear<std::complex<long double> >::operator&(const std::complex<long double> &op2){
	throw hException("hVarLinear<std::complex<long double> >::operator&","Operator `&' doesn't exist for complex variables",hError);
}
template <>
hVarBase* hVarLinear<std::complex<float> >::operator|(const std::complex<float> &op2){
	throw hException("hVarLinear<std::complex<float> >::operator|","Operator `|' doesn't exist for complex variables",hError);
}
template <>
hVarBase* hVarLinear<std::complex<double> >::operator|(const std::complex<double> &op2){
	throw hException("hVarLinear<std::complex<double> >::operator|","Operator `|' doesn't exist for complex variables",hError);
}
template <>
hVarBase* hVarLinear<std::complex<long double> >::operator|(const std::complex<long double> &op2){
	throw hException("hVarLinear<std::complex<long double> >::operator|","Operator `|' doesn't exist for complex variables",hError);
}
template <>
hVarBase* hVarLinear<std::complex<float> >::operator^(const std::complex<float> &op2){
	throw hException("hVarLinear<std::complex<float> >::operator^","Operator `^' doesn't exist for complex variables",hError);
}
template <>
hVarBase* hVarLinear<std::complex<double> >::operator^(const std::complex<double> &op2){
	throw hException("hVarLinear<std::complex<double> >::operator^","Operator `^' doesn't exist for complex variables",hError);
}
template <>
hVarBase* hVarLinear<std::complex<long double> >::operator^(const std::complex<long double> &op2){
	throw hException("hVarLinear<std::complex<long double> >::operator^","Operator `^' doesn't exist for complex variables",hError);
}
template <class dataType>
hVarBase* hVarLinear<dataType>::operator&(const dataType &op2){
	unsigned long int i,s;
	hVarLinear<dataType> *ret;
	ret=new hVarLinear<dataType>;
	s=mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(mem[i]&op2);
	ret->size=size;
	return ret;
}
template <class dataType>
hVarBase* hVarLinear<dataType>::operator|(const dataType &op2){
	unsigned long int i,s;
	hVarLinear<dataType> *ret;
	ret=new hVarLinear<dataType>;
	s=mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(mem[i]|op2);
	ret->size=size;
	return ret;
}
template <class dataType>
hVarBase* hVarLinear<dataType>::operator^(const dataType &op2){
	unsigned long int i,s;
	hVarLinear<dataType> *ret;
	ret=new hVarLinear<dataType>;
	s=mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(mem[i]^op2);
	ret->size=size;
	return ret;
}
template <>
hVarBase* hVarLinear<bool>::operator+(const hVarBase* op2){
	unsigned long s1,s2;
	hVarLinear<bool> *top2;
	top2=(hVarLinear<bool> *)op2;
	s1=mem.size();
	s2=top2->mem.size();
	if(s1==s2){
		hVarLinear<unsigned long> *ret;
		ret=new hVarLinear<unsigned long>;
		ret->mem.reserve(s1);
		for(unsigned long i=0;i<s1;++i)
			ret->mem.push_back(mem[i]+top2->mem[i]);
		return ret;
	}else if(s1==1){
		bool constant;
		constant=mem[0];
		return constant+(*top2);
	}else if(s2==1){
		bool constant;
		constant=top2->mem[0];
		return *this+constant;
	}else{
		throw hException("hVarLinear<bool>::operator+","Dimensions don't match",hError);
	}
}
template <>
hVarBase* hVarLinear<bool>::operator-(const hVarBase* op2){
	unsigned long s1,s2;
	hVarLinear<bool> *top2;
	top2=(hVarLinear<bool> *)op2;
	s1=mem.size();
	s2=top2->mem.size();
	if(s1==s2){
		hVarLinear<signed long> *ret;
		ret=new hVarLinear<signed long>;
		ret->mem.reserve(s1);
		for(unsigned long i=0;i<s1;++i)
			ret->mem.push_back(mem[i]-top2->mem[i]);
		return ret;
	}else if(s1==1){
		bool constant;
		constant=mem[0];
		return constant-(*top2);
	}else if(s2==1){
		bool constant;
		constant=top2->mem[0];
		return *this-constant;
	}else{
		throw hException("hVarLinear<bool>::operator-","Dimensions don't match",hError);
	}
}
template <>
hVarBase* hVarLinear<bool>::operator*(const hVarBase* op2){
	unsigned long s1,s2;
	hVarLinear<bool> *top2;
	top2=(hVarLinear<bool> *)op2;
	s1=mem.size();
	s2=top2->mem.size();
	if(s1==s2){
		hVarLinear<unsigned long> *ret;
		ret=new hVarLinear<unsigned long>;
		ret->mem.reserve(s1);
		for(unsigned long i=0;i<s1;++i)
			ret->mem.push_back(mem[i]*top2->mem[i]);
		return ret;
	}else if(s1==1){
		bool constant;
		constant=mem[0];
		return constant+(*top2);
	}else if(s2==1){
		bool constant;
		constant=top2->mem[0];
		return *this+constant;
	}else{
		throw hException("hVarLinear<bool>::operator+","Dimensions don't match",hError);
	}
}
template <>
hVarBase* hVarLinear<bool>::operator/(const hVarBase* op2){
	unsigned long s1,s2;
	hVarLinear<bool> *top2;
	top2=(hVarLinear<bool> *)op2;
	s1=mem.size();
	s2=top2->mem.size();
	if(s1==s2){
		hVarLinear<unsigned long> *ret;
		ret=new hVarLinear<unsigned long>;
		ret->mem.reserve(s1);
		for(unsigned long i=0;i<s1;++i){
			if(!top2->mem[i]){
				delete ret;
				throw hException("hVarLinear<bool>::operator/","Division by zero",hError);
			}
			ret->mem.push_back(mem[i]*top2->mem[i]);
			ret->size=size;
		}
		return ret;
	}else if(s1==1){
		bool constant;
		constant=mem[0];
		return constant+(*top2);
	}else if(s2==1){
		bool constant;
		constant=top2->mem[0];
		return *this+constant;
	}else{
		throw hException("hVarLinear<bool>::operator+","Dimensions don't match",hError);
	}
}
template <>
hVarBase* hVarLinear<bool>::operator%(const hVarBase* op2){
	unsigned long s1,s2;
	hVarLinear<bool> *top2;
	top2=(hVarLinear<bool> *)op2;
	s1=mem.size();
	s2=top2->mem.size();
	if(s1==s2){
		hVarLinear<unsigned long> *ret;
		ret=new hVarLinear<unsigned long>;
		ret->mem.reserve(s1);
		for(unsigned long i=0;i<s1;++i){
			ret->mem.push_back(mem[i]%top2->mem[i]);
		}
		return ret;
	}else if(s1==1){
		bool constant;
		constant=mem[0];
		return constant%(*top2);
	}else if(s2==1){
		bool constant;
		constant=top2->mem[0];
		return *this%constant;
	}else{
		throw hException("hVarLinear<bool>::operator%","Dimensions don't match",hError);
	}
}
template <>
hVarBase* hVarLinear<unsigned char>::operator/(const hVarBase* op2){
	unsigned long s1,s2;
	hVarLinear<unsigned char> *top2;
	top2=(hVarLinear<unsigned char> *)op2;
	s1=mem.size();
	s2=top2->mem.size();
	if(s1==s2){
		hVarLinear<unsigned char> *ret;
		ret=new hVarLinear<unsigned char>;
		ret->mem.reserve(s1);
		for(unsigned long i=0;i<s1;++i){
			if(!top2->mem[i]){
				delete ret;
				throw hException("hVarLinear<unsigned char>::operator/","Division by zero",hError);
			}
			ret->mem.push_back(mem[i]/top2->mem[i]);
			ret->size=size;
		}
		return ret;
	}else if(s1==1){
		unsigned char constant;
		constant=mem[0];
		return constant/(*top2);
	}else if(s2==1){
		unsigned char constant;
		constant=top2->mem[0];
		return *this/constant;
	}else{
		throw hException("hVarLinear<unsigned char>::operator/","Dimensions don't match",hError);
	}
}
template <>
hVarBase* hVarLinear<signed char>::operator/(const hVarBase* op2){
	unsigned long s1,s2;
	hVarLinear<signed char> *top2;
	top2=(hVarLinear<signed char> *)op2;
	s1=mem.size();
	s2=top2->mem.size();
	if(s1==s2){
		hVarLinear<signed char> *ret;
		ret=new hVarLinear<signed char>;
		ret->mem.reserve(s1);
		for(unsigned long i=0;i<s1;++i){
			if(!top2->mem[i]){
				delete ret;
				throw hException("hVarLinear<signed char>::operator/","Division by zero",hError);
			}
			ret->mem.push_back(mem[i]/top2->mem[i]);
			ret->size=size;
		}
		return ret;
	}else if(s1==1){
		signed char constant;
		constant=mem[0];
		return constant/(*top2);
	}else if(s2==1){
		signed char constant;
		constant=top2->mem[0];
		return *this/constant;
	}else{
		throw hException("hVarLinear<signed char>::operator/","Dimensions don't match",hError);
	}
}
template <>
hVarBase* hVarLinear<unsigned short>::operator/(const hVarBase* op2){
	unsigned long s1,s2;
	hVarLinear<unsigned short> *top2;
	top2=(hVarLinear<unsigned short> *)op2;
	s1=mem.size();
	s2=top2->mem.size();
	if(s1==s2){
		hVarLinear<unsigned short> *ret;
		ret=new hVarLinear<unsigned short>;
		ret->mem.reserve(s1);
		for(unsigned long i=0;i<s1;++i){
			if(!top2->mem[i]){
				delete ret;
				throw hException("hVarLinear<unsigned short>::operator/","Division by zero",hError);
			}
			ret->mem.push_back(mem[i]/top2->mem[i]);
			ret->size=size;
		}
		return ret;
	}else if(s1==1){
		unsigned short constant;
		constant=mem[0];
		return constant/(*top2);
	}else if(s2==1){
		unsigned short constant;
		constant=top2->mem[0];
		return *this/constant;
	}else{
		throw hException("hVarLinear<unsigned short>::operator/","Dimensions don't match",hError);
	}
}
template <>
hVarBase* hVarLinear<signed short>::operator/(const hVarBase* op2){
	unsigned long s1,s2;
	hVarLinear<signed short> *top2;
	top2=(hVarLinear<signed short> *)op2;
	s1=mem.size();
	s2=top2->mem.size();
	if(s1==s2){
		hVarLinear<signed short> *ret;
		ret=new hVarLinear<signed short>;
		ret->mem.reserve(s1);
		for(unsigned long i=0;i<s1;++i){
			if(!top2->mem[i]){
				delete ret;
				throw hException("hVarLinear<signed short>::operator/","Division by zero",hError);
			}
			ret->mem.push_back(mem[i]/top2->mem[i]);
			ret->size=size;
		}
		return ret;
	}else if(s1==1){
		signed short constant;
		constant=mem[0];
		return constant/(*top2);
	}else if(s2==1){
		signed short constant;
		constant=top2->mem[0];
		return *this/constant;
	}else{
		throw hException("hVarLinear<signed short>::operator/","Dimensions don't match",hError);
	}
}
template <>
hVarBase* hVarLinear<unsigned long>::operator/(const hVarBase* op2){
	unsigned long s1,s2;
	hVarLinear<unsigned long> *top2;
	top2=(hVarLinear<unsigned long> *)op2;
	s1=mem.size();
	s2=top2->mem.size();
	if(s1==s2){
		hVarLinear<unsigned long> *ret;
		ret=new hVarLinear<unsigned long>;
		ret->mem.reserve(s1);
		for(unsigned long i=0;i<s1;++i){
			if(!top2->mem[i]){
				delete ret;
				throw hException("hVarLinear<unsigned short>::operator/","Division by zero",hError);
			}
			ret->mem.push_back(mem[i]/top2->mem[i]);
			ret->size=size;
		}
		return ret;
	}else if(s1==1){
		unsigned long constant;
		constant=mem[0];
		return constant/(*top2);
	}else if(s2==1){
		unsigned long constant;
		constant=top2->mem[0];
		return *this/constant;
	}else{
		throw hException("hVarLinear<unsigned short>::operator/","Dimensions don't match",hError);
	}
}
template <>
hVarBase* hVarLinear<signed long>::operator/(const hVarBase* op2){
	unsigned long s1,s2;
	hVarLinear<signed long> *top2;
	top2=(hVarLinear<signed long> *)op2;
	s1=mem.size();
	s2=top2->mem.size();
	if(s1==s2){
		hVarLinear<signed long> *ret;
		ret=new hVarLinear<signed long>;
		ret->mem.reserve(s1);
		for(unsigned long i=0;i<s1;++i){
			if(!top2->mem[i]){
				delete ret;
				throw hException("hVarLinear<signed short>::operator/","Division by zero",hError);
			}
			ret->mem.push_back(mem[i]/top2->mem[i]);
			ret->size=size;
		}
		return ret;
	}else if(s1==1){
		signed long constant;
		constant=mem[0];
		return constant/(*top2);
	}else if(s2==1){
		signed long constant;
		constant=top2->mem[0];
		return *this/constant;
	}else{
		throw hException("hVarLinear<signed short>::operator/","Dimensions don't match",hError);
	}
}
template <>
hVarBase* hVarLinear<float>::operator~(void){
	throw hException("hVarLinear<float>::operator~","Operator `~' doesn't exist for floating point variables",hError);
}
template <>
hVarBase* hVarLinear<float>::operator%(const hVarBase* op2){
	throw hException("hVarLinear<float>::operator%","Operator `%' doesn't exist for floating point variables",hError);
}
template <>
hVarBase* hVarLinear<float>::operator&&(const hVarBase* op2){
	throw hException("hVarLinear<float>::operator&&","Operator `&&' doesn't exist for floating point variables",hError);
}
template <>
hVarBase* hVarLinear<float>::operator||(const hVarBase* op2){
	throw hException("hVarLinear<float>::operator||","Operator `||' doesn't exist for floating point variables",hError);
}
template <>
hVarBase* hVarLinear<float>::operator<<(const hVarBase* op2){
	throw hException("hVarLinear<float>::operator<<","Operator `<<' doesn't exist for floating point variables",hError);
}
template <>
hVarBase* hVarLinear<float>::operator>>(const hVarBase* op2){
	throw hException("hVarLinear<float>::operator>>","Operator `>>' doesn't exist for floating point variables",hError);
}
template <>
hVarBase* hVarLinear<float>::operator|(const hVarBase* op2){
	throw hException("hVarLinear<float>::operator|","Operator `|' doesn't exist for floating point variables",hError);
}
template <>
hVarBase* hVarLinear<float>::operator&(const hVarBase* op2){
	throw hException("hVarLinear<float>::operator&","Operator `&' doesn't exist for floating point variables",hError);
}
template <>
hVarBase* hVarLinear<float>::operator^(const hVarBase* op2){
	throw hException("hVarLinear<float>::operator^","Operator `^' doesn't exist for floating point variables",hError);
}
template <>
hVarBase* hVarLinear<double>::operator~(void){
	throw hException("hVarLinear<double>::operator~","Operator `~' doesn't exist for floating point variables",hError);
}
template <>
hVarBase* hVarLinear<double>::operator%(const hVarBase* op2){
	throw hException("hVarLinear<double>::operator%","Operator `%' doesn't exist for floating point variables",hError);
}
template <>
hVarBase* hVarLinear<double>::operator&&(const hVarBase* op2){
	throw hException("hVarLinear<double>::operator&&","Operator `&&' doesn't exist for floating point variables",hError);
}
template <>
hVarBase* hVarLinear<double>::operator||(const hVarBase* op2){
	throw hException("hVarLinear<double>::operator||","Operator `||' doesn't exist for floating point variables",hError);
}
template <>
hVarBase* hVarLinear<double>::operator<<(const hVarBase* op2){
	throw hException("hVarLinear<double>::operator<<","Operator `<<' doesn't exist for floating point variables",hError);
}
template <>
hVarBase* hVarLinear<double>::operator>>(const hVarBase* op2){
	throw hException("hVarLinear<double>::operator>>","Operator `>>' doesn't exist for floating point variables",hError);
}
template <>
hVarBase* hVarLinear<double>::operator|(const hVarBase* op2){
	throw hException("hVarLinear<double>::operator|","Operator `|' doesn't exist for floating point variables",hError);
}
template <>
hVarBase* hVarLinear<double>::operator&(const hVarBase* op2){
	throw hException("hVarLinear<double>::operator&","Operator `&' doesn't exist for floating point variables",hError);
}
template <>
hVarBase* hVarLinear<double>::operator^(const hVarBase* op2){
	throw hException("hVarLinear<double>::operator^","Operator `^' doesn't exist for floating point variables",hError);
}
template <>
hVarBase* hVarLinear<long double>::operator~(void){
	throw hException("hVarLinear<long double>::operator~","Operator `~' doesn't exist for floating point variables",hError);
}
template <>
hVarBase* hVarLinear<long double>::operator%(const hVarBase* op2){
	throw hException("hVarLinear<long double>::operator%","Operator `%' doesn't exist for floating point variables",hError);
}
template <>
hVarBase* hVarLinear<long double>::operator&&(const hVarBase* op2){
	throw hException("hVarLinear<long double>::operator&&","Operator `&&' doesn't exist for floating point variables",hError);
}
template <>
hVarBase* hVarLinear<long double>::operator||(const hVarBase* op2){
	throw hException("hVarLinear<long double>::operator||","Operator `||' doesn't exist for floating point variables",hError);
}
template <>
hVarBase* hVarLinear<long double>::operator<<(const hVarBase* op2){
	throw hException("hVarLinear<long double>::operator<<","Operator `<<' doesn't exist for floating point variables",hError);
}
template <>
hVarBase* hVarLinear<long double>::operator>>(const hVarBase* op2){
	throw hException("hVarLinear<long double>::operator>>","Operator `>>' doesn't exist for floating point variables",hError);
}
template <>
hVarBase* hVarLinear<long double>::operator|(const hVarBase* op2){
	throw hException("hVarLinear<long double>::operator|","Operator `|' doesn't exist for floating point variables",hError);
}
template <>
hVarBase* hVarLinear<long double>::operator&(const hVarBase* op2){
	throw hException("hVarLinear<long double>::operator&","Operator `&' doesn't exist for floating point variables",hError);
}
template <>
hVarBase* hVarLinear<long double>::operator^(const hVarBase* op2){
	throw hException("hVarLinear<long double>::operator^","Operator `^' doesn't exist for floating point variables",hError);
}
template <>
hVarBase* hVarLinear<std::complex<float> >::operator~(void){
	throw hException("hVarLinear<std::complex<float> >::operator~","Operator `~' doesn't exist for complex variables",hError);
}
template <>
hVarBase* hVarLinear<std::complex<float> >::operator%(const hVarBase *op2){
	throw hException("hVarLinear<std::complex<float> >::operator%","Operator `%' doesn't exist for complex variables",hError);
}
template <>
hVarBase* hVarLinear<std::complex<float> >::operator<(const hVarBase *op2){
	throw hException("hVarLinear<std::complex<float> >::operator<","Operator `<' doesn't exist for complex variables",hError);
}
template <>
hVarBase* hVarLinear<std::complex<float> >::operator<=(const hVarBase *op2){
	throw hException("hVarLinear<std::complex<float> >::operator<=","Operator `<=' doesn't exist for complex variables",hError);
}
template <>
hVarBase* hVarLinear<std::complex<float> >::operator>(const hVarBase *op2){
	throw hException("hVarLinear<std::complex<float> >::operator>","Operator `>' doesn't exist for complex variables",hError);
}
template <>
hVarBase* hVarLinear<std::complex<float> >::operator>=(const hVarBase *op2){
	throw hException("hVarLinear<std::complex<float> >::operator>=","Operator `>=' doesn't exist for complex variables",hError);
}
template <>
hVarBase* hVarLinear<std::complex<float> >::operator&&(const hVarBase *op2){
	throw hException("hVarLinear<std::complex<float> >::operator&&","Operator `&&' doesn't exist for complex variables",hError);
}
template <>
hVarBase* hVarLinear<std::complex<float> >::operator||(const hVarBase *op2){
	throw hException("hVarLinear<std::complex<float> >::operator||","Operator `||' doesn't exist for complex variables",hError);
}
template <>
hVarBase* hVarLinear<std::complex<float> >::operator&(const hVarBase *op2){
	throw hException("hVarLinear<std::complex<float> >::operator&","Operator `&' doesn't exist for complex variables",hError);
}
template <>
hVarBase* hVarLinear<std::complex<float> >::operator|(const hVarBase *op2){
	throw hException("hVarLinear<std::complex<float> >::operator|","Operator `|' doesn't exist for complex variables",hError);
}
template <>
hVarBase* hVarLinear<std::complex<float> >::operator^(const hVarBase *op2){
	throw hException("hVarLinear<std::complex<float> >::operator^","Operator `^' doesn't exist for complex variables",hError);
}
template <>
hVarBase* hVarLinear<std::complex<float> >::operator!(void){
	throw hException("hVarLinear<std::complex<float> >::operator!","Operator `!' doesn't exist for complex variables",hError);
}
template <>
hVarBase* hVarLinear<std::complex<float> >::operator<<(const hVarBase *op2){
	throw hException("hVarLinear<std::complex<float> >::operator<<","Operator `<<' doesn't exist for complex variables",hError);
}
template <>
hVarBase* hVarLinear<std::complex<float> >::operator>>(const hVarBase *op2){
	throw hException("hVarLinear<std::complex<float> >::operator>>","Operator `>>' doesn't exist for complex variables",hError);
}
template <>
hVarBase* hVarLinear<std::complex<double> >::operator~(void){
	throw hException("hVarLinear<std::complex<double> >::operator~","Operator `~' doesn't exist for complex variables",hError);
}
template <>
hVarBase* hVarLinear<std::complex<double> >::operator%(const hVarBase *op2){
	throw hException("hVarLinear<std::complex<double> >::operator%","Operator `%' doesn't exist for complex variables",hError);
}
template <>
hVarBase* hVarLinear<std::complex<double> >::operator<(const hVarBase *op2){
	throw hException("hVarLinear<std::complex<double> >::operator<","Operator `<' doesn't exist for complex variables",hError);
}
template <>
hVarBase* hVarLinear<std::complex<double> >::operator<=(const hVarBase *op2){
	throw hException("hVarLinear<std::complex<double> >::operator<=","Operator `<=' doesn't exist for complex variables",hError);
}
template <>
hVarBase* hVarLinear<std::complex<double> >::operator>(const hVarBase *op2){
	throw hException("hVarLinear<std::complex<double> >::operator>","Operator `>' doesn't exist for complex variables",hError);
}
template <>
hVarBase* hVarLinear<std::complex<double> >::operator>=(const hVarBase *op2){
	throw hException("hVarLinear<std::complex<double> >::operator>=","Operator `>=' doesn't exist for complex variables",hError);
}
template <>
hVarBase* hVarLinear<std::complex<double> >::operator&&(const hVarBase *op2){
	throw hException("hVarLinear<std::complex<double> >::operator&&","Operator `&&' doesn't exist for complex variables",hError);
}
template <>
hVarBase* hVarLinear<std::complex<double> >::operator||(const hVarBase *op2){
	throw hException("hVarLinear<std::complex<double> >::operator||","Operator `||' doesn't exist for complex variables",hError);
}
template <>
hVarBase* hVarLinear<std::complex<double> >::operator&(const hVarBase *op2){
	throw hException("hVarLinear<std::complex<double> >::operator&","Operator `&' doesn't exist for complex variables",hError);
}
template <>
hVarBase* hVarLinear<std::complex<double> >::operator|(const hVarBase *op2){
	throw hException("hVarLinear<std::complex<double> >::operator|","Operator `|' doesn't exist for complex variables",hError);
}
template <>
hVarBase* hVarLinear<std::complex<double> >::operator^(const hVarBase *op2){
	throw hException("hVarLinear<std::complex<double> >::operator^","Operator `^' doesn't exist for complex variables",hError);
}
template <>
hVarBase* hVarLinear<std::complex<double> >::operator!(void){
	throw hException("hVarLinear<std::complex<double> >::operator!","Operator `!' doesn't exist for complex variables",hError);
}
template <>
hVarBase* hVarLinear<std::complex<double> >::operator<<(const hVarBase *op2){
	throw hException("hVarLinear<std::complex<double> >::operator<<","Operator `<<' doesn't exist for complex variables",hError);
}
template <>
hVarBase* hVarLinear<std::complex<double> >::operator>>(const hVarBase *op2){
	throw hException("hVarLinear<std::complex<double> >::operator>>","Operator `>>' doesn't exist for complex variables",hError);
}
template <>
hVarBase* hVarLinear<std::complex<long double> >::operator~(void){
	throw hException("hVarLinear<std::complex<long double> >::operator~","Operator `~' doesn't exist for complex variables",hError);
}
template <>
hVarBase* hVarLinear<std::complex<long double> >::operator%(const hVarBase *op2){
	throw hException("hVarLinear<std::complex<long double> >::operator%","Operator `%' doesn't exist for complex variables",hError);
}
template <>
hVarBase* hVarLinear<std::complex<long double> >::operator<(const hVarBase *op2){
	throw hException("hVarLinear<std::complex<long double> >::operator<","Operator `<' doesn't exist for complex variables",hError);
}
template <>
hVarBase* hVarLinear<std::complex<long double> >::operator<=(const hVarBase *op2){
	throw hException("hVarLinear<std::complex<long double> >::operator<=","Operator `<=' doesn't exist for complex variables",hError);
}
template <>
hVarBase* hVarLinear<std::complex<long double> >::operator>(const hVarBase *op2){
	throw hException("hVarLinear<std::complex<long double> >::operator>","Operator `>' doesn't exist for complex variables",hError);
}
template <>
hVarBase* hVarLinear<std::complex<long double> >::operator>=(const hVarBase *op2){
	throw hException("hVarLinear<std::complex<long double> >::operator>=","Operator `>=' doesn't exist for complex variables",hError);
}
template <>
hVarBase* hVarLinear<std::complex<long double> >::operator&&(const hVarBase *op2){
	throw hException("hVarLinear<std::complex<long double> >::operator&&","Operator `&&' doesn't exist for complex variables",hError);
}
template <>
hVarBase* hVarLinear<std::complex<long double> >::operator||(const hVarBase *op2){
	throw hException("hVarLinear<std::complex<long double> >::operator||","Operator `||' doesn't exist for complex variables",hError);
}
template <>
hVarBase* hVarLinear<std::complex<long double> >::operator&(const hVarBase *op2){
	throw hException("hVarLinear<std::complex<long double> >::operator&","Operator `&' doesn't exist for complex variables",hError);
}
template <>
hVarBase* hVarLinear<std::complex<long double> >::operator|(const hVarBase *op2){
	throw hException("hVarLinear<std::complex<long double> >::operator|","Operator `|' doesn't exist for complex variables",hError);
}
template <>
hVarBase* hVarLinear<std::complex<long double> >::operator^(const hVarBase *op2){
	throw hException("hVarLinear<std::complex<long double> >::operator^","Operator `^' doesn't exist for complex variables",hError);
}
template <>
hVarBase* hVarLinear<std::complex<long double> >::operator!(void){
	throw hException("hVarLinear<std::complex<long double> >::operator!","Operator `!' doesn't exist for complex variables",hError);
}
template <>
hVarBase* hVarLinear<std::complex<long double> >::operator<<(const hVarBase *op2){
	throw hException("hVarLinear<std::complex<long double> >::operator<<","Operator `<<' doesn't exist for complex variables",hError);
}
template <>
hVarBase* hVarLinear<std::complex<long double> >::operator>>(const hVarBase *op2){
	throw hException("hVarLinear<std::complex<long double> >::operator>>","Operator `>>' doesn't exist for complex variables",hError);
}
template <class dataType>
hVarBase* hVarLinear<dataType>::operator+(const hVarBase* op2){
	unsigned long s1,s2;
	hVarLinear<dataType> *top2;
	top2=(hVarLinear<dataType> *)op2;
	s1=mem.size();
	s2=top2->mem.size();
	if(s1==s2){
		hVarLinear<dataType> *ret;
		ret=new hVarLinear<dataType>;
		ret->mem.reserve(s1);
		for(unsigned long i=0;i<s1;++i)
			ret->mem.push_back(mem[i]+top2->mem[i]);
		ret->size=size;
		return ret;
	}else if(s1==1){
		dataType constant;
		constant=mem[0];
		return constant+(*top2);
	}else if(s2==1){
		dataType constant;
		constant=top2->mem[0];
		return *this+constant;
	}else{
		throw hException("hVarLinear<dataType>::operator+","Dimensions don't match",hError);
	}
}
template <class dataType>
hVarBase* hVarLinear<dataType>::operator-(const hVarBase* op2){
	unsigned long s1,s2;
	hVarLinear<dataType> *top2;
	top2=(hVarLinear<dataType> *)op2;
	s1=mem.size();
	s2=top2->mem.size();
	if(s1==s2){
		hVarLinear<dataType> *ret;
		ret=new hVarLinear<dataType>;
		ret->mem.reserve(s1);
		for(unsigned long i=0;i<s1;++i)
			ret->mem.push_back(mem[i]-top2->mem[i]);
		ret->size=size;
		return ret;
	}else if(s1==1){
		dataType constant;
		constant=mem[0];
		return constant-(*top2);
	}else if(s2==1){
		dataType constant;
		constant=top2->mem[0];
		return *this-constant;
	}else{
		throw hException("hVarLinear<dataType>::operator-","Dimensions don't match",hError);
	}
}
template <class dataType>
hVarBase* hVarLinear<dataType>::operator*(const hVarBase* op2){
	unsigned long s1,s2;
	hVarLinear<dataType> *top2;
	top2=(hVarLinear<dataType> *)op2;
	s1=mem.size();
	s2=top2->mem.size();
	if(s1==s2){
		hVarLinear<dataType> *ret;
		ret=new hVarLinear<dataType>;
		ret->mem.reserve(s1);
		for(unsigned long i=0;i<s1;++i)
			ret->mem.push_back(mem[i]*top2->mem[i]);
		ret->size=size;
		return ret;
	}else if(s1==1){
		dataType constant;
		constant=mem[0];
		return constant*(*top2);
	}else if(s2==1){
		dataType constant;
		constant=top2->mem[0];
		return *this*constant;
	}else{
		throw hException("hVarLinear<dataType>::operator*","Dimensions don't match",hError);
	}
}
template <class dataType>
hVarBase* hVarLinear<dataType>::operator/(const hVarBase* op2){
	unsigned long s1,s2;
	hVarLinear<dataType> *top2;
	top2=(hVarLinear<dataType> *)op2;
	s1=mem.size();
	s2=top2->mem.size();
	if(s1==s2){
		hVarLinear<dataType> *ret;
		ret=new hVarLinear<dataType>;
		ret->mem.reserve(s1);
		for(unsigned long i=0;i<s1;++i)
			ret->mem.push_back(mem[i]/top2->mem[i]);
		ret->size=size;
		return ret;
	}else if(s1==1){
		dataType constant;
		constant=mem[0];
		return constant/(*top2);
	}else if(s2==1){
		dataType constant;
		constant=top2->mem[0];
		return *this/constant;
	}else{
		throw hException("hVarLinear<dataType>::operator/","Dimensions don't match",hError);
	}
}
template <class dataType>
hVarBase* hVarLinear<dataType>::operator%(const hVarBase* op2){
	unsigned long s1,s2;
	hVarLinear<dataType> *top2;
	top2=(hVarLinear<dataType> *)op2;
	s1=mem.size();
	s2=top2->mem.size();
	if(s1==s2){
		hVarLinear<dataType> *ret;
		ret=new hVarLinear<dataType>;
		ret->mem.reserve(s1);
		for(unsigned long i=0;i<s1;++i)
			ret->mem.push_back(mem[i]%top2->mem[i]);
		ret->size=size;
		return ret;
	}else if(s1==1){
		dataType constant;
		constant=mem[0];
		return constant%(*top2);
	}else if(s2==1){
		dataType constant;
		constant=top2->mem[0];
		return *this%constant;
	}else{
		throw hException("hVarLinear<dataType>::operator%","Dimensions don't match",hError);
	}
}
template <class dataType>
hVarBase* hVarLinear<dataType>::operator=(const hVarBase* op2){
	unsigned long s1,s2;
	hVarLinear<dataType> *top2;
	top2=(hVarLinear<dataType> *)op2;
	s1=mem.size();
	s2=top2->mem.size();
	if(s1==s2){
		for(unsigned long i=0;i<s1;++i)
			mem[i]=top2->mem[i];
		return this;
	}else{
		throw hException("hVarLinear<dataType>::operator=","Dimensions don't match",hError);
	}
}
template <class dataType>
hVarBase* hVarLinear<dataType>::operator<(const hVarBase* op2){
	unsigned long s1,s2;
	hVarLinear<dataType> *top2;
	top2=(hVarLinear<dataType> *)op2;
	s1=mem.size();
	s2=top2->mem.size();
	if(s1==s2){
		hVarLinear<bool> *ret;
		ret=new hVarLinear<bool>;
		ret->mem.reserve(s1);
		for(unsigned long i=0;i<s1;++i)
			ret->mem.push_back(mem[i]<top2->mem[i]);
		ret->size=size;
		return ret;
	}else if(s1==1){
		dataType constant;
		constant=mem[0];
		return constant<(*top2);
	}else if(s2==1){
		dataType constant;
		constant=top2->mem[0];
		return *this<constant;
	}else{
		throw hException("hVarLinear<dataType>::operator<","Dimensions don't match",hError);
	}
}
template <class dataType>
hVarBase* hVarLinear<dataType>::operator>(const hVarBase* op2){
	unsigned long s1,s2;
	hVarLinear<dataType> *top2;
	top2=(hVarLinear<dataType> *)op2;
	s1=mem.size();
	s2=top2->mem.size();
	if(s1==s2){
		hVarLinear<bool> *ret;
		ret=new hVarLinear<bool>;
		ret->mem.reserve(s1);
		for(unsigned long i=0;i<s1;++i)
			ret->mem.push_back(mem[i]>top2->mem[i]);
		ret->size=size;
		return ret;
	}else if(s1==1){
		dataType constant;
		constant=mem[0];
		return constant>(*top2);
	}else if(s2==1){
		dataType constant;
		constant=top2->mem[0];
		return *this>constant;
	}else{
		throw hException("hVarLinear<dataType>::operator>","Dimensions don't match",hError);
	}
}
template <class dataType>
hVarBase* hVarLinear<dataType>::operator<=(const hVarBase* op2){
	unsigned long s1,s2;
	hVarLinear<dataType> *top2;
	top2=(hVarLinear<dataType> *)op2;
	s1=mem.size();
	s2=top2->mem.size();
	if(s1==s2){
		hVarLinear<bool> *ret;
		ret=new hVarLinear<bool>;
		ret->mem.reserve(s1);
		for(unsigned long i=0;i<s1;++i)
			ret->mem.push_back(mem[i]<=top2->mem[i]);
		ret->size=size;
		return ret;
	}else if(s1==1){
		dataType constant;
		constant=mem[0];
		return constant<=(*top2);
	}else if(s2==1){
		dataType constant;
		constant=top2->mem[0];
		return *this<=constant;
	}else{
		throw hException("hVarLinear<dataType>::operator<=","Dimensions don't match",hError);
	}
}
template <class dataType>
hVarBase* hVarLinear<dataType>::operator>=(const hVarBase* op2){
	unsigned long s1,s2;
	hVarLinear<dataType> *top2;
	top2=(hVarLinear<dataType> *)op2;
	s1=mem.size();
	s2=top2->mem.size();
	if(s1==s2){
		hVarLinear<bool> *ret;
		ret=new hVarLinear<bool>;
		ret->mem.reserve(s1);
		for(unsigned long i=0;i<s1;++i)
			ret->mem.push_back(mem[i]>=top2->mem[i]);
		ret->size=size;
		return ret;
	}else if(s1==1){
		dataType constant;
		constant=mem[0];
		return constant>=(*top2);
	}else if(s2==1){
		dataType constant;
		constant=top2->mem[0];
		return *this>=constant;
	}else{
		throw hException("hVarLinear<dataType>::operator>=","Dimensions don't match",hError);
	}
}

template <class dataType>
hVarBase* hVarLinear<dataType>::operator!(void){
	unsigned long s1;
	s1=mem.size();
	hVarLinear<bool> *ret;
	ret=new hVarLinear<bool>;
	ret->mem.reserve(s1);
	for(unsigned long i=0;i<s1;++i)
		ret->mem.push_back(!mem[i]);
		ret->size=size;
		return ret;
}
template <class dataType>
hVarBase* hVarLinear<dataType>::operator&&(const hVarBase* op2){
	unsigned long s1,s2;
	hVarLinear<dataType> *top2;
	top2=(hVarLinear<dataType> *)op2;
	s1=mem.size();
	s2=top2->mem.size();
	if(s1==s2){
		hVarLinear<bool> *ret;
		ret=new hVarLinear<bool>;
		ret->mem.reserve(s1);
		for(unsigned long i=0;i<s1;++i)
			ret->mem.push_back(mem[i]&&top2->mem[i]);
		ret->size=size;
		return ret;
	}else if(s1==1){
		dataType constant;
		constant=mem[0];
		return constant&&(*top2);
	}else if(s2==1){
		dataType constant;
		constant=top2->mem[0];
		return *this&&constant;
	}else{
		throw hException("hVarLinear<dataType>::operator&&","Dimensions don't match",hError);
	}
}
template <class dataType>
hVarBase* hVarLinear<dataType>::operator||(const hVarBase* op2){
	unsigned long s1,s2;
	hVarLinear<dataType> *top2;
	top2=(hVarLinear<dataType> *)op2;
	s1=mem.size();
	s2=top2->mem.size();
	if(s1==s2){
		hVarLinear<bool> *ret;
		ret=new hVarLinear<bool>;
		ret->mem.reserve(s1);
		for(unsigned long i=0;i<s1;++i)
			ret->mem.push_back(mem[i]||top2->mem[i]);
		ret->size=size;
		return ret;
	}else if(s1==1){
		dataType constant;
		constant=mem[0];
		return constant||(*top2);
	}else if(s2==1){
		dataType constant;
		constant=top2->mem[0];
		return *this||constant;
	}else{
		throw hException("hVarLinear<dataType>::operator||","Dimensions don't match",hError);
	}
}
template <class dataType>
hVarBase* hVarLinear<dataType>::operator==(const hVarBase* op2){
	unsigned long s1,s2;
	hVarLinear<dataType> *top2;
	top2=(hVarLinear<dataType> *)op2;
	s1=mem.size();
	s2=top2->mem.size();
	if(s1==s2){
		hVarLinear<bool> *ret;
		ret=new hVarLinear<bool>;
		ret->mem.reserve(s1);
		for(unsigned long i=0;i<s1;++i)
			ret->mem.push_back(mem[i]==top2->mem[i]);
		ret->size=size;
		return ret;
	}else if(s1==1){
		dataType constant;
		constant=mem[0];
		return constant==(*top2);
	}else if(s2==1){
		dataType constant;
		constant=top2->mem[0];
		return *this==constant;
	}else{
		throw hException("hVarLinear<dataType>::operator==","Dimensions don't match",hError);
	}
}
template <class dataType>
hVarBase* hVarLinear<dataType>::operator!=(const hVarBase* op2){
	unsigned long s1,s2;
	hVarLinear<dataType> *top2;
	top2=(hVarLinear<dataType> *)op2;
	s1=mem.size();
	s2=top2->mem.size();
	if(s1==s2){
		hVarLinear<bool> *ret;
		ret=new hVarLinear<bool>;
		ret->mem.reserve(s1);
		for(unsigned long i=0;i<s1;++i)
			ret->mem.push_back(mem[i]!=top2->mem[i]);
		ret->size=size;
		return ret;
	}else if(s1==1){
		dataType constant;
		constant=mem[0];
		return constant!=(*top2);
	}else if(s2==1){
		dataType constant;
		constant=top2->mem[0];
		return *this!=constant;
	}else{
		throw hException("hVarLinear<dataType>::operator!=","Dimensions don't match",hError);
	}
}

template <class dataType>
hVarBase* hVarLinear<dataType>::operator~(void){
	unsigned long s1;
	s1=mem.size();
	hVarLinear<dataType> *ret;
	ret=new hVarLinear<dataType>;
	ret->mem.reserve(s1);
	for(unsigned long i=0;i<s1;++i)
		ret->mem.push_back(~mem[i]);
	ret->size=size;
	return ret;
}

template <class dataType>
hVarBase* hVarLinear<dataType>::operator<<(const hVarBase* op2){
	unsigned long s1,s2;
	hVarLinear<dataType> *top2;
	top2=(hVarLinear<dataType> *)op2;
	s1=mem.size();
	s2=top2->mem.size();
	if(s1==s2){
		hVarLinear<dataType> *ret;
		ret=new hVarLinear<dataType>;
		ret->mem.reserve(s1);
		for(unsigned long i=0;i<s1;++i)
			ret->mem.push_back(mem[i]<<top2->mem[i]);
		ret->size=size;
		return ret;
	}else if(s1==1){
		dataType constant;
		constant=mem[0];
		return constant<<(*top2);
	}else if(s2==1){
		dataType constant;
		constant=top2->mem[0];
		return *this<<constant;
	}else{
		throw hException("hVarLinear<dataType>::operator<<","Dimensions don't match",hError);
	}
}
template <class dataType>
hVarBase* hVarLinear<dataType>::operator>>(const hVarBase* op2){
	unsigned long s1,s2;
	hVarLinear<dataType> *top2;
	top2=(hVarLinear<dataType> *)op2;
	s1=mem.size();
	s2=top2->mem.size();
	if(s1==s2){
		hVarLinear<dataType> *ret;
		ret=new hVarLinear<dataType>;
		ret->mem.reserve(s1);
		for(unsigned long i=0;i<s1;++i)
			ret->mem.push_back(mem[i]>>top2->mem[i]);
		ret->size=size;
		return ret;
	}else if(s1==1){
		dataType constant;
		constant=mem[0];
		return constant>>(*top2);
	}else if(s2==1){
		dataType constant;
		constant=top2->mem[0];
		return *this>>constant;
	}else{
		throw hException("hVarLinear<dataType>::operator>>","Dimensions don't match",hError);
	}
}
template <class dataType>
hVarBase* hVarLinear<dataType>::operator&(const hVarBase* op2){
	unsigned long s1,s2;
	hVarLinear<dataType> *top2;
	top2=(hVarLinear<dataType> *)op2;
	s1=mem.size();
	s2=top2->mem.size();
	if(s1==s2){
		hVarLinear<dataType> *ret;
		ret=new hVarLinear<dataType>;
		ret->mem.reserve(s1);
		for(unsigned long i=0;i<s1;++i)
			ret->mem.push_back(mem[i]&top2->mem[i]);
		ret->size=size;
		return ret;
	}else if(s1==1){
		dataType constant;
		constant=mem[0];
		return constant&(*top2);
	}else if(s2==1){
		dataType constant;
		constant=top2->mem[0];
		return *this&constant;
	}else{
		throw hException("hVarLinear<dataType>::operator&","Dimensions don't match",hError);
	}
}
template <class dataType>
hVarBase* hVarLinear<dataType>::operator|(const hVarBase* op2){
	unsigned long s1,s2;
	hVarLinear<dataType> *top2;
	top2=(hVarLinear<dataType> *)op2;
	s1=mem.size();
	s2=top2->mem.size();
	if(s1==s2){
		hVarLinear<dataType> *ret;
		ret=new hVarLinear<dataType>;
		ret->mem.reserve(s1);
		for(unsigned long i=0;i<s1;++i)
			ret->mem.push_back(mem[i]|top2->mem[i]);
		ret->size=size;
		return ret;
	}else if(s1==1){
		dataType constant;
		constant=mem[0];
		return constant|(*top2);
	}else if(s2==1){
		dataType constant;
		constant=top2->mem[0];
		return *this|constant;
	}else{
		throw hException("hVarLinear<dataType>::operator|","Dimensions don't match",hError);
	}
}
template <class dataType>
hVarBase* hVarLinear<dataType>::operator^(const hVarBase* op2){
	unsigned long s1,s2;
	hVarLinear<dataType> *top2;
	top2=(hVarLinear<dataType> *)op2;
	s1=mem.size();
	s2=top2->mem.size();
	if(s1==s2){
		hVarLinear<dataType> *ret;
		ret=new hVarLinear<dataType>;
		ret->mem.reserve(s1);
		for(unsigned long i=0;i<s1;++i)
			ret->mem.push_back(mem[i]^top2->mem[i]);
		ret->size=size;
		return ret;
	}else if(s1==1){
		dataType constant;
		constant=mem[0];
		return constant^(*top2);
	}else if(s2==1){
		dataType constant;
		constant=top2->mem[0];
		return *this^constant;
	}else{
		throw hException("hVarLinear<dataType>::operator^","Dimensions don't match",hError);
	}
}

template <>
hVarBase* hVarLinear<bool>::operator++(void){
	throw hException("hVarLinear<bool>::operator++(void)","Operator ++ doesn't exist for boolean variables",hError);
}
template <>
hVarBase* hVarLinear<std::complex<float> >::operator++(void){
	throw hException("hVarLinear<std::complex<float> >::operator++(void)","Operator ++ doesn't exist for complex variables",hError);
}
template <>
hVarBase* hVarLinear<std::complex<double> >::operator++(void){
	throw hException("hVarLinear<std::complex<double> >::operator++(void)","Operator ++ doesn't exist for complex variables",hError);
}
template <>
hVarBase* hVarLinear<std::complex<long double> >::operator++(void){
	throw hException("hVarLinear<std::complex<long double> >::operator++(void)","Operator ++ doesn't exist for complex variables",hError);
}
template <class dataType>
hVarBase* hVarLinear<dataType>::operator++(void){
	unsigned int s;
	s=mem.size();
	for(unsigned int i=0;i<s;++i)
		mem[i]++;
	return this;
}//++a
template <>
hVarBase* hVarLinear<bool>::operator--(void){
	throw hException("hVarLinear<bool>::operator--(void)","Operator -- doesn't exist for boolean variables",hError);
}
template <>
hVarBase* hVarLinear<std::complex<float> >::operator--(void){
	throw hException("hVarLinear<std::complex<float> >::operator--(void)","Operator -- doesn't exist for complex variables",hError);
}
template <>
hVarBase* hVarLinear<std::complex<double> >::operator--(void){
	throw hException("hVarLinear<std::complex<double> >::operator--(void)","Operator -- doesn't exist for complex variables",hError);
}
template <>
hVarBase* hVarLinear<std::complex<long double> >::operator--(void){
	throw hException("hVarLinear<std::complex<long double> >::operator--(void)","Operator -- doesn't exist for complex variables",hError);
}
template <class dataType>
hVarBase* hVarLinear<dataType>::operator--(void){
	unsigned int s;
	s=mem.size();
	for(unsigned int i=0;i<s;++i)
		mem[i]--;
	return this;
}//--a



template <class dataType>
hVarBase* hVarLinear<dataType>::operator[](unsigned int index){
}
template <class dataType>
hVarBase* hVarLinear<dataType>::operator[](hVarBase* index){
}

template <class dataType>
hVarBase* hVarLinear<dataType>::operator()(const hVarBase* op2){
}
template <class dataType>
hVarBase* hVarLinear<dataType>::operator,(const hVarBase* op2){
}

template <class dataType>
hVarBase * hVarLinear<dataType>::matrixMul(hVarBase *B){
	std::vector<unsigned int> s1=size;
	std::vector<unsigned int> s2=B->getSize();
	if(s1.size()!=2)
		throw hException("","1",hError);
	if(s2.size()!=2)
		throw hException("","2",hError);
	unsigned long N,M,K;
	M=s1[1];
	if(M!=s2[0])
		throw hException("","3",hError);
	N=s1[0];
	K=s2[1];
	hVarLinear<dataType> *ret=new hVarLinear<dataType>;
	ret->size.push_back(N);
	ret->size.push_back(K);
	unsigned long i,j,k;
	dataType S;
	hVarLinear *top=(hVarLinear<dataType> *)B;
//	std::vector<dataType> temp=top->mem;
	for(i=0;i<N;++i){
		unsigned long const1=i*M;
		for(j=0;j<K;++j){
			S=0;
			for(k=0;k<M;++k){
				S+=mem[const1+k]*top->mem[k*K+j];
			}
			ret->mem.push_back(S);
		}
	}
	return ret;
}

template <class dataType>
void hVarLinear<dataType>::print(std::ostream& output){
	using namespace std;
	signed long level,dimensions,i,j;
	if(mem.size()>200) throw hException("hVarLinear::print","Printing these many elements will take a very long time",hError);
	output<<"\n";
	vector<unsigned int> index;
	dimensions=size.size();
	for(i=0;i<size.size();++i){
		index.push_back(0);
	}
	level=0;
	do{
		if((dimensions-level)==1){
			output<<std::endl<<'\t';
			for(i=0;i<size[level];++i){
				index[level]=i;
				output<<mem[findIndex(index)]<<'\t';
			}
			output<<endl;
			level--;
			if(level>=0)
				index[level]++;
		}else if((dimensions-level)==2){
			for(i=0;i<size[level];++i){
				index[level]=i;
				output<<'\t';
				for(j=0;j<size[level+1];++j){
					index[level+1]=j;
					output<<mem[findIndex(index)]<<'\t';
				}
				output<<endl;
			}
			level--;
			if(level>=0)
				index[level]++;
		}else{
			if(index[level]<size[level]){
				output<<"table: "<<index[level]<<endl;
				level++;
			}else
				level=-1;
		}
	}while(level>=0);
}

template <class dataType>
hVarBase* hVarLinear<dataType>::traverse(dataType (*function)(dataType)){
	hVarLinear *ret;
	ret=new hVarLinear<dataType>;
	unsigned long S=mem.size();
	for(unsigned long i=0;i<S;++i)
		ret->mem.push_back(function(mem[i]));
	ret->size=size;
	return ret;
}
			
			
//--------------
hVarBase* operator+(const bool &op1,const hVarLinear<bool> &op2){
	hVarLinear<signed long> *ret;
	ret=new hVarLinear<signed long>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1+op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator+(const unsigned char &op1,const hVarLinear<unsigned char> &op2){
	hVarLinear<unsigned char> *ret;
	ret=new hVarLinear<unsigned char>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1+op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator+(const signed char &op1,const hVarLinear<signed char> &op2){
	hVarLinear<signed char> *ret;
	ret=new hVarLinear<signed char>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1+op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator+(const unsigned short &op1,const hVarLinear<unsigned short> &op2){
	hVarLinear<unsigned short> *ret;
	ret=new hVarLinear<unsigned short>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1+op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator+(const signed short &op1,const hVarLinear<signed short> &op2){
	hVarLinear<signed short> *ret;
	ret=new hVarLinear<signed short>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1+op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator+(const unsigned long &op1,const hVarLinear<unsigned long> &op2){
	hVarLinear<unsigned long> *ret;
	ret=new hVarLinear<unsigned long>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1+op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator+(const signed long &op1,const hVarLinear<signed long> &op2){
	hVarLinear<signed long> *ret;
	ret=new hVarLinear<signed long>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1+op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator+(const float &op1,const hVarLinear<float> &op2){
	hVarLinear<float> *ret;
	ret=new hVarLinear<float>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1+op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator+(const double &op1,const hVarLinear<double> &op2){
	hVarLinear<double> *ret;
	ret=new hVarLinear<double>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1+op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator+(const long double &op1,const hVarLinear<long double> &op2){
	hVarLinear<long double> *ret;
	ret=new hVarLinear<long double>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1+op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator+(const std::complex<float> &op1,const hVarLinear<std::complex<float> > &op2){
	hVarLinear<std::complex<float> > *ret;
	ret=new hVarLinear<std::complex<float> >;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1+op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator+(const std::complex<double> &op1,const hVarLinear<std::complex<double> > &op2){
	hVarLinear<std::complex<double> > *ret;
	ret=new hVarLinear<std::complex<double> >;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1+op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator+(const std::complex<long double> &op1,const hVarLinear<std::complex<long double> > &op2){
	hVarLinear<std::complex<long double> > *ret;
	ret=new hVarLinear<std::complex<long double> >;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1+op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator-(const bool &op1,const hVarLinear<bool> &op2){
	hVarLinear<signed long> *ret;
	ret=new hVarLinear<signed long>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1-op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator-(const unsigned char &op1,const hVarLinear<unsigned char> &op2){
	hVarLinear<unsigned char> *ret;
	ret=new hVarLinear<unsigned char>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1-op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator-(const signed char &op1,const hVarLinear<signed char> &op2){
	hVarLinear<signed char> *ret;
	ret=new hVarLinear<signed char>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1-op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator-(const unsigned short &op1,const hVarLinear<unsigned short> &op2){
	hVarLinear<unsigned short> *ret;
	ret=new hVarLinear<unsigned short>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1-op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator-(const signed short &op1,const hVarLinear<signed short> &op2){
	hVarLinear<signed short> *ret;
	ret=new hVarLinear<signed short>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1-op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator-(const unsigned long &op1,const hVarLinear<unsigned long> &op2){
	hVarLinear<unsigned long> *ret;
	ret=new hVarLinear<unsigned long>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1-op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator-(const signed long &op1,const hVarLinear<signed long> &op2){
	hVarLinear<signed long> *ret;
	ret=new hVarLinear<signed long>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1-op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator-(const float &op1,const hVarLinear<float> &op2){
	hVarLinear<float> *ret;
	ret=new hVarLinear<float>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1-op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator-(const double &op1,const hVarLinear<double> &op2){
	hVarLinear<double> *ret;
	ret=new hVarLinear<double>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1-op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator-(const long double &op1,const hVarLinear<long double> &op2){
	hVarLinear<long double> *ret;
	ret=new hVarLinear<long double>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1-op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator-(const std::complex<float> &op1,const hVarLinear<std::complex<float> > &op2){
	hVarLinear<std::complex<float> > *ret;
	ret=new hVarLinear<std::complex<float> >;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1-op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator-(const std::complex<double> &op1,const hVarLinear<std::complex<double> > &op2){
	hVarLinear<std::complex<double> > *ret;
	ret=new hVarLinear<std::complex<double> >;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1-op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator-(const std::complex<long double> &op1,const hVarLinear<std::complex<long double> > &op2){
	hVarLinear<std::complex<long double> > *ret;
	ret=new hVarLinear<std::complex<long double> >;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1-op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator*(const bool &op1,const hVarLinear<bool> &op2){
	hVarLinear<signed long> *ret;
	ret=new hVarLinear<signed long>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1*op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator*(const unsigned char &op1,const hVarLinear<unsigned char> &op2){
	hVarLinear<unsigned char> *ret;
	ret=new hVarLinear<unsigned char>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1*op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator*(const signed char &op1,const hVarLinear<signed char> &op2){
	hVarLinear<signed char> *ret;
	ret=new hVarLinear<signed char>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1*op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator*(const unsigned short &op1,const hVarLinear<unsigned short> &op2){
	hVarLinear<unsigned short> *ret;
	ret=new hVarLinear<unsigned short>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1*op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator*(const signed short &op1,const hVarLinear<signed short> &op2){
	hVarLinear<signed short> *ret;
	ret=new hVarLinear<signed short>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1*op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator*(const unsigned long &op1,const hVarLinear<unsigned long> &op2){
	hVarLinear<unsigned long> *ret;
	ret=new hVarLinear<unsigned long>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1*op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator*(const signed long &op1,const hVarLinear<signed long> &op2){
	hVarLinear<signed long> *ret;
	ret=new hVarLinear<signed long>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1*op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator*(const float &op1,const hVarLinear<float> &op2){
	hVarLinear<float> *ret;
	ret=new hVarLinear<float>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1*op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator*(const double &op1,const hVarLinear<double> &op2){
	hVarLinear<double> *ret;
	ret=new hVarLinear<double>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1*op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator*(const long double &op1,const hVarLinear<long double> &op2){
	hVarLinear<long double> *ret;
	ret=new hVarLinear<long double>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1*op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator*(const std::complex<float> &op1,const hVarLinear<std::complex<float> > &op2){
	hVarLinear<std::complex<float> > *ret;
	ret=new hVarLinear<std::complex<float> >;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1*op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator*(const std::complex<double> &op1,const hVarLinear<std::complex<double> > &op2){
	hVarLinear<std::complex<double> > *ret;
	ret=new hVarLinear<std::complex<double> >;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1*op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator*(const std::complex<long double> &op1,const hVarLinear<std::complex<long double> > &op2){
	hVarLinear<std::complex<long double> > *ret;
	ret=new hVarLinear<std::complex<long double> >;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1*op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator/(const bool &op1,const hVarLinear<bool> &op2){
	hVarLinear<signed long> *ret;
	ret=new hVarLinear<signed long>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i){
		if(!op2.mem[i]){
			delete ret;
			throw hException("operator/","Division by zero",hError);
		}
		ret->mem.push_back(op1/op2.mem[i]);
	}
	ret->size=op2.size;
	return ret;
}
hVarBase* operator/(const unsigned char &op1,const hVarLinear<unsigned char> &op2){
	hVarLinear<unsigned char> *ret;
	ret=new hVarLinear<unsigned char>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i){
		if(!op2.mem[i]){
			delete ret;
			throw hException("operator/","Division by zero",hError);
		}
		ret->mem.push_back(op1/op2.mem[i]);
	}
	ret->size=op2.size;
	return ret;
}
hVarBase* operator/(const signed char &op1,const hVarLinear<signed char> &op2){
	hVarLinear<signed char> *ret;
	ret=new hVarLinear<signed char>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i){
		if(!op2.mem[i]){
			delete ret;
			throw hException("operator/","Division by zero",hError);
		}
		ret->mem.push_back(op1/op2.mem[i]);
	}
	ret->size=op2.size;
	return ret;
}
hVarBase* operator/(const unsigned short &op1,const hVarLinear<unsigned short> &op2){
	hVarLinear<unsigned short> *ret;
	ret=new hVarLinear<unsigned short>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i){
		if(!op2.mem[i]){
			delete ret;
			throw hException("operator/","Division by zero",hError);
		}
		ret->mem.push_back(op1/op2.mem[i]);
	}
	ret->size=op2.size;
	return ret;
}
hVarBase* operator/(const signed short &op1,const hVarLinear<signed short> &op2){
	hVarLinear<signed short> *ret;
	ret=new hVarLinear<signed short>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i){
		if(!op2.mem[i]){
			delete ret;
			throw hException("operator/","Division by zero",hError);
		}
		ret->mem.push_back(op1/op2.mem[i]);
	}
	ret->size=op2.size;
	return ret;
}
hVarBase* operator/(const unsigned long &op1,const hVarLinear<unsigned long> &op2){
	hVarLinear<unsigned long> *ret;
	ret=new hVarLinear<unsigned long>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i){
		if(!op2.mem[i]){
			delete ret;
			throw hException("operator/","Division by zero",hError);
		}
		ret->mem.push_back(op1/op2.mem[i]);
	}
	ret->size=op2.size;
	return ret;
}
hVarBase* operator/(const signed long &op1,const hVarLinear<signed long> &op2){
	hVarLinear<signed long> *ret;
	ret=new hVarLinear<signed long>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i){
		if(!op2.mem[i]){
			delete ret;
			throw hException("operator/","Division by zero",hError);
		}
		ret->mem.push_back(op1/op2.mem[i]);
	}
	ret->size=op2.size;
	return ret;
}
hVarBase* operator/(const float &op1,const hVarLinear<float> &op2){
	hVarLinear<float> *ret;
	ret=new hVarLinear<float>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1/op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator/(const double &op1,const hVarLinear<double> &op2){
	hVarLinear<double> *ret;
	ret=new hVarLinear<double>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1/op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator/(const long double &op1,const hVarLinear<long double> &op2){
	hVarLinear<long double> *ret;
	ret=new hVarLinear<long double>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1/op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator/(const std::complex<float> &op1,const hVarLinear<std::complex<float> > &op2){
	hVarLinear<std::complex<float> > *ret;
	ret=new hVarLinear<std::complex<float> >;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1/op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator/(const std::complex<double> &op1,const hVarLinear<std::complex<double> > &op2){
	hVarLinear<std::complex<double> > *ret;
	ret=new hVarLinear<std::complex<double> >;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1/op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator/(const std::complex<long double> &op1,const hVarLinear<std::complex<long double> > &op2){
	hVarLinear<std::complex<long double> > *ret;
	ret=new hVarLinear<std::complex<long double> >;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1/op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator%(const bool &op1,const hVarLinear<bool> &op2){
	hVarLinear<signed long> *ret;
	ret=new hVarLinear<signed long>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1%op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator%(const unsigned char &op1,const hVarLinear<unsigned char> &op2){
	hVarLinear<unsigned char> *ret;
	ret=new hVarLinear<unsigned char>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1%op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator%(const signed char &op1,const hVarLinear<signed char> &op2){
	hVarLinear<signed char> *ret;
	ret=new hVarLinear<signed char>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1%op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator%(const unsigned short &op1,const hVarLinear<unsigned short> &op2){
	hVarLinear<unsigned short> *ret;
	ret=new hVarLinear<unsigned short>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1%op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator%(const signed short &op1,const hVarLinear<signed short> &op2){
	hVarLinear<signed short> *ret;
	ret=new hVarLinear<signed short>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1%op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator%(const unsigned long &op1,const hVarLinear<unsigned long> &op2){
	hVarLinear<unsigned long> *ret;
	ret=new hVarLinear<unsigned long>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1%op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator%(const signed long &op1,const hVarLinear<signed long> &op2){
	hVarLinear<signed long> *ret;
	ret=new hVarLinear<signed long>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1%op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator%(const float &op1,const hVarLinear<float> &op2){
	throw hException("operator%","Operator % doesn't exist for floationg point variables",hError);
}
hVarBase* operator%(const double &op1,const hVarLinear<double> &op2){
	throw hException("operator%","Operator % doesn't exist for floationg point variables",hError);
}
hVarBase* operator%(const long double &op1,const hVarLinear<long double> &op2){
	throw hException("operator%","Operator % doesn't exist for floationg point variables",hError);
}
hVarBase* operator%(const std::complex<float> &op1,const hVarLinear<std::complex<float> > &op2){
	throw hException("operator%","Operator % doesn't exist for complex variables",hError);
}
hVarBase* operator%(const std::complex<double> &op1,const hVarLinear<std::complex<double> > &op2){
	throw hException("operator%","Operator % doesn't exist for complex variables",hError);
}
hVarBase* operator%(const std::complex<long double> &op1,const hVarLinear<std::complex<long double> > &op2){
	throw hException("operator%","Operator % doesn't exist for complex variables",hError);
}
hVarBase* operator<(const bool &op1,const hVarLinear<bool> &op2){
	hVarLinear<bool> *ret;
	ret=new hVarLinear<bool>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1<op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator<(const unsigned char &op1,const hVarLinear<unsigned char> &op2){
	hVarLinear<bool> *ret;
	ret=new hVarLinear<bool>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1<op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator<(const signed char &op1,const hVarLinear<signed char> &op2){
	hVarLinear<bool> *ret;
	ret=new hVarLinear<bool>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1<op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator<(const unsigned short &op1,const hVarLinear<unsigned short> &op2){
	hVarLinear<bool> *ret;
	ret=new hVarLinear<bool>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1<op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator<(const signed short &op1,const hVarLinear<signed short> &op2){
	hVarLinear<bool> *ret;
	ret=new hVarLinear<bool>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1<op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator<(const unsigned long &op1,const hVarLinear<unsigned long> &op2){
	hVarLinear<bool> *ret;
	ret=new hVarLinear<bool>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1<op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator<(const signed long &op1,const hVarLinear<signed long> &op2){
	hVarLinear<bool> *ret;
	ret=new hVarLinear<bool>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1<op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator<(const float &op1,const hVarLinear<float> &op2){
	hVarLinear<bool> *ret;
	ret=new hVarLinear<bool>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1<op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator<(const double &op1,const hVarLinear<double> &op2){
	hVarLinear<bool> *ret;
	ret=new hVarLinear<bool>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1<op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator<(const long double &op1,const hVarLinear<long double> &op2){
	hVarLinear<bool> *ret;
	ret=new hVarLinear<bool>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1<op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator<(const std::complex<float> &op1,const hVarLinear<std::complex<float> > &op2){
	throw hException("operator<","Operator < doesn't exist for complex variables",hError);
}
hVarBase* operator<(const std::complex<double> &op1,const hVarLinear<std::complex<double> > &op2){
	throw hException("operator<","Operator < doesn't exist for complex variables",hError);
}
hVarBase* operator<(const std::complex<long double> &op1,const hVarLinear<std::complex<long double> > &op2){
	throw hException("operator<","Operator < doesn't exist for complex variables",hError);
}

hVarBase* operator<=(const bool &op1,const hVarLinear<bool> &op2){
	hVarLinear<bool> *ret;
	ret=new hVarLinear<bool>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1<=op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator<=(const unsigned char &op1,const hVarLinear<unsigned char> &op2){
	hVarLinear<bool> *ret;
	ret=new hVarLinear<bool>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1<=op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator<=(const signed char &op1,const hVarLinear<signed char> &op2){
	hVarLinear<bool> *ret;
	ret=new hVarLinear<bool>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1<=op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator<=(const unsigned short &op1,const hVarLinear<unsigned short> &op2){
	hVarLinear<bool> *ret;
	ret=new hVarLinear<bool>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1<=op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator<=(const signed short &op1,const hVarLinear<signed short> &op2){
	hVarLinear<bool> *ret;
	ret=new hVarLinear<bool>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1<=op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator<=(const unsigned long &op1,const hVarLinear<unsigned long> &op2){
	hVarLinear<bool> *ret;
	ret=new hVarLinear<bool>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1<=op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator<=(const signed long &op1,const hVarLinear<signed long> &op2){
	hVarLinear<bool> *ret;
	ret=new hVarLinear<bool>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1<=op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator<=(const float &op1,const hVarLinear<float> &op2){
	hVarLinear<bool> *ret;
	ret=new hVarLinear<bool>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1<=op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator<=(const double &op1,const hVarLinear<double> &op2){
	hVarLinear<bool> *ret;
	ret=new hVarLinear<bool>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1<=op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator<=(const long double &op1,const hVarLinear<long double> &op2){
	hVarLinear<bool> *ret;
	ret=new hVarLinear<bool>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1<=op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator<=(const std::complex<float> &op1,const hVarLinear<std::complex<float> > &op2){
	throw hException("operator<=","Operator `<=' doesn't exist for complex variables",hError);
}
hVarBase* operator<=(const std::complex<double> &op1,const hVarLinear<std::complex<double> > &op2){
	throw hException("operator<=","Operator `<=' doesn't exist for complex variables",hError);
}
hVarBase* operator<=(const std::complex<long double> &op1,const hVarLinear<std::complex<long double> > &op2){
	throw hException("operator<=","Operator `<=' doesn't exist for complex variables",hError);
}
hVarBase* operator>(const bool &op1,const hVarLinear<bool> &op2){
	hVarLinear<bool> *ret;
	ret=new hVarLinear<bool>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1>op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator>(const unsigned char &op1,const hVarLinear<unsigned char> &op2){
	hVarLinear<bool> *ret;
	ret=new hVarLinear<bool>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1>op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator>(const signed char &op1,const hVarLinear<signed char> &op2){
	hVarLinear<bool> *ret;
	ret=new hVarLinear<bool>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1>op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator>(const unsigned short &op1,const hVarLinear<unsigned short> &op2){
	hVarLinear<bool> *ret;
	ret=new hVarLinear<bool>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1>op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator>(const signed short &op1,const hVarLinear<signed short> &op2){
	hVarLinear<bool> *ret;
	ret=new hVarLinear<bool>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1>op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator>(const unsigned long &op1,const hVarLinear<unsigned long> &op2){
	hVarLinear<bool> *ret;
	ret=new hVarLinear<bool>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1>op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator>(const signed long &op1,const hVarLinear<signed long> &op2){
	hVarLinear<bool> *ret;
	ret=new hVarLinear<bool>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1>op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator>(const float &op1,const hVarLinear<float> &op2){
	hVarLinear<bool> *ret;
	ret=new hVarLinear<bool>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1>op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator>(const double &op1,const hVarLinear<double> &op2){
	hVarLinear<bool> *ret;
	ret=new hVarLinear<bool>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1>op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator>(const long double &op1,const hVarLinear<long double> &op2){
	hVarLinear<bool> *ret;
	ret=new hVarLinear<bool>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1>op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator>(const std::complex<float> &op1,const hVarLinear<std::complex<float> > &op2){
	throw hException("operator<=","Operator `>' doesn't exist for complex variables",hError);
}
hVarBase* operator>(const std::complex<double> &op1,const hVarLinear<std::complex<double> > &op2){
	throw hException("operator<=","Operator `>' doesn't exist for complex variables",hError);
}
hVarBase* operator>(const std::complex<long double> &op1,const hVarLinear<std::complex<long double> > &op2){
	throw hException("operator<=","Operator `>' doesn't exist for complex variables",hError);
}
hVarBase* operator>=(const bool &op1,const hVarLinear<bool> &op2){
	hVarLinear<bool> *ret;
	ret=new hVarLinear<bool>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1>=op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator>=(const unsigned char &op1,const hVarLinear<unsigned char> &op2){
	hVarLinear<bool> *ret;
	ret=new hVarLinear<bool>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1>=op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator>=(const signed char &op1,const hVarLinear<signed char> &op2){
	hVarLinear<bool> *ret;
	ret=new hVarLinear<bool>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1>=op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator>=(const unsigned short &op1,const hVarLinear<unsigned short> &op2){
	hVarLinear<bool> *ret;
	ret=new hVarLinear<bool>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1>=op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator>=(const signed short &op1,const hVarLinear<signed short> &op2){
	hVarLinear<bool> *ret;
	ret=new hVarLinear<bool>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1>=op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator>=(const unsigned long &op1,const hVarLinear<unsigned long> &op2){
	hVarLinear<bool> *ret;
	ret=new hVarLinear<bool>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1>=op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator>=(const signed long &op1,const hVarLinear<signed long> &op2){
	hVarLinear<bool> *ret;
	ret=new hVarLinear<bool>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1>=op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator>=(const float &op1,const hVarLinear<float> &op2){
	hVarLinear<bool> *ret;
	ret=new hVarLinear<bool>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1>=op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator>=(const double &op1,const hVarLinear<double> &op2){
	hVarLinear<bool> *ret;
	ret=new hVarLinear<bool>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1>=op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator>=(const long double &op1,const hVarLinear<long double> &op2){
	hVarLinear<bool> *ret;
	ret=new hVarLinear<bool>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1>=op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator>=(const std::complex<float> &op1,const hVarLinear<std::complex<float> > &op2){
	throw hException("operator<=","Operator `>=' doesn't exist for complex variables",hError);
}
hVarBase* operator>=(const std::complex<double> &op1,const hVarLinear<std::complex<double> > &op2){
	throw hException("operator<=","Operator `>=' doesn't exist for complex variables",hError);
}
hVarBase* operator>=(const std::complex<long double> &op1,const hVarLinear<std::complex<long double> > &op2){
	throw hException("operator<=","Operator `>=' doesn't exist for complex variables",hError);
}
hVarBase* operator&&(const bool &op1,const hVarLinear<bool> &op2){
	hVarLinear<bool> *ret;
	ret=new hVarLinear<bool>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1&&op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator&&(const unsigned char &op1,const hVarLinear<unsigned char> &op2){
	hVarLinear<bool> *ret;
	ret=new hVarLinear<bool>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1&&op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator&&(const signed char &op1,const hVarLinear<signed char> &op2){
	hVarLinear<bool> *ret;
	ret=new hVarLinear<bool>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1&&op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator&&(const unsigned short &op1,const hVarLinear<unsigned short> &op2){
	hVarLinear<bool> *ret;
	ret=new hVarLinear<bool>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1&&op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator&&(const signed short &op1,const hVarLinear<signed short> &op2){
	hVarLinear<bool> *ret;
	ret=new hVarLinear<bool>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1&&op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator&&(const unsigned long &op1,const hVarLinear<unsigned long> &op2){
	hVarLinear<bool> *ret;
	ret=new hVarLinear<bool>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1&&op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator&&(const signed long &op1,const hVarLinear<signed long> &op2){
	hVarLinear<bool> *ret;
	ret=new hVarLinear<bool>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1&&op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator&&(const float &op1,const hVarLinear<float> &op2){
	hVarLinear<bool> *ret;
	ret=new hVarLinear<bool>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1&&op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator&&(const double &op1,const hVarLinear<double> &op2){
	hVarLinear<bool> *ret;
	ret=new hVarLinear<bool>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1&&op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator&&(const long double &op1,const hVarLinear<long double> &op2){
	hVarLinear<bool> *ret;
	ret=new hVarLinear<bool>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1&&op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator&&(const std::complex<float> &op1,const hVarLinear<std::complex<float> > &op2){
	throw hException("operator&&","Operator `&&' doesn't exist for complex variables",hError);
}
hVarBase* operator&&(const std::complex<double> &op1,const hVarLinear<std::complex<double> > &op2){
	throw hException("operator&&","Operator `&&' doesn't exist for complex variables",hError);
}
hVarBase* operator&&(const std::complex<long double> &op1,const hVarLinear<std::complex<long double> > &op2){
	throw hException("operator&&","Operator `&&' doesn't exist for complex variables",hError);
}
hVarBase* operator||(const bool &op1,const hVarLinear<bool> &op2){
	hVarLinear<bool> *ret;
	ret=new hVarLinear<bool>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1||op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator||(const unsigned char &op1,const hVarLinear<unsigned char> &op2){
	hVarLinear<bool> *ret;
	ret=new hVarLinear<bool>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1||op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator||(const signed char &op1,const hVarLinear<signed char> &op2){
	hVarLinear<bool> *ret;
	ret=new hVarLinear<bool>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1||op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator||(const unsigned short &op1,const hVarLinear<unsigned short> &op2){
	hVarLinear<bool> *ret;
	ret=new hVarLinear<bool>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1||op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator||(const signed short &op1,const hVarLinear<signed short> &op2){
	hVarLinear<bool> *ret;
	ret=new hVarLinear<bool>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1||op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator||(const unsigned long &op1,const hVarLinear<unsigned long> &op2){
	hVarLinear<bool> *ret;
	ret=new hVarLinear<bool>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1||op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator||(const signed long &op1,const hVarLinear<signed long> &op2){
	hVarLinear<bool> *ret;
	ret=new hVarLinear<bool>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1||op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator||(const float &op1,const hVarLinear<float> &op2){
	hVarLinear<bool> *ret;
	ret=new hVarLinear<bool>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1||op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator||(const double &op1,const hVarLinear<double> &op2){
	hVarLinear<bool> *ret;
	ret=new hVarLinear<bool>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1||op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator||(const long double &op1,const hVarLinear<long double> &op2){
	hVarLinear<bool> *ret;
	ret=new hVarLinear<bool>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1||op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator||(const std::complex<float> &op1,const hVarLinear<std::complex<float> > &op2){
	throw hException("operator||","Operator `||' doesn't exist for complex variables",hError);
}
hVarBase* operator||(const std::complex<double> &op1,const hVarLinear<std::complex<double> > &op2){
	throw hException("operator||","Operator `||' doesn't exist for complex variables",hError);
}
hVarBase* operator||(const std::complex<long double> &op1,const hVarLinear<std::complex<long double> > &op2){
	throw hException("operator||","Operator `||' doesn't exist for complex variables",hError);
}
hVarBase* operator==(const bool &op1,const hVarLinear<bool> &op2){
	hVarLinear<bool> *ret;
	ret=new hVarLinear<bool>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1==op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator==(const unsigned char &op1,const hVarLinear<unsigned char> &op2){
	hVarLinear<bool> *ret;
	ret=new hVarLinear<bool>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1==op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator==(const signed char &op1,const hVarLinear<signed char> &op2){
	hVarLinear<bool> *ret;
	ret=new hVarLinear<bool>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1==op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator==(const unsigned short &op1,const hVarLinear<unsigned short> &op2){
	hVarLinear<bool> *ret;
	ret=new hVarLinear<bool>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1==op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator==(const signed short &op1,const hVarLinear<signed short> &op2){
	hVarLinear<bool> *ret;
	ret=new hVarLinear<bool>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1==op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator==(const unsigned long &op1,const hVarLinear<unsigned long> &op2){
	hVarLinear<bool> *ret;
	ret=new hVarLinear<bool>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1==op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator==(const signed long &op1,const hVarLinear<signed long> &op2){
	hVarLinear<bool> *ret;
	ret=new hVarLinear<bool>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1==op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator==(const float &op1,const hVarLinear<float> &op2){
	hVarLinear<bool> *ret;
	ret=new hVarLinear<bool>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1==op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator==(const double &op1,const hVarLinear<double> &op2){
	hVarLinear<bool> *ret;
	ret=new hVarLinear<bool>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1==op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator==(const long double &op1,const hVarLinear<long double> &op2){
	hVarLinear<bool> *ret;
	ret=new hVarLinear<bool>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1==op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator==(const std::complex<float> &op1,const hVarLinear<std::complex<float> > &op2){
	hVarLinear<bool> *ret;
	ret=new hVarLinear<bool>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1==op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator==(const std::complex<double> &op1,const hVarLinear<std::complex<double> > &op2){
	hVarLinear<bool> *ret;
	ret=new hVarLinear<bool>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1==op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator==(const std::complex<long double> &op1,const hVarLinear<std::complex<long double> > &op2){
	hVarLinear<bool> *ret;
	ret=new hVarLinear<bool>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1==op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator!=(const bool &op1,const hVarLinear<bool> &op2){
	hVarLinear<bool> *ret;
	ret=new hVarLinear<bool>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1!=op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator!=(const unsigned char &op1,const hVarLinear<unsigned char> &op2){
	hVarLinear<bool> *ret;
	ret=new hVarLinear<bool>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1!=op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator!=(const signed char &op1,const hVarLinear<signed char> &op2){
	hVarLinear<bool> *ret;
	ret=new hVarLinear<bool>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1!=op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator!=(const unsigned short &op1,const hVarLinear<unsigned short> &op2){
	hVarLinear<bool> *ret;
	ret=new hVarLinear<bool>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1!=op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator!=(const signed short &op1,const hVarLinear<signed short> &op2){
	hVarLinear<bool> *ret;
	ret=new hVarLinear<bool>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1!=op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator!=(const unsigned long &op1,const hVarLinear<unsigned long> &op2){
	hVarLinear<bool> *ret;
	ret=new hVarLinear<bool>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1!=op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator!=(const signed long &op1,const hVarLinear<signed long> &op2){
	hVarLinear<bool> *ret;
	ret=new hVarLinear<bool>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1!=op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator!=(const float &op1,const hVarLinear<float> &op2){
	hVarLinear<bool> *ret;
	ret=new hVarLinear<bool>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1!=op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator!=(const double &op1,const hVarLinear<double> &op2){
	hVarLinear<bool> *ret;
	ret=new hVarLinear<bool>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1!=op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator!=(const long double &op1,const hVarLinear<long double> &op2){
	hVarLinear<bool> *ret;
	ret=new hVarLinear<bool>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1!=op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator!=(const std::complex<float> &op1,const hVarLinear<std::complex<float> > &op2){
	hVarLinear<bool> *ret;
	ret=new hVarLinear<bool>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1!=op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator!=(const std::complex<double> &op1,const hVarLinear<std::complex<double> > &op2){
	hVarLinear<bool> *ret;
	ret=new hVarLinear<bool>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1!=op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator!=(const std::complex<long double> &op1,const hVarLinear<std::complex<long double> > &op2){
	hVarLinear<bool> *ret;
	ret=new hVarLinear<bool>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1!=op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator<<(const bool &op1,const hVarLinear<bool> &op2){
	hVarLinear<signed long> *ret;
	ret=new hVarLinear<signed long>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1<<op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator<<(const unsigned char &op1,const hVarLinear<unsigned char> &op2){
	hVarLinear<signed long> *ret;
	ret=new hVarLinear<signed long>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1<<op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator<<(const signed char &op1,const hVarLinear<signed char> &op2){
	hVarLinear<signed long> *ret;
	ret=new hVarLinear<signed long>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1<<op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator<<(const unsigned short &op1,const hVarLinear<unsigned short> &op2){
	hVarLinear<signed long> *ret;
	ret=new hVarLinear<signed long>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1<<op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator<<(const signed short &op1,const hVarLinear<signed short> &op2){
	hVarLinear<signed long> *ret;
	ret=new hVarLinear<signed long>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1<<op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator<<(const unsigned long &op1,const hVarLinear<unsigned long> &op2){
	hVarLinear<signed long> *ret;
	ret=new hVarLinear<signed long>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1<<op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator<<(const signed long &op1,const hVarLinear<signed long> &op2){
	hVarLinear<signed long> *ret;
	ret=new hVarLinear<signed long>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1<<op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator<<(const float &op1,const hVarLinear<float> &op2){
	throw hException("operator<<","Operator `<<' doesn't exist for floating point variables",hError);
}
hVarBase* operator<<(const double &op1,const hVarLinear<double> &op2){
	throw hException("operator<<","Operator `<<' doesn't exist for floating point variables",hError);
}
hVarBase* operator<<(const long double &op1,const hVarLinear<long double> &op2){
	throw hException("operator<<","Operator `<<' doesn't exist for floating point variables",hError);
}
hVarBase* operator<<(const std::complex<float> &op1,const hVarLinear<std::complex<float> > &op2){
	throw hException("operator<<","Operator `<<' doesn't exist for complex variables",hError);
}
hVarBase* operator<<(const std::complex<double> &op1,const hVarLinear<std::complex<double> > &op2){
	throw hException("operator<<","Operator `<<' doesn't exist for complex variables",hError);
}
hVarBase* operator<<(const std::complex<long double> &op1,const hVarLinear<std::complex<long double> > &op2){
	throw hException("operator<<","Operator `<<' doesn't exist for complex variables",hError);
}
hVarBase* operator>>(const bool &op1,const hVarLinear<bool> &op2){
	hVarLinear<bool> *ret;
	ret=new hVarLinear<bool>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1>>op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator>>(const unsigned char &op1,const hVarLinear<unsigned char> &op2){
	hVarLinear<unsigned char> *ret;
	ret=new hVarLinear<unsigned char>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1>>op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator>>(const signed char &op1,const hVarLinear<signed char> &op2){
	hVarLinear<signed char> *ret;
	ret=new hVarLinear<signed char>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1>>op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator>>(const unsigned short &op1,const hVarLinear<unsigned short> &op2){
	hVarLinear<unsigned short> *ret;
	ret=new hVarLinear<unsigned short>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1>>op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator>>(const signed short &op1,const hVarLinear<signed short> &op2){
	hVarLinear<signed short> *ret;
	ret=new hVarLinear<signed short>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1>>op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator>>(const unsigned long &op1,const hVarLinear<unsigned long> &op2){
	hVarLinear<unsigned long> *ret;
	ret=new hVarLinear<unsigned long>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1>>op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator>>(const signed long &op1,const hVarLinear<signed long> &op2){
	hVarLinear<signed long> *ret;
	ret=new hVarLinear<signed long>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1>>op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator>>(const float &op1,const hVarLinear<float> &op2){
	throw hException("operator>>","Operator `>>' doesn't exist for floating point variables",hError);
}
hVarBase* operator>>(const double &op1,const hVarLinear<double> &op2){
	throw hException("operator>>","Operator `>>' doesn't exist for floating point variables",hError);
}
hVarBase* operator>>(const long double &op1,const hVarLinear<long double> &op2){
	throw hException("operator>>","Operator `>>' doesn't exist for floating point variables",hError);
}
hVarBase* operator>>(const std::complex<float> &op1,const hVarLinear<std::complex<float> > &op2){
	throw hException("operator>>","Operator `>>' doesn't exist for complex variables",hError);
}
hVarBase* operator>>(const std::complex<double> &op1,const hVarLinear<std::complex<double> > &op2){
	throw hException("operator>>","Operator `>>' doesn't exist for complex variables",hError);
}
hVarBase* operator>>(const std::complex<long double> &op1,const hVarLinear<std::complex<long double> > &op2){
	throw hException("operator>>","Operator `>>' doesn't exist for complex variables",hError);
}
hVarBase* operator&(const bool &op1,const hVarLinear<bool> &op2){
	hVarLinear<bool> *ret;
	ret=new hVarLinear<bool>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1&op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator&(const unsigned char &op1,const hVarLinear<unsigned char> &op2){
	hVarLinear<unsigned char> *ret;
	ret=new hVarLinear<unsigned char>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1&op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator&(const signed char &op1,const hVarLinear<signed char> &op2){
	hVarLinear<signed char> *ret;
	ret=new hVarLinear<signed char>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1&op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator&(const unsigned short &op1,const hVarLinear<unsigned short> &op2){
	hVarLinear<unsigned short> *ret;
	ret=new hVarLinear<unsigned short>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1&op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator&(const signed short &op1,const hVarLinear<signed short> &op2){
	hVarLinear<signed short> *ret;
	ret=new hVarLinear<signed short>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1&op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator&(const unsigned long &op1,const hVarLinear<unsigned long> &op2){
	hVarLinear<unsigned long> *ret;
	ret=new hVarLinear<unsigned long>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1&op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator&(const signed long &op1,const hVarLinear<signed long> &op2){
	hVarLinear<signed long> *ret;
	ret=new hVarLinear<signed long>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1&op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator&(const float &op1,const hVarLinear<float> &op2){
	throw hException("operator&","Operator `&' doesn't exist for floating point variables",hError);
}
hVarBase* operator&(const double &op1,const hVarLinear<double> &op2){
	throw hException("operator&","Operator `&' doesn't exist for floating point variables",hError);
}
hVarBase* operator&(const long double &op1,const hVarLinear<long double> &op2){
	throw hException("operator&","Operator `&' doesn't exist for floating point variables",hError);
}
hVarBase* operator&(const std::complex<float> &op1,const hVarLinear<std::complex<float> > &op2){
	throw hException("operator&","Operator `&' doesn't exist for complex variables",hError);
}
hVarBase* operator&(const std::complex<double> &op1,const hVarLinear<std::complex<double> > &op2){
	throw hException("operator&","Operator `&' doesn't exist for complex variables",hError);
}
hVarBase* operator&(const std::complex<long double> &op1,const hVarLinear<std::complex<long double> > &op2){
	throw hException("operator&","Operator `&' doesn't exist for complex variables",hError);
}
hVarBase* operator|(const bool &op1,const hVarLinear<bool> &op2){
	hVarLinear<bool> *ret;
	ret=new hVarLinear<bool>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1|op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator|(const unsigned char &op1,const hVarLinear<unsigned char> &op2){
	hVarLinear<unsigned char> *ret;
	ret=new hVarLinear<unsigned char>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1|op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator|(const signed char &op1,const hVarLinear<signed char> &op2){
	hVarLinear<signed char> *ret;
	ret=new hVarLinear<signed char>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1|op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator|(const unsigned short &op1,const hVarLinear<unsigned short> &op2){
	hVarLinear<unsigned short> *ret;
	ret=new hVarLinear<unsigned short>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1|op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator|(const signed short &op1,const hVarLinear<signed short> &op2){
	hVarLinear<signed short> *ret;
	ret=new hVarLinear<signed short>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1|op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator|(const unsigned long &op1,const hVarLinear<unsigned long> &op2){
	hVarLinear<unsigned long> *ret;
	ret=new hVarLinear<unsigned long>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1|op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator|(const signed long &op1,const hVarLinear<signed long> &op2){
	hVarLinear<signed long> *ret;
	ret=new hVarLinear<signed long>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1|op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator|(const float &op1,const hVarLinear<float> &op2){
	throw hException("operator|","Operator `|' doesn't exist for floating point variables",hError);
}
hVarBase* operator|(const double &op1,const hVarLinear<double> &op2){
	throw hException("operator|","Operator `|' doesn't exist for floating point variables",hError);
}
hVarBase* operator|(const long double &op1,const hVarLinear<long double> &op2){
	throw hException("operator|","Operator `|' doesn't exist for floating point variables",hError);
}
hVarBase* operator|(const std::complex<float> &op1,const hVarLinear<std::complex<float> > &op2){
	throw hException("operator|","Operator `|' doesn't exist for complex variables",hError);
}
hVarBase* operator|(const std::complex<double> &op1,const hVarLinear<std::complex<double> > &op2){
	throw hException("operator|","Operator `|' doesn't exist for complex variables",hError);
}
hVarBase* operator|(const std::complex<long double> &op1,const hVarLinear<std::complex<long double> > &op2){
	throw hException("operator|","Operator `|' doesn't exist for complex variables",hError);
}
hVarBase* operator^(const bool &op1,const hVarLinear<bool> &op2){
	hVarLinear<bool> *ret;
	ret=new hVarLinear<bool>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1^op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator^(const unsigned char &op1,const hVarLinear<unsigned char> &op2){
	hVarLinear<unsigned char> *ret;
	ret=new hVarLinear<unsigned char>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1^op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator^(const signed char &op1,const hVarLinear<signed char> &op2){
	hVarLinear<signed char> *ret;
	ret=new hVarLinear<signed char>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1^op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator^(const unsigned short &op1,const hVarLinear<unsigned short> &op2){
	hVarLinear<unsigned short> *ret;
	ret=new hVarLinear<unsigned short>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1^op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator^(const signed short &op1,const hVarLinear<signed short> &op2){
	hVarLinear<signed short> *ret;
	ret=new hVarLinear<signed short>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1^op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator^(const unsigned long &op1,const hVarLinear<unsigned long> &op2){
	hVarLinear<unsigned long> *ret;
	ret=new hVarLinear<unsigned long>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1^op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator^(const signed long &op1,const hVarLinear<signed long> &op2){
	hVarLinear<signed long> *ret;
	ret=new hVarLinear<signed long>;
	unsigned long s,i;
	s=op2.mem.size();
	ret->mem.reserve(s);
	for(i=0;i<s;++i)
		ret->mem.push_back(op1^op2.mem[i]);
	ret->size=op2.size;
	return ret;
}
hVarBase* operator^(const float &op1,const hVarLinear<float> &op2){
	throw hException("operator^","Operator `^' doesn't exist for floating point variables",hError);
}
hVarBase* operator^(const double &op1,const hVarLinear<double> &op2){
	throw hException("operator^","Operator `^' doesn't exist for floating point variables",hError);
}
hVarBase* operator^(const long double &op1,const hVarLinear<long double> &op2){
	throw hException("operator^","Operator `^' doesn't exist for floating point variables",hError);
}
hVarBase* operator^(const std::complex<float> &op1,const hVarLinear<std::complex<float> > &op2){
	throw hException("operator^","Operator `^' doesn't exist for complex variables",hError);
}
hVarBase* operator^(const std::complex<double> &op1,const hVarLinear<std::complex<double> > &op2){
	throw hException("operator^","Operator `^' doesn't exist for complex variables",hError);
}
hVarBase* operator^(const std::complex<long double> &op1,const hVarLinear<std::complex<long double> > &op2){
	throw hException("operator^","Operator `^' doesn't exist for complex variables",hError);
}


/*
hVarBase* hvar::operator-(const bool &op1,const hVarLinear<bool> &op2);
hVarBase* hvar::operator*(const bool &op1,const hVarLinear<bool> &op2);
hVarBase* hvar::operator/(const bool &op1,const hVarLinear<bool> &op2);
hVarBase* hvar::operator%(const bool &op1,const hVarLinear<bool> &op2);

hVarBase* hvar::operator=(const bool &op1,const hVarLinear<bool> &op2);

hVarBase* hvar::operator<(const bool &op1,const hVarLinear<bool> &op2);
hVarBase* hvar::operator<=(const bool &op1,const hVarLinear<bool> &op2);
hVarBase* hvar::operator>(const bool &op1,const hVarLinear<bool> &op2);
hVarBase* hvar::operator>=(const bool &op1,const hVarLinear<bool> &op2);

hVarBase* hvar::operator&&(const bool &op1,const hVarLinear<bool> &op2);
hVarBase* hvar::operator||(const bool &op1,const hVarLinear<bool> &op2);
hVarBase* hvar::operator==(const bool &op1,const hVarLinear<bool> &op2);
hVarBase* hvar::operator!=(const bool &op1,const hVarLinear<bool> &op2);

hVarBase* hvar::operator<<(const bool &op1,const hVarLinear<bool> &op2);
hVarBase* hvar::operator>>(const bool &op1,const hVarLinear<bool> &op2);
hVarBase* hvar::operator&(const bool &op1,const hVarLinear<bool> &op2);
hVarBase* hvar::operator|(const bool &op1,const hVarLinear<bool> &op2);
hVarBase* hvar::operator^(const bool &op1,const hVarLinear<bool> &op2);

hVarBase* hvar::operator+(const unsigned char &op1,const hVarLinear<unsigned char> &op2);
hVarBase* hvar::operator-(const unsigned char &op1,const hVarLinear<unsigned char> &op2);
hVarBase* hvar::operator*(const unsigned char &op1,const hVarLinear<unsigned char> &op2);
hVarBase* hvar::operator/(const unsigned char &op1,const hVarLinear<unsigned char> &op2);
hVarBase* hvar::operator%(const unsigned char &op1,const hVarLinear<unsigned char> &op2);

hVarBase* hvar::operator=(const unsigned char &op1,const hVarLinear<unsigned char> &op2);

hVarBase* hvar::operator<(const unsigned char &op1,const hVarLinear<unsigned char> &op2);
hVarBase* hvar::operator<=(const unsigned char &op1,const hVarLinear<unsigned char> &op2);
hVarBase* hvar::operator>(const unsigned char &op1,const hVarLinear<unsigned char> &op2);
hVarBase* hvar::operator>=(const unsigned char &op1,const hVarLinear<unsigned char> &op2);

hVarBase* hvar::operator&&(const unsigned char &op1,const hVarLinear<unsigned char> &op2);
hVarBase* hvar::operator||(const unsigned char &op1,const hVarLinear<unsigned char> &op2);
hVarBase* hvar::operator==(const unsigned char &op1,const hVarLinear<unsigned char> &op2);
hVarBase* hvar::operator!=(const unsigned char &op1,const hVarLinear<unsigned char> &op2);

hVarBase* hvar::operator<<(const unsigned char &op1,const hVarLinear<unsigned char> &op2);
hVarBase* hvar::operator>>(const unsigned char &op1,const hVarLinear<unsigned char> &op2);
hVarBase* hvar::operator&(const unsigned char &op1,const hVarLinear<unsigned char> &op2);
hVarBase* hvar::operator|(const unsigned char &op1,const hVarLinear<unsigned char> &op2);
hVarBase* hvar::operator^(const unsigned char &op1,const hVarLinear<unsigned char> &op2);

hVarBase* hvar::operator+(const signed char &op1,const hVarLinear<signed char> &op2);
hVarBase* hvar::operator-(const signed char &op1,const hVarLinear<signed char> &op2);
hVarBase* hvar::operator*(const signed char &op1,const hVarLinear<signed char> &op2);
hVarBase* hvar::operator/(const signed char &op1,const hVarLinear<signed char> &op2);
hVarBase* hvar::operator%(const signed char &op1,const hVarLinear<signed char> &op2);

hVarBase* hvar::operator=(const signed char &op1,const hVarLinear<signed char> &op2);

hVarBase* hvar::operator<(const signed char &op1,const hVarLinear<signed char> &op2);
hVarBase* hvar::operator<=(const signed char &op1,const hVarLinear<signed char> &op2);
hVarBase* hvar::operator>(const signed char &op1,const hVarLinear<signed char> &op2);
hVarBase* hvar::operator>=(const signed char &op1,const hVarLinear<signed char> &op2);

hVarBase* hvar::operator&&(const signed char &op1,const hVarLinear<signed char> &op2);
hVarBase* hvar::operator||(const signed char &op1,const hVarLinear<signed char> &op2);
hVarBase* hvar::operator==(const signed char &op1,const hVarLinear<signed char> &op2);
hVarBase* hvar::operator!=(const signed char &op1,const hVarLinear<signed char> &op2);

hVarBase* hvar::operator<<(const signed char &op1,const hVarLinear<signed char> &op2);
hVarBase* hvar::operator>>(const signed char &op1,const hVarLinear<signed char> &op2);
hVarBase* hvar::operator&(const signed char &op1,const hVarLinear<signed char> &op2);
hVarBase* hvar::operator|(const signed char &op1,const hVarLinear<signed char> &op2);
hVarBase* hvar::operator^(const signed char &op1,const hVarLinear<signed char> &op2);

hVarBase* hvar::operator+(const unsigned short &op1,const hVarLinear<unsigned short> &op2);
hVarBase* hvar::operator-(const unsigned short &op1,const hVarLinear<unsigned short> &op2);
hVarBase* hvar::operator*(const unsigned short &op1,const hVarLinear<unsigned short> &op2);
hVarBase* hvar::operator/(const unsigned short &op1,const hVarLinear<unsigned short> &op2);
hVarBase* hvar::operator%(const unsigned short &op1,const hVarLinear<unsigned short> &op2);

hVarBase* hvar::operator=(const unsigned short &op1,const hVarLinear<unsigned short> &op2);

hVarBase* hvar::operator<(const unsigned short &op1,const hVarLinear<unsigned short> &op2);
hVarBase* hvar::operator<=(const unsigned short &op1,const hVarLinear<unsigned short> &op2);
hVarBase* hvar::operator>(const unsigned short &op1,const hVarLinear<unsigned short> &op2);
hVarBase* hvar::operator>=(const unsigned short &op1,const hVarLinear<unsigned short> &op2);

hVarBase* hvar::operator&&(const unsigned short &op1,const hVarLinear<unsigned short> &op2);
hVarBase* hvar::operator||(const unsigned short &op1,const hVarLinear<unsigned short> &op2);
hVarBase* hvar::operator==(const unsigned short &op1,const hVarLinear<unsigned short> &op2);
hVarBase* hvar::operator!=(const unsigned short &op1,const hVarLinear<unsigned short> &op2);

hVarBase* hvar::operator<<(const unsigned short &op1,const hVarLinear<unsigned short> &op2);
hVarBase* hvar::operator>>(const unsigned short &op1,const hVarLinear<unsigned short> &op2);
hVarBase* hvar::operator&(const unsigned short &op1,const hVarLinear<unsigned short> &op2);
hVarBase* hvar::operator|(const unsigned short &op1,const hVarLinear<unsigned short> &op2);
hVarBase* hvar::operator^(const unsigned short &op1,const hVarLinear<unsigned short> &op2);

hVarBase* hvar::operator+(const signed short &op1,const hVarLinear<signed short> &op2);
hVarBase* hvar::operator-(const signed short &op1,const hVarLinear<signed short> &op2);
hVarBase* hvar::operator*(const signed short &op1,const hVarLinear<signed short> &op2);
hVarBase* hvar::operator/(const signed short &op1,const hVarLinear<signed short> &op2);
hVarBase* hvar::operator%(const signed short &op1,const hVarLinear<signed short> &op2);

hVarBase* hvar::operator=(const signed short &op1,const hVarLinear<signed short> &op2);

hVarBase* hvar::operator<(const signed short &op1,const hVarLinear<signed short> &op2);
hVarBase* hvar::operator<=(const signed short &op1,const hVarLinear<signed short> &op2);
hVarBase* hvar::operator>(const signed short &op1,const hVarLinear<signed short> &op2);
hVarBase* hvar::operator>=(const signed short &op1,const hVarLinear<signed short> &op2);

hVarBase* hvar::operator&&(const signed short &op1,const hVarLinear<signed short> &op2);
hVarBase* hvar::operator||(const signed short &op1,const hVarLinear<signed short> &op2);
hVarBase* hvar::operator==(const signed short &op1,const hVarLinear<signed short> &op2);
hVarBase* hvar::operator!=(const signed short &op1,const hVarLinear<signed short> &op2);

hVarBase* hvar::operator<<(const signed short &op1,const hVarLinear<signed short> &op2);
hVarBase* hvar::operator>>(const signed short &op1,const hVarLinear<signed short> &op2);
hVarBase* hvar::operator&(const signed short &op1,const hVarLinear<signed short> &op2);
hVarBase* hvar::operator|(const signed short &op1,const hVarLinear<signed short> &op2);
hVarBase* hvar::operator^(const signed short &op1,const hVarLinear<signed short> &op2);

hVarBase* hvar::operator+(const unsigned long &op1,const hVarLinear<unsigned long> &op2);
hVarBase* hvar::operator-(const unsigned long &op1,const hVarLinear<unsigned long> &op2);
hVarBase* hvar::operator*(const unsigned long &op1,const hVarLinear<unsigned long> &op2);
hVarBase* hvar::operator/(const unsigned long &op1,const hVarLinear<unsigned long> &op2);
hVarBase* hvar::operator%(const unsigned long &op1,const hVarLinear<unsigned long> &op2);

hVarBase* hvar::operator=(const unsigned long &op1,const hVarLinear<unsigned long> &op2);

hVarBase* hvar::operator<(const unsigned long &op1,const hVarLinear<unsigned long> &op2);
hVarBase* hvar::operator<=(const unsigned long &op1,const hVarLinear<unsigned long> &op2);
hVarBase* hvar::operator>(const unsigned long &op1,const hVarLinear<unsigned long> &op2);
hVarBase* hvar::operator>=(const unsigned long &op1,const hVarLinear<unsigned long> &op2);

hVarBase* hvar::operator&&(const unsigned long &op1,const hVarLinear<unsigned long> &op2);
hVarBase* hvar::operator||(const unsigned long &op1,const hVarLinear<unsigned long> &op2);
hVarBase* hvar::operator==(const unsigned long &op1,const hVarLinear<unsigned long> &op2);
hVarBase* hvar::operator!=(const unsigned long &op1,const hVarLinear<unsigned long> &op2);

hVarBase* hvar::operator<<(const unsigned long &op1,const hVarLinear<unsigned long> &op2);
hVarBase* hvar::operator>>(const unsigned long &op1,const hVarLinear<unsigned long> &op2);
hVarBase* hvar::operator&(const unsigned long &op1,const hVarLinear<unsigned long> &op2);
hVarBase* hvar::operator|(const unsigned long &op1,const hVarLinear<unsigned long> &op2);
hVarBase* hvar::operator^(const unsigned long &op1,const hVarLinear<unsigned long> &op2);

hVarBase* hvar::operator+(const signed long &op1,const hVarLinear<signed long> &op2);
hVarBase* hvar::operator-(const signed long &op1,const hVarLinear<signed long> &op2);
hVarBase* hvar::operator*(const signed long &op1,const hVarLinear<signed long> &op2);
hVarBase* hvar::operator/(const signed long &op1,const hVarLinear<signed long> &op2);
hVarBase* hvar::operator%(const signed long &op1,const hVarLinear<signed long> &op2);

hVarBase* hvar::operator=(const signed long &op1,const hVarLinear<signed long> &op2);

hVarBase* hvar::operator<(const signed long &op1,const hVarLinear<signed long> &op2);
hVarBase* hvar::operator<=(const signed long &op1,const hVarLinear<signed long> &op2);
hVarBase* hvar::operator>(const signed long &op1,const hVarLinear<signed long> &op2);
hVarBase* hvar::operator>=(const signed long &op1,const hVarLinear<signed long> &op2);

hVarBase* hvar::operator&&(const signed long &op1,const hVarLinear<signed long> &op2);
hVarBase* hvar::operator||(const signed long &op1,const hVarLinear<signed long> &op2);
hVarBase* hvar::operator==(const signed long &op1,const hVarLinear<signed long> &op2);
hVarBase* hvar::operator!=(const signed long &op1,const hVarLinear<signed long> &op2);

hVarBase* hvar::operator<<(const signed long &op1,const hVarLinear<signed long> &op2);
hVarBase* hvar::operator>>(const signed long &op1,const hVarLinear<signed long> &op2);
hVarBase* hvar::operator&(const signed long &op1,const hVarLinear<signed long> &op2);
hVarBase* hvar::operator|(const signed long &op1,const hVarLinear<signed long> &op2);
hVarBase* hvar::operator^(const signed long &op1,const hVarLinear<signed long> &op2);

hVarBase* hvar::operator+(const float &op1,const hVarLinear<float> &op2);
hVarBase* hvar::operator-(const float &op1,const hVarLinear<float> &op2);
hVarBase* hvar::operator*(const float &op1,const hVarLinear<float> &op2);
hVarBase* hvar::operator/(const float &op1,const hVarLinear<float> &op2);
hVarBase* hvar::operator%(const float &op1,const hVarLinear<float> &op2);

hVarBase* hvar::operator=(const float &op1,const hVarLinear<float> &op2);

hVarBase* hvar::operator<(const float &op1,const hVarLinear<float> &op2);
hVarBase* hvar::operator<=(const float &op1,const hVarLinear<float> &op2);
hVarBase* hvar::operator>(const float &op1,const hVarLinear<float> &op2);
hVarBase* hvar::operator>=(const float &op1,const hVarLinear<float> &op2);

hVarBase* hvar::operator&&(const float &op1,const hVarLinear<float> &op2);
hVarBase* hvar::operator||(const float &op1,const hVarLinear<float> &op2);
hVarBase* hvar::operator==(const float &op1,const hVarLinear<float> &op2);
hVarBase* hvar::operator!=(const float &op1,const hVarLinear<float> &op2);

hVarBase* hvar::operator<<(const float &op1,const hVarLinear<float> &op2);
hVarBase* hvar::operator>>(const float &op1,const hVarLinear<float> &op2);
hVarBase* hvar::operator&(const float &op1,const hVarLinear<float> &op2);
hVarBase* hvar::operator|(const float &op1,const hVarLinear<float> &op2);
hVarBase* hvar::operator^(const float &op1,const hVarLinear<float> &op2);

hVarBase* hvar::operator+(const double &op1,const hVarLinear<double> &op2);
hVarBase* hvar::operator-(const double &op1,const hVarLinear<double> &op2);
hVarBase* hvar::operator*(const double &op1,const hVarLinear<double> &op2);
hVarBase* hvar::operator/(const double &op1,const hVarLinear<double> &op2);
hVarBase* hvar::operator%(const double &op1,const hVarLinear<double> &op2);

hVarBase* hvar::operator=(const double &op1,const hVarLinear<double> &op2);

hVarBase* hvar::operator<(const double &op1,const hVarLinear<double> &op2);
hVarBase* hvar::operator<=(const double &op1,const hVarLinear<double> &op2);
hVarBase* hvar::operator>(const double &op1,const hVarLinear<double> &op2);
hVarBase* hvar::operator>=(const double &op1,const hVarLinear<double> &op2);

hVarBase* hvar::operator&&(const double &op1,const hVarLinear<double> &op2);
hVarBase* hvar::operator||(const double &op1,const hVarLinear<double> &op2);
hVarBase* hvar::operator==(const double &op1,const hVarLinear<double> &op2);
hVarBase* hvar::operator!=(const double &op1,const hVarLinear<double> &op2);

hVarBase* hvar::operator<<(const double &op1,const hVarLinear<double> &op2);
hVarBase* hvar::operator>>(const double &op1,const hVarLinear<double> &op2);
hVarBase* hvar::operator&(const double &op1,const hVarLinear<double> &op2);
hVarBase* hvar::operator|(const double &op1,const hVarLinear<double> &op2);
hVarBase* hvar::operator^(const double &op1,const hVarLinear<double> &op2);

hVarBase* hvar::operator+(const long double &op1,const hVarLinear<long double> &op2);
hVarBase* hvar::operator-(const long double &op1,const hVarLinear<long double> &op2);
hVarBase* hvar::operator*(const long double &op1,const hVarLinear<long double> &op2);
hVarBase* hvar::operator/(const long double &op1,const hVarLinear<long double> &op2);
hVarBase* hvar::operator%(const long double &op1,const hVarLinear<long double> &op2);

hVarBase* hvar::operator=(const long double &op1,const hVarLinear<long double> &op2);

hVarBase* hvar::operator<(const long double &op1,const hVarLinear<long double> &op2);
hVarBase* hvar::operator<=(const long double &op1,const hVarLinear<long double> &op2);
hVarBase* hvar::operator>(const long double &op1,const hVarLinear<long double> &op2);
hVarBase* hvar::operator>=(const long double &op1,const hVarLinear<long double> &op2);

hVarBase* hvar::operator&&(const long double &op1,const hVarLinear<long double> &op2);
hVarBase* hvar::operator||(const long double &op1,const hVarLinear<long double> &op2);
hVarBase* hvar::operator==(const long double &op1,const hVarLinear<long double> &op2);
hVarBase* hvar::operator!=(const long double &op1,const hVarLinear<long double> &op2);

hVarBase* hvar::operator<<(const long double &op1,const hVarLinear<long double> &op2);
hVarBase* hvar::operator>>(const long double &op1,const hVarLinear<long double> &op2);
hVarBase* hvar::operator&(const long double &op1,const hVarLinear<long double> &op2);
hVarBase* hvar::operator|(const long double &op1,const hVarLinear<long double> &op2);
hVarBase* hvar::operator^(const long double &op1,const hVarLinear<long double> &op2);

hVarBase* hvar::operator+(const std::complex<float>  &op1,const hVarLinear<std::complex<float> > &op2);
hVarBase* hvar::operator-(const std::complex<float>  &op1,const hVarLinear<std::complex<float> > &op2);
hVarBase* hvar::operator*(const std::complex<float>  &op1,const hVarLinear<std::complex<float> > &op2);
hVarBase* hvar::operator/(const std::complex<float>  &op1,const hVarLinear<std::complex<float> > &op2);
hVarBase* hvar::operator%(const std::complex<float>  &op1,const hVarLinear<std::complex<float> > &op2);

hVarBase* hvar::operator=(const std::complex<float>  &op1,const hVarLinear<std::complex<float> > &op2);

hVarBase* hvar::operator<(const std::complex<float>  &op1,const hVarLinear<std::complex<float> > &op2);
hVarBase* hvar::operator<=(const std::complex<float>  &op1,const hVarLinear<std::complex<float> > &op2);
hVarBase* hvar::operator>(const std::complex<float>  &op1,const hVarLinear<std::complex<float> > &op2);
hVarBase* hvar::operator>=(const std::complex<float>  &op1,const hVarLinear<std::complex<float> > &op2);

hVarBase* hvar::operator&&(const std::complex<float>  &op1,const hVarLinear<std::complex<float> > &op2);
hVarBase* hvar::operator||(const std::complex<float>  &op1,const hVarLinear<std::complex<float> > &op2);
hVarBase* hvar::operator==(const std::complex<float>  &op1,const hVarLinear<std::complex<float> > &op2);
hVarBase* hvar::operator!=(const std::complex<float>  &op1,const hVarLinear<std::complex<float> > &op2);

hVarBase* hvar::operator<<(const std::complex<float>  &op1,const hVarLinear<std::complex<float> > &op2);
hVarBase* hvar::operator>>(const std::complex<float>  &op1,const hVarLinear<std::complex<float> > &op2);
hVarBase* hvar::operator&(const std::complex<float>  &op1,const hVarLinear<std::complex<float> > &op2);
hVarBase* hvar::operator|(const std::complex<float>  &op1,const hVarLinear<std::complex<float> > &op2);
hVarBase* hvar::operator^(const std::complex<float>  &op1,const hVarLinear<std::complex<float> > &op2);

hVarBase* hvar::operator+(const std::complex<double>  &op1,const hVarLinear<std::complex<double> > &op2);
hVarBase* hvar::operator-(const std::complex<double>  &op1,const hVarLinear<std::complex<double> > &op2);
hVarBase* hvar::operator*(const std::complex<double>  &op1,const hVarLinear<std::complex<double> > &op2);
hVarBase* hvar::operator/(const std::complex<double>  &op1,const hVarLinear<std::complex<double> > &op2);
hVarBase* hvar::operator%(const std::complex<double>  &op1,const hVarLinear<std::complex<double> > &op2);

hVarBase* hvar::operator=(const std::complex<double>  &op1,const hVarLinear<std::complex<double> > &op2);

hVarBase* hvar::operator<(const std::complex<double>  &op1,const hVarLinear<std::complex<double> > &op2);
hVarBase* hvar::operator<=(const std::complex<double>  &op1,const hVarLinear<std::complex<double> > &op2);
hVarBase* hvar::operator>(const std::complex<double>  &op1,const hVarLinear<std::complex<double> > &op2);
hVarBase* hvar::operator>=(const std::complex<double>  &op1,const hVarLinear<std::complex<double> > &op2);

hVarBase* hvar::operator&&(const std::complex<double>  &op1,const hVarLinear<std::complex<double> > &op2);
hVarBase* hvar::operator||(const std::complex<double>  &op1,const hVarLinear<std::complex<double> > &op2);
hVarBase* hvar::operator==(const std::complex<double>  &op1,const hVarLinear<std::complex<double> > &op2);
hVarBase* hvar::operator!=(const std::complex<double>  &op1,const hVarLinear<std::complex<double> > &op2);

hVarBase* hvar::operator<<(const std::complex<double>  &op1,const hVarLinear<std::complex<double> > &op2);
hVarBase* hvar::operator>>(const std::complex<double>  &op1,const hVarLinear<std::complex<double> > &op2);
hVarBase* hvar::operator&(const std::complex<double>  &op1,const hVarLinear<std::complex<double> > &op2);
hVarBase* hvar::operator|(const std::complex<double>  &op1,const hVarLinear<std::complex<double> > &op2);
hVarBase* hvar::operator^(const std::complex<double>  &op1,const hVarLinear<std::complex<double> > &op2);

hVarBase* hvar::operator+(const std::complex<long double>  &op1,const hVarLinear<std::complex<long double> > &op2);
hVarBase* hvar::operator-(const std::complex<long double>  &op1,const hVarLinear<std::complex<long double> > &op2);
hVarBase* hvar::operator*(const std::complex<long double>  &op1,const hVarLinear<std::complex<long double> > &op2);
hVarBase* hvar::operator/(const std::complex<long double>  &op1,const hVarLinear<std::complex<long double> > &op2);
hVarBase* hvar::operator%(const std::complex<long double>  &op1,const hVarLinear<std::complex<long double> > &op2);

hVarBase* hvar::operator=(const std::complex<long double>  &op1,const hVarLinear<std::complex<long double> > &op2);

hVarBase* hvar::operator<(const std::complex<long double>  &op1,const hVarLinear<std::complex<long double> > &op2);
hVarBase* hvar::operator<=(const std::complex<long double>  &op1,const hVarLinear<std::complex<long double> > &op2);
hVarBase* hvar::operator>(const std::complex<long double>  &op1,const hVarLinear<std::complex<long double> > &op2);
hVarBase* hvar::operator>=(const std::complex<long double>  &op1,const hVarLinear<std::complex<long double> > &op2);

hVarBase* hvar::operator&&(const std::complex<long double>  &op1,const hVarLinear<std::complex<long double> > &op2);
hVarBase* hvar::operator||(const std::complex<long double>  &op1,const hVarLinear<std::complex<long double> > &op2);
hVarBase* hvar::operator==(const std::complex<long double>  &op1,const hVarLinear<std::complex<long double> > &op2);
hVarBase* hvar::operator!=(const std::complex<long double>  &op1,const hVarLinear<std::complex<long double> > &op2);

hVarBase* hvar::operator<<(const std::complex<long double>  &op1,const hVarLinear<std::complex<long double> > &op2);
hVarBase* hvar::operator>>(const std::complex<long double>  &op1,const hVarLinear<std::complex<long double> > &op2);
hVarBase* hvar::operator&(const std::complex<long double>  &op1,const hVarLinear<std::complex<long double> > &op2);
hVarBase* hvar::operator|(const std::complex<long double>  &op1,const hVarLinear<std::complex<long double> > &op2);
hVarBase* hvar::operator^(const std::complex<long double>  &op1,const hVarLinear<std::complex<long double> > &op2);
*/
//----------------------

template class hVarLinear<bool>;
template class hVarLinear<unsigned char>;
template class hVarLinear<signed char>;
template class hVarLinear<unsigned short int>;
template class hVarLinear<signed short int>;
template class hVarLinear<unsigned long int>;
template class hVarLinear<signed long int>;
//template class hVarLinear<unsigned int>;
//template class hVarLinear<signed int>;
template class hVarLinear<float>;
template class hVarLinear<double>;
template class hVarLinear<long double>;
template class hVarLinear<std::complex<float> >;
template class hVarLinear<std::complex<double> >;
template class hVarLinear<std::complex<long double> >;
}


